//======================================================================================
//===================  PSM3d DEMO Program Code  ========================================
//======================================================================================
.EQU    GLOBAL_BASE  0x03800000
.GLOBAL_BASE_ADDRESS    GLOBAL_BASE
.EQU    P0STACK_BTM  0x02800000
.EQU    P1STACK_BTM  0x03000000

.EXTERNAL_FUNC      P0Main
.EXTERNAL_FUNC      P1Main
.EXTERNAL_FUNC      P0Isr
.EXTERNAL_FUNC      P1Isr
.EXTERNAL_FUNC      BusLock
.EXTERNAL_FUNC      BusUnLock

//=====================================================================================
// START UP
//=====================================================================================
.FUNCTION   startup
.CODE
startup:    di                              // 荞݋֎~
            jpi,al,PcOffsetOf(entry)        // (al)entryփWv
            nop                             // s̐擪[' ', '\t', '.']ȊOŎn܂ŏ̓̕x
            nop                             // ܂AFUNCTIOÑR[h̐擪ɂ́AFUNCTIONƓx
vector0:    jpi,al,PcOffsetOf(IrqHandler0)  // P0xN^ (al)IrqHandler0փWvBłȂRTING
            nop
            nop
            nop
vector1:    jpi,al,PcOffsetOf(IrqHandler1)  // P0xN^ (al)IrqHandler0փWvBłȂRTING
            nop
            nop
            nop
entry:      eic                             // I$ ON
            edc                             // D$ ON
            movhi,  gp, (GLOBAL_BASE >> 16)   // 
            ori,    gp, gp, (GLOBAL_BASE & 0xFFFF)// 
            movr,   r0, sr                  // r0 <- sr
            andi,   r0, r0, 0x8000          // P0P1`FbN
            calli,  eq, PcOffsetOf(setup0)  // P0 SETUP
            calli,  ne, PcOffsetOf(setup1)  // P1 SETUP
.ENDFUNCTION
//=====================================================================================
// setup0
//=====================================================================================
.FUNCTION setup0
.CODE
setup0:     movhi,  sp, (P0STACK_BTM >> 16)   // 
            ori,    sp, sp, (P0STACK_BTM & 0xFFFF)// 
            calli,  al, PcOffsetOf(init_global)
            jpi,    al, PcOffsetOf(P0Main)
.ENDFUNCTION

//=====================================================================================
// setup1
//=====================================================================================
.FUNCTION setup1
.CODE
setup1:     movhi,  sp, (P1STACK_BTM >> 16)   // 
            ori,    sp, sp, (P1STACK_BTM & 0xFFFF)// 
            jpi,    al, PcOffsetOf(P1Main)
.ENDFUNCTION
//=====================================================================================
// init_global
//=====================================================================================
.FUNCTION init_global
.CODE
init_global: subi,  sp, sp, 4
             stwi,  lr, sp, 0
             calli, al, PcOffsetOf(BusLock)
             movhi, r0, ($SizeOfGlobals0$ >> 16)   // 
             ori,   r0, r0, ($SizeOfGlobals0$ & 0xFFFF)// 
             movi,  r1, 0                           // r1= 0;
             movr,  r2, gp                          // r2 = gp
             subi,  r0, r0,   0                     // r0 = r0 - 0
Loop1:       jpi,   eq, PcOffsetOf(Loop1End)        // if(r0==0) goto Loop1End
             stwi,  r1, r2,   0                     // mem32(r2) = r1
             addi,  r2, r2,   4                     // r2 = r2 + 4
             subi,  r0, r0,   4                     // r0 = r0 - 4
             jpi,   al, PcOffsetOf(Loop1)           // goto Loop1
Loop1End:    nop
             movhi, r0, ($SizeOfGlobals1$ >> 16)    // 
             ori,   r0, r0, ($SizeOfGlobals1$ & 0xFFFF)// 
             movhi, r3, ($InitialValue$ >> 16)      // 
             ori,   r3, r3, ($InitialValue$ & 0xFFFF)// 
             subi,  r0, r0,   0                     // r0 = r0 - 0
Loop2:       jpi,   eq, PcOffsetOf(Loop1End)        // if(r0==0) goto Loop2End
             ldwi,  r1, r3,   0                     // r1 = mem32(r3)
             addi,  r3, r3,   4                     // r3 = r3 + 4
             stwi,  r1, r2,   0                     // mem32(r2) = r1
             addi,  r2, r2,   4                     // r2 = r2 + 4
             subi,  r0, r0,   4                     // r0 = r0 - 4
             jpi,   ne, PcOffsetOf(Loop2)           // goto Loop2
Loop2End:    nop
             calli, al, PcOffsetOf(BusUnLock)
             ldwi,  lr, sp, 0
             addi,  sp, sp, 4
             rts,  al
.ENDFUNCTION
//=====================================================================================
// IrqHandler0
//=====================================================================================
.FUNCTION   IrqHandler0
.CODE
IrqHandler0: subi,  sp,  sp,  0x001c
             stwi,  r0,  sp,  0x0018
             stwi,  r1,  sp,  0x0014
             stwi,  r2,  sp,  0x0010
             stwi,  r3,  sp,  0x000c
             stwi,  r4,  sp,  0x0008
             stwi,  r5,  sp,  0x0004
             stwi,  lr,  sp,  0x0000
             calli, al,  PcOffsetOf(P0Isr)
             ldwi,  lr,  sp,  0x0000
             ldwi,  r5,  sp,  0x0004
             ldwi,  r4,  sp,  0x0008
             ldwi,  r3,  sp,  0x000c
             ldwi,  r2,  sp,  0x0010
             ldwi,  r1,  sp,  0x0014
             ldwi,  r0,  sp,  0x0018
             addi,  sp,  sp,  0x001c
             rtir,    al
.ENDFUNCTION

//=====================================================================================
// IrqHandler1
//=====================================================================================
.FUNCTION   IrqHandler1
.CODE
IrqHandler1: subi,  sp,  sp,  0x001c
             stwi,  r0,  sp,  0x0018
             stwi,  r1,  sp,  0x0014
             stwi,  r2,  sp,  0x0010
             stwi,  r3,  sp,  0x000c
             stwi,  r4,  sp,  0x0008
             stwi,  r5,  sp,  0x0004
             stwi,  lr,  sp,  0x0000
             calli, al,  PcOffsetOf(P1Isr)
             ldwi,  lr,  sp,  0x0000
             ldwi,  r5,  sp,  0x0004
             ldwi,  r4,  sp,  0x0008
             ldwi,  r3,  sp,  0x000c
             ldwi,  r2,  sp,  0x0010
             ldwi,  r1,  sp,  0x0014
             ldwi,  r0,  sp,  0x0018
             addi,  sp,  sp,  0x001c
             rtir,    al
.ENDFUNCTION
