//=======================================================================
//  TARGET PROJECT: PSM3(Prosessor Study Model3)
//  TARGET SYSTEM : *(PSM3 TARGET SYSTEM)
//  FUNCTION      : Flash I/F
//
//                      Copyright (C) 2008 by Tomoyuki Inomoto
//=======================================================================

module FlashIf(
    //======== SYSTEM ==============
    Clk             ,
    RstN            ,

    //======= Master0 Bus[Read:32bit/Write:32bit] ================
    Mstr0CRQ        ,
    Mstr0CAK        ,
    Mstr0BRST       ,
    Mstr0RW         ,
    Mstr0BE         ,
    Mstr0ADR        ,
    Mstr0WD         ,
    Mstr0WDAK       ,
    Mstr0RD         ,
    Mstr0RDAK       ,

    //======= Master1 Bus[Read:32bit/Write:32bit] ================
    Mstr1CRQ        ,
    Mstr1CAK        ,
    Mstr1BRST       ,
    Mstr1RW         ,
    Mstr1BE         ,
    Mstr1ADR        ,
    Mstr1WD         ,
    Mstr1WDAK       ,
    Mstr1RD         ,
    Mstr1RDAK       ,

    //======= Master2 Bus[Read:32bit/Write:32bit] ================
    Mstr2CRQ        ,
    Mstr2CAK        ,
    Mstr2BRST       ,
    Mstr2RW         ,
    Mstr2BE         ,
    Mstr2ADR        ,
    Mstr2WD         ,
    Mstr2WDAK       ,
    Mstr2RD         ,
    Mstr2RDAK       ,

    //======= Master3 Bus[Read:32bit/Write:32bit] ================
    Mstr3CRQ        ,
    Mstr3CAK        ,
    Mstr3BRST       ,
    Mstr3RW         ,
    Mstr3BE         ,
    Mstr3ADR        ,
    Mstr3WD         ,
    Mstr3WDAK       ,
    Mstr3RD         ,
    Mstr3RDAK       ,

    //======= Master4 Bus[Read:32bit/Write:32bit] ================
    Mstr4CRQ        ,
    Mstr4CAK        ,
    Mstr4BRST       ,
    Mstr4RW         ,
    Mstr4BE         ,
    Mstr4ADR        ,
    Mstr4WD         ,
    Mstr4WDAK       ,
    Mstr4RD         ,
    Mstr4RDAK       ,

    //======= FLASH ================
    SF_CE0          ,
    SF_OE           ,
    SF_WE           ,
    SF_BYTE         ,
    SF_A            ,
    SF_D            ,
    SF_STS
);
    //============================================================
    //======== port  =============================================
    //============================================================
    //======== SYSTEM ==============
    input           Clk             ;
    input           RstN            ;

    //======= Master0 Bus[Read:32bit/Write:32bit] ================
    input           Mstr0CRQ        ;
    output          Mstr0CAK        ;
    input           Mstr0BRST       ;
    input           Mstr0RW         ;
    input   [3:0]   Mstr0BE         ;
    input   [25:2]  Mstr0ADR        ;
    input   [31:0]  Mstr0WD         ;
    output          Mstr0WDAK       ;
    output  [31:0]  Mstr0RD         ;
    output          Mstr0RDAK       ;

    //======= Master1 Bus[Read:32bit/Write:32bit] ================
    input           Mstr1CRQ        ;
    output          Mstr1CAK        ;
    input           Mstr1BRST       ;
    input           Mstr1RW         ;
    input   [3:0]   Mstr1BE         ;
    input   [25:2]  Mstr1ADR        ;
    input   [31:0]  Mstr1WD         ;
    output          Mstr1WDAK       ;
    output  [31:0]  Mstr1RD         ;
    output          Mstr1RDAK       ;

    //======= Master2 Bus[Read:32bit/Write:32bit] ================
    input           Mstr2CRQ        ;
    output          Mstr2CAK        ;
    input           Mstr2BRST       ;
    input           Mstr2RW         ;
    input   [3:0]   Mstr2BE         ;
    input   [25:2]  Mstr2ADR        ;
    input   [31:0]  Mstr2WD         ;
    output          Mstr2WDAK       ;
    output  [31:0]  Mstr2RD         ;
    output          Mstr2RDAK       ;

    //======= Master3 Bus[Read:32bit/Write:32bit] ================
    input           Mstr3CRQ        ;
    output          Mstr3CAK        ;
    input           Mstr3BRST       ;
    input           Mstr3RW         ;
    input   [3:0]   Mstr3BE         ;
    input   [25:2]  Mstr3ADR        ;
    input   [31:0]  Mstr3WD         ;
    output          Mstr3WDAK       ;
    output  [31:0]  Mstr3RD         ;
    output          Mstr3RDAK       ;

    //======= Master4 Bus[Read:32bit/Write:32bit] ================
    input           Mstr4CRQ        ;
    output          Mstr4CAK        ;
    input           Mstr4BRST       ;
    input           Mstr4RW         ;
    input   [3:0]   Mstr4BE         ;
    input   [25:2]  Mstr4ADR        ;
    input   [31:0]  Mstr4WD         ;
    output          Mstr4WDAK       ;
    output  [31:0]  Mstr4RD         ;
    output          Mstr4RDAK       ;

    //======= FLASH ================
    output          SF_CE0          ;
    output          SF_OE           ;
    output          SF_WE           ;
    output          SF_BYTE         ;
    output  [23:0]  SF_A            ;
    inout   [15:0]  SF_D            ;
    input           SF_STS          ;

    //==================================================
    //======== wire & reg ==============================
    //==================================================

    //====================================================================
    //======== BODY ======================================================
    //====================================================================
    assign  Mstr0CAK  = Mstr0CRQ ;
    assign  Mstr1CAK  = Mstr1CRQ ;
    assign  Mstr2CAK  = Mstr2CRQ ;
    assign  Mstr3CAK  = Mstr3CRQ ;
    assign  Mstr4CAK  = Mstr4CRQ ;

    assign  Mstr0WDAK = Mstr0CRQ ;
    assign  Mstr1WDAK = Mstr1CRQ ;
    assign  Mstr2WDAK = Mstr2CRQ ;
    assign  Mstr3WDAK = Mstr3CRQ ;
    assign  Mstr4WDAK = Mstr4CRQ ;

    assign  Mstr0RDAK = Mstr0CRQ ;
    assign  Mstr1RDAK = Mstr1CRQ ;
    assign  Mstr2RDAK = Mstr2CRQ ;
    assign  Mstr3RDAK = Mstr3CRQ ;
    assign  Mstr4RDAK = Mstr4CRQ ;

    assign  Mstr0RD  = 32'h0     ;
    assign  Mstr1RD  = 32'h0     ;
    assign  Mstr2RD  = 32'h0     ;
    assign  Mstr3RD  = 32'h0     ;
    assign  Mstr4RD  = 32'h0     ;

    assign  SF_CE0  = 1'b1;
    assign  SF_OE   = 1'b1;
    assign  SF_WE   = 1'b1;
    assign  SF_BYTE = 1'b1; // 16bit
    assign  SF_A    = 24'h0;
    assign  SF_D    = (RstN)? 16'h0 : 16'hz;

endmodule
