//============================================================
//  TARGET SYSTEM : *
//  FUNCTION      : oXgpCu
//
//                  Copyright (C) 2009-2010 by Tomoyuki Inomoto
//=============================================================
#include    "BiDirList.h"

//====================================================================================================================
BiDirList *BiDirListCreate(int (*Remove)(void *Object), int (*Find)(BiDirListMember *Position, void *Key))
//====================================================================================================================
// [@\] Xg쐬
// [] Xg̃f[^i*(BiDirListMember.Data)free֐ւ̃|C^BwȂ̏ꍇNULLł悢
// [Ԓl] sNULLAABiDirListւ̃|C^ԂB
{
    BiDirList       *Ld;

    Ld = calloc(1, sizeof(BiDirList));
    if(Ld == NULL) return NULL;

    Ld->NumOfMember = 0;
    Ld->Entry   = NULL;
    Ld->Last    = NULL;
    Ld->Index    = NULL;
    Ld->Remove = Remove;
    Ld->Find   = Find;
    return  Ld;
}
//====================================================================================================================
int BiDirListRemove(BiDirList *Ld)
//====================================================================================================================
// [@\] Xg̊ǗubN݂̂폜
// [] BiDirList *Ld     F폜Ώۂ̑oXg
// [Ԓl] sBIDIR_LIST_NGAABIDIR_LIST_OKԂB
{
    if(Ld == NULL) return BIDIR_LIST_NG;
    free(Ld);
    return BIDIR_LIST_OK;
}

//====================================================================================================================
int BiDirListRemoveAll(BiDirList *Ld)
//====================================================================================================================
// [@\] XgŜ폜
// [] BiDirList *Ld     F폜Ώۂ̑oXg
// [Ԓl] sBIDIR_LIST_NGAABIDIR_LIST_OKԂB
{
    BiDirListMember     *Mp;
    BiDirListMember     *NextMp;

    if(Ld == NULL) return BIDIR_LIST_NG;
    Mp = Ld->Entry;
    while(Mp != NULL){
        NextMp = Mp->Next;
        if(Mp->Object != NULL){
            if(Ld->Remove == NULL) free(Mp->Object);
            else                         (*(Ld->Remove))(Mp->Object);
        }
        free(Mp);
        Mp = NextMp;
    }
    if(Ld->Index != NULL) free(Ld->Index);
    free(Ld);
    return BIDIR_LIST_OK;
}

//====================================================================================================================
BiDirListMember  *BiDirListMemberAdd(BiDirList *Ld,  void *Object, int ObjectSize)
//====================================================================================================================
// [@\] Xg̍ŌɃoǉ(*Object̓Rs[ÃRs[XgɂԂ牺)
// [] BiDirList *Ld     FoXg
// [] void      *Object FǉIuWFNgւ̃|C^
// [] void      *ObjectSize FǉIuWFNg̃TCY
// [Ԓl] sNULLAAǉoւ̃|C^Ԃ
{
    BiDirListMember     *Mp;

    if(Ld == NULL) return NULL;
    if(Object == NULL) return NULL;
    if(ObjectSize <= 0) return NULL;

    Mp = calloc(1, sizeof(BiDirListMember));
    if(Mp == NULL) return NULL;
    Mp->Object = calloc(1, ObjectSize);
    if(Mp->Object == NULL) return NULL;
    memcpy(Mp->Object, Object, ObjectSize);

    if(Ld->Entry == NULL){
        Mp->Prev = NULL;
        Mp->Next = NULL;
        Ld->Entry = Mp;
        Ld->Last = Mp;
    }
    else{
        Mp->Prev = Ld->Last;
        Mp->Next = NULL;
        Ld->Last->Next = Mp;
        Ld->Last = Mp;
    }

    Ld->NumOfMember += 1;

    return Mp;
}

//====================================================================================================================
int BiDirListMemberRemove(BiDirList *Ld,  BiDirListMember *Position)
//====================================================================================================================
// [@\] XgPositoño폜
// [] BiDirList *Ld     FoXg
// [] int       PositionF폜郁ôւ̃|C^
// [Ԓl] sBIDIR_LIST_NGAABIDIR_LIST_OKԂB
{
    BiDirListMember     *MyPosition;

    if(Ld == NULL) return BIDIR_LIST_NG;
    if(Position == NULL) return BIDIR_LIST_NG;
#ifdef BIDIR_LIST_DEBUG
    if(Ld->Index != NULL) printf("yxzIndex̃Xgւ̃oǉ/폜͋֎~\n");
#endif

    MyPosition = Ld->Entry;
    while(1){
        if(MyPosition == NULL) return BIDIR_LIST_NG; //Xg̍Ō܂ŌPositionƈv郁oȂ
        if(MyPosition == Position) break;
        MyPosition = MyPosition->Next;
    }

    if(MyPosition->Object != NULL){
        if(Ld->Remove == NULL) free(MyPosition->Object);
        else                   (*(Ld->Remove))(MyPosition->Object);
    }

    if(MyPosition->Prev == NULL){//擪
        if(MyPosition->Next == NULL){//Ō
            Ld->Entry = NULL;
            Ld->Last  = NULL;
        }
        else{//ŌłȂ
            Ld->Entry = MyPosition->Next;
            MyPosition->Next->Prev = NULL;
        }
    }
    else{//擪łȂ
        if(MyPosition->Next == NULL){//Ō
            Ld->Last = MyPosition->Prev;
            MyPosition->Prev->Next = NULL;
        }
        else{//ŌłȂ
            MyPosition->Prev->Next = MyPosition->Next;
            MyPosition->Next->Prev = MyPosition->Prev;
        }
    }

    free(MyPosition);
    Ld->NumOfMember -= 1;

    return BIDIR_LIST_OK;
}

//====================================================================================================================
int BiDirListMemberInsertPrev(BiDirList *Ld,  BiDirListMember *Position, void *Object, int ObjectSize)
//====================================================================================================================
// [@\] XgPositon̑OɃoǉ(*Object̓Rs[A
//        ̃Rs[BiDirListMember.ObjectɃXgɂԂ牺)
//        XgȂ΁A擪ɒǉ
// [] BiDirList        *Ld         F*ObjectǉoXg
// [] BiDirListMember  *Position   FIuWFNgǉʒu
// [] void             *Object     FǉIuWFNgւ̃|C^
// [] void             *ObjectSize FǉIuWFNg̃TCY
// [Ԓl] sBIDIR_LIST_NGAABIDIR_LIST_OKԂB
{
    BiDirListMember     *MyPosition;
    BiDirListMember     *Mp;

    if(Ld == NULL) return BIDIR_LIST_NG;
    if(Object == NULL) return BIDIR_LIST_NG;
    if(ObjectSize <= 0) return BIDIR_LIST_NG;
    if(Position == NULL) return BIDIR_LIST_NG;
    if(Ld->NumOfMember == 0){
        if(BiDirListMemberAdd(Ld, Object, ObjectSize) != NULL) return BIDIR_LIST_OK;
        else return BIDIR_LIST_NG;
    }
#ifdef BIDIR_LIST_DEBUG
    if(Ld->Index != NULL) printf("yxzIndex̃Xgւ̃oǉ/폜͋֎~\n");
#endif


#ifdef BIDIR_LIST_CHECK
    // PositioñozgɊ܂܂Ă邩`FbN
    MyPosition = Ld->Entry;
    while(1){
        if(MyPosition == NULL) return BIDIR_LIST_NG; //Xg̍Ō܂ŌPositionƈv郁oȂ
        if(MyPosition == Position) break;
        MyPosition = MyPosition->Next;
    }
#else
    MyPosition = Position;
#endif

    Mp = calloc(1, sizeof(BiDirListMember));
    if(Mp == NULL) return BIDIR_LIST_NG;
    Mp->Object = calloc(1, ObjectSize);
    if(Mp->Object == NULL) return BIDIR_LIST_NG;
    memcpy(Mp->Object, Object, ObjectSize);

    Mp->Prev = MyPosition->Prev;
    Mp->Next = MyPosition;
    if(MyPosition == Ld->Entry){
        Ld->Entry = Mp;
    }
    else{
        MyPosition->Prev->Next = Mp;
    }
    MyPosition->Prev = Mp;

    Ld->NumOfMember += 1;

    return BIDIR_LIST_OK;
}
//====================================================================================================================
int BiDirListMemberInsertNext(BiDirList *Ld,  BiDirListMember *Position, void *Object, int ObjectSize)
//====================================================================================================================
// [@\] XgPositoňɃoǉ(*Object̓Rs[A
//        ̃Rs[BiDirListMember.ObjectɃXgɂԂ牺)
//        XgȂ΁A擪ɒǉ
// [] BiDirList        *Ld         F*ObjectǉoXg
// [] BiDirListMember  *Position   FIuWFNgǉʒu
// [] void             *Object     FǉIuWFNgւ̃|C^
// [] void             *ObjectSize FǉIuWFNg̃TCY
// [Ԓl] sBIDIR_LIST_NGAABIDIR_LIST_OKԂB
{
    BiDirListMember     *MyPosition;
    BiDirListMember     *Mp;

    if(Ld == NULL) return BIDIR_LIST_NG;
    if(Object == NULL) return BIDIR_LIST_NG;
    if(ObjectSize <= 0) return BIDIR_LIST_NG;
    if(Position == NULL) return BIDIR_LIST_NG;
    if(Ld->NumOfMember == 0){
        if(BiDirListMemberAdd(Ld, Object, ObjectSize) != NULL) return BIDIR_LIST_OK;
        else return BIDIR_LIST_NG;
    }

#ifdef BIDIR_LIST_DEBUG
    if(Ld->Index != NULL) printf("yxzIndex̃Xgւ̃oǉ/폜͋֎~\n");
#endif

#ifdef BIDIR_LIST_CHECK
    // PositioñozgɊ܂܂Ă邩`FbN
    MyPosition = Ld->Entry;
    while(1){
        if(MyPosition == NULL) return BIDIR_LIST_NG; //Xg̍Ō܂ŌPositionƈv郁oȂ
        if(MyPosition == Position) break;
        MyPosition = MyPosition->Next;
    }
#else
    MyPosition = Position;
#endif

    Mp = calloc(1, sizeof(BiDirListMember));
    if(Mp == NULL) return BIDIR_LIST_NG;
    Mp->Object = calloc(1, ObjectSize);
    if(Mp->Object == NULL) return BIDIR_LIST_NG;
    memcpy(Mp->Object, Object, ObjectSize);

    Mp->Prev = MyPosition;
    Mp->Next = MyPosition->Next;
    if(MyPosition == Ld->Last){
        Ld->Last = Mp;
    }
    else{
        MyPosition->Next->Prev = Mp;
    }
    MyPosition->Next = Mp;

    Ld->NumOfMember += 1;

    return BIDIR_LIST_OK;
}

//====================================================================================================================
BiDirListMember *BiDirListMemberFind(BiDirList *Ld,  BiDirListMember *Position, void *Key)
//====================================================================================================================
// [@\] Ldɓo^ꂽFind֐KeyL[ƂāAXgPosition猟AŏɌoԂB
//        ɎsAȂNULLԂ
// [] BiDirList       *Ld       F*Objecti[oXg
// [] BiDirListMember *Position FJnʒu
// [] void            *Key      FL[ւ̃|C^
// [Ԓl] sNULL
{
    BiDirListMember     *MyPosition;

    if(Ld == NULL) return NULL;
    if(Position == NULL) return NULL;
    if(Ld->NumOfMember == 0) return NULL;
    if(Ld->Find == NULL) return NULL;

#ifdef BIDIR_LIST_CHECK
    // PositioñozgɊ܂܂Ă邩`FbN
    MyPosition = Ld->Entry;
    while(1){
        if(MyPosition == NULL) return NULL; //Xg̍Ō܂ŌPositionƈv郁oȂ
        if(MyPosition == Position) break;
        MyPosition = MyPosition->Next;
    }
#else
    MyPosition = Position;
#endif

    while(1){
        if(MyPosition == NULL) return NULL; //Xg̍Ō܂ŌKeyƈv郁oȂ
        if((*(Ld->Find))(MyPosition, Key) == BIDIR_LIST_OK) break;
        MyPosition = MyPosition->Next;
    }
    return MyPosition;
}

//====================================================================================================================
void *BiDirListObjectFind(BiDirList *Ld, void *Key)
//====================================================================================================================
// [@\] Ldɓo^ꂽFind֐KeyL[ƂāAXg擪猟AŏɌoԂB
//        ɎsAȂNULLԂ
// [] BiDirList       *Ld       F*Objecti[oXg
// [] void            *Key      FL[ւ̃|C^
// [Ԓl] sNULL
{
    BiDirListMember     *MyPosition;
    MyPosition = BiDirListMemberFind(Ld, Ld->Entry, Key);
    if(MyPosition == NULL) return NULL;
    return MyPosition->Object;
}

//====================================================================================================================
BiDirListMember *BiDirListMemberGet(BiDirList *Ld,  int Position)
//====================================================================================================================
// [@\] Xg̐擪PositonԖڂ̃oւ̃|C^Ԃ
// [] BiDirList *Ld     FoXg
// [] int       PositionFʒui擪 : Position == 0)
// [Ԓl] sNULL
{
    BiDirListMember     *MyPosition;

    if(Ld == NULL) return NULL;
    if(Position < 0) return NULL;
    if(Position > Ld->NumOfMember - 1) return NULL;

    if(Ld->Index != NULL){
        MyPosition = (Ld->Index)[Position];
    }
    else{
        for(MyPosition = Ld->Entry ; Position > 0; --Position){
            if(MyPosition == NULL) return NULL;
            MyPosition = MyPosition->Next;
        }
    }
    return MyPosition;
}

//====================================================================================================================
void *BiDirListObjectGet(BiDirList *Ld,  int Position)
//====================================================================================================================
// [@\] Xg̐擪PositonԖڂ̃oɂԂ牺ĂIuWFNgւ̃|C^Ԃ
// [] BiDirList *Ld     FoXg
// [] int       PositionFʒui擪 : Position == 0)
// [Ԓl] sNULL
{
    BiDirListMember     *MyPosition;

    MyPosition = BiDirListMemberGet(Ld, Position);
    if(MyPosition == NULL) return NULL;
    return MyPosition->Object;
}

//====================================================================================================================
int BiDirListConnect(BiDirList *LdPrev,  BiDirList *LdNext)
//====================================================================================================================
// [@\] LdPrevLdNextA
// [] BiDirList *LdPrev FoXg
// [] BiDirList *LdNext FoXg
// [Ԓl] sBIDIR_LIST_NGAABIDIR_LIST_OKԂB
{
    if(LdPrev == NULL) return BIDIR_LIST_NG;
    if(LdNext == NULL) return BIDIR_LIST_NG;

#ifdef BIDIR_LIST_DEBUG
    if(LdPrev->Index != NULL) printf("yxzIndex̃Xgւ̃oǉ/폜͋֎~\n");
    if(LdNext->Index != NULL) printf("yxzIndex̃Xgւ̃oǉ/폜͋֎~\n");
#endif

    if(LdPrev->Entry == NULL){//̏ꍇ
        if(LdNext->Entry != NULL){//Kg
            LdPrev->Entry = LdNext->Entry;
            LdPrev->Last  = LdNext->Last;
        }
        else{//KgȂ
            ;
        }
    }
    else if(LdNext->Entry != NULL){//gAKg
        LdPrev->Last->Next = LdNext->Entry;
        LdNext->Entry->Prev = LdPrev->Last;
        LdPrev->Last = LdNext->Last;
    }
    else{//gAK͋
        ;
    }

    return BIDIR_LIST_OK;
}

//====================================================================================================================
int BiDirListSwap(BiDirList *Ld, BiDirListMember *Position0, BiDirListMember *Position1)
//====================================================================================================================
// [@\] Position0ObjectPosition1Objectւ
// [] BiDirList *LdFoXg
// [] BiDirListMember *Position0 FΏۃoʒu
// [] BiDirListMember *Position1 FΏۃoʒu
// [Ԓl] sBIDIR_LIST_NGAABIDIR_LIST_OKԂB
{
    BiDirListMember     *MyPosition0;
    BiDirListMember     *MyPosition1;
    void                *Temp;

    if(Ld == NULL) return BIDIR_LIST_NG;
    if(Position0 == NULL) return BIDIR_LIST_NG;
    if(Position1 == NULL) return BIDIR_LIST_NG;

#ifdef BIDIR_LIST_DEBUG
    if(Ld->Index != NULL) printf("yxzIndex̃Xgւ̃oǉ/폜/oړ͋֎~\n");
#endif

#ifdef BIDIR_LIST_CHECK
    // PositioñozgɊ܂܂Ă邩`FbN
    MyPosition0 = Ld->Entry;
    while(1){
        if(MyPosition0 == NULL) return BIDIR_LIST_NG; //Xg̍Ō܂ŌPositionƈv郁oȂ
        if(MyPosition0 == Position0) break;
        MyPosition0 = MyPosition0->Next;
    }
    MyPosition1 = Ld->Entry;
    while(1){
        if(MyPosition1 == NULL) return BIDIR_LIST_NG; //Xg̍Ō܂ŌPositionƈv郁oȂ
        if(MyPosition1 == Position1) break;
        MyPosition1 = MyPosition1->Next;
    }
#else
    MyPosition0 = Position0;
    MyPosition1 = Position1;
#endif

    Temp = MyPosition0->Object;
    MyPosition0->Object = MyPosition1->Object;
    MyPosition1->Object = Temp;

    return BIDIR_LIST_OK;
}

//====================================================================================================================
int BiDirListNumOfMemberGet(BiDirList *Ld)
//====================================================================================================================
// [@\] ݂̗vfԂ
// [] BiDirList *LdFoXg
// [Ԓl] sBIDIR_LIST_NGAA0ȏ̒lԂB
{
    if(Ld == NULL) return BIDIR_LIST_NG;
    else           return Ld->NumOfMember;
}

//====================================================================================================================
int BiDirListIndexCreate(BiDirList *Ld)
//====================================================================================================================
// [@\] Xg̃CfbNX\쐬BBiDirListMemberGet()ABiDirListObjectGet()
//        AIndexĹAXgւ̒ǉ/폜/oړn̑֎~B
// [] BiDirList *LdFoXg
// [Ԓl] sBIDIR_LIST_NGAABIDIR_LIST_OKB
{
    int     i;
    BiDirListMember             **Index;
    if(Ld->Index != NULL) return BIDIR_LIST_NG;
    Index = calloc(Ld->NumOfMember, sizeof(BiDirListMember *));
    for(i = 0; i < Ld->NumOfMember; i++){
        Index[i] = BiDirListMemberGet(Ld, i);
    }
    Ld->Index = Index;
    return BIDIR_LIST_OK;
}
