//============================================================
//  TARGET SYSTEM : Psm3Core (Processor Study Model 3 Core)
//  FUNCTION      : Psm3 Assembler version 2.00
//
//                  Copyright (C) 2009-2010 by Tomoyuki Inomoto
//=============================================================

#include    "BiDirList.h"

//=====================================================================================================
//  o[W`
//=====================================================================================================
#define     VERSION_MAJOR       (0)
#define     VERSION_MINER       (0)
//#define     VERSION_SUB_MINER   (1)  // 20100228J
#define     VERSION_SUB_MINER   (2)  // 20100322J

//=====================================================================================================
//  IvV`
//=====================================================================================================
#define     P3AL_MSGENABLE
#define     P3AL_DEBUG
#define     P3AL_LOG

#define     P3AL_NEW_HW_MODE   // PCItZbgLD/STߎgps & x[XWX^XVtLD/STߎgps


//=====================================================================================================
//  萔`
//=====================================================================================================
#define     P3AL_OK             (0)
#define     P3AL_NG             (-1)
#define     P3AL_ESCAPE         (-2)
#define     P3AL_TRUE           (1)
#define     P3AL_FALSE          (0)
#define     P3AL_ILLEGAL        (-1)

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// ͊֘A
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
#define     FILE_READ_AND_TRIM          (0)
#define     FILE_READ_ONLY              (1)

#define     MAX_FILE_NAME_LENGTH        (256)
#define     MAX_FILE_LINE               (10000)   // ̓t@C̑ős
#define     MAX_LINE_LENGTH             (1024)    // Ps̍ő啶
#define     MAX_TOKEN_LENGTH            (64)      // g[N̍ő啶
#define     MAX_IDENTIFIER_CHAR         (64)      // ʎq̍ő啶@̏ꍇ31OK̂͂
#define     MAX_NUMERIC_LITERAL_CHAR    (16)      // le̍ő啶@̏ꍇ16OK̂͂
#define     MAX_STRING_LITERAL_CHAR     (1023)    // 񃊃e̍ő啶@̏ꍇ1023OK̂͂
#define     MAX_LABEL_LENGTH            (32)      // x̍ő啶

#define     MAX_PROG_LABEL          (100000)  // vOx̍ő
#define     MAX_GVAR_LABEL          (100000)  // O[oϐx̍ő
#define     MAX_LVAR_LABEL          (100000)  // [Jϐx̍ő

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// g[N
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//===== K̖ =====================
#define     TOKEN_JP_R        (  0)     // jpr
#define     TOKEN_JP_I        (  1)     // jpi
#define     TOKEN_CALL_R      (  2)     // callr
#define     TOKEN_CALL_I      (  3)     // calli
#define     TOKEN_DJP_R       (  4)     // djpr
#define     TOKEN_RTI_R       (  5)     // rtir
#define     TOKEN_LDW_R       (  6)     // ldwr
#define     TOKEN_LDW_I       (  7)     // ldwi
#define     TOKEN_LDW_UB_R    (  8)     // ldwubr
#define     TOKEN_LDW_UB_I    (  9)     // ldwubi
#define     TOKEN_LDW_UA_R    ( 10)     // ldwuar
#define     TOKEN_LDW_UA_I    ( 11)     // ldwuai
#define     TOKEN_LDH_R       ( 12)     // ldhr
#define     TOKEN_LDH_I       ( 13)     // ldhi
#define     TOKEN_LDH_UB_R    ( 14)     // ldhubr
#define     TOKEN_LDH_UB_I    ( 15)     // ldhubi
#define     TOKEN_LDH_UA_R    ( 16)     // ldhuar
#define     TOKEN_LDH_UA_I    ( 17)     // ldhuai
#define     TOKEN_LDB_R       ( 18)     // ldbr
#define     TOKEN_LDB_I       ( 19)     // ldbi
#define     TOKEN_LDB_UB_R    ( 20)     // ldbubr
#define     TOKEN_LDB_UB_I    ( 21)     // ldbubi
#define     TOKEN_LDB_UA_R    ( 22)     // ldbuar
#define     TOKEN_LDB_UA_I    ( 23)     // ldbuai
#define     TOKEN_LDSH_R      ( 24)     // ldshr
#define     TOKEN_LDSH_I      ( 25)     // ldshi
#define     TOKEN_LDSH_UB_R   ( 26)     // ldshubr
#define     TOKEN_LDSH_UB_I   ( 27)     // ldshubi
#define     TOKEN_LDSH_UA_R   ( 28)     // ldshuar
#define     TOKEN_LDSH_UA_I   ( 29)     // ldshuai
#define     TOKEN_LDSB_R      ( 30)     // ldsbr
#define     TOKEN_LDSB_I      ( 31)     // ldsbi
#define     TOKEN_LDSB_UB_R   ( 32)     // ldsbubr
#define     TOKEN_LDSB_UB_I   ( 33)     // ldsbubi
#define     TOKEN_LDSB_UA_R   ( 34)     // ldsbuar
#define     TOKEN_LDSB_UA_I   ( 35)     // ldsbuai
#define     TOKEN_STW_R       ( 36)     // stwr
#define     TOKEN_STW_I       ( 37)     // stwi
#define     TOKEN_STW_UB_R    ( 38)     // stwubr
#define     TOKEN_STW_UB_I    ( 39)     // stwubi
#define     TOKEN_STW_UA_R    ( 40)     // stwuar
#define     TOKEN_STW_UA_I    ( 41)     // stwuai
#define     TOKEN_STH_R       ( 42)     // sthr
#define     TOKEN_STH_I       ( 43)     // sthi
#define     TOKEN_STH_UB_R    ( 44)     // sthubr
#define     TOKEN_STH_UB_I    ( 45)     // sthubi
#define     TOKEN_STH_UA_R    ( 46)     // sthuar
#define     TOKEN_STH_UA_I    ( 47)     // sthuai
#define     TOKEN_STB_R       ( 48)     // stbr
#define     TOKEN_STB_I       ( 49)     // stbi
#define     TOKEN_STB_UB_R    ( 50)     // stbubr
#define     TOKEN_STB_UB_I    ( 51)     // stbubi
#define     TOKEN_STB_UA_R    ( 52)     // stbuar
#define     TOKEN_STB_UA_I    ( 53)     // stbuai
#define     TOKEN_DCDRAIN     ( 54)     // dcdrain
#define     TOKEN_MOV_I       ( 55)     // movi
#define     TOKEN_MOV_R       ( 56)     // movr
#define     TOKEN_MOVL_I      ( 59)     // movli
#define     TOKEN_MOVH_I      ( 60)     // movhi
#define     TOKEN_ADD_R       ( 61)     // addr
#define     TOKEN_ADD_I       ( 62)     // addi
#define     TOKEN_SUB_R       ( 63)     // subr
#define     TOKEN_SUB_I       ( 64)     // subi
#define     TOKEN_AND_R       ( 65)     // andr
#define     TOKEN_AND_I       ( 66)     // andi
#define     TOKEN_OR_R        ( 67)     // orr
#define     TOKEN_OR_I        ( 68)     // ori
#define     TOKEN_XOR_R       ( 69)     // xorr
#define     TOKEN_XOR_I       ( 70)     // xori
#define     TOKEN_LSR_R       ( 71)     // lsrr
#define     TOKEN_LSR_I       ( 72)     // lsri
#define     TOKEN_LSL_R       ( 73)     // lslr
#define     TOKEN_LSL_I       ( 74)     // lsli
#define     TOKEN_ASR_R       ( 75)     // asrr
#define     TOKEN_ASR_I       ( 76)     // asri
#define     TOKEN_MUL_R       ( 77)     // mulr
#define     TOKEN_MUL_I       ( 78)     // muli
#define     TOKEN_DIVU_R      ( 79)     // divur
#define     TOKEN_DIVU_I      ( 80)     // divui
#define     TOKEN_DIV_R       ( 81)     // divr
#define     TOKEN_DIV_I       ( 82)     // divi
#define     TOKEN_MODU_R      ( 83)     // modur
#define     TOKEN_MODU_I      ( 84)     // modui
#define     TOKEN_MOD_R       ( 85)     // modr
#define     TOKEN_MOD_I       ( 86)     // modi
#define     TOKEN_DI          ( 87)     // di
#define     TOKEN_EI          ( 88)     // ei
#define     TOKEN_DIC         ( 89)     // dic
#define     TOKEN_EIC         ( 90)     // eic
#define     TOKEN_DDC         ( 91)     // ddc
#define     TOKEN_EDC         ( 92)     // edc
#define     TOKEN_BULK        ( 93)     // bulk
#define     TOKEN_BLK         ( 94)     // blk
#define     TOKEN_CPRD        ( 95)     // cprd
#define     TOKEN_CPWR        ( 96)     // cpwr
#define     TOKEN_BREAK       ( 98)     // break
#define     TOKEN_NOP         ( 99)     // nop

//===== ^ =====================
#define     TOKEN_IMMSET      (100)
#define     TOKEN_RTS         (101)
#define     TOKEN_PUSH        (102)
#define     TOKEN_POP         (103)

//===== R[h =====================
#define     TOKEN_COND_ALWAYS                    (110)     // "al"
#define     TOKEN_COND_ZERO                      (111)     // "eq"
#define     TOKEN_COND_NOT_ZERO                  (112)     // "ne"
#define     TOKEN_COND_UNSIGNED_HIGHER_OR_SAME   (113)     // "hs"
#define     TOKEN_COND_UNSIGNED_LOWER            (114)     // "lo"
#define     TOKEN_COND_MINUS                     (115)     // "mi"
#define     TOKEN_COND_PLUS                      (116)     // "pl"
#define     TOKEN_COND_OVERFLOW                  (117)     // "vs"
#define     TOKEN_COND_NOT_OVERFLOW              (118)     // "vc"
#define     TOKEN_COND_UNSIGNED_HIGHER           (119)     // "hi"
#define     TOKEN_COND_UNSIGNED_LOWER_OR_SAME    (120)     // "ls"
#define     TOKEN_COND_SIGNED_GRATER_THAN_OR_EQ  (121)     // "ge"
#define     TOKEN_COND_SIGNED_LESS_THAN          (122)     // "lt"
#define     TOKEN_COND_SIGNED_GRATER_THAN        (123)     // "gt"
#define     TOKEN_COND_SIGNED_LESS_THAN_OR_EQ    (124)     // "le"

//===== 萔&؂蕶 =====================
#define     TOKEN_SQUARE_L          (132)       // [
#define     TOKEN_SQUARE_R          (133)       // ]
#define     TOKEN_BRACE_L           (134)       // {
#define     TOKEN_BRACE_R           (135)       // }
#define     TOKEN_BRACKET_L         (136)       // (
#define     TOKEN_BRACKET_R         (137)       // )
#define     TOKEN_COLON             (138)       // :
#define     TOKEN_SEMICOLON         (139)       // ;
#define     TOKEN_COMMA             (140)       // ,
#define     TOKEN_PERIOD            (141)       // .
#define     TOKEN_NOT               (143)       // ~
#define     TOKEN_PLUS              (146)       // +
#define     TOKEN_MINUS             (147)       // -
#define     TOKEN_ASTERISK          (148)       // *
#define     TOKEN_DIV               (149)       // /
#define     TOKEN_MOD               (150)       // %
#define     TOKEN_AMPERSAND         (151)       // &
#define     TOKEN_OR                (152)       // |
#define     TOKEN_XOR               (153)       // ^
#define     TOKEN_SHIFT_L           (154)       // <<
#define     TOKEN_SHIFT_R           (155)       // >>
#define     TOKEN_EQ                (165)       // =
#define     TOKEN_LF                (169)       // s

//=== g[N.ʎq.e ===
#define     TOKEN_IDENTIFIER        (170)       // ʎq
#define     TOKEN_STRING_LITERAL    (171)       // 񃊃e
#define     TOKEN_NUMERIC_LITERAL   (172)       // le

//===== \ =====================
//#define     TOKEN_P3CC_ASM_OUT      (180)   // .P3CC_ASM_OUT
//#define     TOKEN_SRCFILE           (181)   // .SRCFILE
//#define     TOKEN_ENDSRCFILE        (182)   // .ENDSRCFILE
#define     TOKEN_FUNCTION          (183)   // .FUNCTION
#define     TOKEN_ENDFUNCTION       (184)   // .ENDFUNCTION
#define     TOKEN_CODE              (185)   // .CODE
#define     TOKEN_EXTERNAL_FUNC     (186)   // .EXTERNAL_FUNC
#define     TOKEN_EXTERNAL_VAR      (187)   // .EXTERNAL_VAR
#define     TOKEN_GLOBAL_VAR        (188)   // .GLOBAL_VAR
#define     TOKEN_LOCAL_VAR         (189)   // .LOCAL_VAR
#define     TOKEN_ARG               (190)   // .ARG
#define     TOKEN_EQU               (191)   // .EQUŐ錾ꂽ萔́A.P3CC_ASM_OUT܂܂Ȃ\[XSŗLɂȂ
#define     TOKEN_GLOBAL_BASE       (192)   // .GLOBAL_BASE_ADDRESS

#define     TOKEN_PcOffsetOf        (200)   // PcOffsetOf()
#define     TOKEN_FpOffsetOf        (201)   // FpOffsetOf()
#define     TOKEN_GpOffsetOf        (202)   // GpOffsetOf()
#define     TOKEN_GpOffsetHiOf      (203)   // GpOffsetHiOf()
#define     TOKEN_GpOffsetLoOf      (204)   // GpOffsetLoOf()
#define     TOKEN_AddressOf         (205)   // AddressOf()
#define     TOKEN_AddressHiOf       (206)   // AddressHiOf()
#define     TOKEN_AddressLoOf       (207)   // AddressLoOf()
#define     TOKEN_EntryPointOf      (208)   // EntryPointOf()
#define     TOKEN_EntryPointHiOf    (209)   // EntryPointHiOf()
#define     TOKEN_EntryPointLoOf    (210)   // EntryPointHiOf()
#define     TOKEN_SizeOfGlobals     (211)   // $SizeOfGlobals$
#define     TOKEN_OffsetOfGlobals   (212)   // $OffsetOfGlobals$ AZuŎvZꂽO[oϐ̈̐擪AhX
#define     TOKEN_SizeOfGlobals0    (213)   // $SizeOfGlobals0$  lȂ(Öق0jO[oϐ̈̃TCY
#define     TOKEN_SizeOfGlobals1    (214)   // $SizeOfGlobals1$  lO[oϐ̈̃TCY@l̈̐擪́iO[oϐ̈̐擪{$SizeOfGlobals0$j
#define     TOKEN_InitialValue      (215)   // $InitialValue$  lϐ̏l̐擪AhX

#define     TOKEN_NON               (220)   // non
#define     TOKEN_R0                (221)   // r0
#define     TOKEN_R1                (222)   // r1
#define     TOKEN_R2                (223)   // r2
#define     TOKEN_R3                (224)   // r3
#define     TOKEN_R4                (225)   // r4
#define     TOKEN_R5                (226)   // r5
#define     TOKEN_R6                (227)   // r6
#define     TOKEN_R7                (228)   // r7
#define     TOKEN_R8                (229)   // r8
#define     TOKEN_R9                (230)   // r9
#define     TOKEN_R10               (231)   // r10
#define     TOKEN_R11               (232)   // r11
#define     TOKEN_R12               (233)   // r12
#define     TOKEN_R13               (234)   // r13
#define     TOKEN_R14               (235)   // r14
#define     TOKEN_R15               (236)   // r15
#define     TOKEN_SR                (237)   // sr
#define     TOKEN_ISR               (238)   // isr
#define     TOKEN_FP                (239)   // fp
#define     TOKEN_GP                (240)   // gp
#define     TOKEN_SP                (241)   // sp
#define     TOKEN_LR                (242)   // lr
#define     TOKEN_ILR               (243)   // ilr
#define     TOKEN_PC                (244)   // pc


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// HEXR[h֘A
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

#define     OPERAND_IS_IMM      0x10000000

#define     HEXCODE_JP          0x00000000
#define     HEXCODE_CALL        0x20000000
#define     HEXCODE_RTS         0x60D00000
#define     HEXCODE_DJP         0x60000000
#define     HEXCODE_RTI         0x40E00000

#define     HEXCODE_LDW         0x80000000
#define     HEXCODE_LDWUB       0x81000000
#define     HEXCODE_LDWUA       0x82000000
#define     HEXCODE_LDH         0x83000000
#define     HEXCODE_LDHUB       0x84000000
#define     HEXCODE_LDHUA       0x85000000
#define     HEXCODE_LDB         0x86000000
#define     HEXCODE_LDBUB       0x87000000
#define     HEXCODE_LDBUA       0x88000000
#define     HEXCODE_LDSH        0x89000000
#define     HEXCODE_LDSHUB      0x8A000000
#define     HEXCODE_LDSHUA      0x8B000000
#define     HEXCODE_LDSB        0x8C000000
#define     HEXCODE_LDSBUB      0x8D000000
#define     HEXCODE_LDSBUA      0x8E000000

#define     HEXCODE_STW         0xA0000000
#define     HEXCODE_STWUB       0xA1000000
#define     HEXCODE_STWUA       0xA2000000
#define     HEXCODE_STH         0xA3000000
#define     HEXCODE_STHUB       0xA4000000
#define     HEXCODE_STHUA       0xA5000000
#define     HEXCODE_STB         0xA6000000
#define     HEXCODE_STBUB       0xA7000000
#define     HEXCODE_STBUA       0xA8000000
#define     HEXCODE_DRAIN       0xBFF00000

#define     HEXCODE_POP         0x92000004
#define     HEXCODE_PUSH        0xB100FFFC


#define     HEXCODE_MOV         0xC00F0000
#define     HEXCODE_MOVL        0xD10F0000
#define     HEXCODE_MOVH        0xD20F0000
#define     HEXCODE_ADD         0xC3000000
#define     HEXCODE_SUB         0xC4000000
#define     HEXCODE_AND         0xC5000000
#define     HEXCODE_OR          0xC6000000
#define     HEXCODE_XOR         0xC7000000
#define     HEXCODE_LSR         0xC8000000
#define     HEXCODE_LSL         0xC9000000
#define     HEXCODE_ASR         0xCA000000
#define     HEXCODE_MUL         0xCB000000
#define     HEXCODE_DIVU        0xCC000000
#define     HEXCODE_DIV         0xCD000000
#define     HEXCODE_MODU        0xCE000000
#define     HEXCODE_MOD         0xCF000000

#define     HEXCODE_DI          0xE0000000
#define     HEXCODE_EI          0xE8000000
#define     HEXCODE_DIC         0xE1000000
#define     HEXCODE_EIC         0xE9000000
#define     HEXCODE_DDC         0xE2000000
#define     HEXCODE_EDC         0xEA000000
#define     HEXCODE_BLK         0xEB000000
#define     HEXCODE_BULK        0xE3000000
#define     HEXCODE_BREAK       0xFEFFFFFF
#define     HEXCODE_NOP         0xFFFFFFFF

#define     HEXCODE_CPRD        0xF0000000
#define     HEXCODE_CPWR        0xF1000000

#define     COND_EQ             0x01000000
#define     COND_NE             0x02000000
#define     COND_HS             0x03000000
#define     COND_LO             0x04000000
#define     COND_MI             0x05000000
#define     COND_PL             0x06000000
#define     COND_VS             0x07000000
#define     COND_VC             0x08000000
#define     COND_HI             0x09000000
#define     COND_LS             0x0A000000
#define     COND_GE             0x0B000000
#define     COND_LT             0x0C000000
#define     COND_GT             0x0D000000
#define     COND_LE             0x0E000000
#define     COND_AL             0x00000000

#define     REG_NUM_NON         (15)
#define     REG_NUM_ISR         (17)
#define     REG_NUM_SR          (18)
#define     REG_NUM_FP          (11)
#define     REG_NUM_GP          (10)
#define     REG_NUM_SP          (12)
#define     REG_NUM_LR          (13)
#define     REG_NUM_ILR         (14)
#define     REG_NUM_PC          (15)

//=====================================================================================================
//  TYPEDEF
//=====================================================================================================
//============================================================
//======== ̓\[Xt@CǗ֌W ========================
//============================================================
//\[Xt@CXg̍\vf
typedef struct InputSrcFileInfo_t{
    char        *FileName;      // t@C
    BiDirList   *SrcList;       // ̃XgevfɃ\[XPsi[iHpj
    BiDirList   *OrgSrcList;    // ̃XgevfɃ\[XPsi[iIWiۑĂpj
    BiDirList   *TokenList;     // g[ÑXgiXgoTokenInfoj
    BiDirList   *EquList;       // .EQȔ
    BiDirList   *FunctionList;  // ֐XgiXgoFunctionj
} InputSrcFileInfo;

//============================================================
//===== ͊֘A =========================================
//============================================================


//=== InputSrcFileInfôPo֘A ===
#define     GET_CHAR_MODE_INIT      (0)
#define     GET_CHAR_MODE_NOMAL     (1)
#define     GET_CHAR_MODE_BACK      (2)

//=== le̓[h ===
#define     NUMLITERAL_DEC_MODE     (0)
#define     NUMLITERAL_HEX_READY    (1)
#define     NUMLITERAL_HEX_MODE     (2)

//=== l(萔)e̓[h ===
#define     NUMSTRLITERAL_NOMAL     (0)
#define     NUMSTRLITERAL_ESCAPE    (1)

//=== .EQȔ
struct EquInfo_t{
    char    *BeforeStr; // u̕
    char    *AfterStr;  // u̕
};
typedef struct EquInfo_t EquInfo;

//=== ͂Ő؂og[Ni[ׂ̃e[u\vf
struct TokenInfo_t{
    int     Type;           // g[N
    char    *FileName;      // ǂ̃t@C
    int     Line;           // \[X̉sڂ؂oꂽ
    void    *ExtInfo;       // ʂAʎqA񃊃eAlêꂩłꍇɁAꂼ
                            // i[e[uANZXׂ̃|C^
                            // ʎq           ʎqւ̃|C^
                            // 񃊃e   񃊃eւ̃|C^
                            // le     unsigned longւ̃|C^
} ;
typedef struct TokenInfo_t TokenInfo;

//=== \[X當oׂɎgnh ===
struct SrcListAccessHandle_t{
        BiDirList   *SrcList;
        int         TotalLine;
        int         LineNo;
        int         CharNo;
};


//============================================================
//===== \/Ӗ  R[h֘A ======================
//============================================================
#define             VARIABLE_GLOBAL         (0)
#define             VARIABLE_LOCAL          (1)
#define             VARIABLE_ARG            (2)

//=============== ϐ̏l =================================
typedef struct Initializer_t{
    unsigned char   InitVal;//l
    unsigned char   StrNo;  //  l񃊃e̕ւ̃|C^ƂƁA
                            //  邢́Alʎq(֐)֐ւ̃|C^Ƃ
                            //  ĺAzu܂ȂƋ߂ȂB
                            //  ďl͂Ƃ肠SoCg̗̈m
                            //    3=[31:24], 2=[23:16], 1=[15:8], 0:[7:0]
    unsigned char   Type;   // TOKEN_NUMERIC_LITERAL / TOKEN_STRING_LITERAL / TOKEN_IDENTIFIER
    char            *Str;
} Initializer;

//=============== ϐ =================================
typedef struct Variable_t{
    char            *Name;  // ʎq
    unsigned long   Size;   // TCY
    long            Offset; // ItZbg
    int             OffsetIsValid; // 0:, 1:L
    BiDirList       *InitializerList; // l񃊃XgioInitializerj
} Variable;

//=============== R[h =================================
typedef struct CodeInfo_t{
    int             Line;
    char            *Label;
    int             StartTokenIndex;
    int             NumOfToken;
    unsigned long   Address;
    unsigned long   Offset;
    unsigned long   HexCode;
} CodeInfo;

//=============== ֐ =================================
typedef struct Function_t{
    char            *Name;
    char            *FileName;
    unsigned long   EntryAddress;   // ֐̃AhX
    unsigned long   CodeSize;       // ֐TCY
    BiDirList       *ArgList;       // ̃XgioVariablej
    BiDirList       *LocalList;     // [Jϐ̃XgioVariablej
    BiDirList       *CodeList;      // R[h̃XgioCodeInfoj
} Function;

//=============== g[NANZXpnh =================================
typedef struct TokenAccessHandler_t{
    //int                   AnalysisMode;
    InputSrcFileInfo    *SrcInfo;
    int                 TokenIndex;
    int                 NumOfToken;
    Function            *f;
} TokenAccessHandler;
