//============================================================
//  TARGET SYSTEM : Psm3Core (Processor Study Model 3 Core)
//  FUNCTION      : Psm3 C Compiler (vvZbT)
//
//                  Copyright (C) 2009-2010 by Tomoyuki Inomoto
//=============================================================

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//X  Ƃ肠Borland̃vvZbT(cpp32.exe)̗͂؂ X
//X  ́AIWĩvvZbT\           X
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX


#include    <stdio.h>
#include    <stdlib.h>
#include    <string.h>

#include    "p3cc.h"

//=========================================================
//  GLOBAL
//=========================================================
//=========================================================
//  PROTOTYPE
//=========================================================
static int  call_cpp32exe(char *SrcFileName, cc0_result *Cc0Res);
static int  source_name_table_init(cc0_source_file *SrcFileTbl);
static int  source_name_table_add(cc0_source_file *SrcFileTbl, char *FileName, int *Count);

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// vvZbTTOP
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//=========================================================
// [@\] vvZbT
// [] t@C
// [] cc0_resultւ̃|C^
// [Ԓl] P3CC_OKP3CC_NGԂB
//=========================================================
int p3cc0(char *SrcFileName, cc0_result *Cc0Res)
{
    int         Ret;

#ifdef CC_MSGENABLE
    fprintf(MsgOut, "cpp32.exe(Borland̃vvZbT)sB\n");
#endif

    Ret = call_cpp32exe(SrcFileName, Cc0Res);

#ifdef CC0_DEBUG
    if(Ret == P3CC_OK) Print_cc0_result(Cc0Res);
#endif

    return Ret;
}
//=========================================================
// [@\] cc0_resultcc0_result_handleŎꂽ
//        ʒu̓éAƂ̃t@CƍsƂ̍s̓eԂB
// [] cc0_result
// [] cc0_result_handle
// [] \[Xt@Ci[z|C^ւ̃|C^
// [] si[ϐւ̃|C^
// [] \[Xt@C̊Ys̓ei[z|C^ւ̃|C^
// [Ԓl]
//=========================================================
int GetSrcInfoFromCc0Res(cc0_result *Cc0Res, cc0_result_handle *Handle, char **SrcFile, int *LineNo, char **SrcCode)
{
    int FileNo;

    *LineNo = Cc0Res->SrcTbl[Handle->SrcTblIndex].SourceLineNo;
    *SrcCode = Cc0Res->SrcTbl[Handle->SrcTblIndex].SourceCode;
    FileNo  = Cc0Res->SrcTbl[Handle->SrcTblIndex].SourceFileNo;
    *SrcFile = (char *)&Cc0Res->SrcFileTbl[FileNo].FileName[0];
    return P3CC_OK;
}
//=========================================================
// [@\] cc0_result̓et@Cɏo
// [] source_name_tableւ̃|C^
// [Ԓl] ȂB
//=========================================================
void    Print_cc0_result(cc0_result *Cc0Res)
{
    FILE        *Fp;
    int         i;
    int         FileNo;
    int         LineNo;
    char        *File;
    char        *SrcCode;

    Fp = fopen("cc0_result.txt", "w");
    fprintf(Fp, "=====================================\n");
    fprintf(Fp, "===        CC0 RESULT            ====\n");
    fprintf(Fp, "=====================================\n");
    for(i=0; i<Cc0Res->NumOfSrcLine;i++){
        FileNo = Cc0Res->SrcTbl[i].SourceFileNo;
        LineNo = Cc0Res->SrcTbl[i].SourceLineNo;
        File = Cc0Res->SrcFileTbl[FileNo].FileName;
        SrcCode = Cc0Res->SrcTbl[i].SourceCode;
        fprintf(Fp, "%s : %d : %s\n", File, LineNo, SrcCode);
    }
    fclose(Fp);
}
//=========================================================
// [@\] vvZbT i[p̈m
// [] cc0_resultւ̃|C^
// [Ԓl] P3CC_OKP3CC_NGԂB
//=========================================================
int P3cc0ResultAreaGet(cc0_result *Cc0Res, int Line)
{
    Cc0Res->SrcTbl  = calloc(Line  , sizeof(cc0_source_data));
    if(Cc0Res->SrcTbl == NULL){
        fprintf(MsgOut, "yG[zvvZbTʊi[p̈mێs TCY%dKoCg\n", (Line * sizeof(cc0_source_data)) / (1024) );
        return P3CC_NG;
    }
    Cc0Res->SrcFileTbl  = calloc(MAX_SOURCE_FILE  , sizeof(cc0_source_file));
    if(Cc0Res->SrcFileTbl == NULL){
        fprintf(MsgOut, "yG[zvvZbTʊi[pit@Ce[uj̈mێs TCY%dKoCg\n", (MAX_SOURCE_FILE * sizeof(cc0_source_file)) / (1024) );
        free(Cc0Res->SrcTbl);
        return P3CC_NG;
    }

#ifdef CC_MSGENABLE
    fprintf(MsgOut, "vvZbTʊi[p̈mې TCY%dKoCg\n", ((Line * sizeof(cc0_source_data)) + (MAX_SOURCE_FILE * sizeof(cc0_source_file))) / (1024) );
#endif

    source_name_table_init(Cc0Res->SrcFileTbl);

    return P3CC_OK;
}
//=========================================================
// [@\] vvZbT i[p̈
// [] cc0_resultւ̃|C^
// [Ԓl] P3CC_OKP3CC_NGԂB
//=========================================================
int P3cc0ResultAreaFree(cc0_result *Cc0Res)
{
    free(Cc0Res->SrcTbl);
    free(Cc0Res->SrcFileTbl);
    return P3CC_OK;
}

//=========================================================
// [@\] cc0_resultꕶǂݍ݁Acc0_result_handleXV
// [] cc0_result_handle
// [Ԓl] ǂݍ񂾕iŌ܂łNULLԂj
//=========================================================
char GetCharFromCc0Res(cc0_result *Cc0Res, cc0_result_handle *Handle)
{
    char        Ret;
    while(1){
        Ret = Cc0Res->SrcTbl[Handle->SrcTblIndex].SourceCode[Handle->CodeIndex];
        if(Ret != '\0'){
            break;
        }
        else{
            if(Handle->SrcTblIndex == Cc0Res->NumOfSrcLine - 1){ // Ōォǂ
                break;
            }
            else{
                Handle->SrcTblIndex += 1;
                Handle->CodeIndex = 0;
            }
        }
    }
    Handle->CodeIndex += 1;
    return Ret;
}
//=========================================================
// [@\] cc0_result_handle̍sɐi߂
// [] cc0_result_handle
// [Ԓl] P3CC_OK
//=========================================================
char ForwardCc0ResHandleOneLine(cc0_result *Cc0Res, cc0_result_handle *Handle)
{
    char        Ret;

    if(Handle->SrcTblIndex == Cc0Res->NumOfSrcLine - 1){
        while(1){
            Ret = Cc0Res->SrcTbl[Handle->SrcTblIndex].SourceCode[Handle->CodeIndex];
            if(Ret == '\0') break;
            Handle->CodeIndex += 1;
        }
    }
    else{
        Handle->SrcTblIndex += 1;
        Handle->CodeIndex = 0;
    }

    return Ret;
}

//=========================================================
// [@\] cc0_result_handleRs[
// [] Rs[cc0_result_handle
// [] Rs[cc0_result_handle
// [Ԓl] ȂB
//=========================================================
void CopyCc0ResHndle(cc0_result_handle *d, cc0_result_handle *s)
{
    d->SrcTblIndex  = s->SrcTblIndex;
    d->CodeIndex    = s->CodeIndex;
}

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//=========================================================
// [@\] cpp32.exeĂяoāAʂcc0_result֊i[
// [] \[Xt@C
// [] cc0_resultւ̃|C^
// [Ԓl] P3CC_OKԂBG[̏ꍇP3CC_NG
//=========================================================
static int  call_cpp32exe(char *SrcFileName, cc0_result *Cc0Res)
{
    int         Ret;
    int         i,j;
    char        *s;
    char        *p;
    FILE        *Fp;
    char        PreProOutFile[MAX_SOURCE_FILE_NAME_CHAR];
    char        Buf[MAX_SOURCE_LINE_CHAR * 2];

    //========== OvvZbTs =======================
    sprintf(PreProOutFile, "cpp32.exe %s\n", SrcFileName);
    system(PreProOutFile);
    FileExtensionSwitch(SrcFileName, PreProOutFile, "i");

    //========== Ƃ肠ʂs邩JEg =======================
    Fp = fopen(PreProOutFile, "r");
    if(Fp==NULL){
        fprintf(MsgOut, "yG[z(p3cc0  LINE:%d) t@C(%s)I[vs\n", __LINE__, PreProOutFile);
        return P3CC_NG;
    }
    i = 0;
    while(1){
        if(feof(Fp)) break;
        fgets(Buf, (MAX_SOURCE_LINE_CHAR * 2) - 1, Fp);
        ++i;
        if(i == MAX_SOURCE_LINE - 1){
            fprintf(MsgOut, "yG[z(p3cc0  LINE:%d) t@C̓CI[o[\n", __LINE__);
            return P3CC_NG;
        }
    }
    fclose(Fp);

    // vvZbTʊi[p̈m
    Ret = P3cc0ResultAreaGet(Cc0Res, i+1);
    if(Ret == P3CC_NG) return Ret;


    //========== ʂ̓Ǎ =======================
    Fp = fopen(PreProOutFile, "r");
    i = 0;
    j = 0;
    while(1){
        if(feof(Fp)) break;
        fgets(Buf, (MAX_SOURCE_LINE_CHAR * 2) - 1, Fp);
        if(strlen(Buf) > MAX_SOURCE_LINE_CHAR - 1){
            fprintf(MsgOut, "yG[z(p3cc0  LINE:%d)FPs̕(%d)I[o[ %s%ds\n", __LINE__, MAX_SOURCE_LINE_CHAR, PreProOutFile, i);
            fclose(Fp);
            return P3CC_NG;
        }

        s=Buf;
        if(*s != '/') continue;
        ++s;++s;++s;
        p = strtok(s, " ");//t@C
        Ret = source_name_table_add(Cc0Res->SrcFileTbl, p, &j);
        if(Ret == P3CC_NG){
            fclose(Fp);
            return P3CC_NG;
        }
        Cc0Res->SrcTbl[i].SourceFileNo = Ret;


        p = strtok(NULL, " :");//s
        Cc0Res->SrcTbl[i].SourceLineNo = atoi(p);

        p = strtok(NULL, "/");//\[X{
        p = strtok(NULL, "\n");//\[X{
        if(p!=NULL){
            strcpy(Cc0Res->SrcTbl[i].SourceCode, p);
            strcat(Cc0Res->SrcTbl[i].SourceCode, " ");
        }
        else{
            Cc0Res->SrcTbl[i].SourceCode[0] = '\0';
        }

        ++i;
        if(i == MAX_SOURCE_LINE - 1){
            fprintf(MsgOut, "yG[z(p3cc0  LINE:%d) t@C̓CI[o[\n", __LINE__);
            fclose(Fp);
            return P3CC_NG;
        }
    }

    Cc0Res->NumOfSrcLine = i;
    Cc0Res->NumOfSrcFile = j;
    fclose(Fp);

    return  P3CC_OK;
}

//=========================================================
// [@\] source_name_table
// [] source_name_tableւ̃|C^
// [Ԓl] P3CC_OKԂB
//=========================================================
static int  source_name_table_init(cc0_source_file *SrcFileTbl)
{
    int         i;
    for(i=0; i < MAX_SOURCE_FILE; i++) SrcFileTbl[i].FileName[0] = '\0';
    return  P3CC_OK;
}
//=========================================================
// [@\] source_name_tableɖo^̃t@CȂǉo^
// [] source_name_tableւ̃|C^
// [] o^t@C
// [Ԓl] o^A͓o^ς݂IndexԂB
//        o^\ȃt@C𒴂ꍇ́AP3CC_NGԂ
//=========================================================
static int  source_name_table_add(cc0_source_file *SrcFileTbl, char *FileName, int *Count)
{
    int         i;
    for(i=0; i < MAX_SOURCE_FILE; i++){
        if(strcmp(SrcFileTbl[i].FileName, FileName) == 0) return i;
    }
    for(i=0; i < MAX_SOURCE_FILE; i++){
        if(SrcFileTbl[i].FileName[0] == '\0'){
            strcpy(SrcFileTbl[i].FileName, FileName);
            *Count = *Count + 1;
            return i;
        }
    }
    fprintf(MsgOut, "yG[z(p3cc0  LINE:%d) o^\ȃt@CI[o[\n",__LINE__);
    return P3CC_NG;
}
