﻿//=======================================================================
//  TARGET PROJECT: PSM3(Prosessor Study Model3)
//  FUNCTION      : Debugger
//
//                      Copyright (C) 2008 by Tomoyuki Inomoto
//=======================================================================
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace Psm3Debugger
{
    public partial class MemBox : UserControl
    {
        public const uint P3DBG_OK = 0;
        public const uint P3DBG_NG = 1;

        public uint DataNo;
        public uint DataUpDataFlag;
        public uint TopAddress;
        public uint AddressUpDataFlag;
        public uint ScrollFlag;
        public uint RefreshFlag;

        //=　コンストラクタ =================================
        public MemBox()
        {
            InitializeComponent();
            AddressUpDataFlag = 0;
            DataUpDataFlag = 0;
            RefreshFlag = 0;
            TopAddress = 0;
            ScrollFlag = 0;
        }
        //=　[更新]ボタン =================================
        private void MemRefreshBtn_Click(object sender, EventArgs e)
        {
            RefreshFlag = 1;
        }
        //=　[アドレスのテキストBOX]をDoubleClick =================================
        private void AdrLine0_DoubleClick(object sender, EventArgs e)
        {
            AddressUpDataFlag = 1;
        }
        //=　共通関数[レジスタ値をGUIへ反映] =================================
        public uint MemValueSet2GUI(ref uint[] MEM, ref uint[] OLD_MEM)
        {
            int i;
            Data0.Text = String.Format("{0:X8}", MEM[0]);
            if (OLD_MEM[0] != MEM[0]) Data0.ForeColor = Color.Blue;
            else Data0.ForeColor = Color.Black;
            Data1.Text = String.Format("{0:X8}", MEM[1]);
            if (OLD_MEM[1] != MEM[1]) Data1.ForeColor = Color.Blue;
            else Data1.ForeColor = Color.Black;
            Data2.Text = String.Format("{0:X8}", MEM[2]);
            if (OLD_MEM[2] != MEM[2]) Data2.ForeColor = Color.Blue;
            else Data2.ForeColor = Color.Black;
            Data3.Text = String.Format("{0:X8}", MEM[3]);
            if (OLD_MEM[3] != MEM[3]) Data3.ForeColor = Color.Blue;
            else Data3.ForeColor = Color.Black;
            Data4.Text = String.Format("{0:X8}", MEM[4]);
            if (OLD_MEM[4] != MEM[4]) Data4.ForeColor = Color.Blue;
            else Data4.ForeColor = Color.Black;
            Data5.Text = String.Format("{0:X8}", MEM[5]);
            if (OLD_MEM[5] != MEM[5]) Data5.ForeColor = Color.Blue;
            else Data5.ForeColor = Color.Black;
            Data6.Text = String.Format("{0:X8}", MEM[6]);
            if (OLD_MEM[6] != MEM[6]) Data6.ForeColor = Color.Blue;
            else Data6.ForeColor = Color.Black;
            Data7.Text = String.Format("{0:X8}", MEM[7]);
            if (OLD_MEM[7] != MEM[7]) Data7.ForeColor = Color.Blue;
            else Data7.ForeColor = Color.Black;
            Data8.Text = String.Format("{0:X8}", MEM[8]);
            if (OLD_MEM[8] != MEM[8]) Data8.ForeColor = Color.Blue;
            else Data8.ForeColor = Color.Black;
            Data9.Text = String.Format("{0:X8}", MEM[9]);
            if (OLD_MEM[9] != MEM[9]) Data9.ForeColor = Color.Blue;
            else Data9.ForeColor = Color.Black;
            Data10.Text = String.Format("{0:X8}", MEM[10]);
            if (OLD_MEM[10] != MEM[10]) Data10.ForeColor = Color.Blue;
            else Data10.ForeColor = Color.Black;
            Data11.Text = String.Format("{0:X8}", MEM[11]);
            if (OLD_MEM[11] != MEM[11]) Data11.ForeColor = Color.Blue;
            else Data11.ForeColor = Color.Black;
            Data12.Text = String.Format("{0:X8}", MEM[12]);
            if (OLD_MEM[12] != MEM[12]) Data12.ForeColor = Color.Blue;
            else Data12.ForeColor = Color.Black;
            Data13.Text = String.Format("{0:X8}", MEM[13]);
            if (OLD_MEM[13] != MEM[13]) Data13.ForeColor = Color.Blue;
            else Data13.ForeColor = Color.Black;
            Data14.Text = String.Format("{0:X8}", MEM[14]);
            if (OLD_MEM[14] != MEM[14]) Data14.ForeColor = Color.Blue;
            else Data14.ForeColor = Color.Black;
            Data15.Text = String.Format("{0:X8}", MEM[15]);
            if (OLD_MEM[15] != MEM[15]) Data15.ForeColor = Color.Blue;
            else Data15.ForeColor = Color.Black;

            AdrLine0.Text = String.Format("{0:X8}", TopAddress);
            AdrLine1.Text = String.Format("{0:X8}", TopAddress + 4 * 1);
            AdrLine2.Text = String.Format("{0:X8}", TopAddress + 4 * 2);
            AdrLine3.Text = String.Format("{0:X8}", TopAddress + 4 * 3);
            AdrLine4.Text = String.Format("{0:X8}", TopAddress + 4 * 4);
            AdrLine5.Text = String.Format("{0:X8}", TopAddress + 4 * 5);
            AdrLine6.Text = String.Format("{0:X8}", TopAddress + 4 * 6);
            AdrLine7.Text = String.Format("{0:X8}", TopAddress + 4 * 7);
            AdrLine8.Text = String.Format("{0:X8}", TopAddress + 4 * 8);
            AdrLine9.Text = String.Format("{0:X8}", TopAddress + 4 * 9);
            AdrLine10.Text = String.Format("{0:X8}", TopAddress + 4 * 10);
            AdrLine11.Text = String.Format("{0:X8}", TopAddress + 4 * 11);
            AdrLine12.Text = String.Format("{0:X8}", TopAddress + 4 * 12);
            AdrLine13.Text = String.Format("{0:X8}", TopAddress + 4 * 13);
            AdrLine14.Text = String.Format("{0:X8}", TopAddress + 4 * 14);
            AdrLine15.Text = String.Format("{0:X8}", TopAddress + 4 * 15);

            for (i = 0; i < 16; i++)
            {
                OLD_MEM[i] = MEM[i];
            }
            return P3DBG_OK;
        }
        //=　[データのテキストBOX]をDoubleClick =================================
        private void Data0_DoubleClick(object sender, EventArgs e)
        {
            DataNo = 0;
            DataUpDataFlag = 1;
        }
        private void Data1_DoubleClick(object sender, EventArgs e)
        {
            DataNo = 1;
            DataUpDataFlag = 1;
        }
        private void Data2_DoubleClick(object sender, EventArgs e)
        {
            DataNo = 2;
            DataUpDataFlag = 1;
        }
        private void Data3_DoubleClick(object sender, EventArgs e)
        {
            DataNo = 3;
            DataUpDataFlag = 1;
        }
        private void Data4_DoubleClick(object sender, EventArgs e)
        {
            DataNo = 4;
            DataUpDataFlag = 1;
        }
        private void Data5_DoubleClick(object sender, EventArgs e)
        {
            DataNo = 5;
            DataUpDataFlag = 1;
        }
        private void Data6_DoubleClick(object sender, EventArgs e)
        {
            DataNo = 6;
            DataUpDataFlag = 1;
        }
        private void Data7_DoubleClick(object sender, EventArgs e)
        {
            DataNo = 7;
            DataUpDataFlag = 1;
        }
        private void Data8_DoubleClick(object sender, EventArgs e)
        {
            DataNo = 8;
            DataUpDataFlag = 1;
        }
        private void Data9_DoubleClick(object sender, EventArgs e)
        {
            DataNo = 9;
            DataUpDataFlag = 1;
        }
        private void Data10_DoubleClick(object sender, EventArgs e)
        {
            DataNo = 10;
            DataUpDataFlag = 1;
        }
        private void Data11_DoubleClick(object sender, EventArgs e)
        {
            DataNo = 11;
            DataUpDataFlag = 1;
        }
        private void Data12_DoubleClick(object sender, EventArgs e)
        {
            DataNo = 12;
            DataUpDataFlag = 1;
        }
        private void Data13_DoubleClick(object sender, EventArgs e)
        {
            DataNo = 13;
            DataUpDataFlag = 1;
        }
        private void Data14_DoubleClick(object sender, EventArgs e)
        {
            DataNo = 14;
            DataUpDataFlag = 1;
        }
        private void Data15_DoubleClick(object sender, EventArgs e)
        {
            DataNo = 15;
            DataUpDataFlag = 1;
        }

        //=　UP/DOWNボタン =================================
        private void Dwn8Btn_Click(object sender, EventArgs e)
        {
            if (TopAddress >= 8 * 4) TopAddress -= (8 * 4);
            else TopAddress = 0;
            ScrollFlag = 1;
        }
        private void Dwn1Btn_Click(object sender, EventArgs e)
        {
            if (TopAddress >= 4) TopAddress -= (4);
            else TopAddress = 0;
            ScrollFlag = 1;
        }
        private void Up1Btn_Click(object sender, EventArgs e)
        {
            if (TopAddress <= (0xFFFFFFFC - (15 * 4) - (4))) TopAddress += (4);
            else TopAddress = 0xFFFFFFFC - (15 * 4);
            ScrollFlag = 1;
        }
        private void Up8Btn_Click(object sender, EventArgs e)
        {
            if (TopAddress <= (0xFFFFFFFC - (15 * 4) - (8 * 4))) TopAddress += (8 * 4);
            else TopAddress = 0xFFFFFFFC - (15 * 4);
            ScrollFlag = 1;
        }
    }
}
