//============================================================
//  TARGET SYSTEM : Psm3Core (Processor Study Model 3 Core)
//  FUNCTION      : Psm3 C Compiler (\/Ӗ/ԃR[h)
//
//                  Copyright (C) 2009-2010 by Tomoyuki Inomoto
//=============================================================
#include    <stdio.h>
#include    <stdlib.h>
#include    <string.h>


#include    "p3cc.h"

#define     OUTSIDE_OF_FUNCTION     (0)
#define     INSIDE_OF_FUNCTION      (1)
#define     ARG_DEC_OF_FUNCTION     (2)

#define     TYPEDEF_ANALYSIS        (0)
#define     VARIABLE_ANALYSIS       (1)
#define     STRUCT_MEMBER_ANALYSIS  (2)
#define     ARG_ANALYSIS            (3)
#define     FPOINTER_ARG_ANALYSIS   (4)
#define     CAST_ANALYSIS           (5)

#define     PROGRAM_LABEL_INDENT_WIDTH (16)


//============================================================================================================
//============================================================================================================
//  EXTERN
//============================================================================================================
//============================================================================================================

//============================================================================================================
//============================================================================================================
//  GLOBAL
//============================================================================================================
//============================================================================================================

//============================================================================================================
//============================================================================================================
//  PRIVATE
//============================================================================================================
//============================================================================================================
//-------- œK ----------------------------------------
static int                  EnableRemoveNop = P3CC_TRUE;          // ̔ѐɎ؂uNOP폜邩ۂ
static int                  EnableBranchOptimaize;                // 򔻒œK邩ۂ

//-------- ̓f[^n ----------------------------------------
static cc0_result           *Cc0Result;
static cc1_result           *Cc1Result;
static cc0_source_file      *SrcFileTbl     ; // \[Xt@Ce[u
static cc0_source_data      *SrcTbl         ; // \[Xe[u
static int                  NumOfToken      ; // g[N
static cc1_token            *TokenTbl       ; // g[Ni[e[u
static cc1_identifier       *IdentifierTbl  ; // ʎqe[u
static cc1_string_literal   *StrLiteralTbl  ; // 񃊃ei[e[u
static cc1_numeric_literal  *NumLiteralTbl  ; // lei[e[u
static int                  TokenIndex = 0  ;

//-------- \͌n ----------------------------------------
static int                  CompoundStatementLevel;
static int                  Location   = 0  ; //ǂ̏Ă邩...֐̓/O/Xg̒
static int                  DeclarationStructLevel = 0;
static function             *CurrentFuncInfo = NULL; //ݏ̊֐̏

static int                  ConstantExpressionErrorFlag;
static int                  ExpressionErrorFlag;

static int                  NumOfLabel = 0;
static short                LoopLevel = 0;
static loop_label_stack     LoopLabelStack; //=== [v̓ƏõxNoL^X^bN

static int                  CallCounter;

//-------- ͌n ----------------------------------------
static int                  GeneratedGprNo;
static vertual_code_list_header SideEffectVCodeHeader;//ppVCodewb_[

//-------- e̕\(Xg) ----------------------------------------
static typedef_info         *TypedefInfoList; //TypedefΉ\
static struct_info          *StructInfoList ; //\̂̌^\
static variable             *ExtVariableList; //Oϐ̏\
static variable             *GlVariableList ; //Globalϐ̏\
static variable             *PvVariableList ; //Privateϐ̏\
static function             *FunctionList   ; //֐̏\

//-------- for Debug ----------------------------------------
static int                  WarningLevel0;
static int                  WarningLevel1;

static int                  TokenReadDebugFlag = 0;
static int                  ConstantExpressionDebugFlag = 0;
static int                  ExpressionDebugFlag = 0;
static int                  ExpressionDebugFlag2 = 0;
static int                  FunctionOptimizeDebugFlag = 0;
static int                  StatementDebugFlag = 0;
static int                  DebugMsgIndentCounter = 0;
static int                  PrintVariableTableFlag = 0;
static int                  PrintFunctionTableFlag = 0;
static int                  PrintCodeFlag = 0;
static int                  PrintVCodeGenProcess = 0;
static char                 CurrentTokenBuf[MAX_SOURCE_LINE_CHAR];
static int                  PrintTabLebel = 0;
static int                  ExpressionOptimizeDbgFlag = 0;
static FILE                 *LogFile;


//============================================================================================================
//============================================================================================================
//  PROTOTYPE
//============================================================================================================
//============================================================================================================
static void     InitCc1ResAcsessPointers(cc0_result *Cc0Res, cc1_result *Cc1Res);

//-------- TOKENn ----------------------------------------
static int      TokenGet(int TokenIndex, int Line);
static char     *TokenSrcFileNameGet(int TokenIndex);
static int      TokenSrcLineGet(int TokenIndex);
static char     *TokenIdStrGet(int TokenIndex);
static char     *TokenStrLiteralGet(int TokenIndex);
static int      TokenSrcFileIndexGet(int TokenIndex);
static char     *TokenSrcFileNameGetBySrcTblIndex(int SrcTblIndex);
static int      TokenNumLiteralValueGet(int TokenIndex);
static int      TokenNumLiteralStyleGet(int TokenIndex);
static cc1_numeric_literal *TokenNumLiteralPtrGet(int TokenIndex);

//-------- ̉͌n̑ -------------------------------------
static int      ProgramAnalysis(void);
static int      Statement(vertual_code_list_header *BodyVCodeListHeader, int Line);
static int      StatementCompound(vertual_code_list_header *BodyVCodeListHeader, int Line);
static int      StatementSingle(vertual_code_list_header *BodyVCodeListHeader, int Line);
static int      StatementIf(vertual_code_list_header *BodyVCodeListHeader, int Line);
static int      StatementGoto(vertual_code_list_header *BodyVCodeListHeader, int Line);
static int      StatementLabel(vertual_code_list_header *BodyVCodeListHeader, int Line);
static int      StatementExpression(vertual_code_list_header *BodyVCodeListHeader, int Line);
static int      StatementReturn(vertual_code_list_header *BodyVCodeListHeader, int Line);
static int      StatementWile(vertual_code_list_header *BodyVCodeListHeader, int Line);
static int      StatementDoWile(vertual_code_list_header *BodyVCodeListHeader, int Line);
static int      StatementFor(vertual_code_list_header *BodyVCodeListHeader, int Line);
static int      StatementSwitch(vertual_code_list_header *BodyVCodeListHeader, int Line);
static int      StatementContinue(vertual_code_list_header *BodyVCodeListHeader, int Line);
static int      StatementBreak(vertual_code_list_header *BodyVCodeListHeader, int Line);

static void     StatementDebugMsg(char *Func, int Status, int Line);

//-------- 錾͌n -------------------------------------
static int      DeclarationTypedef(void);
static int      DeclarationTypeInfoGet(variable *v, int *Flag);
static int      DeclarationVariable(int DecAnalysisMode, void *Target);
static int      DeclarationFunction(void);
static int      DeclarationStruct(variable *v, int *StructDecOnly);
static int      DeclarationStructCheck(variable *v, int  *DefaultPointer, int *DefaultTypeSize, int  *DefaultTotalSize);

//-------- 萔̉͌n̑ -------------------------------------
static int      ConstantExpressionTop(void);
static int      ConstantExpressionBitOr(void);
static int      ConstantExpressionBitXor(void);
static int      ConstantExpressionBitAnd(void);
static int      ConstantExpressionShift(void);
static int      ConstantExpressionAddaptive(void);
static int      ConstantExpressionMultiplicative(void);
static int      ConstantExpressionPrimary(void);

//-------- ̉͌n̑ -------------------------------------
static int      ExpressionGprNoInit(void);
static int      ExpressionGprNoForce(int GprNoForce);
static int      ExpressionNewGprNoGet(void);
static void     ExpressionDebugMsg(expression_analsys_result *RootRet, char *Func, int Status, int Line);

static int      ExpressionSizeof(int *Size, int Line);

static int      ExpressionList(int Mode, expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);
static int      ExpressionAssignment(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);
static int      ExpressionAssignResultTrim(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader);
static int      ExpressionChkStruct(expression_analsys_result *Ret);
static int      ExpressionConvAssignToken2OpToken(int Token);
static int      ExpressionBinomialOpCodeGet(int Token, int Imm, unsigned char *OpCode, char Sign0, char Sign1);
static int      ExpressionChkBinomialOpToken(int Token);
static int      ExpressionChkOperationAndItem(int Token, expression_analsys_result *Arg0, expression_analsys_result *Arg1);
static int      ExpressionUpperRankResultGet(expression_analsys_result *RootRet, expression_analsys_result *Arg0, expression_analsys_result  *Arg1);
static int      ExpressionPointerUnitSizeGet(expression_analsys_result *RootRet);
static int      ExpressionBinomialOperation(
                    expression_analsys_result   *RootRet,
                    vertual_code_list_header    *RootVCodeListHeader,
                    int                         Token,
                    expression_analsys_result   *Arg0,
                    expression_analsys_result   *Arg1,
                    int                         RetRegNo,
                    int                         Line
                );
static int      ExpressionAssignTrim(expression_analsys_result *LeftRet, expression_analsys_result *RightRet, vertual_code_list_header *RightVCodeListHeader);
static int      ExpressionResultTrimRightSide(int Option, expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);
static int      ExpressionResultSizeGet(result_type_info *TypeInfo);
static int      ExpressionConditional(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);
static int      ExpressionPrimary(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);
static int      ExpressionStringLiteral(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);
static int      ExpressionArgList(variable *ArgList, int *ArgNum, vertual_code_list_header *RootVCodeListHeader, int Line);
static int      ExpressionFunctionCall(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);
static int      ExpressionFunctionEntry(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);
static int      ExpressionVariable(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);
static int      ExpressionStructAndArray(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);
static int      ExpressionStruct(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);
static int      ExpressionSetResultByVariable(expression_analsys_result *RootRet, variable *v, int Line);
static int      ExpressionSetResultByFunction(expression_analsys_result *RootRet, function *f, int Line);
static int      ExpressionBasicTypeSizeGetV(variable *v);
static int      ExpressionBasicTypeSizeGetF(function *f);
static int      ExpressionOptiHintAdd(expression_analsys_result *RootRet, vertual_code_list_header *VCodeListHeader);
static int      ExpressionNumeric(expression_analsys_result *RootRet, int Line);
static int      ExpressionNumericBody(expression_analsys_result *RootRet, int Num, char Sign);
static int      ExpressionResultInit(expression_analsys_result *ExprRes);
//static int      ExpressionNumericLoad(unsigned long Num, char Sign, int RegNo, expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);
static int      ExpressionNumericLoad(int Mode, unsigned long Num, char Sign, int RegNo, expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);
static int      ExpressionNumericRangeCheck(unsigned char Code, unsigned long Numeric);
static int      ExpressionArrayDimGet(dimension_info *DimInfo);
static int      ExpressionArray(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);
static int      ExpressionCast(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);
static int      ExpressionShift(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);
static int      ExpressionInEquality(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);
static int      ExpressionLogicalOrSub(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int LabelNo);
static int      ExpressionLogicalOr(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);
static int      ExpressionLogicalAndSub(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int LabelNo);
static int      ExpressionLogicalAnd(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);
static int      ExpressionBitOr(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);
static int      ExpressionBitXor(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);
static int      ExpressionBitAnd(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);
static int      ExpressionEquality(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);
static int      ExpressionAddaptive(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);
static int      ExpressionMultiplicative(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);
static int      ExpressionPreFix(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);
static int      ExpressionPreFixDoublePlusMinus(int Token, expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);
static int      ExpressionPostFix(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);

static int      ExpressionOptimize(int Mode, expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);
static int      ExpressionOptiVCodeCount(int *NumOfVCode, vertual_code_list_header *RootVCodeListHeader);
static vertual_reg_list *ExpressionOptiVRegListFind(int VRegNo, vertual_reg_list **VRegList);
static int      ExpressionOptiVRegListAdd(vertual_reg_list **VRegList, vertual_reg_list *VRegListMember);
static int      ExpressionOptiVRegListFree(vertual_reg_list **VRegList);
static int      ExpressionOptiUsedVRegListGet(vertual_reg_list **VRegList, int *NumOfUsedReg, int *NumOfVCode, vertual_code *EntryVCode, vertual_code *TargetVCode);
static int      ExpressionOptiVRegIsUsed(int VRegNo, vertual_code *EntryVCode, vertual_code *TargetVCode);
static int      ExpressionOpti120(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);
static int      ExpressionOpti110(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);
static int      ExpressionOpti130(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);
static int      ExpressionOptiIsRegRegOp(char OpCode);
static int      ExpressionOpti140(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);
static int      ExpressionOpti150(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);
static int      ExpressionOpti151(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);
static vertual_reg_list *ExpressionOptiFindNotReferredReg(vertual_reg_list *VRegList, vertual_code *VCodeEntry, vertual_code *VCodeLast);
static int      ExpressionOpti310(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);
static int      ExpressionOptiVRegListSort(vertual_reg_list **VRegList, int NumOfUsedVReg);
//static int      ExpressionOptiVRegListSwap(vertual_reg_list **VRegList, vertual_reg_list *Reg0 , vertual_reg_list *Reg1);
static int      ExpressionOptiVRegListSwap(vertual_reg_list *Reg0 , vertual_reg_list *Reg1);
static int      ExpressionOpti320(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);
static int      ExpressionOptiTmpVarNameGet(char *Name, int Number);
static int      ExpressionOptiAddTmpVar(int NumOfAddTmpLocal);
static int      ExpressionOpti330(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line);

static int      SwapVCodeOffsetType(int VOpCode);


static int      IsImmOffsetLoadStre(char Code);
static int      IsAssignmentOperator(int Token);
static int      IsPrefixUnaryOperator(int Token);
static int      IsOperandTypeReg(char OffsetType);

//-------- ϐ\(Xg) -------------------------------------
static int      VariableInit(variable *v);
static void     VariableListInit(void);
static int      VariableListAdd(variable *v, function *f);
static int      VariableCountElements(variable *v);
static int      VariableElementsInitialListAdd(element_init_val_info *e, element_initial_list_header *Header);
static int      VariableElementsInitialListFree(element_initial_list_header *Header);
static int      VariableElementsInitialListGet(variable *v, element_initial_list_header *Header, int Offset);
static int      VariableInitialValueGet(variable *v);
static int      VariableCheck(variable *v);
static int      VariableListFree(variable *v);
static int      VariableArrayDimInfoInit(dimension_info *DimInfo);
static int      VariableArrayDimensionGet(int DecAnalysisMode, variable *v);
static variable *VariableFind(char *Name, function *Func);
static variable *VariableFindBody(char *Name, variable *v);
static int      VariableGrobalAndExternTrim(void);
static int      VariableArgListAdd(variable *v, variable *f);


//-------- \̕\(Xg) -------------------------------------
static int      StructInit(struct_info *si);
static struct_info *StructFind(char *TagName, char *FuncName, char Scope);
static variable *StructMemberFind(struct_info *StructInfo, char *MemberName);
static int      StructMemberAdd(variable *Member, struct_info *si);
static int      StructMemberCheck(variable *v);
static int      StructInfoListAdd(struct_info *si);
static int      StructSizeGet(struct_info *si);
static int      UnionSizeGet(struct_info *si);
static int      StructInfoListRemove(struct_info *si);

//-------- TYPEDEF\(Xg) -------------------------------------
static int      TypedefListAdd(variable *v);
static typedef_info    *TypedefFind(char *Id);

//-------- ֐\(Xg)n -------------------------------------
static int      FunctionListInit(void);
static int      FunctionInit(function *f);
static int      FunctionPrototypeAdd(function *f);
static int      FuncLocalVariableSizeGet(variable *LocalList);
static int      FuncLocalArgSizeGet(variable *ArgList);
static int      FunctionBodyAdd(function *f);
static function *FunctionFind(char *FuncName);
static int      FinctionNameCheck(char *Name);

//-------- \(Xg) -------------------------------------
static int      ArgListAdd(variable *v, function *f);
static int      ArgCheck(variable *v);
static int      ArgListCompare(function *ft, function *fbuf);
static int      ArgListCompare2(variable *Arg0, variable *Arg1);
static int      ArgListCheck(variable *Arg, int Mode);
static variable *ArgFind(char *Id, function *ft);


//-------- xn\(Xg) -------------------------------------
static int      LiteralLabelListAdd(int LabelNo, int Type, literal_label_ext_info *ExtInfo);
static int      LiteralLabelListFind(literal_label_ext_info *ExtInfo);
static int      UserLabelListAdd(int LabelNo, char *LabelStr);
static user_label *UserLabelFindByLabelStr(char *LabelStr);
static user_label *UserLabelFindByLabelNo(int LabelNo);

//-------- [vxpX^bN -------------------------------------
static void     LoopLabelStackInit(void);
static int      LoopLabelStackPush(int NewLoopTopLabel, int NewLoopBtmLabel);
static int      LoopLabelStackPop(void);
static int      LoopLabelStackGetCurrentLoopTop(void);
static int      LoopLabelStackGetCurrentLoopBtm(void);


//-------- ԃR[hn -------------------------------------
static int      VertualCodeNewLabelNoGet(void);
static int      VertualCodeLabelNoReset(void);
static int      VertualCodeInit(vertual_code *VCode);
static int      VertualCodeAdd(vertual_code_list_header *VCodeList, vertual_code *VCode);
static int      VertualCodeInsertPrev(vertual_code_list_header *VCodeListHeader, vertual_code *VCodePosition, vertual_code *VCode);
static int      VertualCodeInsertNext(vertual_code_list_header *VCodeListHeader, vertual_code *VCodePosition, vertual_code *VCode);
static int      VertualCodeRemove(vertual_code_list_header *VCodeListHeader, vertual_code *VCodePosition);
static int      VertualCodeListConnect(vertual_code_list_header *VCodeListHeaderPri, vertual_code_list_header *VCodeListHeaderSec);
static int      VertualCodeSideEffectListConnect(vertual_code_list_header *VCodeListHeaderPri, vertual_code_list_header *VCodeListHeaderSec);
static int      VertualCodeListFree(vertual_code_list_header *Header);
static int      VCodeGen_Store(
                    vertual_code    *VCode,         // ԃR[hi[
                    int             LabelNo,        // xNoF0͊֐̓A1͊֐̏oA-1̓xȂALȊO͔Cӂ̃Wv
                    int             Size,           // TCY@PCQCS
                    int             BaseUpDate,     // BASE_UPDATE_NO(=0) / BASE_UPDATE_BEFORE(=1) / BASE_UPDATE_AFTER(=2)
                    char            SrcRegType,     // \[XWX^^CvF GPR(ėpREG) / SPR(REG)
                    unsigned long   SrcRegNo,       // \[XWX^No
                    char            BaseRegType,    // x[XWX^^CvF GPR(ėpREG) / SPR(REG)
                    unsigned long   BaseRegNo,      // x[XWX^No
                    char            OffsetType,     // ItZbg̃^CvFOFFSET_IS_GPR(ėpREG) / OFFSET_IS_IMM(l) / OFFSET_IS_VAR(ϐ) / OFFSET_IS_LABEL(vOx)
                    value_info      *vi,            // ItZbgl̏
                    int             SrcFileIndex,   // \[Xt@Ce[uIndex
                    int             SrcFileLine     // \[X̉C߂
                );
static int      VCodeGen_Push(vertual_code *VCode, int LabelNo, char SrcRegType, unsigned long SrcRegNo, int SrcFileIndex, int SrcFileLine);
static int      VCodeGen_Load(
                    vertual_code    *VCode,         // ԃR[hi[
                    int             LabelNo,        // xNoF0͊֐̓A1͊֐̏oA-1̓xȂALȊO͔Cӂ̃Wv
                    int             Size,           // TCY@PCQCS
                    int             Sign,           // UNSIGN(=0) / SIGN(=1)
                    int             BaseUpDate,     // BASE_UPDATE_NO(=0) / BASE_UPDATE_BEFORE(=1) / BASE_UPDATE_AFTER(=2)
                    char            DstRegType,     // i[惌WX^^CvF GPR(ėpREG) / SPR(REG)
                    unsigned long   DstRegNo,       // i[惌WX^No
                    char            BaseRegType,    // x[XWX^^CvF GPR(ėpREG) / SPR(REG)
                    unsigned long   BaseRegNo,      // x[XWX^No
                    char            OffsetType,     // ItZbg̃^CvFOFFSET_IS_GPR(ėpREG) / OFFSET_IS_IMM(l) / OFFSET_IS_VAR(ϐ) / OFFSET_IS_LABEL(vOx)
                    value_info      *vi,            // ItZbgl̏
                    int             SrcFileIndex,   // \[Xt@Ce[uIndex
                    int             SrcFileLine     // \[X̉C߂
                );
static int      VCodeGen_Pop(vertual_code *VCode, int LabelNo, char DstRegType, unsigned long DstRegNo, int SrcFileIndex, int SrcFileLine);
static int      VCodeGen_Operation(
                    vertual_code    *VCode,         // ԃR[hi[
                    int             LabelNo,        // xNoF0͊֐̓A1͊֐̏oA-1̓xȂALȊO͔Cӂ̃Wv
                    char            Operation,      // OPR[h
                    char            ResRegType,     // ʊi[惌WX^^CvF GPR(ėpREG) / SPR(REG)
                    unsigned long   ResRegNo,       // ʊi[惌WX^No
                    char            Arg1RegType,    // PWX^^CvF GPR(ėpREG) / SPR(REG)
                    unsigned long   Arg1RegNo,      // PWX^No
                    char            Arg2Type,       // Q̃^CvFOFFSET_IS_GPR(ėpREG) / OFFSET_IS_IMM(l) / OFFSET_IS_VAR(ϐ) / OFFSET_IS_LABEL(vOx)
                    value_info      *vi,            // Q̒l̏
                    int             SrcFileIndex,   // \[Xt@Ce[uIndex
                    int             SrcFileLine     // \[X̉C߂
                );
static int      VCodeGen_DummyCode(vertual_code *VCode, int LabelNo,  int Operation, int CallCounter, int SrcFileIndex, int SrcFileLine);
static int      VCodeGen_Jump(
                    vertual_code    *VCode,         // ԃR[hi[
                    int             LabelNo,        // xNoF0͊֐̓A1͊֐̏oA-1̓xȂALȊO͔Cӂ̃Wv
                    char            Operation,      // OPR[h
                    unsigned long   ConditionCode,  // R[h
                    char            ArgType,        // ̃^CvFGPR(ėpREG) / LABEL(vOx)
                    value_info      *vi,            // ̒l̏
                    int             SrcFileIndex,   // \[Xt@Ce[uIndex
                    int             SrcFileLine     // \[X̉C߂
                );
static int      VCodeGen_Nop(vertual_code *VCode, int LabelNo, int SrcFileIndex, int SrcFileLine);
static int      VCodeGen_ImmSet(vertual_code *VCode, int LabelNo, unsigned long Value, int SrcFileIndex, int SrcFileLine);
static int      ConvertLiteral2Immset(literal_label *LiteralLabelList, vertual_code_list_header *ExitVCodeListHeader, int SrcFileIndex, int SrcFileLine);
#ifdef ARG_DELIVERY_METHOD0
static int      FunctionEntryVCodeGen(vertual_code_list_header  *EntryVCodeListHeader,  function *f, int SrcFileIndex, int SrcFileLine);
static int      FunctionExitVCodeGen (vertual_code_list_header  *ExitVCodeListHeader,   function *f);
#endif
#ifdef ARG_DELIVERY_METHOD1
static int      FunctionEntryVCodeGen(vertual_code_list_header  *EntryVCodeListHeader,  function *f, int Leaf, int NoLocal, int SrcFileIndex, int SrcFileLine);
static int      FunctionExitVCodeGen (vertual_code_list_header  *ExitVCodeListHeader,   function *f, int Leaf, int NoLocal);
#endif

static int      VCodeListHeaderInit(vertual_code_list_header *VCodeListHeader);

//-------- R[hœKn -------------------------------------
static int      FunctionOptimize(vertual_code_list_header *RootVCodeListHeader);
static void     FunctionOptimizeDebugMsg(char *Func, int Status);
static int      FunctionOptimizeRemoveNop(vertual_code_list_header *RootVCodeListHeader);
static int      FunctionOptimizeChangeJumpTargetLabel(vertual_code_list_header *RootVCodeListHeader, int NewLabel, int OldLabel);
static int      FunctionOptimizeRemoveLastJump(vertual_code_list_header *RootVCodeListHeader);
static int      FunctionOptimizeMaxRegNoGet(vertual_reg_list *VRegList);
static int      FunctionOptimizeBranch(vertual_code_list_header *RootVCodeListHeader);
static int      FunctionOptimizeBranch2(vertual_code_list_header *RootVCodeListHeader);
static int      FunctionOptimizeBranch3(vertual_code_list_header *RootVCodeListHeader);
static int      FunctionOptimizeCall(vertual_code_list_header *RootVCodeListHeader);
static int      FunctionOptiRemoveDisuseCode(vertual_code_list_header *RootVCodeListHeader);
static int      FunctionOptiReplaceRegNo(int RegNoOrg, int RegNoNew, vertual_code_list_header *RootVCodeListHeader);
static int      FunctionOptiTrimRegNo(vertual_code_list_header *RootVCodeListHeader);
static int      FunctionLeafCheck(vertual_code_list_header *RootVCodeListHeader);
static int      FunctionUseLocalCheck(vertual_code_list_header *RootVCodeListHeader);
static int      FunctionOptiVariableOptiInfoGet(variable *VList, vertual_code_list_header *RootVCodeListHeader);
static int      FunctionOptiSelectVarOnReg(function *f);
static int      FunctionOptiCopyArg2Reg(function *f, vertual_code_list_header *MyVCodeListHeader);
static int      FunctionOptiVar2Reg(function *f, vertual_code_list_header *RootVCodeListHeader);
static int      FunctionOptiUsedRegTblSet(function *f, vertual_code *VCode);
static int      FunctionOptimizeMovr(vertual_code_list_header *RootVCodeListHeader);
static int      FunctionOptimizeMovr2(vertual_code_list_header *RootVCodeListHeader);
static int      FunctionOptiLeafFunc(function *f, vertual_code_list_header *RootVCodeListHeader);
static int      FunctionOptimizeEscapeReg(vertual_code_list_header *RootVCodeListHeader);

//-------- PSM4ṕu߂viKɂ͑g܂Ȃj
static int      FunctionOptimizeTest001(vertual_code_list_header *RootVCodeListHeader);


//-------- RpCʁiAZu`jo͊֐Q -------------------------------------
static int      AsmOut(void);
static int      AsmOutHeader(FILE *Fp);
static int      AsmOutSrcFileList(FILE *Fp);

static int      AsmOutExtVarList(FILE *Fp);
static int      AsmOutGlobalVarList(FILE *Fp);
static int      AsmOutPrivateVarList(FILE *Fp);
static int      AsmOutLocalStaticVarList(FILE *Fp);
static int      AsmOutLocalVarList(FILE *Fp, variable *v);
static int      AsmOutArgList(FILE *Fp, variable *v);
static int      AsmOutVarInitList(FILE *Fp, variable *v);

static int      AsmOutExtFuncList(FILE *Fp);
static int      AsmOutMakeVarName(char *out, variable *v);
static int      AsmOutMakeFuncName(char *out, function *f);
static int      AsmOutFunc(FILE *Fp);
static int      AsmOutFuncBody(FILE *Fp, function *f);

static int      AsmOutCodeAll(FILE *Fp, function *f);
static int      AsmOutCode(FILE *Fp, vertual_code *VCode, function *f);
static int      AsmOutSrcInfo(FILE *Fp, vertual_code *VCode);
static int      AsmOutLabel(FILE *Fp, vertual_code *VCode, function *f);
static int      AsmOutOpCode(FILE *Fp, v_opecode *OpCode);
static int      AsmOutOpRand(FILE *Fp, vertual_code *VCode);
static int      AsmOutOpRandBody(char *p, v_operand *OpRand);
static int      AsmOutSrcCode(FILE *Fp, vertual_code *VCode);


//-------- fobOn -------------------------------------
static void     PrintVariableTableBody(variable *v, int Mode);
static void     PrintVariable(variable *v, int Mode);
static void     PrintVariableTable(void);
static void     PrintStructInfo(struct_info *si);
static void     Token2String(int TokenIndex, char *buf);
static int      PrintVertualCodeBody(vertual_code *Code);
static int      PrintVertualCodeList(vertual_code *CodeList);
static int      PrintVertualRegList(vertual_reg_list *VRegList);
static void     PrintFunctionList(void);
static void     PrintSpace(int Num);
static void     PrintTab(void);
static int      PrintExpAnaResult(expression_analsys_result *Res, char *Str);
static void     PrintWarning(char *FileName, int Line, char *Str0, char *Str1, char *Str2);
static void     PrintInfo(char *FileName, int Line, char *Str0, char *Str1, char *Str2);
static void     PrintError(char *FileName, int Line, char *Str0, char *Str1, char *Str2);

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//xxxxxxxxxxxxxxxxxx  TOP FUNCTION     p3cc2(\+Ӗ+R[h)   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//=====================================================================================================================
int p3cc2(cc0_result *Cc0Res, cc1_result *Cc1Res)
//=====================================================================================================================
// [@\] \+Ӗ+R[h
// [] Cc0ResFvvZbT
// [] Cc1ResF͌
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    int     Ret;
#ifdef CC2_DEBUG
    char        LogOutFileName[MAX_SOURCE_FILE_NAME_CHAR];
#endif

    LogFile = stdout;
    
#ifdef CC2_DEBUG
    TokenReadDebugFlag = 1;
    ConstantExpressionDebugFlag = 0;
    ExpressionDebugFlag = 1;
    ExpressionDebugFlag2 = 0;
    FunctionOptimizeDebugFlag = 1;
    StatementDebugFlag = 1;
    DebugMsgIndentCounter = 0;
    PrintVariableTableFlag = 1;
    PrintFunctionTableFlag = 1;
    PrintCodeFlag = 1;
    PrintVCodeGenProcess = 1;
    ExpressionOptimizeDbgFlag = 1;
    FileExtensionSwitch(SrcFileName, LogOutFileName, "log.txt");
    LogFile = fopen(LogOutFileName, "w");
    //LogFile = fopen("cc2_log.txt", "w");
#endif

#ifdef CC2_WARNING_ON
    WarningLevel0 = 1;
    WarningLevel1 = 1;
#endif

    //=== ͌ʃANZXp|C^̏
    InitCc1ResAcsessPointers(Cc0Res, Cc1Res);
    //=== 낢돉
    VariableListInit();
    FunctionListInit();

    //=== vO
    Ret = ProgramAnalysis();

    //=== 
    if(PrintVariableTableFlag + PrintFunctionTableFlag){
        fprintf(LogFile, "\n\n");
        fprintf(LogFile, "===================================================================================================\n");
        fprintf(LogFile, "=                            \ / Ӗ / R[h                                 =\n");
        fprintf(LogFile, "===================================================================================================\n\n");
    }
    if(PrintVariableTableFlag) PrintVariableTable();
    if(PrintFunctionTableFlag) PrintFunctionList();

    if(Ret == P3CC_OK){
        //=== RpCʁiAZũXgjo
        Ret = AsmOut();
    }

    if(Ret == P3CC_OK){
        fprintf(MsgOut, "I\n");
    }
    else{
        fprintf(MsgOut, "~ُI~\n");
    }

    if((LogFile != NULL) && (LogFile != stdout)) fclose(LogFile);

    return Ret;
}


//=====================================================================================================================
static int ProgramAnalysis(void)
//=====================================================================================================================
// [@\] Program
// [Ԓl] P3CC_OK/NG
{
    int         Ret;

    CurrentFuncInfo = NULL;

    while(TokenIndex < NumOfToken){
        //=== typedef̉
        Ret = DeclarationTypedef();
        if(Ret == P3CC_NG) return P3CC_NG;
        else if(Ret == P3CC_ESCAPE){
            //=== ϐ錾̉
            Ret = DeclarationVariable(VARIABLE_ANALYSIS, NULL);
            if(Ret == P3CC_NG) return P3CC_NG;
            else if(Ret == P3CC_ESCAPE){
//FILE *BK;
                //=== ֐錾̉
                Ret = DeclarationFunction();
//BK = LogFile;
//LogFile = stdout;
//printf("\n");
//PrintFunctionList();
//LogFile = BK;
                if(Ret == P3CC_NG){
                    PrintError(__FILE__, __LINE__, "\͎sB", "", "");
                    return P3CC_NG;
                }
            }
        }
    }
    //SCOPE_EXSCOPE_GĽ
    VariableGrobalAndExternTrim();

    return P3CC_OK;
}
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// ̉͊֘A
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//=====================================================================================================================
static int Statement(vertual_code_list_header *BodyVCodeListHeader, int Line)
//=====================================================================================================================
// [@\] P̉
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    int             Token;
    int             Ret;

    StatementDebugMsg("Statement", STATEMENT_START, Line);

    Token = TokenGet(TokenIndex, __LINE__);
    if(Token == TOKEN_BRACE_L) Ret = StatementCompound(BodyVCodeListHeader, __LINE__);
    else Ret = StatementSingle(BodyVCodeListHeader, __LINE__);

    StatementDebugMsg("Statement", STATEMENT_END, Line);

    return Ret;
}
//=====================================================================================================================
static int StatementCompound(vertual_code_list_header *BodyVCodeListHeader, int Line)
//=====================================================================================================================
// [@\] ̉
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    int             SaveIndex;
    int             Ret;
    int             Token;
    int             Flag; // ^̐錾ołȂ0
    variable        v;

    StatementDebugMsg("StatementCompound", STATEMENT_START, Line);
fprintf(LogFile, "CompoundStatementLevel = %d\n",CompoundStatementLevel);
    ++TokenIndex; //'{'̎
    if(CompoundStatementLevel == 0){ // ֐TOPx̎[Jϐ錾͎̉{
        while(1){
            SaveIndex = TokenIndex;
            Ret = DeclarationTypeInfoGet(&v, &Flag);
            if(Ret == P3CC_NG){ return P3CC_NG; }// ^̐錾̉͂ɎsNGŔ
            if(Flag == 0){ TokenIndex = SaveIndex; break;}// ^̐錾ołȂ犪߂Ĕ
            else{
                TokenIndex = SaveIndex;
                if(DeclarationVariable(VARIABLE_ANALYSIS, NULL) != P3CC_OK) return P3CC_NG;
            }
        }

        //[Jϐ̃R[h
        //if(VCodeGen_LocalInit(CurrentFuncInfo) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    }

    ++CompoundStatementLevel;
    // ͎̉{
    while(1){
        Token = TokenGet(TokenIndex, __LINE__);
        if(Token == TOKEN_BRACE_R){
            break;//=== ̏I
        }
        if(StatementSingle(BodyVCodeListHeader, __LINE__) == P3CC_NG) return P3CC_NG;
    }
    --CompoundStatementLevel;

    if(CompoundStatementLevel != 0) ++TokenIndex;// "}"̎

    StatementDebugMsg("StatementCompound", STATEMENT_END, Line);

    return  P3CC_OK;
}
//=====================================================================================================================
static int StatementSingle(vertual_code_list_header *BodyVCodeListHeader, int Line)
//=====================================================================================================================
// [@\] P̉
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    int             Token;
    int             NextToken;

    StatementDebugMsg("StatementSingle", STATEMENT_START, Line);

    Token = TokenGet(TokenIndex, __LINE__);
    NextToken = TokenGet(TokenIndex + 1, __LINE__);
    if(Token == TOKEN_SEMICOLON){//=== 
        ++TokenIndex;
    }
    else if(Token == TOKEN_IF){//=== if
        if(StatementIf(BodyVCodeListHeader, __LINE__) != P3CC_OK) return P3CC_NG;
    }
    else if(Token == TOKEN_WHILE){//=== while
        if(StatementWile(BodyVCodeListHeader, __LINE__) != P3CC_OK) return P3CC_NG;
    }
    else if(Token == TOKEN_CONTINUE){//=== continue
        if(StatementContinue(BodyVCodeListHeader, __LINE__) != P3CC_OK) return P3CC_NG;
    }
    else if(Token == TOKEN_BREAK){//=== break
        if(StatementBreak(BodyVCodeListHeader, __LINE__) != P3CC_OK) return P3CC_NG;
    }
    else if(Token == TOKEN_SWITCH){//=== switch
        if(StatementSwitch(BodyVCodeListHeader, __LINE__) != P3CC_OK) return P3CC_NG;
    }
    else if(Token == TOKEN_FOR){//=== for
        if(StatementFor(BodyVCodeListHeader, __LINE__) != P3CC_OK) return P3CC_NG;
    }
    else if(Token == TOKEN_DO){//=== do_while
        if(StatementDoWile(BodyVCodeListHeader, __LINE__) != P3CC_OK) return P3CC_NG;
    }
    else if(Token == TOKEN_GOTO){//=== goto
        if(StatementGoto(BodyVCodeListHeader, __LINE__) != P3CC_OK) return P3CC_NG;
    }
    else if(Token == TOKEN_RETURN){//=== return
        if(StatementReturn(BodyVCodeListHeader, __LINE__) != P3CC_OK) return P3CC_NG;
    }
    else if((Token == TOKEN_IDENTIFIER) && (NextToken == TOKEN_COLON)){//=== [U[`x
        if(StatementLabel(BodyVCodeListHeader, __LINE__) != P3CC_OK) return P3CC_NG;
    }
    else{//=== 
        if(StatementExpression(BodyVCodeListHeader, __LINE__) != P3CC_OK) return P3CC_NG;
    }

    StatementDebugMsg("StatementSingle", STATEMENT_END, Line);

    return P3CC_OK;
}
//====================================================================================================================
static int StatementBreak(vertual_code_list_header *BodyVCodeListHeader, int Line)
//====================================================================================================================
// [@\] while
// [Ԓl] P3CC_OK
{
    int                         Token;
    vertual_code                VCode;
    value_info                  vi;
    int                         SrcFileIndex;
    int                         SrcFileLine;

    StatementDebugMsg("StatementBreak", STATEMENT_START, Line);

    //==== [v擪փWv ===============
    SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
    SrcFileLine = TokenSrcLineGet(TokenIndex);
    vi.LabelNo = LoopLabelStackGetCurrentLoopBtm();
    VCodeGen_Jump(&VCode, PLABEL_NON, OPECODE_JP_I, COND_ALWAYS, OPERAND_TYPE_LABEL, &vi, SrcFileIndex, SrcFileLine);
    if(VertualCodeAdd(BodyVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    //==== ";"`FbN ===============
    ++TokenIndex; // "break"̎
    Token = TokenGet(TokenIndex, __LINE__);
    if(Token != TOKEN_SEMICOLON){
        PrintError(__FILE__, __LINE__, "Z~R҂Ă鏊ɃZ~RȊO", CurrentTokenBuf, "݂܂B");
        return P3CC_NG;
    }
    ++TokenIndex; // ';'̎

    StatementDebugMsg("StatementBreak", STATEMENT_END, Line);


    return P3CC_OK;
}

//====================================================================================================================
static int StatementContinue(vertual_code_list_header *BodyVCodeListHeader, int Line)
//====================================================================================================================
// [@\] while
// [Ԓl] P3CC_OK
{
    int                         Token;
    vertual_code                VCode;
    value_info                  vi;
    int                         SrcFileIndex;
    int                         SrcFileLine;

    StatementDebugMsg("StatementContinue", STATEMENT_START, Line);

    //==== [v擪փWv ===============
    SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
    SrcFileLine = TokenSrcLineGet(TokenIndex);
    vi.LabelNo = LoopLabelStackGetCurrentLoopTop();
    VCodeGen_Jump(&VCode, PLABEL_NON, OPECODE_JP_I, COND_ALWAYS, OPERAND_TYPE_LABEL, &vi, SrcFileIndex, SrcFileLine);
    if(VertualCodeAdd(BodyVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    //==== ";"`FbN ===============
    ++TokenIndex; // "continue"̎
    Token = TokenGet(TokenIndex, __LINE__);
    if(Token != TOKEN_SEMICOLON){
        PrintError(__FILE__, __LINE__, "Z~R҂Ă鏊ɃZ~RȊO", CurrentTokenBuf, "݂܂B");
        return P3CC_NG;
    }
    ++TokenIndex; // ';'̎

    StatementDebugMsg("StatementContinue", STATEMENT_END, Line);


    return P3CC_OK;
}
//====================================================================================================================
static int StatementFor(vertual_code_list_header *BodyVCodeListHeader, int Line)
//====================================================================================================================
// [@\] for
// [Ԓl] P3CC_OK
// [for̍\]
//                      
//                      goto for_top
//              for_in :nop (continueѐ)
//                       JE^XV
//              for_top:nop
//                      
//                      for
//              for_out:nop (breakѐ)

{
    int                         Token;
    int                         LabelLoopTop;
    int                         LabelLoopBtm;
    int                         LabelLoopBody;
    int                         Arg0RegNo;
    expression_analsys_result   Arg0;
    expression_analsys_result   Arg1;
    expression_analsys_result   TmpRet;
    expression_analsys_result   MyRet0;
    vertual_code_list_header    MyVCodeListHeader0;
    expression_analsys_result   MyRet1;
    vertual_code_list_header    MyVCodeListHeader1;
    vertual_code                VCode;
    vertual_code                VCodeLoopBodyEntry;
    vertual_code                VCodeLoopTop;
    value_info                  vi;
    int                         SrcFileIndex;
    int                         SrcFileLine;

    StatementDebugMsg("StatementFor", STATEMENT_START, Line);

    ExpressionResultInit(&Arg0);
    ExpressionResultInit(&Arg1);
    ExpressionResultInit(&TmpRet);
    ExpressionResultInit(&MyRet0);
    ExpressionResultInit(&MyRet1);
    
    //==== [v[ ===============
    ++LoopLevel;

    //==== [vpƏop̃xX^bNɐς ===============
    LabelLoopTop = VertualCodeNewLabelNoGet();
    LabelLoopBtm = VertualCodeNewLabelNoGet();
    if(LoopLabelStackPush(LabelLoopTop, LabelLoopBtm) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    ++TokenIndex; // "for"̎

    //=== "("`FbN
    Token = TokenGet(TokenIndex, __LINE__);
    if(Token != TOKEN_BRACKET_L){
        PrintError(__FILE__, __LINE__, "for͎̉sB", "for̎\"(\"ȂH", "");
        return P3CC_NG;
    }

    ++TokenIndex; // "("̎

    //=== 
    //ExpressionGprNoInit();
    VCodeListHeaderInit(&MyVCodeListHeader0);
    VCodeListHeaderInit(&SideEffectVCodeHeader);
    Token = TokenGet(TokenIndex, __LINE__);
    if(Token != TOKEN_SEMICOLON){
        //==== Xg
        if(ExpressionList(NOT_KEEP_RESULT, &MyRet0, &MyVCodeListHeader0, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        //==== ܂ł̒ԃR[hBodyVCodeListHeader֐ڑ
        VertualCodeListConnect(BodyVCodeListHeader, &MyVCodeListHeader0);
    }
    //=== ";"`FbN
    Token = TokenGet(TokenIndex, __LINE__);
    if(Token != TOKEN_SEMICOLON){
        PrintError(__FILE__, __LINE__, "for͎̉sB", "\";\"ȂH", "");
        return P3CC_NG;
    }


    //==== [v̐擪փWv ===============
    SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
    SrcFileLine = TokenSrcLineGet(TokenIndex);
    LabelLoopBody = VertualCodeNewLabelNoGet();
    vi.LabelNo = LabelLoopBody;
    VCodeGen_Jump(&VCode, PLABEL_NON, OPECODE_JP_I, COND_ALWAYS, OPERAND_TYPE_LABEL, &vi, SrcFileIndex, SrcFileLine);
    if(VertualCodeAdd(BodyVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    ++TokenIndex; // ";"̎


    //==== 䎮(I)ׂ͂̈̏ ================================
    ExpressionGprNoInit();
    VCodeListHeaderInit(&MyVCodeListHeader0);
    VCodeListHeaderInit(&SideEffectVCodeHeader);

    //==== [v̐擪ɃxtNOP𐶐Ă ===============
    SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
    SrcFileLine = TokenSrcLineGet(TokenIndex);
    VCodeGen_Nop(&VCodeLoopBodyEntry, LabelLoopBody, SrcFileIndex, SrcFileLine);

    Token = TokenGet(TokenIndex, __LINE__);
    if(Token != TOKEN_SEMICOLON){
        //====  ===============
        if(ExpressionAssignment(&MyRet0, &MyVCodeListHeader0, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, &MyRet0, &MyVCodeListHeader0, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        //==== pf ===============
        VertualCodeSideEffectListConnect(&MyVCodeListHeader0, &SideEffectVCodeHeader);
        //==== œK ===============
        if(ExpressionOptimize(KEEP_RESULT, &MyRet0, &MyVCodeListHeader0, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

        //====  =========
        SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
        SrcFileLine = TokenSrcLineGet(TokenIndex);
        if(MyRet0.Method == RETURN_METHOD_NUMERIC){
            if(MyRet0.Value.Num == 0){
                vi.LabelNo = LabelLoopBtm;
                VCodeGen_Jump(&VCode, PLABEL_NON, OPECODE_JP_I, COND_ALWAYS, OPERAND_TYPE_LABEL, &vi, SrcFileIndex, SrcFileLine);
                if(VertualCodeAdd(&MyVCodeListHeader0, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            }
        }
        else{// MyRet0.Method == RETURN_METHOD_REG
            Arg0 = MyRet0;
            Arg0RegNo = Arg0.Value.RegNo;
            ExpressionNumericBody(&Arg1, 0, UNSIGN);
            if(ExpressionBinomialOperation(&TmpRet, &MyVCodeListHeader0, TOKEN_MINUS, &Arg0, &Arg1, Arg0RegNo, __LINE__) == P3CC_NG){
                PrintError(__FILE__, __LINE__, "", "", "");
                return P3CC_NG;
            }
            vi.LabelNo = LabelLoopBtm;
            VCodeGen_Jump(&VCode, PLABEL_NON, OPECODE_JP_I, COND_ZERO, OPERAND_TYPE_LABEL, &vi, SrcFileIndex, SrcFileLine);
            if(VertualCodeAdd(&MyVCodeListHeader0, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }
    }

    //=== ";"`FbN
    Token = TokenGet(TokenIndex, __LINE__);
    if(Token != TOKEN_SEMICOLON){
        PrintError(__FILE__, __LINE__, "for͎̉sB", "\";\"ȂH", "");
        return P3CC_NG;
    }

    ++TokenIndex; // ";"̎

    //==== [v擪(I蕔)ɃxtNOPǉ ===============
    SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
    SrcFileLine = TokenSrcLineGet(TokenIndex);
    VCodeGen_Nop(&VCodeLoopTop, LabelLoopTop, SrcFileIndex, SrcFileLine);
    if(VertualCodeAdd(BodyVCodeListHeader, &VCodeLoopTop) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    //=== JE^XV̎
    //ExpressionGprNoInit();
    VCodeListHeaderInit(&MyVCodeListHeader1);
    VCodeListHeaderInit(&SideEffectVCodeHeader);

    Token = TokenGet(TokenIndex, __LINE__);
    if(Token != TOKEN_BRACKET_R){
        //==== Xg
        if(ExpressionList(NOT_KEEP_RESULT, &MyRet1, &MyVCodeListHeader1, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        //==== ܂ł̒ԃR[hBodyVCodeListHeader֐ڑ
        VertualCodeListConnect(BodyVCodeListHeader, &MyVCodeListHeader1);
    }
    //=== ")"`FbN
    Token = TokenGet(TokenIndex, __LINE__);
    if(Token != TOKEN_BRACKET_R){
        PrintError(__FILE__, __LINE__, "for͎̉sB", "\")\"ȂH", "");
        return P3CC_NG;
    }

    ++TokenIndex; // ")"̎

    //==== Ă[v̐擪ɃxtNOPR[hXg֒ǉ ===============
    if(VertualCodeAdd(BodyVCodeListHeader, &VCodeLoopBodyEntry) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    //==== Î̒ԃR[hBodyVCodeListHeader֐ڑ
    VertualCodeListConnect(BodyVCodeListHeader, &MyVCodeListHeader0);

    //=== [v̒g̏
    if(Statement(BodyVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    //---[v擪(I)փWv
    SrcFileIndex = TokenSrcFileIndexGet(TokenIndex - 1);
    SrcFileLine = TokenSrcLineGet(TokenIndex - 1);
    vi.LabelNo = LabelLoopTop;
    VCodeGen_Jump(&VCode, PLABEL_NON, OPECODE_JP_I, COND_ALWAYS, OPERAND_TYPE_LABEL, &vi, SrcFileIndex, SrcFileLine);
    if(VertualCodeAdd(BodyVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    //---[voixtNOP}j
    VCodeGen_Nop(&VCode, LabelLoopBtm, SrcFileIndex, SrcFileLine);
    if(VertualCodeAdd(BodyVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    //==== [vpƏop̃xX^bN牺낷 ===============
    if(LoopLabelStackPop() == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    //==== [v[ ===============
    --LoopLevel;

    StatementDebugMsg("StatementFor", STATEMENT_END, Line);


    return P3CC_OK;
}

//====================================================================================================================
static int StatementDoWile(vertual_code_list_header *BodyVCodeListHeader, int Line)
//====================================================================================================================
// [@\] do while
// [Ԓl] P3CC_OK
{
    int                         Token;
    int                         LabelLoopTop;
    int                         LabelLoopBtm;
    int                         Arg0RegNo;
    expression_analsys_result   Arg0;
    expression_analsys_result   Arg1;
    expression_analsys_result   TmpRet;
    expression_analsys_result   MyRet;
    vertual_code_list_header    MyVCodeListHeader;
    vertual_code                VCode;
    value_info                  vi;
    int                         SrcFileIndex;
    int                         SrcFileLine;

    StatementDebugMsg("StatementDoWile", STATEMENT_START, Line);

    ExpressionResultInit(&Arg0);
    ExpressionResultInit(&Arg1);
    ExpressionResultInit(&TmpRet);
    ExpressionResultInit(&MyRet);

    //==== [v[ ===============
    ++LoopLevel;

    //==== [vpƏop̃xX^bNɐς ===============
    LabelLoopTop = VertualCodeNewLabelNoGet();
    LabelLoopBtm = VertualCodeNewLabelNoGet();
    if(LoopLabelStackPush(LabelLoopTop, LabelLoopBtm) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    //==== [v擪ɃxtNOP} ===============
    SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
    SrcFileLine = TokenSrcLineGet(TokenIndex);
    VCodeGen_Nop(&VCode, LabelLoopTop, SrcFileIndex, SrcFileLine);
    if(VertualCodeAdd(BodyVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }


    ++TokenIndex; // "do"̎

    //=== [v̒g̏
    if(Statement(BodyVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    //=== while`FbN
    Token = TokenGet(TokenIndex, __LINE__);
    if(Token != TOKEN_WHILE){
        PrintError(__FILE__, __LINE__, "do whilẻ͎sB", "", "");
        return P3CC_NG;
    }

    ++TokenIndex; // "while"̎

    //=== "("`FbN
    Token = TokenGet(TokenIndex, __LINE__);
    if(Token != TOKEN_BRACKET_L){
        PrintError(__FILE__, __LINE__, "do whilẻ͎sB", "\"(\"ȂH", "");
        return P3CC_NG;
    }

    ++TokenIndex; // "("̎

    //==== 䎮ׂ͂̈̏ ===============
    ExpressionGprNoInit();
    VCodeListHeaderInit(&MyVCodeListHeader);
    VCodeListHeaderInit(&SideEffectVCodeHeader);

    //====  ===============
    if(ExpressionAssignment(&MyRet, &MyVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, &MyRet, &MyVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    //==== pf ===============
    VertualCodeSideEffectListConnect(&MyVCodeListHeader, &SideEffectVCodeHeader);
    //==== œK ===============
    if(ExpressionOptimize(KEEP_RESULT, &MyRet, &MyVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    //====  =========
    SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
    SrcFileLine = TokenSrcLineGet(TokenIndex);
    if(MyRet.Method == RETURN_METHOD_NUMERIC){
        if(MyRet.Value.Num != 0){
            vi.LabelNo = LabelLoopTop;
            VCodeGen_Jump(&VCode, PLABEL_NON, OPECODE_JP_I, COND_ALWAYS, OPERAND_TYPE_LABEL, &vi, SrcFileIndex, SrcFileLine);
            if(VertualCodeAdd(&MyVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }
    }
    else{// MyRet.Method == RETURN_METHOD_REG
        Arg0 = MyRet;
        Arg0RegNo = Arg0.Value.RegNo;
        ExpressionNumericBody(&Arg1, 0, UNSIGN);
        if(ExpressionBinomialOperation(&TmpRet, &MyVCodeListHeader, TOKEN_MINUS, &Arg0, &Arg1, Arg0RegNo, __LINE__) == P3CC_NG){
            PrintError(__FILE__, __LINE__, "", "", "");
            return P3CC_NG;
        }
        vi.LabelNo = LabelLoopTop;
        VCodeGen_Jump(&VCode, PLABEL_NON, OPECODE_JP_I, COND_NOT_ZERO, OPERAND_TYPE_LABEL, &vi, SrcFileIndex, SrcFileLine);
        if(VertualCodeAdd(&MyVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }

    //==== ܂ł̒ԃR[hBodyVCodeListHeader֐ڑ ===============
    VertualCodeListConnect(BodyVCodeListHeader, &MyVCodeListHeader);

    //=== ")"`FbN
    Token = TokenGet(TokenIndex, __LINE__);
    if(Token != TOKEN_BRACKET_R){
        PrintError(__FILE__, __LINE__, "whilẻ͎sB", "\")\"ȂH", "");
        return P3CC_NG;
    }

    ++TokenIndex; // ")"̎

    //=== ";"`FbN
    Token = TokenGet(TokenIndex, __LINE__);
    if(Token != TOKEN_SEMICOLON){
        PrintError(__FILE__, __LINE__, "whilẻ͎sB", "\";\"ȂH", "");
        return P3CC_NG;
    }


    //---[voixtNOP}j
    SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
    SrcFileLine = TokenSrcLineGet(TokenIndex);
    VCodeGen_Nop(&VCode, LabelLoopBtm, SrcFileIndex, SrcFileLine);
    if(VertualCodeAdd(BodyVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    //==== [vpƏop̃xX^bN牺낷 ===============
    if(LoopLabelStackPop() == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    //==== [v[ ===============
    --LoopLevel;

    ++TokenIndex; // ";"̎

    StatementDebugMsg("StatementDoWile", STATEMENT_END, Line);


    return P3CC_OK;
}

//====================================================================================================================
static int StatementWile(vertual_code_list_header *BodyVCodeListHeader, int Line)
//====================================================================================================================
// [@\] while
// [Ԓl] P3CC_OK
{
    int                         Token;
    int                         LabelLoopTop;
    int                         LabelLoopBtm;
    int                         Arg0RegNo;
    expression_analsys_result   Arg0;
    expression_analsys_result   Arg1;
    expression_analsys_result   TmpRet;
    expression_analsys_result   MyRet;
    vertual_code_list_header    MyVCodeListHeader;
    vertual_code                VCode;
    value_info                  vi;
    int                         SrcFileIndex;
    int                         SrcFileLine;

    StatementDebugMsg("StatementWile", STATEMENT_START, Line);

    ExpressionResultInit(&Arg0);
    ExpressionResultInit(&Arg1);
    ExpressionResultInit(&TmpRet);
    ExpressionResultInit(&MyRet);

    ++TokenIndex; // "while"̎

    Token = TokenGet(TokenIndex, __LINE__);
    if(Token != TOKEN_BRACKET_L){
        PrintError(__FILE__, __LINE__, "whilẻ͎sB", "\"(\"ȂH", "");
        return P3CC_NG;
    }

    ++TokenIndex; // "("̎


    //==== [v[ ===============
    ++LoopLevel;

    //==== [vpƏop̃xX^bNɐς ===============
    LabelLoopTop = VertualCodeNewLabelNoGet();
    LabelLoopBtm = VertualCodeNewLabelNoGet();
    if(LoopLabelStackPush(LabelLoopTop, LabelLoopBtm) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    //==== 䎮ׂ͂̈̏ ===============
    ExpressionGprNoInit();
    VCodeListHeaderInit(&MyVCodeListHeader);
    VCodeListHeaderInit(&SideEffectVCodeHeader);

    //==== [v擪ɃxtNOP} ===============
    SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
    SrcFileLine = TokenSrcLineGet(TokenIndex);
    VCodeGen_Nop(&VCode, LabelLoopTop, SrcFileIndex, SrcFileLine);
    if(VertualCodeAdd(BodyVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    //====  ===============
    if(ExpressionAssignment(&MyRet, &MyVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, &MyRet, &MyVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    //==== pf ===============
    VertualCodeSideEffectListConnect(&MyVCodeListHeader, &SideEffectVCodeHeader);
    //==== œK ===============
    if(ExpressionOptimize(KEEP_RESULT, &MyRet, &MyVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    //====  =========
    SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
    SrcFileLine = TokenSrcLineGet(TokenIndex);
    if(MyRet.Method == RETURN_METHOD_NUMERIC){
        if(MyRet.Value.Num == 0){
            vi.LabelNo = LabelLoopBtm;
            VCodeGen_Jump(&VCode, PLABEL_NON, OPECODE_JP_I, COND_ALWAYS, OPERAND_TYPE_LABEL, &vi, SrcFileIndex, SrcFileLine);
            if(VertualCodeAdd(&MyVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }
    }
    else{// MyRet.Method == RETURN_METHOD_REG
        Arg0 = MyRet;
        Arg0RegNo = Arg0.Value.RegNo;
        ExpressionNumericBody(&Arg1, 0, UNSIGN);
        if(ExpressionBinomialOperation(&TmpRet, &MyVCodeListHeader, TOKEN_MINUS, &Arg0, &Arg1, Arg0RegNo, __LINE__) == P3CC_NG){
            PrintError(__FILE__, __LINE__, "", "", "");
            return P3CC_NG;
        }
        vi.LabelNo = LabelLoopBtm;
        VCodeGen_Jump(&VCode, PLABEL_NON, OPECODE_JP_I, COND_ZERO, OPERAND_TYPE_LABEL, &vi, SrcFileIndex, SrcFileLine);
        if(VertualCodeAdd(&MyVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }

    //==== ܂ł̒ԃR[hBodyVCodeListHeader֐ڑ ===============
    VertualCodeListConnect(BodyVCodeListHeader, &MyVCodeListHeader);

    Token = TokenGet(TokenIndex, __LINE__);
    if(Token != TOKEN_BRACKET_R){
        PrintError(__FILE__, __LINE__, "whilẻ͎sB", "\")\"ȂH", "");
        return P3CC_NG;
    }

    ++TokenIndex; // ")"̎

    //=== while()ꍇ̏
    if(Statement(BodyVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    //---[v擪փWv
    SrcFileIndex = TokenSrcFileIndexGet(TokenIndex - 1);
    SrcFileLine = TokenSrcLineGet(TokenIndex - 1);
    vi.LabelNo = LabelLoopTop;
    VCodeGen_Jump(&VCode, PLABEL_NON, OPECODE_JP_I, COND_ALWAYS, OPERAND_TYPE_LABEL, &vi, SrcFileIndex, SrcFileLine);
    if(VertualCodeAdd(BodyVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    //---[voixtNOP}j
    VCodeGen_Nop(&VCode, LabelLoopBtm, SrcFileIndex, SrcFileLine);
    if(VertualCodeAdd(BodyVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    //==== [vpƏop̃xX^bN牺낷 ===============
    if(LoopLabelStackPop() == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    //==== [v[ ===============
    --LoopLevel;

    StatementDebugMsg("StatementWile", STATEMENT_END, Line);


    return P3CC_OK;
}
//====================================================================================================================
static int StatementSwitch(vertual_code_list_header *BodyVCodeListHeader, int Line)
//====================================================================================================================
// [@\] switch
// [Ԓl] P3CC_OK
{
    int                         Token;
    int                         LabelLoopTop;
    int                         LabelLoopBtm;
    expression_analsys_result   Arg0;
    expression_analsys_result   Arg1;
    expression_analsys_result   TmpRet;
    expression_analsys_result   MyRet;
    vertual_code_list_header    MyVCodeListHeader;
    expression_analsys_result   MyRet1;
    vertual_code_list_header    MyVCodeListHeader1;
    vertual_code                VCode;
    value_info                  vi;
    int                         i;
    int                         WorkRegNo;
    int                         SrcFileIndex;
    int                         SrcFileLine;
    int                         SrcFileIndexOfEntry;
    int                         SrcFileLineOfEntry;
    int                         NumOfLabel;
    struct LabelVsValueTable_t{
        int         Label;
        int         Value;
    } LabelVsValueTable[MAX_SWITCH_LABEL];

    StatementDebugMsg("StatementSwitch", STATEMENT_START, Line);

    ExpressionResultInit(&Arg0);
    ExpressionResultInit(&Arg1);
    ExpressionResultInit(&TmpRet);
    ExpressionResultInit(&MyRet);
    ExpressionResultInit(&MyRet1);

    ++TokenIndex; // "switch"̎

    Token = TokenGet(TokenIndex, __LINE__);
    if(Token != TOKEN_BRACKET_L){
        PrintError(__FILE__, __LINE__, "whilẻ͎sB", "\"(\"ȂH", "");
        return P3CC_NG;
    }
    SrcFileIndexOfEntry = TokenSrcFileIndexGet(TokenIndex);
    SrcFileLineOfEntry = TokenSrcLineGet(TokenIndex);

    ++TokenIndex; // "("̎


    //==== switchpƏop̃xX^bNɐς ===============
    LabelLoopTop = VertualCodeNewLabelNoGet();
    LabelLoopBtm = VertualCodeNewLabelNoGet();
    if(LoopLabelStackPush(LabelLoopTop, LabelLoopBtm) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    //==== 䎮ׂ͂̈̏ ===============
    ExpressionGprNoInit();
    VCodeListHeaderInit(&MyVCodeListHeader);
    VCodeListHeaderInit(&SideEffectVCodeHeader);

    //==== [v擪ɃxtNOP} ===============
    SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
    SrcFileLine = TokenSrcLineGet(TokenIndex);
    VCodeGen_Nop(&VCode, LabelLoopTop, SrcFileIndex, SrcFileLine);
    if(VertualCodeAdd(BodyVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    //====  ===============
    if(ExpressionAssignment(&MyRet, &MyVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, &MyRet, &MyVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    //==== pf ===============
    VertualCodeSideEffectListConnect(&MyVCodeListHeader, &SideEffectVCodeHeader);
    //==== œK ===============
    if(ExpressionOptimize(KEEP_RESULT, &MyRet, &MyVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    //==== switch()̎̒l萔Ȃ烌WX^Ƀ[hĂ ===============
    if(MyRet.Method == RETURN_METHOD_NUMERIC){
        TmpRet = MyRet;
        if(ExpressionNumericLoad(0, TmpRet.Value.Num, TmpRet.TypeInfo.Sign, ExpressionNewGprNoGet(), &MyRet, &MyVCodeListHeader, __LINE__) != P3CC_OK){
            PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;
        }
    }

    //==== ƂcaseɎgGprNoP擾Ă =========
    WorkRegNo = ExpressionNewGprNoGet();

    Token = TokenGet(TokenIndex, __LINE__);
    if(Token != TOKEN_BRACKET_R){
        PrintError(__FILE__, __LINE__, "switch͎̉sB", "\")\"ȂH", "");
        return P3CC_NG;
    }

    ++TokenIndex; // ")"̎

    Token = TokenGet(TokenIndex, __LINE__);
    if(Token != TOKEN_BRACE_L){
        PrintError(__FILE__, __LINE__, "switch͎̉sB", "\"{\"ȂH", "");
        return P3CC_NG;
    }

    ++TokenIndex; // "{"̎

    //==== switch̒gׂ̈̏ ===============
    ExpressionGprNoInit();
    VCodeListHeaderInit(&MyVCodeListHeader1);
    VCodeListHeaderInit(&SideEffectVCodeHeader);
    NumOfLabel = 0;

    //==== switch̒g ===============
    while(1){
        Token = TokenGet(TokenIndex, __LINE__);
        if(Token == TOKEN_BRACE_R){
            ++TokenIndex; // "}"̎
            break;
        }
        else if(Token == TOKEN_CASE){
            ++TokenIndex; // "case"̎
            ConstantExpressionErrorFlag = 0;
            LabelVsValueTable[NumOfLabel].Value = ConstantExpressionTop();
            if(ConstantExpressionErrorFlag){
                PrintError(__FILE__, __LINE__, "switch`case̎Ꭾ̌vZɎsB", "", "");
                return P3CC_NG;
            }
            LabelVsValueTable[NumOfLabel].Label = VertualCodeNewLabelNoGet();
            // case ̏ɃxtNOP}
            SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
            SrcFileLine = TokenSrcLineGet(TokenIndex);
            VCodeGen_Nop(&VCode, LabelVsValueTable[NumOfLabel].Label, SrcFileIndex, SrcFileLine);
            if(VertualCodeAdd(&MyVCodeListHeader1, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            ++NumOfLabel;
            Token = TokenGet(TokenIndex, __LINE__);
            if(Token != TOKEN_COLON){
                PrintError(__FILE__, __LINE__, "switch͎̉sB", "\":\"ȂH", "");
                return P3CC_NG;
            }
            ++TokenIndex; // ":"̎
        }
        else if(Token == TOKEN_DEFAULT){
            ++TokenIndex; // "default"̎
            Token = TokenGet(TokenIndex, __LINE__);
            if(Token != TOKEN_COLON){
                PrintError(__FILE__, __LINE__, "switch͎̉sB", "\":\"ȂH", "");
                return P3CC_NG;
            }
            ++TokenIndex; // ":"̎
        }
        else{
            if(Statement(&MyVCodeListHeader1, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }
    }
    //---[voixtNOP}j
    SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
    SrcFileLine = TokenSrcLineGet(TokenIndex);
    VCodeGen_Nop(&VCode, LabelLoopBtm, SrcFileIndex, SrcFileLine);
    if(VertualCodeAdd(&MyVCodeListHeader1, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    //====  ===============
    ExpressionGprNoForce(WorkRegNo);
    for(i = 0; i < NumOfLabel; i++){
        if(ExpressionNumericRangeCheck(OPECODE_SUB_I, (unsigned long)LabelVsValueTable[i].Value) == P3CC_OK){ //--- lw\͈
            vi.NumLiteral = (unsigned long)LabelVsValueTable[i].Value;
            VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_SUB_I,  RET_IS_GPR,WorkRegNo,  ARG_IS_GPR,MyRet.Value.RegNo,  ARG_IS_IMM,&vi,  SrcFileIndexOfEntry, SrcFileLineOfEntry);
        }
        else{//--- lws͈
            if(ExpressionNumericLoad(0, (unsigned long)LabelVsValueTable[i].Value, SIGN, WorkRegNo, &TmpRet, &MyVCodeListHeader, __LINE__) != P3CC_OK){
                PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;
            }
            vi.RegNo = WorkRegNo;
            VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_SUB_R,  RET_IS_GPR,WorkRegNo,  ARG_IS_GPR,MyRet.Value.RegNo,  ARG_IS_GPR,&vi,  SrcFileIndexOfEntry, SrcFileLineOfEntry);
        }
        if(VertualCodeAdd(&MyVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        vi.LabelNo = LabelVsValueTable[i].Label;
        VCodeGen_Jump(&VCode, PLABEL_NON, OPECODE_JP_I, COND_ZERO, OPERAND_TYPE_LABEL, &vi, SrcFileIndexOfEntry, SrcFileLineOfEntry);
        if(VertualCodeAdd(&MyVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }

    //==== ܂ł̒ԃR[hBodyVCodeListHeader֐ڑ ===============
    VertualCodeListConnect(BodyVCodeListHeader, &MyVCodeListHeader);
    VertualCodeListConnect(BodyVCodeListHeader, &MyVCodeListHeader1);


    //==== [vpƏop̃xX^bN牺낷 ===============
    if(LoopLabelStackPop() == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }


    StatementDebugMsg("StatementSwitch", STATEMENT_END, Line);


    return P3CC_OK;
}

//====================================================================================================================
static int StatementIf(vertual_code_list_header *BodyVCodeListHeader, int Line)
//====================================================================================================================
// [@\] IF
// [Ԓl] P3CC_OK
{
    int                         Token;
    int                         LabelSkip0;
    int                         LabelSkip1;
    int                         Arg0RegNo;
    expression_analsys_result   Arg0;
    expression_analsys_result   Arg1;
    expression_analsys_result   TmpRet;
    expression_analsys_result   MyRet;
    vertual_code_list_header    MyVCodeListHeader;
    vertual_code                VCode;
    value_info                  vi;
    int                         SrcFileIndex;
    int                         SrcFileLine;

    StatementDebugMsg("StatementIf", STATEMENT_START, Line);

    ExpressionResultInit(&Arg0);
    ExpressionResultInit(&Arg1);
    ExpressionResultInit(&TmpRet);
    ExpressionResultInit(&MyRet);

    ++TokenIndex; // "if"̎

    Token = TokenGet(TokenIndex, __LINE__);
    if(Token != TOKEN_BRACKET_L){
        PrintError(__FILE__, __LINE__, "if͎̉sB", "\"(\"ȂH", "");
        return P3CC_NG;
    }

    ++TokenIndex; // "("̎

    //==== 䎮ׂ͂̈̏ ===============
    ExpressionGprNoInit();
    VCodeListHeaderInit(&MyVCodeListHeader);
    VCodeListHeaderInit(&SideEffectVCodeHeader);
    //====  ===============
    if(ExpressionAssignment(&MyRet, &MyVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, &MyRet, &MyVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    //==== pf ===============
    VertualCodeSideEffectListConnect(&MyVCodeListHeader, &SideEffectVCodeHeader);
    //==== œK ===============
    if(ExpressionOptimize(KEEP_RESULT, &MyRet, &MyVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    //====  =========
    SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
    SrcFileLine = TokenSrcLineGet(TokenIndex);
    LabelSkip0 = VertualCodeNewLabelNoGet();
    if(MyRet.Method == RETURN_METHOD_NUMERIC){
        if(MyRet.Value.Num == 0){
            vi.LabelNo = LabelSkip0;
            VCodeGen_Jump(&VCode, PLABEL_NON, OPECODE_JP_I, COND_ALWAYS, OPERAND_TYPE_LABEL, &vi, SrcFileIndex, SrcFileLine);
            if(VertualCodeAdd(&MyVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }
    }
    else{// MyRet.Method == RETURN_METHOD_REG
        Arg0 = MyRet;
        Arg0RegNo = Arg0.Value.RegNo;
        ExpressionNumericBody(&Arg1, 0, UNSIGN);
        if(ExpressionBinomialOperation(&TmpRet, &MyVCodeListHeader, TOKEN_MINUS, &Arg0, &Arg1, Arg0RegNo, __LINE__) == P3CC_NG){
            PrintError(__FILE__, __LINE__, "", "", "");
            return P3CC_NG;
        }
        vi.LabelNo = LabelSkip0;
        VCodeGen_Jump(&VCode, PLABEL_NON, OPECODE_JP_I, COND_ZERO, OPERAND_TYPE_LABEL, &vi, SrcFileIndex, SrcFileLine);
        if(VertualCodeAdd(&MyVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }

    //==== ܂ł̒ԃR[hBodyVCodeListHeader֐ڑ ===============
    VertualCodeListConnect(BodyVCodeListHeader, &MyVCodeListHeader);

    Token = TokenGet(TokenIndex, __LINE__);
    if(Token != TOKEN_BRACKET_R){
        PrintError(__FILE__, __LINE__, "if͎̉sB", "\")\"ȂH", "");
        return P3CC_NG;
    }

    ++TokenIndex; // ")"̎

    //=== if()ꍇ̏
    if(Statement(BodyVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    //===else`FbN
    Token = TokenGet(TokenIndex, __LINE__);
    if(Token == TOKEN_ELSE){
        LabelSkip1 = VertualCodeNewLabelNoGet();
        vi.LabelNo = LabelSkip1;
        SrcFileIndex = TokenSrcFileIndexGet(TokenIndex - 1);
        SrcFileLine = TokenSrcLineGet(TokenIndex - 1);
        VCodeGen_Jump(&VCode, PLABEL_NON, OPECODE_JP_I, COND_ALWAYS, OPERAND_TYPE_LABEL, &vi, SrcFileIndex, SrcFileLine);
        if(VertualCodeAdd(BodyVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        //---xtNOP}
        SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
        SrcFileLine = TokenSrcLineGet(TokenIndex);
        VCodeGen_Nop(&VCode, LabelSkip0, SrcFileIndex, SrcFileLine);
        if(VertualCodeAdd(BodyVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        ++TokenIndex; // "else"̎
        //=== else ̏ꍇ̏
        if(Statement(BodyVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        //---xtNOP}
        SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
        SrcFileLine = TokenSrcLineGet(TokenIndex);
        VCodeGen_Nop(&VCode, LabelSkip1, SrcFileIndex, SrcFileLine);
        if(VertualCodeAdd(BodyVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }
    else{
        SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
        SrcFileLine = TokenSrcLineGet(TokenIndex);
        //---xtNOP}
        VCodeGen_Nop(&VCode, LabelSkip0, SrcFileIndex, SrcFileLine);
        if(VertualCodeAdd(BodyVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }

    StatementDebugMsg("StatementIf", STATEMENT_END, Line);


    return P3CC_OK;
}
//====================================================================================================================
static int StatementExpression(vertual_code_list_header *BodyVCodeListHeader, int Line)
//====================================================================================================================
// [@\] 
// [Ԓl] P3CC_OK
{
    int                         Token;
    expression_analsys_result   MyRet;
    vertual_code_list_header    MyVCodeListHeader;

    StatementDebugMsg("StatementExpression", STATEMENT_START, Line);

    ExpressionResultInit(&MyRet);

    //
    //ExpressionGprNoInit();
    VCodeListHeaderInit(&MyVCodeListHeader);

    //
    if(ExpressionList(NOT_KEEP_RESULT, &MyRet, &MyVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    //==== œKςݒԃR[hBodyVCodeListHeader֐ڑ ===============
    VertualCodeListConnect(BodyVCodeListHeader, &MyVCodeListHeader);

    //==== ";"`FbN ===============
    Token = TokenGet(TokenIndex, __LINE__);
    if(Token != TOKEN_SEMICOLON){
        PrintError(__FILE__, __LINE__, "Z~R҂Ă鏊ɃZ~RȊO", CurrentTokenBuf, "݂܂B");
        return P3CC_NG;
    }
    ++TokenIndex; // ';'̎

    StatementDebugMsg("StatementExpression", STATEMENT_END, Line);

    return P3CC_OK;
}
//=====================================================================================================================
static int StatementLabel(vertual_code_list_header *BodyVCodeListHeader, int Line)
//=====================================================================================================================
// [@\] x̉(Ƃ肠߂ǂ̂NOPuiʂ͕pɂɂ͏oĂȂ͂j)
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    int             Ret;
    int             LabelNo;
    char            *LabelStr;
    user_label      *L;
    vertual_code    VCode;
    int             SrcFileIndex;
    int             SrcFileLine;

    StatementDebugMsg("StatementLabel", STATEMENT_START, Line);

    SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
    SrcFileLine = TokenSrcLineGet(TokenIndex);

    LabelStr = TokenIdStrGet(TokenIndex);
    L = UserLabelFindByLabelStr(LabelStr);
    if(L == NULL){//o^Ȃo^
        LabelNo = VertualCodeNewLabelNoGet();
        Ret = UserLabelListAdd(LabelNo, LabelStr);
        if(Ret == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }
    else{//o^ς݂ȂQƉtO𗧂Ă
        L->ReferSolvFlag = 1;
        LabelNo = L->LabelNo;
    }
    //R[h
    VCodeGen_Nop(&VCode, LabelNo, SrcFileIndex, SrcFileLine);
    if(VertualCodeAdd(BodyVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    ++TokenIndex; // "ʎq"̎
    ++TokenIndex; // ":"̎

    StatementDebugMsg("StatementLabel", STATEMENT_END, Line);

    return P3CC_OK;
}
//=====================================================================================================================
static int StatementGoto(vertual_code_list_header *BodyVCodeListHeader, int Line)
//=====================================================================================================================
// [@\] Gotỏ
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    int             Token;
    int             LabelNo;
    int             Ret;
    char            *LabelStr;
    user_label      *L;
    vertual_code    VCode;
    value_info      vi;
    int             SrcFileIndex;
    int             SrcFileLine;

    StatementDebugMsg("StatementGoto", STATEMENT_START, Line);

    SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
    SrcFileLine = TokenSrcLineGet(TokenIndex);

    ++TokenIndex; // "goto"̎
    Token = TokenGet(TokenIndex, __LINE__);
    if(Token != TOKEN_IDENTIFIER){ // goto̎ʎqȊOȂ
        PrintError(__FILE__, __LINE__, "ʎq҂Ă鏊ɎʎqȊO", CurrentTokenBuf, "݂܂B");
        return P3CC_NG;
    }
    LabelStr = TokenIdStrGet(TokenIndex);
    L = UserLabelFindByLabelStr(LabelStr);
    if(L == NULL){//o^Ȃo^
        LabelNo = VertualCodeNewLabelNoGet();
        Ret = UserLabelListAdd(LabelNo, LabelStr);
        if(Ret == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }
    else{//o^ς݂ȂQƉtO𗧂Ă
        L->ReferSolvFlag = 1;
        LabelNo = L->LabelNo;
    }
    //R[h
    vi.LabelNo = LabelNo;
    VCodeGen_Jump(&VCode, PLABEL_NON, OPECODE_JP_I, COND_ALWAYS, OPERAND_TYPE_LABEL, &vi, SrcFileIndex, SrcFileLine);
    if(VertualCodeAdd(BodyVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    ++TokenIndex; // "ʎq"̎

    //==== ";"`FbN ===============
    Token = TokenGet(TokenIndex, __LINE__);
    if(Token != TOKEN_SEMICOLON){
        PrintError(__FILE__, __LINE__, "Z~R҂Ă鏊ɃZ~RȊO", CurrentTokenBuf, "݂܂B");
        return P3CC_NG;
    }

    ++TokenIndex; // ';'̎

    StatementDebugMsg("StatementGoto", STATEMENT_END, Line);

    return P3CC_OK;
}

//=====================================================================================================================
static int StatementReturn(vertual_code_list_header *BodyVCodeListHeader, int Line)
//=====================================================================================================================
// [@\] return̉
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    int                         Token;
    vertual_code                VCode;
    value_info                  vi;
    expression_analsys_result   MyRet;
    expression_analsys_result   ReturnType;
    vertual_code_list_header    MyVCodeListHeader;
    int                         SrcFileIndex;
    int                         SrcFileLine;

    StatementDebugMsg("StatementReturn", STATEMENT_START, Line);

    ExpressionResultInit(&MyRet);
    ExpressionResultInit(&ReturnType);

    //
    SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
    SrcFileLine = TokenSrcLineGet(TokenIndex);
    ExpressionGprNoInit();
    VCodeListHeaderInit(&MyVCodeListHeader);
    VCodeListHeaderInit(&SideEffectVCodeHeader);

    ++TokenIndex; // "return"̎
    if((CurrentFuncInfo->Type == TYPE_VOID) && (CurrentFuncInfo->Pointer == 0)){// void^̊֐̏ꍇ
        ;//ȂɂȂ
    }
    else{
        Token = TokenGet(TokenIndex, __LINE__);
        if(Token == TOKEN_SEMICOLON){
            PrintError(__FILE__, __LINE__, "return ̕Ԃl܂B", "", "");
            return P3CC_NG;
        }
        if(ExpressionAssignment(&MyRet, &MyVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, &MyRet, &MyVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(MyRet.Method == RETURN_METHOD_NUMERIC){
            if(ExpressionNumericLoad(0, MyRet.Value.Num, UNSIGN, ExpressionNewGprNoGet(), &MyRet, &MyVCodeListHeader, __LINE__) != P3CC_OK){
                PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;
            }
        }
        //==== RETURN^`FbN ========
        ExpressionSetResultByFunction(&ReturnType, CurrentFuncInfo, __LINE__);
        if(ExpressionAssignTrim(&ReturnType, &MyRet, NULL) == P3CC_NG){ PrintError(__FILE__, __LINE__, "֐̕Ԃľ^ƈvȂB", "", ""); return P3CC_NG; }

        //==== pf ===============
        VertualCodeSideEffectListConnect(&MyVCodeListHeader, &SideEffectVCodeHeader);

        //==== œK ===============
        if(ExpressionOptimize(KEEP_RESULT, &MyRet, &MyVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        vi.RegNo = MyRet.Value.RegNo;
        VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_MOV_R,  RET_IS_GPR,0, ARG_IS_NOTING,0,  ARG_IS_GPR,&vi, SrcFileIndex, SrcFileLine);
        if(VertualCodeAdd(&MyVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }

    vi.LabelNo = PLABEL_FUNC_EXIT;
    VCodeGen_Jump(&VCode, PLABEL_NON, OPECODE_JP_I, COND_ALWAYS, OPERAND_TYPE_LABEL, &vi, SrcFileIndex, SrcFileLine);
    if(VertualCodeAdd(&MyVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    VertualCodeListConnect(BodyVCodeListHeader, &MyVCodeListHeader);

    //==== ";"`FbN ===============
    Token = TokenGet(TokenIndex, __LINE__);
    if(Token != TOKEN_SEMICOLON){
        PrintError(__FILE__, __LINE__, "Z~R҂Ă鏊ɃZ~RȊO", CurrentTokenBuf, "݂܂B");
        return P3CC_NG;
    }

    ++TokenIndex; // ';'̎

    StatementDebugMsg("StatementReturn", STATEMENT_END, Line);

    return P3CC_OK;
}
//====================================================================================================================
static void StatementDebugMsg(char *Func, int Status, int Line)
//====================================================================================================================
// [@\] ̓fobObZ[W
// [Ԓl] P3CC_OK/P3CC_NG
{
    char  DbgTokenBuf[MAX_SOURCE_LINE_CHAR];
    char  *Sts;

    if(StatementDebugFlag){
        if(Status != STATEMENT_START){
             --DebugMsgIndentCounter;
        }
        PrintSpace(DebugMsgIndentCounter);
        Token2String(TokenIndex, DbgTokenBuf);
        if(Status == STATEMENT_START){
            Sts = "Start";
        }
        else{
            Sts = "End";
        }
        fprintf(LogFile, "%s %s %d %s\n", Func, Sts, Line, DbgTokenBuf);
        if(Status == STATEMENT_START){
            ++DebugMsgIndentCounter;
        }
    }
}
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// [v̓ƏõxNoL^X^bN ֘A
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//=====================================================================================================================
static void LoopLabelStackInit(void)
//=====================================================================================================================
// [@\] 
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    LoopLabelStack.Depth = -1;
}

//=====================================================================================================================
static int LoopLabelStackPush(int NewLoopTopLabel, int NewLoopBtmLabel)
//=====================================================================================================================
// [@\] vbV
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    if(LoopLabelStack.Depth >= (MAX_LOOP_NEST - 1)){
        PrintError(__FILE__, __LINE__, "[ṽlXg̐[[B", "", "");
        return P3CC_NG;
    }
    LoopLabelStack.Depth += 1;
    LoopLabelStack.LoopTopLabel[LoopLabelStack.Depth] = NewLoopTopLabel;
    LoopLabelStack.LoopBtmLabel[LoopLabelStack.Depth] = NewLoopBtmLabel;
    return P3CC_OK;
}

//=====================================================================================================================
static int LoopLabelStackPop(void)
//=====================================================================================================================
// [@\] |bv
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    if(LoopLabelStack.Depth < 0){
        PrintError(__FILE__, __LINE__, "[v甲鏈ߏH", "@炭RpC̃oOB", "");
        return P3CC_NG;
    }
    LoopLabelStack.Depth -= 1;
    return P3CC_OK;
}
//=====================================================================================================================
static int LoopLabelStackGetCurrentLoopTop(void)
//=====================================================================================================================
// [@\] ݂̃x̃[v擪Ԃ
// [Ԓl] F̒lAsF̒l
{
    if(LoopLabelStack.Depth < 0) return -1;
    return LoopLabelStack.LoopTopLabel[LoopLabelStack.Depth];
}
//=====================================================================================================================
static int LoopLabelStackGetCurrentLoopBtm(void)
//=====================================================================================================================
// [@\] ݂̃x̃[vI[Ԃ
// [Ԓl] F̒lAsF̒l
{
    if(LoopLabelStack.Depth < 0) return -1;
    return LoopLabelStack.LoopBtmLabel[LoopLabelStack.Depth];
}

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// ֐ϐ̐錾֘A
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//=====================================================================================================================
static int DeclarationTypedef(void)
//=====================================================================================================================
// [@\] typedef̉
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    int             Token;
    int             Ret;

    Token = TokenGet(TokenIndex, __LINE__);
    if(Token != TOKEN_TYPEDEF) return P3CC_ESCAPE;
    ++TokenIndex;
    Ret = DeclarationVariable(TYPEDEF_ANALYSIS, NULL);
    return Ret;
}

//=====================================================================================================================
static int DeclarationStructCheck(variable *v, int  *DefaultPointer, int *DefaultTypeSize, int  *DefaultTotalSize)
//=====================================================================================================================
// [@\] ϐ錾̉
// [Ԓl] FP3CC_OKAsFP3CC_NGA\̂̌^`̂݁FP3CC_ESCAPE
{
    int             Ret;
    int             Token;
    int             StructDecOnly; //\̂̌^̒`݂̂Ȃ1

    //== \́H
    Token = TokenGet(TokenIndex, __LINE__);
    //if((Token == TOKEN_IDENTIFIER) && (v->Type == TYPE_STRUCT)){//== ʎqȂ
    if((Token == TOKEN_IDENTIFIER) && ((v->Type == TYPE_STRUCT) || (v->Type == TYPE_UNION))){//== ʎqȂ
        v->Name = TokenIdStrGet(TokenIndex);
        if(Location == INSIDE_OF_FUNCTION){
            v->FuncName = CurrentFuncInfo->FuncName;
        }
        StructDecOnly = 0;
        ++DeclarationStructLevel;
        Ret = DeclarationStruct(v, &StructDecOnly);
        --DeclarationStructLevel;
        if(Ret == P3CC_NG){ return P3CC_NG; } // s甲
        if(StructDecOnly){ // \̂̌^`݂̂
            ++TokenIndex;
            return P3CC_ESCAPE;
        }
        *DefaultPointer = v->Pointer;
        *DefaultTypeSize = v->TypeSize;
        *DefaultTotalSize = v->TotalSize;
    }
    return P3CC_OK;
}

//=====================================================================================================================
static int DeclarationVariable(int DecAnalysisMode, void *Target)
//=====================================================================================================================
// [@\] ϐ錾̉
// [] int DecAnalysisMode   F̓[h
// [] void *Target          F͌ʂ̓o^
// [Ԓl] FP3CC_OKAsFP3CC_NGAϐ̐錾ȂFP3CC_ESCAPE
{
    int             SaveIndex;
    int             Ret;
    int             Token;
    int             Flag; // ^̐錾ołȂ0
    int             Loop;
    int             StructDecOnly; //\̂̌^̒`݂̂Ȃ1
    int             DefaultPointer;
    int             DefaultTypeFunction;
    int             DefaultFuncPointer;
    int             DefaultTypeSize;
    int             DefaultTotalSize;
    int             Pointer;
    variable        v;

    SaveIndex = TokenIndex;
    VariableInit(&v);

    if(Location == INSIDE_OF_FUNCTION){
        v.FuncName = CurrentFuncInfo->FuncName;
    }

    //=== ^擾
    Ret = DeclarationTypeInfoGet(&v, &Flag);
    if(Ret == P3CC_NG){// ^̐錾̉͂ɎsNGŔ
        TokenIndex = SaveIndex;        return P3CC_NG;
    }
    if(Flag == 0){// ^̐錾ołȂ
        if(DecAnalysisMode == TYPEDEF_ANALYSIS){
            PrintError(__FILE__, __LINE__, "typedefȂ̂Ɍ^̏񂪂ȂB", "", "");
            return P3CC_NG;
        }
        else if(DecAnalysisMode == STRUCT_MEMBER_ANALYSIS){
            PrintError(__FILE__, __LINE__, "\̃ǒ^̐錾ołȂB", "", "");
            return P3CC_NG;
        }
        else if(DecAnalysisMode == ARG_ANALYSIS){
            PrintError(__FILE__, __LINE__, "̌^񂪂ȂB", "", "");
            return P3CC_NG;
        }
        else if(DecAnalysisMode == FPOINTER_ARG_ANALYSIS){
            PrintError(__FILE__, __LINE__, "֐|C^̈̌^񂪂ȂB", "", "");
            return P3CC_NG;
        }
        else{// VARIABLE_ANALYSIS / CAST_ANALYSIS
            return P3CC_ESCAPE;
        }
    }

    DefaultPointer = v.Pointer;
    DefaultTypeFunction = v.TypeFunction;
    DefaultFuncPointer = v.FuncPointer;
    DefaultTypeSize= v.TypeSize;
    DefaultTotalSize    = v.TotalSize;


    //== \́H
    Ret = DeclarationStructCheck(&v, &DefaultPointer, &DefaultTypeSize, &DefaultTotalSize);
    if(Ret == P3CC_ESCAPE){// \̂̌^`݂̂ꍇ
        if(DecAnalysisMode == VARIABLE_ANALYSIS){
            return P3CC_OK;
        }
        else if(DecAnalysisMode == CAST_ANALYSIS){
            *(variable *)Target = v;
            return P3CC_OK;
        }
        else{
            PrintError(__FILE__, __LINE__, "Ή̋LqB", "", "");
            return P3CC_NG;
        }
    }
    if(Ret == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    Loop = 0;
    while(1){
        Token = TokenGet(TokenIndex, __LINE__);
        //== 2Tڈȍ~","𖳎
        if(Loop != 0) {
            if(Token == TOKEN_COMMA){ ++TokenIndex; continue; }
        }
        //== ";"oI
        if(Token == TOKEN_SEMICOLON){
            ++TokenIndex; // ";"̎
            break;
        }

        v.Pointer = DefaultPointer;
        v.TypeFunction = DefaultTypeFunction;
        v.FuncPointer = DefaultFuncPointer;
        v.TypeSize= DefaultTypeSize;
        v.TotalSize = DefaultTotalSize;
        //== "*"̌𐔂
        Pointer = 0;
        while(1){
            if(Token != TOKEN_ASTERISK) break;
            Pointer += 1;
            ++TokenIndex;
            Token = TokenGet(TokenIndex, __LINE__);
        }
        if(Pointer != 0){
            if(v.TypeFunction == TYPE_FUNCTION_POINTER){
                v.FuncPointer += Pointer;
            }
            else{
                v.Pointer += Pointer;
            }
            v.TypeSize = SIZEOF_POINTER;
            v.TotalSize = SIZEOF_POINTER;
        }

        if(Token == TOKEN_BRACKET_L){//== "("֐|C^ߑł
            ++TokenIndex; // "("̎
            Token = TokenGet(TokenIndex, __LINE__);
            Pointer = 0;
            while(1){
                if(Token != TOKEN_ASTERISK) break;
                Pointer += 1;
                ++TokenIndex;
                Token = TokenGet(TokenIndex, __LINE__);
            }
            if(Pointer == 0){
                PrintError(__FILE__, __LINE__, "Ή̍\B֐|C^錾̉͂ɎsB", "", "");
                return P3CC_NG;
            }

            v.FuncPointer += Pointer;
            v.TypeFunction = 1;
            v.TypeSize = SIZEOF_POINTER;
            v.TotalSize = SIZEOF_POINTER;

            if(Token == TOKEN_IDENTIFIER){
                if(DecAnalysisMode == CAST_ANALYSIS){
                    PrintError(__FILE__, __LINE__, "ʎq҂Ă鏊ɎʎqȊO", CurrentTokenBuf, "݂܂B");
                    PrintError(__FILE__, __LINE__, "Ή̍\B֐|C^錾̉͂Ɏs", "", "");
                    return P3CC_NG;
                }
                else{
                    v.Name = TokenIdStrGet(TokenIndex);
                }
            }
            else{
                if(DecAnalysisMode != CAST_ANALYSIS){
                    PrintError(__FILE__, __LINE__, "ʎq҂Ă鏊ɎʎqȊO", CurrentTokenBuf, "݂܂B");
                    PrintError(__FILE__, __LINE__, "Ή̍\B֐|C^錾̉͂Ɏs", "", "");
                    return P3CC_NG;
                }
                else{//CAST_ANALYSIS[h
                    //VariableArrayDimensionGet́ATokenIndexʎqwĂ鎖OɂĂׁA
                    //CAST_ANALYSIS[hł́A܂ȂȂ邽TokenIndex߂
                    --TokenIndex;
                }
            }
            //== zH
            v.ArrayDim = 0;
            v.DimInfo = NULL;
            if(VariableArrayDimensionGet(DecAnalysisMode, &v) == P3CC_NG){return P3CC_NG;}// s甲

            ++TokenIndex; // "ʎq"̎ ')'
            Token = TokenGet(TokenIndex, __LINE__);
            if(Token != TOKEN_BRACKET_R){//== ʎq̎TOKEN')'ȊOȂ
                PrintError(__FILE__, __LINE__, "Ή̍\B֐|C^錾̉͂ɎsB", "", "");
                return P3CC_NG;
            }

            ++TokenIndex; // ")"̎"("
            Token = TokenGet(TokenIndex, __LINE__);
            if(Token != TOKEN_BRACKET_L){
                PrintError(__FILE__, __LINE__, "Ή̍\B֐|C^錾̉͂ɎsB", "", "");
                return P3CC_NG;
            }
            //Xg̉
            ++TokenIndex;//"("̎ֈړ
            Token = TokenGet(TokenIndex, __LINE__);
            if(Token == TOKEN_BRACKET_R){//Xgȗ
                //++TokenIndex;//")"̎ֈړ
                ;
            }
            else{
                while(1){
                    if(DeclarationVariable(FPOINTER_ARG_ANALYSIS, &v) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                    v.ArgNum += 1;

                    ++TokenIndex;
                    Token = TokenGet(TokenIndex, __LINE__);
                    if(Token == TOKEN_COMMA){ // ","𖳎
                        ++TokenIndex;
                    }
                    if(Token == TOKEN_BRACKET_R) {// ")"oXgI
                        //++TokenIndex;
                        break;
                    }
                }
                //---vg^Cv錾Ɖ肵ĈXg`FbN
                if(ArgListCheck(v.ArgList, 0) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            }
        }
        else{//֐|C^łȂꍇ
            //== ʎqs\Ȃ
            if(Token != TOKEN_IDENTIFIER){
                if((DecAnalysisMode == ARG_ANALYSIS) || (DecAnalysisMode == FPOINTER_ARG_ANALYSIS) || (DecAnalysisMode == CAST_ANALYSIS)){
                    v.Name = NULL;
                    --TokenIndex;
                }
                else{//̓[h/CAST̓[hȊOłُ͈I
                    PrintError(__FILE__, __LINE__, "ʎq҂Ă鏊ɎʎqȊO", CurrentTokenBuf, "݂܂B");
                    return P3CC_NG;
                }
            }
            else{//== ʎq!!
                if(DecAnalysisMode == CAST_ANALYSIS){
                    PrintError(__FILE__, __LINE__, "ʎq҂Ă鏊ɎʎqȊO", CurrentTokenBuf, "݂܂B");
                    PrintError(__FILE__, __LINE__, "Ή̍\B֐|C^錾̉͂Ɏs", "", "");
                    return P3CC_NG;
                }
                v.Name = TokenIdStrGet(TokenIndex);
                //== ʎq̎TOKEN'('ȂA֐̐錾
                if(TokenGet(TokenIndex + 1, __LINE__) == TOKEN_BRACKET_L){
                    TokenIndex = SaveIndex;
                    return P3CC_ESCAPE;
                }
                //== zH
                v.ArrayDim = 0;
                v.DimInfo = NULL;
                if(VariableArrayDimensionGet(DecAnalysisMode, &v) == P3CC_NG){return P3CC_NG;}// s甲
            }
        }

        //====== e[hƂ̃Xg֓o^ ======================================================
        if(DecAnalysisMode == TYPEDEF_ANALYSIS){
            if(v.DimInfo != NULL){
                PrintError(__FILE__, __LINE__, "ztypedef͖̂ΉB", "", "");
                return P3CC_NG;
            }
            //== typedefΉ\ɒǉ
            Ret = TypedefListAdd(&v);
            if(Ret == P3CC_NG){// ǉɎs甲
                PrintError(__FILE__, __LINE__, "typedefΉ\ǉɎsB", "", "");
                return P3CC_NG;
            }
            ++TokenIndex;
            if(TokenGet(TokenIndex, __LINE__) == TOKEN_SEMICOLON){
                ++TokenIndex;
                break;
            }
            else{
                PrintError(__FILE__, __LINE__, "\G[H", "", "");
                return P3CC_NG;
            }
        }
        else if(DecAnalysisMode == STRUCT_MEMBER_ANALYSIS){
            //== \̃oɒǉ
            Ret = StructMemberAdd(&v, (struct_info *)Target);
            if(Ret == P3CC_NG){// \̃oǉɎs甲
                PrintError(__FILE__, __LINE__, "\̃oǉɎsB", "", "");
                return P3CC_NG;
            }
        }
        else if(DecAnalysisMode == ARG_ANALYSIS){
            //== o^
            v.Scope = SCOPE_ARG;
            v.FuncName = ((function *)Target)->FuncName;
            Ret = ArgListAdd(&v, (function *)Target);
            if(Ret == P3CC_NG){
                PrintError(__FILE__, __LINE__, "Xg̓o^ɎsB", "", "");
                return P3CC_NG;
            }
            break;
        }
        else if(DecAnalysisMode == FPOINTER_ARG_ANALYSIS){
            //== o^
            v.Scope = SCOPE_ARG;
            v.FuncName = NULL;
            Ret = VariableArgListAdd(&v, (variable *)Target);
            if(Ret == P3CC_NG){
                PrintError(__FILE__, __LINE__, "Xg̓o^ɎsB", "", "");
                return P3CC_NG;
            }
            break;
        }
        else if(DecAnalysisMode == CAST_ANALYSIS){
            //== sV邢ACAST̓[h̎͂琳ɔ
            *(variable *)Target = v;
            ++TokenIndex;
            break;
        }
        else{
            //== ʎq̎TOKEN'='ȂAl
            if(TokenGet(TokenIndex + 1, __LINE__) == TOKEN_EQ){
                if((Location == INSIDE_OF_FUNCTION) && (v.Scope != SCOPE_ATS)){
                    PrintError(__FILE__, __LINE__, "l̉͂ɎsB", "staticŖ[Jϐiϐj̏ɂ͖ΉB", "");
                    TokenIndex = SaveIndex;
                    return P3CC_NG;
                }
                ++TokenIndex; // '='
                ++TokenIndex; // '='̎
                Ret = VariableInitialValueGet(&v);
                if(Ret == P3CC_NG){// ǉɎs甲
                    PrintError(__FILE__, __LINE__, "l̉͂ɎsB", "", "");
                    TokenIndex = SaveIndex;
                    return P3CC_NG;
                }
            }
            //== ϐ\ɒǉ
            Ret = VariableListAdd(&v, CurrentFuncInfo);
            if(Ret == P3CC_NG){// ǉɎs甲
                PrintError(__FILE__, __LINE__, "ϐ\ǉɎsB", "", "");
                TokenIndex = SaveIndex;
                return P3CC_NG;
            }
        }

        ++TokenIndex;
        ++Loop;

    }
    return P3CC_OK;
}
//======================================================================================================================
static int DeclarationFunction(void)
//=====================================================================================================================
// [@\] ֐錾̉
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    int             SaveIndex;
    int             Ret;
    int             Token;
    int             Flag; // ^̐錾ołȂ0
    variable        v;
    function        f;
    struct_info     *psi;
    int             SrcFileIndexOfFuncEntry;
    int             SrcFileLineOfFuncEntry;
    int             Leaf;       // NOT_LEAF_FUNC:[t֐łȂALEAF_FUNCF[t֐
    int             NoLocal;    // 0:[JϐorA0ȊOF[JϐorȂ

    vertual_code_list_header    EntryVCodeListHeader;
    vertual_code_list_header    BodyVCodeListHeader;
    vertual_code_list_header    ExitVCodeListHeader;

    SaveIndex = TokenIndex;
    VariableInit(&v);
    FunctionInit(&f);

    //=== ^擾
    Ret = DeclarationTypeInfoGet(&v, &Flag);
    if((Ret == P3CC_NG) || (Flag == 0)){return P3CC_NG;}// ^̐錾̉͂ɎsNGŔ

    //== "*"̌𐔂
    Token = TokenGet(TokenIndex, __LINE__);
    while(1){
        if(Token != TOKEN_ASTERISK) break;
        v.Pointer += 1;
        ++TokenIndex;
        Token = TokenGet(TokenIndex, __LINE__);
    }
    if(v.Pointer != 0){
        v.TypeSize = SIZEOF_POINTER;
        v.TotalSize = SIZEOF_POINTER;
    }
    //== ʎqs\ȂُI
    if(Token != TOKEN_IDENTIFIER){
        PrintError(__FILE__, __LINE__, "ʎq҂Ă鏊ɎʎqȊO", CurrentTokenBuf, "݂܂B");
        return P3CC_NG;
    }
    //== ʎq!!
    v.Name = TokenIdStrGet(TokenIndex);

    //== ʎq`ς݂̍\̖Ȃ
    if((psi = StructFind(v.Name, v.FuncName, v.Scope)) != NULL){//== `ς݂̍\̃^OȂ
        ++TokenIndex;
        Token = TokenGet(TokenIndex, __LINE__);
        //== "*"̌𐔂
        v.Pointer = 0;
        while(1){
            if(Token != TOKEN_ASTERISK) break;
            v.Pointer += 1;
            ++TokenIndex;
            Token = TokenGet(TokenIndex, __LINE__);
        }
        if(v.Pointer != 0){
            v.TypeSize = SIZEOF_POINTER;
            v.TotalSize = SIZEOF_POINTER;
        }
        if(Token != TOKEN_IDENTIFIER){
            PrintError(__FILE__, __LINE__, "ʎq҂Ă鏊ɎʎqȊO", CurrentTokenBuf, "݂܂B");
            return P3CC_NG;
        }
        //== ʎqꍇ
        v.Name = TokenIdStrGet(TokenIndex);
        v.StructInfo = psi;
    }

    //== ʎq̎TOKEN"("ȊOȂA֐̐錾ł͂Ȃ
    if(TokenGet(TokenIndex+1, __LINE__) != TOKEN_BRACKET_L){
        TokenIndex = SaveIndex;
        return P3CC_OK;
    }
    //== ֐m
    if((v.Type == TYPE_STRUCT) && (v.Pointer == 0)){
        PrintError(__FILE__, __LINE__, "\̂Ԃ֐ɂ͖Ήłi\̂ւ̃|C^֐͉jB", "", "");
       return P3CC_NG;
    }
    f.FuncName = TokenIdStrGet(TokenIndex);
    if(FinctionNameCheck(f.FuncName) == P3CC_NG){
        PrintError(__FILE__, __LINE__, "֐`ς݂̕ϐƏdB", "", "");
       return P3CC_NG;
    }
    if(v.Scope == SCOPE_EX) f.Scope = SCOPE_EX;
    else if(v.Scope == SCOPE_GL) f.Scope = SCOPE_GL;
    else  f.Scope = SCOPE_PV;
    f.Sign = v.Sign;
    f.Pointer = v.Pointer;
    f.Type = v.Type;
    f.TypeSize = v.TypeSize;
    f.StructInfo = v.StructInfo;
    if((f.StructInfo != NULL) && (f.Pointer == 0)){
        PrintError(__FILE__, __LINE__, "\̂ԂlƂ֐ɂ͖ΉłB", "", "");
        return P3CC_NG;
    }
    ++TokenIndex;//"("ֈړ
    ++TokenIndex;//"("̎ֈړ
    //======== Xg̉ ==============================
    Token = TokenGet(TokenIndex, __LINE__);
    if(Token == TOKEN_BRACKET_R){//Xgȗ
        ++TokenIndex;//")"̎ֈړ
    }
    else{
        while(1){
            if(DeclarationVariable(ARG_ANALYSIS, &f) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            f.ArgNum += 1;

            ++TokenIndex;
            Token = TokenGet(TokenIndex, __LINE__);
            if(Token == TOKEN_COMMA){ // ","𖳎
                ++TokenIndex;
            }
            if(Token == TOKEN_BRACKET_R) {
                ++TokenIndex; // ")"oXgI
                break;
            }
        }
        //---vg^Cv錾Ɖ肵ĈXg`FbN
        if(ArgListCheck(f.ArgList, 0) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }


    Token = TokenGet(TokenIndex, __LINE__);
    if(Token == TOKEN_SEMICOLON){ // ";"o֐vg^Cv
        //֐_uĂȂmFȂo^
        Ret = FunctionPrototypeAdd(&f);
        if(Ret == P3CC_NG){
            PrintError(__FILE__, __LINE__, "֐̓o^ɎsB", "", "");
            return P3CC_NG;
        }
        ++TokenIndex;// ";"̎
    }
    else if(Token == TOKEN_BRACE_L){ // "{"o֐{̂̉
        //---֐{̐錾ƂĈXg`FbN
        if(ArgListCheck(f.ArgList, 1) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        //vg^Cv錾΁Ǎ^ƏvĂ邩ƁA̎ʎq݂邩mFȂo^
        Ret = FunctionBodyAdd(&f);
        if(Ret == P3CC_NG){
            PrintError(__FILE__, __LINE__, "֐̓o^ɎsB", "", "");
            return P3CC_NG;
        }
        //֐̉͊Jn
        Location = INSIDE_OF_FUNCTION;
        VertualCodeLabelNoReset();
        LoopLabelStackInit();
        CallCounter = 0;
        CurrentFuncInfo = FunctionFind(f.FuncName);
        if(CurrentFuncInfo == NULL){
            PrintError(__FILE__, __LINE__, "֐̌ɎsB", "", "");
            return P3CC_NG;
        }

        VCodeListHeaderInit(&EntryVCodeListHeader);
        VCodeListHeaderInit(&BodyVCodeListHeader);
        VCodeListHeaderInit(&ExitVCodeListHeader);

        SrcFileIndexOfFuncEntry = TokenSrcFileIndexGet(TokenIndex);
        SrcFileLineOfFuncEntry = TokenSrcLineGet(TokenIndex);
        CurrentFuncInfo->SrcFileIndexOfFuncEntry = SrcFileIndexOfFuncEntry;
        CurrentFuncInfo->SrcFileLineOfFuncEntry = SrcFileLineOfFuncEntry;

        //̉(̓[hTOP)   *TOP̎ϐ錾
        CompoundStatementLevel = 0;
        Ret = StatementCompound(&BodyVCodeListHeader, __LINE__);
        if(Ret == P3CC_NG){
            PrintError(__FILE__, __LINE__, "͎̉sB", "", "");
            return P3CC_NG;
        }
        CompoundStatementLevel = 0;

        //œK
        if(FunctionOptimize(&BodyVCodeListHeader) == P3CC_NG){
            PrintError(__FILE__, __LINE__, "œKsB", "", "");
            return P3CC_NG;
        }


        //Localϐ̃ItZbgvZ
        CurrentFuncInfo->SizeOfLocal = FuncLocalVariableSizeGet(CurrentFuncInfo->VariableList);
        if(CurrentFuncInfo->SizeOfLocal > 0x7FFF){
            PrintError(__FILE__, __LINE__, "[JϐiϐjTCY32KoCg𒴂Ă܂B", "", "");
            return P3CC_NG;
        }
        //̃ItZbgvZ
        if(FuncLocalArgSizeGet(CurrentFuncInfo->ArgList) > 0x7FFC){
            PrintError(__FILE__, __LINE__, "TCY32KoCg𒴂Ă܂B", "", "");
            return P3CC_NG;
        }

#ifdef ARG_DELIVERY_METHOD1
        Leaf = FunctionLeafCheck(&BodyVCodeListHeader);
        NoLocal = FunctionUseLocalCheck(&BodyVCodeListHeader);
#endif

        //֐̃R[h
#ifdef ARG_DELIVERY_METHOD0
        if(FunctionEntryVCodeGen(&EntryVCodeListHeader, CurrentFuncInfo, SrcFileIndexOfFuncEntry, SrcFileLineOfFuncEntry) != P3CC_OK){
#endif
#ifdef ARG_DELIVERY_METHOD1
        if(FunctionEntryVCodeGen(&EntryVCodeListHeader, CurrentFuncInfo, Leaf, NoLocal, SrcFileIndexOfFuncEntry, SrcFileLineOfFuncEntry) != P3CC_OK){
#endif
            PrintError(__FILE__, __LINE__, "", "", "");
            return P3CC_NG;
        }

        //֐õR[h
#ifdef ARG_DELIVERY_METHOD0
        if(FunctionExitVCodeGen(&ExitVCodeListHeader, CurrentFuncInfo) != P3CC_OK){
#endif
#ifdef ARG_DELIVERY_METHOD1
        if(FunctionExitVCodeGen(&ExitVCodeListHeader, CurrentFuncInfo, Leaf, NoLocal) != P3CC_OK){
#endif
            PrintError(__FILE__, __LINE__, "", "", "");
            return P3CC_NG;
        }

        //R[hڑ
        if(VertualCodeListConnect(&CurrentFuncInfo->VCodeListHeader, &EntryVCodeListHeader) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(VertualCodeListConnect(&CurrentFuncInfo->VCodeListHeader, &BodyVCodeListHeader) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(VertualCodeListConnect(&CurrentFuncInfo->VCodeListHeader, &ExitVCodeListHeader) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

        //֐̉͏I
        Location = OUTSIDE_OF_FUNCTION;
        CurrentFuncInfo = NULL;

        ++TokenIndex;// "}"̎
    }
    else{
        PrintError(__FILE__, __LINE__, "͕s\Ȋ֐錾B", CurrentTokenBuf, "ρH");
        return P3CC_NG;
    }
    return P3CC_OK;
}
//======================================================================================================================
static int DeclarationStruct(variable *v, int *StructDecOnly)
//=====================================================================================================================
// [@\] \̏擾
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    int             Ret;
    int             Token;
    struct_info     si;
    struct_info     *psi;
    struct_info     *TempSi;

    //if(v->Type != TYPE_STRUCT){
    if((v->Type != TYPE_STRUCT) && (v->Type != TYPE_UNION)){
        return P3CC_OK; // \̊֘A̐錾ł͂Ȃ
    }
    if(v->StructInfo != NULL){
        return P3CC_OK;  // ^͎擾ς
    }

    StructInit(&si);
    si.TagName = v->Name;
    si.FuncName = v->FuncName;
    si.Scope = v->Scope;
    if(v->Type == TYPE_STRUCT) si.Type = TYPE_STRUCT;
    else                       si.Type = TYPE_UNION;

    // TOKENǂݍ
    Token = TokenGet(TokenIndex + 1, __LINE__);
    if(Token == TOKEN_BRACE_L){   // '{'Ȃ΍\̂̌^̒`
        TempSi = StructFind(si.TagName, si.FuncName, si.Scope);
        if(TempSi == NULL){ // o^ς݂łȂ
            //======== \̉o^===================
            Ret = StructInfoListAdd(&si);
            if(Ret == P3CC_NG){// \̂̌^\̒ǉɎs甲
                PrintError(__FILE__, __LINE__, "\̂̌^\̒ǉɎsB", "", "");
                return P3CC_NG;
            }
        }
        else{// o^ς݂Ȃ
            if(TempSi->Provisional != P3CC_TRUE){// o^łȂ
                PrintError(__FILE__, __LINE__, "^O̍\̂H", "", "");
                return P3CC_NG;
            }
        }
        //======== \̂̌^̒` ===================
        ++TokenIndex; // '{'
        ++TokenIndex; // '{'̎

        //======= oXL ====================
        while(1){
            Token = TokenGet(TokenIndex, __LINE__);

            //== "}"oI
            if(Token == TOKEN_BRACE_R){
                ++TokenIndex;// "}"̎
                break;
            }

            if(DeclarationVariable(STRUCT_MEMBER_ANALYSIS, &si) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }

        //== TCY̌vZ
        if(si.Type == TYPE_STRUCT) si.StructSize = StructSizeGet(&si);
        else                       si.StructSize = UnionSizeGet(&si);

        //== \̂̌^\ɒǉi{o^j
        si.Provisional = P3CC_FALSE;
        Ret = StructInfoListAdd(&si);
        if(Ret == P3CC_NG){// \̂̌^\̒ǉɎs甲
            PrintError(__FILE__, __LINE__, "\̂̌^\̒ǉɎsB", "", "");
            return P3CC_NG;
        }
        //== ";"oI c\̒`ŏIƂ
        Token = TokenGet(TokenIndex, __LINE__);
        if(Token == TOKEN_SEMICOLON){
            *StructDecOnly = 1;
            return P3CC_OK;
        }
        v->TypeSize = si.StructSize;
        v->TotalSize = si.StructSize;
        v->StructInfo = StructFind(si.TagName, si.FuncName, si.Scope);
        if(v->StructInfo == NULL){
            PrintError(__FILE__, __LINE__, si.TagName, "̒`܂B", "");
            return P3CC_NG;
        }
        return P3CC_OK;
    }
    else if((Token == TOKEN_SEMICOLON) && (DeclarationStructLevel == 1)){// ';'Ȃ΃^Ôݒ`
        //======== \̉o^===================
        Ret = StructInfoListAdd(&si);
        if(Ret == P3CC_NG){// \̂̌^\̒ǉɎs甲
            PrintError(__FILE__, __LINE__, "\̂̌^\̒ǉɎsB", "", "");
            return P3CC_NG;
        }
        //======== \̂̌^̒` ===================
        ++TokenIndex; // ';'
        *StructDecOnly = 1;
        return P3CC_OK;
    }
    else if((psi = StructFind(si.TagName, si.FuncName, si.Scope)) != NULL){//== `ς݂̍\̃^OȂ
        v->StructInfo = psi;
        v->TypeSize = psi->StructSize;
        v->TotalSize = psi->StructSize;
        ++TokenIndex;
        return P3CC_OK;
    }
    else{//== ????
        PrintError(__FILE__, __LINE__, si.TagName, "̒`܂B", "");
        return P3CC_NG;
    }
}
//=====================================================================================================================
static int VariableArrayDimInfoInit(dimension_info *DimInfo)
//=====================================================================================================================
// [@\] dimension_info
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    int     Index;

    for(Index=0; Index < MAX_ARRAY_DIM; Index++){
        DimInfo->NumOfElements[Index] = 0;
        DimInfo->ElementSize[Index] = 0;
    }
    return P3CC_OK;
}
//=====================================================================================================================
static int VariableArrayDimensionGet(int DecAnalysisMode, variable *v)
//=====================================================================================================================
// [@\] z̎擾
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    int     Ret;
    int     Index;
    int     i;
    int     Size;
    char    tmp[4];
    dimension_info *DimInfo;

    if(TokenGet(TokenIndex+1, __LINE__) != TOKEN_SQUARE_L) return P3CC_OK;
    if(TokenGet(TokenIndex+2, __LINE__) == TOKEN_SQUARE_R){
        if((DecAnalysisMode != ARG_ANALYSIS) && (DecAnalysisMode != FPOINTER_ARG_ANALYSIS)){
            PrintError(__FILE__, __LINE__, "zɐ錾ŗvf([])ȗ\Ȃ̂͊֐̈錾݂̂łB", "", "");
            return P3CC_NG;
        }
        v->Pointer += 1;
        v->TypeSize = SIZEOF_POINTER;
        v->TotalSize = SIZEOF_POINTER;
        //v->ArrayDim = NO_ARRAY_SIZE;
        ++TokenIndex;// "["
        ++TokenIndex;// "]"
        if(TokenGet(TokenIndex+1, __LINE__) == TOKEN_SQUARE_L){
            PrintError(__FILE__, __LINE__, "zɐ錾ŗvf([])ȗ\Ȃ̂͂Pz̏ꍇ̂ݑΉB", "", "");
            PrintError(__FILE__, __LINE__, "Aint a[] = { 1, 2, 3};̗lȐ錾ɂΉłB", "", "");
            PrintError(__FILE__, __LINE__, "̏ꍇ́Aint a[3] = { 1, 2, 3};Ɛ錾ĂB", "", "");
            return P3CC_NG;
        }
        return P3CC_OK;
    }
    ++TokenIndex;// "["̎
    DimInfo = calloc(1, sizeof(dimension_info));
    if(DimInfo == NULL){
        PrintError(__FILE__, __LINE__, "z񎟌i[p̈mێsB", "", "");
        return P3CC_NG;
    }
    VariableArrayDimInfoInit(DimInfo);
    Index = 0;
    while(1){
        if(TokenGet(TokenIndex, __LINE__) != TOKEN_SQUARE_L){
            --TokenIndex;
            break;
        }
        ++TokenIndex;
        ConstantExpressionErrorFlag = 0;
        Ret = ConstantExpressionTop();
        if(ConstantExpressionErrorFlag){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(Ret <= 0){
            PrintError(__FILE__, __LINE__, "TCY0ȉ̔z錾悤ƂĂ܂B", "", "");
            return P3CC_NG;
        }
        DimInfo->NumOfElements[Index] = Ret;
        if(TokenGet(TokenIndex, __LINE__) != TOKEN_SQUARE_R){
            PrintError(__FILE__, __LINE__, "s\ȃg[NF", CurrentTokenBuf, "");
            return P3CC_NG;
        }
        ++TokenIndex;// ']'̎
        ++Index;
        if(Index >= MAX_ARRAY_DIM){
            sprintf(tmp, "%3d", MAX_ARRAY_DIM);
            PrintError(__FILE__, __LINE__, "z͍ő", tmp, "܂");
            return P3CC_NG;
        }
    }
    v->ArrayDim = Index;
    v->DimInfo = DimInfo;
    Size = v->TypeSize;
    for(i=Index-1;i>=0;i--){
        DimInfo->ElementSize[i] = Size;
        Size *= DimInfo->NumOfElements[i];
    }
    v->TotalSize = Size;

    return P3CC_OK;
}


//=====================================================================================================================
static typedef_info *TypedefFind(char *Id)
//=====================================================================================================================
// [@\] typedefΉ\̌
// [Ԓl] ݂ȂNULL
{
    typedef_info    *t;

    t = TypedefInfoList;
    if(TypedefInfoList == NULL) return NULL;
    if(Id == NULL) return NULL;
    while(1){
        if(strcmp(t->TypeName, Id) == 0) return t;
        if(t->Next == NULL) break;
        t = t->Next;
    }
    return NULL;
}


//=====================================================================================================================
static int DeclarationTypeInfoGet(variable *v, int *Flag)
// [@\] ^̎擾
// [Ԓl] FP3CC_OKAsFP3CC_NG
// [Ԓl(Flag)]  ^̐錾ołȂ0
//=====================================================================================================================
{
    int             Token;
    char            *Id;
    typedef_info    *t;

    *Flag = 0;
    while(1){
        Token = TokenGet(TokenIndex, __LINE__);

        Id = TokenIdStrGet(TokenIndex);
        t = TypedefFind(Id);

        if(t != NULL){//=== typedefĂ鎯ʎq𔭌
            v->Sign = t->Sign;
            v->Pointer = t->Pointer;
            v->Type = t->Type;
            v->TypeFunction = t->TypeFunction;
            v->FuncPointer = t->FuncPointer;
            v->ArgNum = t->ArgNum;
            v->ArgList = t->ArgList;
            if     (v->Type == TYPE_VOID  ) { v->TypeSize = SIZEOF_VOID  ;  v->TotalSize = SIZEOF_VOID  ;  *Flag = 1;}
            else if(v->Type == TYPE_CHAR  ) { v->TypeSize = SIZEOF_CHAR  ;  v->TotalSize = SIZEOF_CHAR  ;  *Flag = 1;}
            else if(v->Type == TYPE_SHORT ) { v->TypeSize = SIZEOF_SHORT ;  v->TotalSize = SIZEOF_SHORT ;  *Flag = 1;}
            else if(v->Type == TYPE_INT   ) { v->TypeSize = SIZEOF_INT   ;  v->TotalSize = SIZEOF_INT   ;  *Flag = 1;}
            else if(v->Type == TYPE_LONG  ) { v->TypeSize = SIZEOF_LONG  ;  v->TotalSize = SIZEOF_LONG  ;  *Flag = 1;}
            else if(v->Type == TYPE_FLOAT ) { v->TypeSize = SIZEOF_FLOAT ;  v->TotalSize = SIZEOF_FLOAT ;  *Flag = 1;}
            else if(v->Type == TYPE_DOUBLE) { v->TypeSize = SIZEOF_DOUBLE;  v->TotalSize = SIZEOF_DOUBLE;  *Flag = 1;}
            else if(v->Type == TYPE_ENUM  ) { v->TypeSize = SIZEOF_ENUM  ;  v->TotalSize = SIZEOF_ENUM  ;  *Flag = 1;}
            else if(v->Type == TYPE_STRUCT) { v->TypeSize =  0;  v->TotalSize =  0;  *Flag = 1;}
            else if(v->Type == TYPE_UNION ) { v->TypeSize =  0;  v->TotalSize =  0;  *Flag = 1;}
            else                            { v->TypeSize = -1;  v->TotalSize = -1;  *Flag = 1;}
            v->StructInfo = t->StructInfo;
            if(v->StructInfo != NULL){
                v->TypeSize = v->StructInfo->StructSize;
                v->TotalSize = v->StructInfo->StructSize;
            }
            if((v->Pointer != 0) || (v->FuncPointer != 0)){
                v->TypeSize = SIZEOF_POINTER;
                v->TotalSize = SIZEOF_POINTER;
            }
            ++TokenIndex;
            *Flag = 1;
            break;
        }
        else if(Token == TOKEN_VOLATILE){ PrintInfo(__FILE__, __LINE__, "volatile𖳎܂B", "", "");}
        else if(Token == TOKEN_REGISTER){ PrintInfo(__FILE__, __LINE__, "register𖳎܂B", "", "");}
        else if(Token == TOKEN_CONST)   { PrintInfo(__FILE__, __LINE__, "const𖳎܂B", "", "");}
        else if(Token == TOKEN_AUTO)    { PrintInfo(__FILE__, __LINE__, "auto𖳎܂B", "", "");}
        else if(Token == TOKEN_STATIC)  { v->Scope =(Location == OUTSIDE_OF_FUNCTION)?  SCOPE_PV : SCOPE_ATS;}
        else if(Token == TOKEN_EXTERN)  {
            v->Scope = SCOPE_EX;
            if(Location != OUTSIDE_OF_FUNCTION){
                PrintError(__FILE__, __LINE__, "֐łextern錾ɂ́A܂ΉłĂ܂", "", "");
                return  P3CC_NG;
            }
        }
        else if(Token == TOKEN_SIGNED  ){ v->Sign = SIGN;  }
        else if(Token == TOKEN_UNSIGNED){ v->Sign = UNSIGN;}
        else if(Token == TOKEN_VOID  )  { v->Type = TYPE_VOID;   v->TypeSize = SIZEOF_VOID ;  v->TotalSize = SIZEOF_VOID ;  *Flag = 1;}
        else if(Token == TOKEN_CHAR  )  { v->Type = TYPE_CHAR;   v->TypeSize = SIZEOF_CHAR ;  v->TotalSize = SIZEOF_CHAR ;  *Flag = 1;}
        else if(Token == TOKEN_SHORT )  { v->Type = TYPE_SHORT;  v->TypeSize = SIZEOF_SHORT;  v->TotalSize = SIZEOF_SHORT;  *Flag = 1;}
        //else if(Token == TOKEN_INT   )  { v->Type = TYPE_INT;    v->TypeSize = SIZEOF_INT  ;  v->TotalSize = SIZEOF_INT  ;  *Flag = 1;}
        else if(Token == TOKEN_INT   )  { *Flag = 1;}
        else if(Token == TOKEN_LONG  )  { v->Type = TYPE_LONG;   v->TypeSize = SIZEOF_LONG ;  v->TotalSize = SIZEOF_LONG ;  *Flag = 1;}
        else if(Token == TOKEN_FLOAT )  { v->Type = TYPE_FLOAT;  v->TypeSize = SIZEOF_FLOAT;  v->TotalSize = SIZEOF_FLOAT;  *Flag = 1;
            PrintError(__FILE__, __LINE__, "floatΉB", "", "");
            return  P3CC_NG;
        }
        else if(Token == TOKEN_DOUBLE)  { v->Type = TYPE_DOUBLE; v->TypeSize = SIZEOF_DOUBLE;  v->TotalSize = SIZEOF_DOUBLE;  *Flag = 1;
            PrintError(__FILE__, __LINE__, "doubleΉB", "", "");
            return  P3CC_NG;
        }
        else if(Token == TOKEN_ENUM  )  { v->Type = TYPE_ENUM;   v->TypeSize = SIZEOF_ENUM;  v->TotalSize = SIZEOF_ENUM;  *Flag = 1;
            PrintError(__FILE__, __LINE__, "enumΉB", "", "");
            return  P3CC_NG;
        }
        else if(Token == TOKEN_STRUCT)  { v->Type = TYPE_STRUCT; v->TypeSize = 0; v->TotalSize = 0; *Flag = 1;} // 
        else if(Token == TOKEN_UNION )  { v->Type = TYPE_UNION;  v->TypeSize = 0; v->TotalSize = 0; *Flag = 1;} // 
        else if(Token == TOKEN_TYPEDEF) { v->Type = TYPE_TYPEDEF;v->TypeSize = 0; v->TotalSize = 0; *Flag = 1;} // 
        else break;
        ++TokenIndex;
    }
    return P3CC_OK;
}
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// ʎq\֘A
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//=====================================================================================================================
static void VariableListInit(void)
//=====================================================================================================================
// [@\] ϐe[ȕ
{
    TypedefInfoList     = NULL;
    StructInfoList  = NULL;
    ExtVariableList = NULL;
    GlVariableList  = NULL;
    PvVariableList  = NULL;
}
//=====================================================================================================================
static int VariableInit(variable *v)
//=====================================================================================================================
// [@\] ϐ̏
// [] |C^
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    v->Prev         = NULL;
    v->Next        = NULL;
    v->StructInfo   = NULL;
    v->Name         = NULL;
    v->FuncName     = NULL;
    if(Location == OUTSIDE_OF_FUNCTION) v->Scope = SCOPE_GL;
    else                                v->Scope = SCOPE_AT;
    v->Sign = SIGN;
    v->Pointer = NOT_POINTER;
    v->FuncPointer = NOT_POINTER;
    v->ArgNum = 0;
    v->Type = TYPE_INT;
    v->TypeFunction = TYPE_NOT_FUNCTION_POINTER;
    v->ArrayDim = 0;
    v->TypeSize = SIZEOF_INT;
    v->TotalSize = SIZEOF_INT;
    v->Offset = 0;
    v->ArgList = NULL;
    v->DimInfo = NULL;
    v->InitValHead.InfoNum = 0;
    v->InitValHead.Entry = NULL;
    v->InitValHead.Last = NULL;
    v->OptiInfo.RegEna = REG_DIS;
    v->OptiInfo.RegNo = 0;
    v->OptiInfo.RefCount = 0;
    return P3CC_OK;
}
//=====================================================================================================================
static int FunctionInit(function *f)
//=====================================================================================================================
// [@\] ֐̏
// [] |C^
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    int             i;
    f->Prev         = NULL;
    f->Next        = NULL;
    f->FuncName     = NULL;
    f->DeclaredPt = 0;
    f->DeclaredBody = 0;
    f->Sign = SIGN;
    f->Pointer = NOT_POINTER;
    f->Type = TYPE_INT;
    f->TypeSize = SIZEOF_INT;
    f->ArgNum = 0;
    f->StructInfo   = NULL;
    f->ArgList = NULL;
    f->VariableList = NULL;
    f->SizeOfLocal = 0;
    f->UserLabelList = NULL;
    f->LiteralLabelList = NULL;
    f->VCodeListHeader.Entry = NULL;
    f->VCodeListHeader.Last = NULL;
    f->MaxNumOfUsedVReg = 0;
    f->NumOfVarOnReg = 0;
    f->NumOfUsedScratchReg = 0;
    for(i = 0; i < NUM_OF_SCRATCH_REG + NUM_OF_VER_ON_REG + 1; i++){
        f->RegVsVar.v[i] = NULL;
    }
    for(i = 0; i < NUM_OF_SCRATCH_REG + NUM_OF_VER_ON_REG + 1; i++){
        f->UsedRegTbl[i] = 0;
    }
    return P3CC_OK;
}
//=====================================================================================================================
static int VariableGrobalAndExternTrim(void)
//=====================================================================================================================
// [@\] SCOPE_EXSCOPE_GĽ
// []
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    variable    *Ex;
    variable    *NextEx;
    variable    *Gl;

    if(GlVariableList == NULL) return P3CC_OK;
    Ex = ExtVariableList;
    while(1){
        if(Ex == NULL) break;
        Gl = GlVariableList;
        NextEx = Ex->Next;
        while(1){
            if(Gl == NULL) break;
            if(strcmp(Ex->Name, Gl->Name) == 0){//ϐAEx폜
                if(Ex == ExtVariableList){
                    ExtVariableList = Ex->Next;
                    if(Ex->Next != NULL){
                        Ex->Next->Prev = NULL;
                    }
                }
                else{
                    Ex->Prev->Next = Ex->Next;
                    if(Ex->Next != NULL){
                        Ex->Next->Prev = Ex->Prev;
                    }
                }
                free(Ex);
                break;
            }
            Gl = Gl->Next;
        }
        Ex = NextEx;
    }
    return P3CC_OK;
}
//=====================================================================================================================
static variable *VariableFindBody(char *Name, variable *v)
//=====================================================================================================================
// [@\] ϐ
// [] ʎq
// [] ֐
// [] ϐe[u̐擪
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    if(v == NULL) return NULL;
    while(1){
        if(strcmp(v->Name, Name)==0) return v;
        if(v->Next == NULL) return NULL;
        v = v->Next;
    }
}
//=====================================================================================================================
static int FinctionNameCheck(char *Name)
//=====================================================================================================================
// [@\] ֐`ς݂GlobalϐƏdĂȂ`FbN
// [] ʎq
// [Ԓl] P3CC_OK / P3CC_NG
{
    if(VariableFindBody(Name, GlVariableList ) != NULL) return P3CC_NG;
    if(VariableFindBody(Name, ExtVariableList) != NULL) return P3CC_NG;
    return P3CC_OK;
}
//=====================================================================================================================
static variable *VariableFind(char *Name, function *Func)
//=====================================================================================================================
// [@\] ϐ
// [] ʎq
// [] ֐
// [Ԓl] sNULL
{
    variable *v;

    v = NULL;
    if(Name == NULL) return v;

    if(Func != NULL) v = VariableFindBody(Name, Func->VariableList);
    if(v != NULL) return v;

    v = VariableFindBody(Name, PvVariableList);
    if(v != NULL) return v;

    v = VariableFindBody(Name, GlVariableList);
    if(v != NULL) return v;

    v = VariableFindBody(Name, ExtVariableList);
    return v;
}
//=====================================================================================================================
static int VariableCountElements(variable *v)
//=====================================================================================================================
// [@\] ϐ̗vfԂ
// [] ϐ̍\̂ւ̃|C^
// [Ԓl] ϐ̗vfԂ
{
    int     NumOfTopElements;
    int     NumOfElements;
    struct_info  *s;
    variable     *Member;

//    if(v->Type != TYPE_STRUCT){ // \̈ȊO
    if((v->Type != TYPE_STRUCT) && (v->Type != TYPE_STRUCT)){ // \(p)ȊO
        if(v->TypeSize != 0) NumOfElements = v->TotalSize / v->TypeSize;
        else NumOfElements = 0;
    }
    else{
        NumOfTopElements = v->TotalSize / v->TypeSize;
        if(v->Pointer == 0){
            s = v->StructInfo;
            Member = s->Member;
            NumOfElements = 0;
            while(1){
                NumOfElements += VariableCountElements(Member);
                if(Member->Next == NULL) break;
                Member = Member->Next;
            }
            NumOfElements = NumOfElements * NumOfTopElements;
        }
        else{
            NumOfElements = NumOfTopElements;
        }
    }
    return NumOfElements;
}
//=====================================================================================================================
static int VariableElementsInitialListFree(element_initial_list_header *Header)
//=====================================================================================================================
// [@\] ϐ̗vfTCYXg
// [] element_size_list          Fǉ
// [] element_initial_list_headerFXg̃wb_
// [Ԓl] P3CC_OK
{
    element_init_val_info   *Info;
    element_init_val_info   *Next;

    Info = Header->Entry;
    while(Info != NULL){
        Next = Info->Next;
        free(Info);
        Info = Next;
    }
    return P3CC_OK;
}

//=====================================================================================================================
static int VariableElementsInitialListAdd(element_init_val_info *e, element_initial_list_header *Header)
//=====================================================================================================================
// [@\] ϐ̗vfTCYXg֗vfTCYǉ
// [] element_size_list          Fǉ
// [] element_initial_list_headerFXg̃wb_
// [Ԓl] P3CC_OK
{
    element_init_val_info   *ebuf;

    ebuf =  calloc(1, sizeof(element_init_val_info));
    if(ebuf == NULL){
        PrintError(__FILE__, __LINE__, "lTCYXg̋L̈mێsB", "", "");
        return P3CC_NG;
    }
    *ebuf = *e;

    if(Header->Entry == NULL){
        Header->Entry = ebuf;
        Header->Last = ebuf;
        ebuf->Next = NULL;
    }
    else{
        Header->Last->Next = ebuf;
        Header->Last = ebuf;
        ebuf->Next = NULL;
    }
    Header->InfoNum +=1;
    return P3CC_OK;
}
//=====================================================================================================================
static int VariableElementsInitialListGet(variable *v, element_initial_list_header *Header, int Offset)
//=====================================================================================================================
// [@\] ϐ̊evfTCỸXg
// [] ϐ̍\̂ւ̃|C^
// [Ԓl] P3CC_OK
{
    int                     NumOfTopElements;
    int                     NumOfElements;
    int                     i;
    struct_info             *s;
    variable                *Member;
    element_init_val_info   e;


    e.Next = NULL;
    e.Value = 0;
    e.Id = 0;
    e.Str = NULL;
    e.DimInfo = NULL;
    //if(v->Type != TYPE_STRUCT){ // \̈ȊO
    if((v->Type != TYPE_STRUCT) && (v->Type != TYPE_UNION)){ // \(p)ȊO
        e.Sign = v->Sign;
        e.Pointer = v->Pointer;
        e.Size = v->TypeSize;
        e.DimInfo = v->DimInfo;
        NumOfElements = v->TotalSize / v->TypeSize;
        for(i = 0; i < NumOfElements; i++){
            e.Offset = Offset + (e.Size * i);
            if(VariableElementsInitialListAdd(&e, Header) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }
    }
    else if(v->Type != TYPE_UNION){ // p
        PrintError(__FILE__, __LINE__, "p̂̏ɂ͖ΉB", "", ""); return P3CC_NG;
    }
    else{ // \
        NumOfElements = v->TotalSize / v->TypeSize;
        if(v->Pointer == 0){
            e.Size = v->TypeSize;
            s = v->StructInfo;
            for(i = 0; i < NumOfElements; i++){
                Member = s->Member;
                e.Offset = Offset + (e.Size * i);
                while(1){
                    if(VariableElementsInitialListGet(Member, Header, (e.Offset + Member->Offset)) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                    if(Member->Next == NULL) break;
                    Member = Member->Next;
                }
            }
        }
        else{
            e.Sign = v->Sign;
            e.Pointer = v->Pointer;
            e.Size = v->TypeSize;
            e.DimInfo = v->DimInfo;
            for(i = 0; i < NumOfElements; i++){
                e.Offset = Offset + (e.Size * i);
                if(VariableElementsInitialListAdd(&e, Header) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            }
        }
    }
    return P3CC_OK;
}
//=====================================================================================================================
static int VariableArrayBtmDimGet(dimension_info *DimInfo)
//=====================================================================================================================
// [@\] z̍ŉʎ̗vf擾
// [] dimension_infoւ̃|C^
// [Ԓl] (Fchar a[5]Ȃ5ԂBchar a[5][3]Ȃ3ԂB)
{
    int i;

    for(i = 0; i < MAX_ARRAY_DIM; i++){
        if(DimInfo->NumOfElements[i] == 0) break;
    }
    return DimInfo->NumOfElements[i-1];
}
//=====================================================================================================================
static int VariableInitialValueGet(variable *v)
//=====================================================================================================================
// [@\] ϐ̏l擾
// [] ϐ̍\̂ւ̃|C^
// [Ԓl] ȂFP3CC_OKA肠FP3CC_NG
{
    int                         Token;
    int                         Value;
    int                         BraceCounter;// '{','}'̐𐔂
    int                         NumOfElements;//ׂvf
    element_initial_list_header Header;
    element_init_val_info       *InitValInfo;
    int                         InitializerCounter;//ľ
    int                         Dim;
    char                        *p;
    int                         Len;
    int                         i;
    function                    *f;

    Header.InfoNum = 0;
    Header.Entry = NULL;
    Header.Last = NULL;
    if(VariableElementsInitialListGet(v, &Header, 0) == P3CC_NG){
        PrintError(__FILE__, __LINE__, "ϐ̊evfTCỸXgsB", "", "");
        return P3CC_NG;
    }
    NumOfElements = Header.InfoNum;

    BraceCounter = 0;
    InitializerCounter = 0;
    InitValInfo = Header.Entry;
    while(1){
        Token = TokenGet(TokenIndex, __LINE__);
        if(Token == TOKEN_SEMICOLON){// ';'Ȃ
            if(BraceCounter == 0){ break;       } // {}̊OȂΐI;
            else{
                PrintError(__FILE__, __LINE__, "{}̑ΉĂȂH", "", "");
                return P3CC_NG;
            }
        }
        else if(Token == TOKEN_COMMA){    // ','Ȃ
            if(BraceCounter == 0){ break;       } // {}̊OȂΐI;
            else                 { ++TokenIndex;} // ','ǂݔ΂
        }
        else if(Token == TOKEN_BRACE_L){ ++BraceCounter; ++TokenIndex; }
        else if(Token == TOKEN_BRACE_R){ --BraceCounter; ++TokenIndex; }
        else if(InitializerCounter >= NumOfElements){
//printf("%d,%d\n",InitializerCounter,NumOfElements);
            PrintError(__FILE__, __LINE__, "ľH", "", "");
            if(InitValInfo->Pointer > 0){
                PrintError(__FILE__, __LINE__, "Ⴆ΁Aint a[] = { 1, 2, 3};̗lȐ錾ɂΉłB", "", "");
                PrintError(__FILE__, __LINE__, "̏ꍇ́Aint a[3] = { 1, 2, 3};Ɛ錾ĂB", "", "");
            }
            return P3CC_NG;
        }
        else {
            //l擾
            if(Token == TOKEN_STRING_LITERAL){
                if(InitValInfo->Pointer == 0){
                    if((InitValInfo->DimInfo != NULL) && (InitValInfo->Size == 1)){
                        Dim = VariableArrayBtmDimGet(InitValInfo->DimInfo);
                        p = TokenStrLiteralGet(TokenIndex);
                        Len = strlen(p);
                        if(Len + 1 > Dim){
                            PrintError(__FILE__, __LINE__, "񂪒܂B", "", "");
                            return P3CC_NG;
                        }
                        for(i = 0; i < Dim; i++){
                            if(i < Len){
                                InitValInfo->Value = (unsigned long)(*p) & 0xFF;
                                ++p;
                            }
                            else{
                                InitValInfo->Value = 0;
                            }
                            InitValInfo->Str = NULL;
                            ++InitializerCounter;
                            InitValInfo = InitValInfo->Next;
                        }
                    }
                    else {
                        //PrintWarning(__FILE__, __LINE__, "|C^^Ŗϐ𕶎ŏ悤ƂĂB", "", "");
                        PrintError(__FILE__, __LINE__, "|C^^Ŗϐ𕶎ŏ悤ƂĂB", "", "");
                        return P3CC_NG;
                    }
                }
                else{
                    InitValInfo->Str = TokenStrLiteralGet(TokenIndex);
                    ++InitializerCounter;
                    InitValInfo = InitValInfo->Next;
                }
                ++TokenIndex;
            }
            else if(Token == TOKEN_IDENTIFIER){//ʎqH
                InitValInfo->Id = 1;
                p = TokenIdStrGet(TokenIndex);
                //֐H
                f = FunctionFind(p);
                if(f != NULL){
                    InitValInfo->Str = p;
                    InitValInfo->Id = 1;
                    ++InitializerCounter;
                     InitValInfo = InitValInfo->Next;
                }
                else{
                    PrintError(__FILE__, __LINE__, "Ή̍\B", "炭ϐ̐錾̏̐ᔽB", "邢́A݂ȂʎqH");
                    return P3CC_NG;
                }
                ++TokenIndex;

            }
            else{
                ConstantExpressionErrorFlag = 0;
                Value = ConstantExpressionTop();
                if(ConstantExpressionErrorFlag){
                    PrintError(__FILE__, __LINE__, "ľvZɎsB", "", "");
                    return P3CC_NG;
                }
                InitValInfo->Str = NULL;
                InitValInfo->Value = (unsigned long)Value;
                ++InitializerCounter;
                InitValInfo = InitValInfo->Next;
            }
        }
    }
    if(InitializerCounter < NumOfElements){
        PrintError(__FILE__, __LINE__, "ľȂH", "", "");
        PrintError(__FILE__, __LINE__, "Ⴆ΁Aint a[3][3] = {{1,2},{4,5},{7,8}};̗lȏȗɂ͖ΉłB", "", "");
        PrintError(__FILE__, __LINE__, "̏ꍇAint a[3][3] = {{1,2,0},{4,5,0},{7,8,0}};ƂĉB", "", "");
       return P3CC_NG;
    }

    v->InitValHead = Header;

    --TokenIndex; // ';'̈OɊ߂

    return P3CC_OK;
}
//=====================================================================================================================
static int VariableCheck(variable *v)
//=====================================================================================================================
// [@\] ϐsۂ`FbN
// [] o^ϐ̍\̂ւ̃|C^
// [Ԓl] ȂFP3CC_OKA肠FP3CC_NG
{
    if((v->TypeSize == 0) || (v->TotalSize == 0)){
        PrintError(__FILE__, __LINE__, "͕s\ȕϐ̒`", v->Name, "");
        PrintVariable(v,0);
        return P3CC_NG;
    }

    return P3CC_OK;
}
//=====================================================================================================================
static int VariableListAdd(variable *v, function *f)
//=====================================================================================================================
// [@\] ϐXg֓o^
// [] o^ϐ̍\̂ւ̃|C^
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    variable    *vbuf;
    variable    *vt;

    if(VariableCheck(v) == P3CC_NG){
        return P3CC_NG;
    }
    vbuf = calloc(1, sizeof(variable));
    if(vbuf == NULL){
        PrintError(__FILE__, __LINE__, "ϐe[up̈mێsB", "", "");
        return P3CC_NG;
    }
    *vbuf = *v;

    if      (v->Scope == SCOPE_EX   )   vt = ExtVariableList;
    else if (v->Scope == SCOPE_GL   )   vt = GlVariableList ;
    else if (v->Scope == SCOPE_PV   )   vt = PvVariableList ;
    else  /*(v->Scope == SCOPE_AT or SCOPE_ATS )*/ vt = CurrentFuncInfo->VariableList ;


    if(vt == NULL){
        if      (v->Scope == SCOPE_EX   )   { ExtVariableList = vbuf; vbuf->Prev = NULL;}
        else if (v->Scope == SCOPE_GL   )   { GlVariableList  = vbuf; vbuf->Prev = NULL;}
        else if (v->Scope == SCOPE_PV   )   { PvVariableList  = vbuf; vbuf->Prev = NULL;}
        else  /*(v->Scope == SCOPE_AT  SCOPE_ATS   )*/ {
            if(ArgFind(vbuf->Name, f) != NULL){
                PrintError(__FILE__, __LINE__, "ʎq", vbuf->Name, "Qd`Ă܂B");
                free(vbuf);
                return P3CC_NG;
            }
            CurrentFuncInfo->VariableList  = vbuf;
            vbuf->Prev = NULL;
        }
    }
    else{
        while(1){
            if((vbuf->Scope != SCOPE_ATS) && (vbuf->Scope != SCOPE_AT)){ // [JϐȊO
                if(strcmp(vt->Name, vbuf->Name)==0){
                    PrintError(__FILE__, __LINE__, "ʎq", vbuf->Name, "Qd`Ă܂B");
                    free(vbuf);
                    return P3CC_NG;
                }
            }
            else{ // [Jϐ̏ꍇ
                if((strcmp(vt->Name, vbuf->Name)==0) // O̕ϐꍇ
                    || (ArgFind(vbuf->Name, f) != NULL)) // Öꍇ
                {
                    PrintError(__FILE__, __LINE__, "ʎq", vbuf->Name, "Qd`Ă܂B");
                    free(vbuf);
                    return P3CC_NG;
                }
            }
            if(vt->Next == NULL) break;
            vt = vt->Next;
        }
        vt->Next = vbuf;
        vbuf->Prev = vt;
    }

    return P3CC_OK;
}
//====================================================================================================================
static variable *ArgFind(char *Id, function *f)
//====================================================================================================================
// [@\] e[uɓʎqTĔ炻̃|C^Ԃ
// [] ֐ւ̃|C^
// [] ʎqւ̃|C^
// [Ԓl] F|C^AFNULL
{
    variable *vt;

    if(f==NULL) return NULL;
    if(f->ArgNum == 0) return NULL;
    vt = f->ArgList;
    while(1){
        if(vt == NULL) return NULL;
        if(vt->Name == NULL) return NULL;
        if(strcmp(Id, vt->Name)==0) break;
        vt = vt->Next;
    }
    return vt;
}
//=====================================================================================================================
static int ArgCheck(variable *v)
//=====================================================================================================================
// [@\] ϐsۂ`FbN
// [] o^ϐ̍\̂ւ̃|C^
// [Ԓl] ȂFP3CC_OKA肠FP3CC_NG
{
    if(v->DimInfo != NULL){// z̏ꍇNG
        if(v->DimInfo->NumOfElements[0] != 0){
            PrintError(__FILE__, __LINE__, "zƂ֐ɂ͖ΉłB", "", "");
            return P3CC_NG;
        }
    }
    else if(v->Type == TYPE_STRUCT){// \̂̏ꍇ́A|C^łȂNG
        if(v->Pointer == 0){
            PrintError(__FILE__, __LINE__, "\̂Ƃ֐ɂ͖ΉłB", "", "");
            return P3CC_NG;
        }
    }
    if(v->Type != TYPE_VOID){
        if((v->TypeSize == 0) || (v->TotalSize == 0)){
            PrintError(__FILE__, __LINE__, "͕s\Ȉ̒`B", "", "");
            return P3CC_NG;
        }
    }
    else{
        if(((v->Pointer == 0) && (v->FuncPointer == 0)) && (v->Name != NULL)) {
            PrintError(__FILE__, __LINE__, "\"void", v->Name, "͂肦ȂB");
            return P3CC_NG;
        }
    }
    return P3CC_OK;
}



//====================================================================================================================
static int VariableArgListAdd(variable *v, variable *f)
//====================================================================================================================
// [@\] e[u֓o^
// [] o^ϐ̍\̂ւ̃|C^
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    variable *vbuf;
    variable *vt;


    if(ArgCheck(v) == P3CC_NG){
        return P3CC_NG;
    }

    vbuf = calloc(1, sizeof(variable));
    if(vbuf == NULL){
        PrintError(__FILE__, __LINE__, "ϐe[up̈mێsB", "", "");
        return P3CC_NG;
    }
    *vbuf = *v;

    vt = f->ArgList;
    if(vt == NULL){
        f->ArgList = vbuf;
        vbuf->Prev = NULL;
    }
    else{
        while(1){
            if((vbuf->Name != NULL) && (vt->Name != NULL)){
                if(strcmp(vt->Name, vbuf->Name)==0){
                    PrintError(__FILE__, __LINE__, "̎ʎq", vbuf->Name, "Qd`Ă܂B");
                    free(vbuf);
                    return P3CC_NG;
                }
            }
            if(vt->Next == NULL) break;
            vt = vt->Next;
        }
        vt->Next = vbuf;
        vbuf->Prev = vt;
    }

    return P3CC_OK;
}
//====================================================================================================================
static int ArgListAdd(variable *v, function *f)
//====================================================================================================================
// [@\] e[u֓o^
// [] o^ϐ̍\̂ւ̃|C^
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    variable *vbuf;
    variable *vt;


    if(ArgCheck(v) == P3CC_NG){
        return P3CC_NG;
    }

    vbuf = calloc(1, sizeof(variable));
    if(vbuf == NULL){
        PrintError(__FILE__, __LINE__, "e[up̈mێs", "", "");
        return P3CC_NG;
    }
    *vbuf = *v;

    vt = f->ArgList;
    if(vt == NULL){
        f->ArgList = vbuf;
        vbuf->Prev = NULL;
    }
    else{
        while(1){
            if((vbuf->Name != NULL) && (vt->Name != NULL)){
                if(strcmp(vt->Name, vbuf->Name)==0){
                    PrintError(__FILE__, __LINE__, "̎ʎq", vbuf->Name, "Qd`Ă܂B");
                    free(vbuf);
                    return P3CC_NG;
                }
            }
            if(vt->Next == NULL) break;
            vt = vt->Next;
        }
        vt->Next = vbuf;
        vbuf->Prev = vt;
    }

    return P3CC_OK;
}
//====================================================================================================================
static int FunctionPrototypeAdd(function *f)
//====================================================================================================================
// [@\] ֐vg^Cv֐e[u֓o^
// [] o^֐̍\̂ւ̃|C^
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    function *fbuf;
    function *ft;

    fbuf = calloc(1, sizeof(function));
    if(fbuf == NULL){
        PrintError(__FILE__, __LINE__, "֐e[up̈mێsB", "", "");
        return P3CC_NG;
    }
    *fbuf = *f;

    ft = FunctionList;
    if(ft == NULL){
        FunctionList = fbuf;
        fbuf->Prev = NULL;
    }
    else{
        while(1){
            if(strcmp(ft->FuncName, fbuf->FuncName)==0){
                PrintError(__FILE__, __LINE__, "֐̎ʎq", fbuf->FuncName, "Qd`Ă܂B");
                free(fbuf);
                return P3CC_NG;
            }
            if(ft->Next == NULL) break;
            ft = ft->Next;
        }
        ft->Next = fbuf;
        fbuf->Prev = ft;
    }
    fbuf->DeclaredPt = 1;
    return P3CC_OK;
}
//====================================================================================================================
static int FuncLocalVariableSizeGet(variable *LocalList)
//====================================================================================================================
// [@\] ֐f̃[Jϐ̃ItZbg̑TCYvZ
// [] ȗ
// [Ԓl] ֐f̃[Jϐ̑TCY
{
    variable *v;
    int      Size;
    int      Total;
    int      Flag;

    v = LocalList;
    if(v == NULL){ // oȂȂ
        return 0;
    }
    Flag = 0;
    Total = 0;
    while(1){
        if(v == NULL) break;
        if(v->Scope == SCOPE_AT){
//FILE *BK;
//BK = LogFile;
//LogFile = stdout;
//PrintVariable(v,0);
//LogFile = BK;
            Size = v->TotalSize;
            if(Flag == 0){
#ifdef VAR_ON_REG_ENABLE
                if(v->OptiInfo.RegNo == 0){
                    v->Offset = 0;
                    Total = Size;
                    Flag = 1;
                }
#else
                v->Offset = 0;
                Total = Size;
                Flag = 1;
#endif
            }
            else{
#ifdef VAR_ON_REG_ENABLE
                if(v->OptiInfo.RegNo == 0){
                    if(Size == 1)       v->Offset = Total;
                    else if(Size == 2)  v->Offset = (Total + 1) & (~0x1);
                    else                v->Offset = (Total + 3) & (~0x3);
                    Total = v->Offset + Size;
                }
#else
                if(Size == 1)       v->Offset = Total;
                else if(Size == 2)  v->Offset = (Total + 1) & (~0x1);
                else                v->Offset = (Total + 3) & (~0x3);
                Total = v->Offset + Size;
#endif
            }
        }
        v = v->Next;
//printf("%d\n",Total);
    }
    Total = (Total + 3) & (~0x3);

    v = LocalList;
    while(1){
        if(v == NULL) break;
        if(v->Scope == SCOPE_AT){
#ifdef VAR_ON_REG_ENABLE
            if(v->OptiInfo.RegNo == 0){
                v->Offset = -Total + v->Offset;
            }
#else
            v->Offset = -Total + v->Offset;
#endif
        }
        v = v->Next;
    }
    return  Total;
}
//====================================================================================================================
static int FuncLocalArgSizeGet(variable *ArgList)
//====================================================================================================================
// [@\] ֐f̈̃ItZbg̑TCYvZ
// [] ȗ
// [Ԓl] ֐f̈̑TCY
{
    variable *v;
    int      Size;
    int      Total;
    int      Flag;

    v = ArgList;
    if(v == NULL){ // oȂȂ
        return 0;
    }

    Flag = 0;
    while(1){
        if(v == NULL) break;
        Size = v->TotalSize;
        if(Size < 4) Size = 4;
        if(Flag == 0){
            v->Offset = 0;
            Total = Size;
            Flag = 1;
        }
        else{
            v->Offset = (Total + 3) & (~0x3);
            Total = v->Offset + Size;
        }
        v = v->Next;
    }
    Total = (Total + 3) & (~0x3);

    v = ArgList;
    while(1){
        if(v == NULL) break;
        v->Offset = v->Offset + 8;  // FP+0ɂ́AĂяo̊֐FP&LRޔ̂ŁA
                                    // FP+8zu
        v = v->Next;
    }
    return  Total;
}

//====================================================================================================================
static int ArgListCheck(variable *Arg, int Mode)
//====================================================================================================================
// [@\] Xg̑Ó`FbN
// [] Xgւ̃|C^
// [] [h:0:vg^CvA0
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    int         NumOfArg;
    int         NumOfVoid;

    NumOfArg = NumOfVoid = 0;
    while(1){
        if(Arg == NULL) break;
        if(Mode){
            if(Arg->Name == NULL){
                if((Arg->Type == TYPE_VOID) && ((Arg->Pointer == 0) && (Arg->FuncPointer == 0))){
                    ++NumOfVoid;
                }
                else{
                    PrintError(__FILE__, __LINE__, "̎ʎqȂB", "", "");
                    return P3CC_NG;
                }
            }
        }
        else{
            if((Arg->Type == TYPE_VOID) && ((Arg->Pointer == 0) && (Arg->FuncPointer == 0))){
                ++NumOfVoid;
            }
        }
        Arg = Arg->Next;
        ++NumOfArg;
    }
    if(NumOfVoid >= 1){
        if((NumOfVoid == 1) && (NumOfArg == 1)){
            ;
        }
        else{
            PrintError(__FILE__, __LINE__, "", "", "");
            return P3CC_NG;
        }
    }
    return P3CC_OK;
}
//====================================================================================================================
static int ArgListCompare2(variable *Arg0, variable *Arg1)
//====================================================================================================================
// [@\] Xǧ^ƏԂvĂ邩`FbN
// [] ֐̍\̂ւ̃|C^ ft:vg^Cv fbuf:̑
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    int         NumOfArg;
    int         NumOfVoid;

    NumOfArg = NumOfVoid = 0;
    while(1){
        if((Arg0 == NULL) || (Arg1 == NULL)){
            if((Arg0 == NULL) && (Arg1 == NULL)){   break;          }
            else{ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }
        if(Arg0->Sign         != Arg1->Sign        ){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(Arg0->Pointer      != Arg1->Pointer     ){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(Arg0->Type         != Arg1->Type        ){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(Arg0->TypeFunction != Arg1->TypeFunction){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(Arg0->TypeSize     != Arg1->TypeSize    ){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(Arg0->DimInfo      != Arg1->DimInfo     ){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(Arg0->StructInfo   != Arg1->StructInfo  ){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(Arg0->FuncPointer  != Arg1->FuncPointer ){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(Arg0->ArgNum       != Arg1->ArgNum      ){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(ArgListCompare2(Arg0->ArgList, Arg1->ArgList) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
//        if(Arg1->Name == NULL){
//            if((Arg1->Type == TYPE_VOID) && (Arg1->Pointer == 0)){
//                ++NumOfVoid;
//            }
//            else{
//                PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;
//            }
//        }
        Arg0 = Arg0->Next;
        Arg1 = Arg1->Next;
        ++NumOfArg;
    }
    if(NumOfVoid >= 1){
        if((NumOfVoid == 1) && (NumOfArg == 1)){
            ;
        }
        else{
            PrintError(__FILE__, __LINE__, "", "", "");
            return P3CC_NG;
        }
    }
    return P3CC_OK;
}

//====================================================================================================================
static int ArgListCompare(function *ft, function *fbuf)
//====================================================================================================================
// [@\] Xǧ^ƏԂvĂ邩`FbN
// [] ֐̍\̂ւ̃|C^ ft:vg^Cv fbuf:̑
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    variable    *Arg0;
    variable    *Arg1;
    int         NumOfArg;
    int         NumOfVoid;

    if(ft->ArgNum != fbuf->ArgNum){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    if(ft->ArgNum == 0) return P3CC_OK;

    Arg0=ft->ArgList;
    Arg1=fbuf->ArgList;
    NumOfArg = NumOfVoid = 0;
    while(1){
        if((Arg0 == NULL) || (Arg1 == NULL)){
            if((Arg0 == NULL) && (Arg1 == NULL)){   break;          }
            else{ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }
        if(Arg0->Sign         != Arg1->Sign        ){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(Arg0->Pointer      != Arg1->Pointer     ){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(Arg0->Type         != Arg1->Type        ){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(Arg0->TypeFunction != Arg1->TypeFunction){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(Arg0->TypeSize     != Arg1->TypeSize    ){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(Arg0->DimInfo      != Arg1->DimInfo     ){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(Arg0->StructInfo   != Arg1->StructInfo  ){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(Arg0->FuncPointer  != Arg1->FuncPointer ){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(Arg0->ArgNum       != Arg1->ArgNum      ){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(ArgListCompare2(Arg0->ArgList, Arg1->ArgList) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(Arg1->Name == NULL){
            if((Arg1->Type == TYPE_VOID) && (Arg1->Pointer == 0)){
                ++NumOfVoid;
            }
            else{
                PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;
            }
        }
        Arg0 = Arg0->Next;
        Arg1 = Arg1->Next;
        ++NumOfArg;
    }
    if(NumOfVoid >= 1){
        if((NumOfVoid == 1) && (NumOfArg == 1)){
            ;
        }
        else{
            PrintError(__FILE__, __LINE__, "", "", "");
            return P3CC_NG;
        }
    }
    return P3CC_OK;
}
//====================================================================================================================
static int VariableListFree(variable *v)
//====================================================================================================================
// [@\] ϐ񃊃Xg
// [] ֐̍\̂ւ̃|C^
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    variable *Next;

    while(v != NULL){
        Next = v->Next;
        if(v->ArgList != NULL) VariableListFree(v->ArgList);
        if(v->DimInfo != NULL) free(v->DimInfo);
        if(v->InitValHead.Entry != NULL) VariableElementsInitialListFree(&v->InitValHead);
        free(v);
        v = Next;
    }
    return P3CC_OK;
}
//====================================================================================================================
static int FunctionListInit(void)
//====================================================================================================================
// [@\] ֐e[ȕ
// []
// []
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    FunctionList = NULL;
    return P3CC_OK;
}
//====================================================================================================================
static function *FunctionFind(char *FuncName)
//====================================================================================================================
// [@\] ֐
// [] ֐
// [Ԓl] F֐ւ̃|C^AsFNULL
{
    function *f;

    f = FunctionList;
    while(1){
        if(f == NULL) return NULL;
        if(strcmp(FuncName, f->FuncName) == 0) break;
        f = f->Next;
    }
    return f;
}
//====================================================================================================================
static int FunctionCopy(function *proto, function *body)
//====================================================================================================================
// [@\] ֐bodyprotoփRs[
// [] ꂼ̊֐̍\̂ւ̃|C^(ǂNULLłȂƂĂяoŕۏ)
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    function *Prev;
    function *Next;

    Prev = proto->Prev;
    Next = proto->Next;
    if(proto->ArgList != NULL){ VariableListFree(proto->ArgList); }
    *proto = *body;
    proto->Prev = Prev;
    proto->Next = Next;
    body->ArgList = NULL;
    free(body);
    return P3CC_OK;
}
//====================================================================================================================
static int FunctionBodyAdd(function *f)
//====================================================================================================================
// [@\] ֐{̂֐e[u֓o^
// [] o^֐̍\̂ւ̃|C^
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    int      Ret;
    function *fbuf;
    function *ft;

    fbuf = calloc(1, sizeof(function));
    if(fbuf == NULL){
        PrintError(__FILE__, __LINE__, "֐e[up̈mێs", "", "");
        return P3CC_NG;
    }
    *fbuf = *f;
    fbuf->DeclaredBody = 1;

    ft = FunctionList;
    if(ft == NULL){
        FunctionList = fbuf;
        fbuf->Prev = NULL;
    }
    else{
        while(1){
            if(strcmp(ft->FuncName, fbuf->FuncName)==0){
                if(ft->DeclaredBody != 0){
                    PrintError(__FILE__, __LINE__, "֐Qd`Ă܂B", "", "");
                    free(fbuf);
                    return P3CC_NG;
                }
                Ret = ArgListCompare(ft, fbuf);//Xǧ^ƏԂvĂ邩`FbN
                if(Ret == P3CC_NG){
                    PrintError(__FILE__, __LINE__, "̌^AAvĂ܂B", "", "");
                    free(fbuf);
                    return P3CC_NG;
                }
                //=== ւo^
                FunctionCopy(ft, fbuf);
                break;
            }
            if(ft->Next == NULL){
                //=== VKo^
                ft->Next = fbuf;
                fbuf->Prev = ft;
                break;
            }
            ft = ft->Next;
        }
    }
    fbuf->DeclaredBody = 1;
    return P3CC_OK;
}
//====================================================================================================================
static int TypedefListAdd(variable *v)
//====================================================================================================================
// [@\] TypedefΉe[u֓o^
// [] o^ϐ̍\̂ւ̃|C^
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    typedef_info *tbuf;
    typedef_info *t;

    tbuf = calloc(1, sizeof(typedef_info));
    if(tbuf == NULL){
        PrintError(__FILE__, __LINE__, "TypedefΉe[up̈mێsB", "", "");
        return P3CC_NG;
    }
    tbuf->Prev = NULL;
    tbuf->Next = NULL;
    tbuf->TypeName = v->Name;
    tbuf->Pointer = v->Pointer;
    tbuf->Sign = v->Sign;
    tbuf->Type = v->Type;
    tbuf->TypeFunction = v->TypeFunction;
    tbuf->FuncPointer = v->FuncPointer;
    tbuf->ArgNum = v->ArgNum;
    tbuf->ArgList = v->ArgList;
    tbuf->StructInfo = v->StructInfo;

    t = TypedefInfoList;
    if(t == NULL){
        TypedefInfoList = tbuf;
    }
    else{
        while(1){
            if(strcmp(t->TypeName, tbuf->TypeName)==0){
                PrintError(__FILE__, __LINE__, "typedefʎq", tbuf->TypeName, "Qd`Ă܂B");
                free(tbuf);
                return P3CC_NG;
            }
            if(t->Next == NULL) break;
            t = t->Next;
        }
        t->Next = tbuf;
        tbuf->Prev = t;
    }

    return P3CC_OK;
}
//====================================================================================================================
static int StructInit(struct_info *si)
//====================================================================================================================
// [@\] \̌^̏
// [] |C^
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    si->Prev         = NULL;
    si->Next        = NULL;
    si->TagName      = NULL;
    si->FuncName     = NULL;
    si->Provisional  = P3CC_TRUE;
    if(Location == OUTSIDE_OF_FUNCTION) si->Scope = SCOPE_GL;
    else                                si->Scope = SCOPE_AT;
    si->Type = TYPE_STRUCT;
    si->StructSize = 0;
    si->Member = NULL;
    return P3CC_OK;
}
//====================================================================================================================
static struct_info *StructFind(char *TagName, char *FuncName, char Scope)
//====================================================================================================================
// [@\] \̌^
// [] ^O
// [] ֐
// [] XR[v
// [] ʊi[p̃|C^
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    struct_info *si;
    char TestScope;

    si = StructInfoList;
    if(si == NULL) return NULL;
    if(TagName == NULL) return NULL;
    TestScope = Scope;
    while(1){
        si = StructInfoList;
        while(1){
            if(si->Scope == TestScope){
                if(strcmp(si->TagName, TagName) == 0){
                    if(((Scope == SCOPE_ATS) || (Scope == SCOPE_AT)) && ((TestScope == SCOPE_ATS) || (TestScope == SCOPE_AT))){
                        if((strcmp(si->FuncName, FuncName) == 0)){
                            return si;
                        }
                    }
                    else{
                        return si;
                    }
                }
            }
            if(si->Next == NULL) break;
            si = si->Next;
        }
        if(TestScope == SCOPE_EX) break;
        --TestScope;
    }
    return NULL;
}
//====================================================================================================================
static variable *StructMemberFind(struct_info *StructInfo, char *MemberName)
//====================================================================================================================
// [@\] \̃o
// [] struct_info
// [] o
// [Ԓl] Foւ̃|C^AsFNULL
{
    variable    *m;

    if(StructInfo == NULL) return NULL;
    if(MemberName == NULL) return NULL;
    m = StructInfo->Member;
    if(m == NULL) return NULL;

    while(1){
        if(strcmp(m->Name, MemberName) == 0) break;
        if(m->Next == NULL) return NULL;
        m = m->Next;
    }

    return m;
}
//====================================================================================================================
static int StructSizeGet(struct_info *si)
//====================================================================================================================
// [@\] \̃TCYvZ
// [] \̂̌^ւ̃|C^
// [Ԓl] \̂̃TCY
{
    variable *vt;
    int      Size;
    int      Offset;

    vt = si->Member;
    if(vt == NULL){ // oȂȂ
        return 0;
    }
    else{
        while(1){
            if(vt->Next == NULL) break;
            vt = vt->Next;
        }
        Size = vt->TotalSize;
        Offset = vt->Offset;
        return  (Offset + Size + 3) & (~0x3);
    }
}
//====================================================================================================================
static int UnionSizeGet(struct_info *si)
//====================================================================================================================
// [@\] p̃TCYvZ
// [] p̂̌^ւ̃|C^
// [Ԓl] p̂̃TCY
{
    variable *vt;
    int      MaxSize;

    vt = si->Member;
    if(vt == NULL){ // oȂȂ
        return 0;
    }
    else{
        MaxSize = 0;
        while(1){
            if(MaxSize < vt->TotalSize) MaxSize = vt->TotalSize;
            if(vt->Next == NULL) break;
            vt = vt->Next;
        }
        return  (MaxSize + 3) & (~0x3);
    }
}

//=====================================================================================================================
static int StructMemberCheck(variable *v)
//=====================================================================================================================
// [@\] ϐsۂ`FbN
// [] o^ϐ̍\̂ւ̃|C^
// [Ԓl] ȂFP3CC_OKA肠FP3CC_NG
{
    if((v->TypeSize == 0) || (v->TotalSize == 0)){
        PrintError(__FILE__, __LINE__, "͕s\ȍ\̃o̒`", v->Name, "");
        //PrintVariable(v,0);
        return P3CC_NG;
    }
    return P3CC_OK;
}

//====================================================================================================================
static int StructMemberAdd(variable *Member, struct_info *si)
//====================================================================================================================
// [@\] \̃oɒǉ
// [] o^\̂̌^ւ̃|C^
// [] o^郁oւ̃|C^
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    variable *vbuf;
    variable *vt;
    int      Size;
    int      Offset;

    if(StructMemberCheck(Member) == P3CC_NG){
        return P3CC_NG;
    }

    vbuf = calloc(1, sizeof(variable));
    if(vbuf == NULL){
        PrintError(__FILE__, __LINE__, "\̃op̈mێs", "", "");
        return P3CC_NG;
    }
    *vbuf = *Member;

    vt = si->Member;
    if(vt == NULL){ // ŏ̃oȂ
        si->Member = vbuf;
        vbuf->Prev = NULL;
        vbuf->Offset = 0;
    }
    else{
        while(1){
            if(strcmp(vt->Name, vbuf->Name)==0){
                PrintError(__FILE__, __LINE__, "\̃oʎq", vbuf->Name, "Qd`Ă܂B");
                free(vbuf);
                return P3CC_NG;
            }
            if(vt->Next == NULL) break;
            vt = vt->Next;
        }
        vt->Next = vbuf;
        vbuf->Prev = vt;

        if(si->Type == TYPE_STRUCT){
            Size = vt->TotalSize;
            Offset = vt->Offset;
            if(vbuf->TotalSize == 1){
                vbuf->Offset = Offset + Size;
            }
            else if(vbuf->TotalSize == 2){
                vbuf->Offset = (Offset + Size + 1) & (~0x1);
            }
            else{
                vbuf->Offset = (Offset + Size + 3) & (~0x3);
            }
        }
        else{
            vbuf->Offset = 0;
        }
    }

    return P3CC_OK;
}
//====================================================================================================================
static int StructInfoListRemove(struct_info *si)
//====================================================================================================================
// [@\] \̌^e[u폜
// [] o^\̌^ւ̃|C^
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    struct_info *sit;

    sit = StructInfoList;
    if(sit == NULL) return P3CC_OK;
    while(1){
        if(strcmp(sit->TagName, si->TagName)==0){
            if((sit->Scope == si->Scope)
                &&  (   ((sit->Scope == SCOPE_EX)  || (sit->Scope == SCOPE_GL)  || (sit->Scope == SCOPE_PV))
                    ||  (((sit->Scope == SCOPE_ATS) || (sit->Scope == SCOPE_AT)) && (strcmp(sit->FuncName, si->FuncName) == 0))
                    )
              )
            {
                if(sit == StructInfoList){ //Xg̐擪̏ꍇ
                    if(sit->Next == NULL){
                        StructInfoList = NULL;
                    }
                    else{
                        StructInfoList = sit->Next;
                        sit->Next->Prev = NULL;
                    }
                }
                else{//Xg̐擪ȊȌꍇ
                    if(sit->Next == NULL){
                        sit->Prev->Next = NULL;
                    }
                    else{
                        sit->Prev->Next = sit->Next;
                        sit->Next->Prev = sit->Prev;
                    }
                }
                free(sit);
            }
            break;
        }
        if(sit->Next == NULL) break;
        sit = sit->Next;
    }
    return P3CC_OK;
}
//====================================================================================================================
static int StructInfoListAdd(struct_info *si)
//====================================================================================================================
// [@\] \̌^e[u֓o^
// [] o^\̌^ւ̃|C^
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    struct_info *sibuf;
    struct_info *sit;

    sibuf = calloc(1, sizeof(struct_info));
    if(sibuf == NULL){
        PrintError(__FILE__, __LINE__, "\̌^e[up̈mێs", "", "");
        return P3CC_NG;
    }
    *sibuf = *si;

    sit = StructInfoList;
    if(sit == NULL){
        StructInfoList = sibuf;
        sibuf->Prev = NULL;
    }
    else{
        while(1){
            if(strcmp(sit->TagName, sibuf->TagName)==0){
                if((sit->Scope == sibuf->Scope)
                    &&  (   ((sit->Scope == SCOPE_EX)  || (sit->Scope == SCOPE_GL)  || (sit->Scope == SCOPE_PV))
                        ||  (((sit->Scope == SCOPE_ATS) || (sit->Scope == SCOPE_AT)) && (strcmp(sit->FuncName, sibuf->FuncName) == 0))
                        )
                  )
                {
                    if((sit->Provisional == P3CC_TRUE) && (sibuf->Provisional != P3CC_TRUE)){ //o^̏ɖ{o^
                        sibuf->Prev = sit->Prev;
                        sibuf->Next = sit->Next;
                        *sit = *sibuf;
                        free(sibuf);
                        return P3CC_OK;
                    }
                    else{
                        PrintError(__FILE__, __LINE__, "\̃^O", sibuf->TagName, "Qd`Ă܂B");
                        free(sibuf);
                        return P3CC_NG;
                    }
                }
            }
            if(sit->Next == NULL) break;
            sit = sit->Next;
        }
        sit->Next = sibuf;
        sibuf->Prev = sit;
    }
    return P3CC_OK;
}
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// TOKEN֘A
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//====================================================================================================================
static void InitCc1ResAcsessPointers(cc0_result *Cc0Res, cc1_result *Cc1Res)
//====================================================================================================================
// [@\] ͌ʃANZXp|C^̏
{
    SrcFileTbl      = Cc0Res->SrcFileTbl;
    SrcTbl          = Cc0Res->SrcTbl;
    NumOfToken      = Cc1Res->TokenTblIndex;
    TokenTbl        = Cc1Res->TokenTbl;
    IdentifierTbl   = Cc1Res->IdentifierTbl;
    StrLiteralTbl   = Cc1Res->StrLiteralTbl;
    NumLiteralTbl   = Cc1Res->NumLiteralTbl;
    Cc0Result       = Cc0Res; // for debug
    Cc1Result       = Cc1Res; // for debug
}
//====================================================================================================================
static char *TokenStrLiteralGet(int TokenIndex)
//====================================================================================================================
// [@\] ʎq擾
// [Ԓl] ʎqւ̃|C^
{
    if(TokenTbl[TokenIndex].Type != TOKEN_STRING_LITERAL) return NULL;
    return StrLiteralTbl[TokenTbl[TokenIndex].ExtInfoIndex].StringLiteral;
}
//====================================================================================================================
static char *TokenIdStrGet(int TokenIndex)
//====================================================================================================================
// [@\] ʎq̕擾
// [Ԓl] ʎqւ̃|C^
{
    if(TokenTbl[TokenIndex].Type != TOKEN_IDENTIFIER) return NULL;
    return IdentifierTbl[TokenTbl[TokenIndex].ExtInfoIndex].Identifier;
}
//====================================================================================================================
static char *TokenSrcFileNameGet(int TokenIndex)
//====================================================================================================================
// [@\] \[Xt@C擾
// [Ԓl] \[Xt@Cւ̃|C^
{
    return TokenSrcFileNameGetBySrcTblIndex(TokenSrcFileIndexGet(TokenIndex));
    //return SrcFileTbl[TokenSrcFileIndexGet(TokenIndex)].FileName;
}
//====================================================================================================================
static char *TokenSrcFileNameGetBySrcTblIndex(int SrcTblIndex)
//====================================================================================================================
// [@\] \[Xt@C擾
// [Ԓl] \[Xt@Cւ̃|C^
{
    return SrcFileTbl[SrcTblIndex].FileName;
}
//====================================================================================================================
static int TokenSrcFileIndexGet(int TokenIndex)
//====================================================================================================================
// [@\] \[Xt@CIndex
// [Ԓl] \[Xt@Ce[uIndex
{
    return SrcTbl[TokenTbl[TokenIndex].SrcTblIndex].SourceFileNo;
}
//====================================================================================================================
static int TokenSrcLineGet(int TokenIndex)
//====================================================================================================================
// [@\] \[Xs擾
// [Ԓl] \[XsNo
{
    return SrcTbl[TokenTbl[TokenIndex].SrcTblIndex].SourceLineNo;
}
//====================================================================================================================
static int TokenGet(int TokenIndex, int Line)
//====================================================================================================================
// [@\] TOKEN擾
// [Ԓl] TOKEN
{
    int         Ret;
    static int  Counter = 0;
    static int  LastIndex = 0;

    Ret = TokenTbl[TokenIndex].Type;
    Token2String(TokenIndex, CurrentTokenBuf);
    if(LastIndex == TokenIndex){
        ++Counter;
        if(Counter > 30){
            PrintError(__FILE__, __LINE__, "RpC̃oOB", "", "");
            exit(0);
        }
    }
    else{
        Counter = 0;
        LastIndex = TokenIndex;
    }

    if(TokenReadDebugFlag){
        //PrintSpace(DebugMsgIndentCounter);
        fprintf(LogFile, "[%d]:%d:%d:", Line, TokenIndex,Ret);
        fprintf(LogFile, "%s\n",CurrentTokenBuf);
    }
    return Ret;
}
//====================================================================================================================
static int TokenNumLiteralValueGet(int TokenIndex)
//====================================================================================================================
// [@\] 萔擾
// [Ԓl] 萔
{
    unsigned long   Ret;
    int             iRet;
    Ret = NumLiteralTbl[TokenTbl[TokenIndex].ExtInfoIndex].Value.FixedPointValue;
    iRet=(int)Ret;
    return iRet;
}
//====================================================================================================================
static int TokenNumLiteralStyleGet(int TokenIndex)
//====================================================================================================================
// [@\] 萔Lڏ̎擾
// [Ԓl] 萔
{
    unsigned long   Ret;
    int             iRet;
    Ret = NumLiteralTbl[TokenTbl[TokenIndex].ExtInfoIndex].Value.FixedPointValue;
    iRet=(int)Ret;
    return iRet;
}
//====================================================================================================================
static cc1_numeric_literal *TokenNumLiteralPtrGet(int TokenIndex)
//====================================================================================================================
// [@\] leւ̃|C^擾
// [Ԓl] 萔
{
    return &NumLiteralTbl[TokenTbl[TokenIndex].ExtInfoIndex];
}

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// ֘A
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//====================================================================================================================
static int ExpressionGprNoForce(int GprNoForce)
//====================================================================================================================
// [@\] ėpWX^Nos̊JnWX^Noݒ
// [Ԓl] P3CC_OK
{
    GeneratedGprNo = GprNoForce;
    return GeneratedGprNo;
}

//====================================================================================================================
static int ExpressionGprNoInit(void)
//====================================================================================================================
// [@\] ėpWX^Nos̏
// [Ԓl] P3CC_OK
{
    GeneratedGprNo = 0;
    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionNewGprNoGet(void)
//====================================================================================================================
// [@\] ėpWX^Nos
// [Ԓl] ėpWX^No
{
    ++GeneratedGprNo;
    return GeneratedGprNo;
}
//====================================================================================================================
static int IsImmOffsetLoadStre(char Code)
//====================================================================================================================
// [@\] lItZbgw̃[h/XgA߂ۂ𔻒肷
// [] g[N
// [Ԓl] Zq:1AZqȊOF0
{
    if(Code == OPECODE_LDW_I    ) return P3CC_TRUE;
    if(Code == OPECODE_LDW_UB_I ) return P3CC_TRUE;
    if(Code == OPECODE_LDW_UA_I ) return P3CC_TRUE;
    if(Code == OPECODE_LDH_I    ) return P3CC_TRUE;
    if(Code == OPECODE_LDH_UB_I ) return P3CC_TRUE;
    if(Code == OPECODE_LDH_UA_I ) return P3CC_TRUE;
    if(Code == OPECODE_LDB_I    ) return P3CC_TRUE;
    if(Code == OPECODE_LDB_UB_I ) return P3CC_TRUE;
    if(Code == OPECODE_LDB_UA_I ) return P3CC_TRUE;
    if(Code == OPECODE_LDSH_I   ) return P3CC_TRUE;
    if(Code == OPECODE_LDSH_UB_I) return P3CC_TRUE;
    if(Code == OPECODE_LDSH_UA_I) return P3CC_TRUE;
    if(Code == OPECODE_LDSB_I   ) return P3CC_TRUE;
    if(Code == OPECODE_LDSB_UB_I) return P3CC_TRUE;
    if(Code == OPECODE_LDSB_UA_I) return P3CC_TRUE;
    if(Code == OPECODE_STW_I    ) return P3CC_TRUE;
    if(Code == OPECODE_STW_UB_I ) return P3CC_TRUE;
    if(Code == OPECODE_STW_UA_I ) return P3CC_TRUE;
    if(Code == OPECODE_STH_I    ) return P3CC_TRUE;
    if(Code == OPECODE_STH_UB_I ) return P3CC_TRUE;
    if(Code == OPECODE_STH_UA_I ) return P3CC_TRUE;
    if(Code == OPECODE_STB_I    ) return P3CC_TRUE;
    if(Code == OPECODE_STB_UB_I ) return P3CC_TRUE;
    if(Code == OPECODE_STB_UA_I ) return P3CC_TRUE;
    return P3CC_FALSE;
}
//====================================================================================================================
static int IsAssignmentOperator(int Token)
//====================================================================================================================
// [@\] Zq`FbN
// [] g[N
// [Ԓl] Zq:1AZqȊOF0
{
    if(Token == TOKEN_EQ        ) return P3CC_TRUE;
    if(Token == TOKEN_PLUS_EQ   ) return P3CC_TRUE;
    if(Token == TOKEN_MINUS_EQ  ) return P3CC_TRUE;
    if(Token == TOKEN_MULT_EQ   ) return P3CC_TRUE;
    if(Token == TOKEN_DIV_EQ    ) return P3CC_TRUE;
    if(Token == TOKEN_MOD_EQ    ) return P3CC_TRUE;
    if(Token == TOKEN_AND_EQ    ) return P3CC_TRUE;
    if(Token == TOKEN_XOR_EQ    ) return P3CC_TRUE;
    if(Token == TOKEN_OR_EQ     ) return P3CC_TRUE;
    if(Token == TOKEN_SHIFT_L_EQ) return P3CC_TRUE;
    if(Token == TOKEN_SHIFT_R_EQ) return P3CC_TRUE;
    return P3CC_FALSE;
}
//====================================================================================================================
static int IsPrefixUnaryOperator(int Token)
//====================================================================================================================
// [@\] Zq`FbN
// [] g[N
// [Ԓl] Zq:1AZqȊOF0
{
    if(Token == TOKEN_AMPERSAND  ) return P3CC_TRUE;
    if(Token == TOKEN_ASTERISK   ) return P3CC_TRUE;
    if(Token == TOKEN_PLUS       ) return P3CC_TRUE;
    if(Token == TOKEN_MINUS      ) return P3CC_TRUE;
    if(Token == TOKEN_NOT        ) return P3CC_TRUE;
    if(Token == TOKEN_EXCLAMATION) return P3CC_TRUE;
    return P3CC_FALSE;
}
//====================================================================================================================
static int VCodeListHeaderInit(vertual_code_list_header *VCodeListHeader)
//====================================================================================================================
// [@\] VCodeListHeader
// []
// [Ԓl] P3CC_OK
{
    VCodeListHeader->Entry = NULL;
    VCodeListHeader->Last = NULL;
    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionList(int Mode, expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] Xg
// [] int  Mode                                     FKEEP_RESULTFԂlԂR[hی삷^NOT_KEEP_RESULTFی삵Ȃ
// [] expression_analsys_result *RootRet           Fʊi[
// [] vertual_code_list_header *RootVCodeListHeaderFR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         Token;
    expression_analsys_result   MyRet;
    vertual_code_list_header    MyVCodeListHeader;
    vertual_code                VCode;
    value_info                  vi;
    int                         SrcFileIndex;
    int                         SrcFileLine;

    ExpressionDebugMsg(RootRet, "ExpressionList", EXPRESSION_START, Line);

    ExpressionResultInit(&MyRet);

    while(1){
        Token = TokenGet(TokenIndex, __LINE__);
        if(Token == TOKEN_SEMICOLON) break;

        //===͏
        ExpressionGprNoInit();
        VCodeListHeaderInit(&MyVCodeListHeader);
        VCodeListHeaderInit(&SideEffectVCodeHeader);
        //===
        if(ExpressionAssignment(&MyRet, &MyVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        //===pf
        VertualCodeSideEffectListConnect(&MyVCodeListHeader, &SideEffectVCodeHeader);
        //==== œK ===============
        if(ExpressionOptimize(Mode, &MyRet, &MyVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        //==== R[h ===============
        VertualCodeListConnect(RootVCodeListHeader, &MyVCodeListHeader);
        *RootRet = MyRet;

        Token = TokenGet(TokenIndex, __LINE__);
        if(Token != TOKEN_COMMA) break;
        ++TokenIndex; // ","̎
    }

    ExpressionDebugMsg(RootRet, "ExpressionList", EXPRESSION_END, Line);
    return P3CC_OK;
}

//====================================================================================================================
static int ExpressionAssignResultTrim(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader)
//====================================================================================================================
// [@\] ̌^킹
// [] expression_analsys_result *RootRet        Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader   FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         RegNo0;
    value_info                  vi;
    vertual_code                VCode;
    int                         SrcFileIndex;
    int                         SrcFileLine;

    if(RootRet->TypeInfo.Pointer == 0){
        if(RootRet->TypeInfo.Sign == UNSIGN){
            if((RootRet->TypeInfo.Type == TYPE_CHAR) || (RootRet->TypeInfo.Type == TYPE_SHORT)){
                SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
                SrcFileLine = TokenSrcLineGet(TokenIndex);
                RegNo0 = RootRet->Value.RegNo;
                if(RootRet->TypeInfo.Type == TYPE_CHAR) vi.NumLiteral = 0xFF;
                else                                    vi.NumLiteral = 0xFFFF;
                VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_AND_I,  RET_IS_GPR,RegNo0,  ARG_IS_GPR,RegNo0,  ARG_IS_IMM,&vi,  SrcFileIndex, SrcFileLine);
                if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            }
        }
    }
    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionAssignment(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] 
// [] expression_analsys_result *RootRet        Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader   FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         Token;
    int                         OpToken;
    int                         LeftAdrReg;
    int                         RightValReg;
    vertual_code_list_header    MyVCodeListHeader0;
    vertual_code_list_header    MyVCodeListHeader1;
    vertual_code_list_header    MyVCodeListHeader2;
    expression_analsys_result   MyRet0;
    expression_analsys_result   MyRet1;
    expression_analsys_result   MyRet2;
    vertual_code                VCode;
    value_info                  vi;
    int                         Size;
    int                         SrcFileIndex;
    int                         SrcFileLine;
    int                         i, j;
    int                         StructSize;
    int                         StructCopyBy2Word;
    int                         StructCopyBy1Word;
    int                         SrcReg;
    int                         DstReg;
    int                         TmpReg;
    int                         CounterReg;
    int                         LabelNo;
    int                         NewReg;
    int                         Flag;
    vertual_code                LastVCode;
    unsigned char               OpCode;

    ExpressionDebugMsg(RootRet, "ExpressionAssignment", EXPRESSION_START, Line);

    ExpressionResultInit(&MyRet0);
    ExpressionResultInit(&MyRet1);
    ExpressionResultInit(&MyRet2);

    VCodeListHeaderInit(&MyVCodeListHeader0);
    VCodeListHeaderInit(&MyVCodeListHeader1);
    VCodeListHeaderInit(&MyVCodeListHeader2);

    if(ExpressionConditional(&MyRet0, &MyVCodeListHeader0, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    Token = TokenGet(TokenIndex, __LINE__);
    if(!IsAssignmentOperator(Token)){ //łȂ
        *RootRet = MyRet0;
        if(VertualCodeListConnect(RootVCodeListHeader, &MyVCodeListHeader0) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }
    else{//
        if((MyRet0.Method == RETURN_METHOD_REG) && (MyRet0.Property == RETURN_PROPERTY_ADDRESS)){
            LeftAdrReg = MyRet0.Value.RegNo;
        }
        else{
            PrintError(__FILE__, __LINE__, "ӂ\Ȍ^ł͂ȂH", "", "");
            return P3CC_NG;
        }

        ++TokenIndex; // "Zq"̎
        SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
        SrcFileLine = TokenSrcLineGet(TokenIndex);

        if(ExpressionAssignment(&MyRet1, &MyVCodeListHeader1, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

        if((ExpressionChkStruct(&MyRet0) == P3CC_TRUE) || (ExpressionChkStruct(&MyRet1) == P3CC_TRUE)){//\̂̑
            if(MyRet0.TypeInfo.StructInfo != MyRet1.TypeInfo.StructInfo){
                PrintError(__FILE__, __LINE__, "^̈قȂ\̂̑ɂ͖ΉB", "", ""); return P3CC_NG;
            } 
            if((MyRet0.Method == RETURN_METHOD_REG) && (MyRet0.Property == RETURN_PROPERTY_ADDRESS) && (MyRet1.Method == RETURN_METHOD_REG) && (MyRet1.Property == RETURN_PROPERTY_ADDRESS)){
                if(VertualCodeListConnect(RootVCodeListHeader, &MyVCodeListHeader1) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                if(VertualCodeListConnect(RootVCodeListHeader, &MyVCodeListHeader0) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                StructSize = ((MyRet0.TypeInfo.StructInfo)->StructSize) / 4;
                SrcReg = MyRet1.Value.RegNo;
                DstReg = MyRet0.Value.RegNo;
                if(StructSize <= STRUCT_COPY_NO_LOOP_LIMIT){
                    StructCopyBy2Word = StructSize / 2;
                    StructCopyBy1Word = StructSize % 2;
                    TmpReg = ExpressionNewGprNoGet();
                    j = 0;
                    for(i = 0; i < StructCopyBy2Word; i++){
                        vi.NumLiteral = (unsigned long)(j * 4);
                        VCodeGen_Load (&VCode, PLABEL_NON, SIZE_4, UNSIGN, BASE_UPDATE_NO,  DST_IS_GPR,0, BASE_IS_GPR, SrcReg,  OFFSET_IS_IMM,&vi, SrcFileIndex, SrcFileLine);
                        if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                        
                        vi.NumLiteral = (unsigned long)((j + 1) * 4);
                        VCodeGen_Load (&VCode, PLABEL_NON, SIZE_4, UNSIGN, BASE_UPDATE_NO,  DST_IS_GPR,TmpReg, BASE_IS_GPR, SrcReg,  OFFSET_IS_IMM,&vi, SrcFileIndex, SrcFileLine);
                        if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                        
                        vi.NumLiteral = (unsigned long)(j * 4);
                        VCodeGen_Store(&VCode, PLABEL_NON, SIZE_4,         BASE_UPDATE_NO,  SRC_IS_GPR,0, BASE_IS_GPR, DstReg,  OFFSET_IS_IMM,&vi, SrcFileIndex, SrcFileLine);
                        if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

                        vi.NumLiteral = (unsigned long)((j + 1) * 4);
                        VCodeGen_Store(&VCode, PLABEL_NON, SIZE_4,         BASE_UPDATE_NO,  SRC_IS_GPR,TmpReg, BASE_IS_GPR, DstReg,  OFFSET_IS_IMM,&vi, SrcFileIndex, SrcFileLine);
                        if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                        
                        j += 2;
                    }
                    if(StructCopyBy1Word != 0){
                        vi.NumLiteral = (unsigned long)(j * 4);
                        VCodeGen_Load (&VCode, PLABEL_NON, SIZE_4, UNSIGN, BASE_UPDATE_NO,  DST_IS_GPR,0, BASE_IS_GPR, SrcReg,  OFFSET_IS_IMM,&vi, SrcFileIndex, SrcFileLine);
                        if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                        VCodeGen_Store(&VCode, PLABEL_NON, SIZE_4,         BASE_UPDATE_NO,  SRC_IS_GPR,0, BASE_IS_GPR, DstReg,  OFFSET_IS_IMM,&vi, SrcFileIndex, SrcFileLine);
                        if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                    }
                }
                else{
                    vi.RegNo = SrcReg;
                    VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_MOV_R, RET_IS_GPR,0, ARG_IS_NOTING,0,  ARG_IS_GPR,&vi, SrcFileIndex, SrcFileLine);
                    if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

                    CounterReg = ExpressionNewGprNoGet();
                    TmpReg = ExpressionNewGprNoGet();
                    if(ExpressionNumericLoad(0, StructSize, UNSIGN, CounterReg, &MyRet2, RootVCodeListHeader, __LINE__) == P3CC_NG) return P3CC_NG;
                    LabelNo = VertualCodeNewLabelNoGet();

                    vi.NumLiteral = 0;
                    VCodeGen_Load (&VCode, LabelNo, SIZE_4, UNSIGN, BASE_UPDATE_NO,  DST_IS_GPR,TmpReg, BASE_IS_GPR, SrcReg,  OFFSET_IS_IMM,&vi, SrcFileIndex, SrcFileLine);
                    if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

                    vi.NumLiteral = 4;
                    VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_ADD_I,  RET_IS_GPR,SrcReg,  ARG_IS_GPR,SrcReg,  OFFSET_IS_IMM,&vi,  SrcFileIndex, SrcFileLine);
                    if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

                    vi.NumLiteral = 0;
                    VCodeGen_Store(&VCode, PLABEL_NON, SIZE_4,         BASE_UPDATE_NO,  SRC_IS_GPR,TmpReg, BASE_IS_GPR, DstReg,  OFFSET_IS_IMM,&vi, SrcFileIndex, SrcFileLine);
                    if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                    
                    vi.NumLiteral = 4;
                    VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_ADD_I,  RET_IS_GPR,DstReg,  ARG_IS_GPR,DstReg,  OFFSET_IS_IMM,&vi,  SrcFileIndex, SrcFileLine);
                    if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

                    vi.NumLiteral = 1;
                    VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_SUB_I,  RET_IS_GPR,CounterReg,  ARG_IS_GPR,CounterReg,  ARG_IS_IMM,&vi,  SrcFileIndex, SrcFileLine);
                    if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

                    vi.LabelNo = LabelNo;
                    VCodeGen_Jump(&VCode, PLABEL_NON, OPECODE_JP_I, COND_NOT_ZERO, OPERAND_TYPE_LABEL, &vi, SrcFileIndex, SrcFileLine);
                    if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

                    vi.RegNo = 0;
                    VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_MOV_R, RET_IS_GPR,SrcReg, ARG_IS_NOTING,0,  ARG_IS_GPR,&vi, SrcFileIndex, SrcFileLine);
                    if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                }
                *RootRet = MyRet1;
            }
            else{
                PrintError(__FILE__, __LINE__, "͕s\ȍ\̂̑B", "", ""); return P3CC_NG;
            }
        }
        else{//ʏ̕ϐ̑
            if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, &MyRet1, &MyVCodeListHeader1, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            if(Token == TOKEN_EQ){
                if(ExpressionAssignTrim(&MyRet0, &MyRet1, &MyVCodeListHeader1) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                RightValReg = MyRet1.Value.RegNo;
                if(VertualCodeListConnect(RootVCodeListHeader, &MyVCodeListHeader1) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                if(VertualCodeListConnect(RootVCodeListHeader, &MyVCodeListHeader0) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                
                Size = ExpressionResultSizeGet(&(MyRet0.TypeInfo));
                
                vi.NumLiteral = 0;
                VCodeGen_Store(&VCode, PLABEL_NON, Size, BASE_UPDATE_NO,  SRC_IS_GPR,RightValReg, BASE_IS_GPR,LeftAdrReg, OFFSET_IS_IMM,&vi,SrcFileIndex, SrcFileLine);
                if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                *RootRet = MyRet0;
                RootRet->Method = RETURN_METHOD_REG;
                RootRet->Property = RETURN_PROPERTY_VALUE;
                RootRet->Value.RegNo = RightValReg;
                if(ExpressionAssignResultTrim(RootRet, RootVCodeListHeader) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

            }
            else{
                LastVCode = *(MyVCodeListHeader0.Last);
                if((LastVCode.OpCode.Code == OPECODE_ADD_I) && (LastVCode.OpRand1.Type == OPERAND_TYPE_SPR) 
                    && (LastVCode.OpRand1.ValueInfo.RegNo == SPR_FP) && (LastVCode.OpRand2.Type == OPERAND_TYPE_VARIABLE)){
                    Flag = 1;
                    LastVCode.Prev = NULL;
                    LastVCode.Next = NULL;
                    LastVCode.LabelNo = PLABEL_NON;
                    NewReg = ExpressionNewGprNoGet();
                    LastVCode.OpRand0.ValueInfo.RegNo = NewReg;
                    if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, &MyRet0, &MyVCodeListHeader0, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                }
                else{
                    Flag = 0;
                    if(ExpressionResultTrimRightSide(USE_NEW_REG, &MyRet0, &MyVCodeListHeader0, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                }
                RightValReg = MyRet0.Value.RegNo;
                OpToken = ExpressionConvAssignToken2OpToken(Token);
                if(ExpressionBinomialOperation(&MyRet2, &MyVCodeListHeader2, OpToken, &MyRet0, &MyRet1, RightValReg, __LINE__) == P3CC_NG){
                    PrintError(__FILE__, __LINE__, "", "", "");
                    return P3CC_NG;
                }
                if(VertualCodeListConnect(RootVCodeListHeader, &MyVCodeListHeader1) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                if(VertualCodeListConnect(RootVCodeListHeader, &MyVCodeListHeader0) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                if(VertualCodeListConnect(RootVCodeListHeader, &MyVCodeListHeader2) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                
                Size = ExpressionResultSizeGet(&(MyRet0.TypeInfo));
                
                vi.NumLiteral = 0;
                if(Flag){
                    if(VertualCodeAdd(RootVCodeListHeader, &LastVCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                    VCodeGen_Store(&VCode, PLABEL_NON, Size, BASE_UPDATE_NO,  SRC_IS_GPR,RightValReg, BASE_IS_GPR,NewReg, OFFSET_IS_IMM,&vi,SrcFileIndex, SrcFileLine);
                }
                else{
                    VCodeGen_Store(&VCode, PLABEL_NON, Size, BASE_UPDATE_NO,  SRC_IS_GPR,RightValReg, BASE_IS_GPR,LeftAdrReg, OFFSET_IS_IMM,&vi,SrcFileIndex, SrcFileLine);
                }
                if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                *RootRet = MyRet0;
                RootRet->Method = RETURN_METHOD_REG;
                RootRet->Property = RETURN_PROPERTY_VALUE;
                RootRet->Value.RegNo = RightValReg;
                if(ExpressionAssignResultTrim(RootRet, RootVCodeListHeader) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            }
        }
    }

    ExpressionDebugMsg(RootRet, "ExpressionAssignment", EXPRESSION_END, Line);

    return P3CC_OK;
}


//====================================================================================================================
static int ExpressionConditional(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] 
// [] expression_analsys_result *RootRet        Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader   FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    //int                       Ret;
    int                         Token;
    int                         LabelEnd;
    int                         LabelSkip;
    int                         Arg0RegNo;
    int                         ResultReg;
    unsigned long               Num;
    vertual_code                VCode;
    value_info                  vi;
    expression_analsys_result   Arg0;
    expression_analsys_result   Arg1;
    expression_analsys_result   TmpRet;
    expression_analsys_result   Result0;
    expression_analsys_result   Result1;
    int                         SrcFileIndex;
    int                         SrcFileLine;

    ExpressionDebugMsg(RootRet, "ExpressionConditional", EXPRESSION_START, Line);

    ExpressionResultInit(&Arg0);
    ExpressionResultInit(&Arg1);
    ExpressionResultInit(&TmpRet);
    ExpressionResultInit(&Result0);
    ExpressionResultInit(&Result1);

    if(ExpressionLogicalOr(RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    Token = TokenGet(TokenIndex, __LINE__);
    if(Token == TOKEN_QUESTION){
        ++TokenIndex;
        LabelSkip = VertualCodeNewLabelNoGet();
        LabelEnd = VertualCodeNewLabelNoGet();
        ResultReg = ExpressionNewGprNoGet();
        if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
        SrcFileLine = TokenSrcLineGet(TokenIndex);
        if(RootRet->Method == RETURN_METHOD_NUMERIC){
            if(RootRet->Value.Num == 0){
                vi.LabelNo = LabelSkip;
                VCodeGen_Jump(&VCode, PLABEL_NON, OPECODE_JP_I, COND_ALWAYS, OPERAND_TYPE_LABEL, &vi, SrcFileIndex, SrcFileLine);
                if(VertualCodeAdd(RootVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            }
        }
        else{// RootRet->Method == RETURN_METHOD_REG
            Arg0 = *RootRet;
            Arg0RegNo = RootRet->Value.RegNo;
            ExpressionNumericBody(&Arg1, 0, UNSIGN);
            if(ExpressionBinomialOperation(&TmpRet, RootVCodeListHeader, TOKEN_MINUS, &Arg0, &Arg1, Arg0RegNo, __LINE__) == P3CC_NG){
                PrintError(__FILE__, __LINE__, "", "", "");
                return P3CC_NG;
            }
            vi.LabelNo = LabelSkip;
            VCodeGen_Jump(&VCode, PLABEL_NON, OPECODE_JP_I, COND_ZERO, OPERAND_TYPE_LABEL, &vi, SrcFileIndex, SrcFileLine);
            if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }
        //--- Pڂ̎
        if(ExpressionConditional(&Result0, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, &Result0, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(Result0.Method == RETURN_METHOD_NUMERIC){
            Num = Result0.Value.Num;
            if(ExpressionNumericLoad(0, Num, UNSIGN, ExpressionNewGprNoGet(), &Result0, RootVCodeListHeader, __LINE__) == P3CC_NG){PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
        }
        vi.RegNo = Result0.Value.RegNo;
        VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_MOV_R,  RET_IS_GPR,ResultReg, ARG_IS_NOTING,0,  ARG_IS_GPR,&vi, SrcFileIndex, SrcFileLine);
        if(VertualCodeAdd(RootVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

        vi.LabelNo = LabelEnd;
        VCodeGen_Jump(&VCode, PLABEL_NON, OPECODE_JP_I, COND_ZERO, OPERAND_TYPE_LABEL, &vi, SrcFileIndex, SrcFileLine);
        if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

        Token = TokenGet(TokenIndex, __LINE__);
        if(Token != TOKEN_COLON){ PrintError(__FILE__, __LINE__, "\":\"҂Ă鏊\":\"Ȃ", "", ""); return P3CC_NG; }
        ++TokenIndex;

        //---̍Ōɔ
        SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
        SrcFileLine = TokenSrcLineGet(TokenIndex);
        VCodeGen_Nop(&VCode, LabelSkip, SrcFileIndex, SrcFileLine);
        if(VertualCodeAdd(RootVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

        //--- Qڂ̎
        if(ExpressionConditional(&Result1, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, &Result1, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(Result1.Method == RETURN_METHOD_NUMERIC){
            Num = Result1.Value.Num;
            if(ExpressionNumericLoad(0, Num, UNSIGN, ExpressionNewGprNoGet(), &Result1, RootVCodeListHeader, __LINE__) == P3CC_NG){PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
        }
        vi.RegNo = Result1.Value.RegNo;
        VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_MOV_R,  RET_IS_GPR,ResultReg, ARG_IS_NOTING,0,  ARG_IS_GPR,&vi, SrcFileIndex, SrcFileLine);
        if(VertualCodeAdd(RootVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

        //---̍ŌɃxtNOP}
        SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
        SrcFileLine = TokenSrcLineGet(TokenIndex);
        VCodeGen_Nop(&VCode, LabelEnd, SrcFileIndex, SrcFileLine);
        if(VertualCodeAdd(RootVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

        //--- Ԃľ^߂
        ExpressionUpperRankResultGet(RootRet, &Result0, &Result1);//ʂ̌^RootRetɐݒ
        RootRet->Value.RegNo = ResultReg;
    }

    ExpressionDebugMsg(RootRet, "ExpressionConditional", EXPRESSION_END, Line);
    //return Ret;
    return P3CC_OK;
}

//====================================================================================================================
static int ExpressionLogicalOrSub(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int LabelNo)
//====================================================================================================================
// [@\] _OR(||)̃Tu[`
// [] expression_analsys_result *Ret            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader   FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         Arg0RegNo;
    vertual_code                VCode;
    value_info                  vi;
    expression_analsys_result   Arg0;
    expression_analsys_result   Arg1;
    expression_analsys_result   TmpRet;
    int                         SrcFileIndex;
    int                         SrcFileLine;

    SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
    SrcFileLine = TokenSrcLineGet(TokenIndex);

    ExpressionResultInit(&Arg0);
    ExpressionResultInit(&Arg1);
    ExpressionResultInit(&TmpRet);

    //==== pf ===============
    VertualCodeSideEffectListConnect(RootVCodeListHeader, &SideEffectVCodeHeader);//===pf

    if(RootRet->Method == RETURN_METHOD_NUMERIC){
        if(RootRet->Value.Num != 0){
            vi.LabelNo = LabelNo;
            VCodeGen_Jump(&VCode, PLABEL_NON, OPECODE_JP_I, COND_ALWAYS, OPERAND_TYPE_LABEL, &vi, SrcFileIndex, SrcFileLine);
            if(VertualCodeAdd(RootVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }
    }
    else{// RootRet->Method == RETURN_METHOD_REG
        Arg0 = *RootRet;
        Arg0RegNo = RootRet->Value.RegNo;
        ExpressionNumericBody(&Arg1, 0, UNSIGN);
        if(ExpressionBinomialOperation(&TmpRet, RootVCodeListHeader, TOKEN_MINUS, &Arg0, &Arg1, Arg0RegNo, __LINE__) == P3CC_NG){
            PrintError(__FILE__, __LINE__, "", "", "");
            return P3CC_NG;
        }
        vi.LabelNo = LabelNo;
        VCodeGen_Jump(&VCode, PLABEL_NON, OPECODE_JP_I, COND_NOT_ZERO, OPERAND_TYPE_LABEL, &vi, SrcFileIndex, SrcFileLine);
        if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }
    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionLogicalOr(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] _OR(||)
// [] expression_analsys_result *Ret            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader   FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         Token;
    int                         MyRetRegNo;
    int                         LabelNo;
    expression_analsys_result   MyRet;
    vertual_code                VCode;
    value_info                  vi;
    int                         SrcFileIndex;
    int                         SrcFileLine;

    ExpressionDebugMsg(RootRet, "ExpressionLogicalOr", EXPRESSION_START, Line);

    ExpressionResultInit(&MyRet);

    if(ExpressionLogicalAnd(RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    Token = TokenGet(TokenIndex, __LINE__);
    if(Token == TOKEN_OR_OR){
        LabelNo = VertualCodeNewLabelNoGet();
        if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
#ifdef USE_MOVLI_FOR_LOGICAL_RESULT
        if(ExpressionNumericLoad(1, 1, UNSIGN, ExpressionNewGprNoGet(), &MyRet, RootVCodeListHeader, __LINE__) == P3CC_NG){PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
#else
        if(ExpressionNumericLoad(0, 1, UNSIGN, ExpressionNewGprNoGet(), &MyRet, RootVCodeListHeader, __LINE__) == P3CC_NG){PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
#endif
        while(1){
            Token = TokenGet(TokenIndex, __LINE__);
            if(Token != TOKEN_OR_OR){
                SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
                SrcFileLine = TokenSrcLineGet(TokenIndex);
                if(ExpressionLogicalOrSub(RootRet, RootVCodeListHeader, LabelNo) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                vi.NumLiteral = 0;
                MyRetRegNo = MyRet.Value.RegNo;
#ifdef USE_MOVLI_FOR_LOGICAL_RESULT
                VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_MOVL_I,  RET_IS_GPR,MyRetRegNo,  ARG_IS_NOTING,0,  ARG_IS_IMM,&vi,  SrcFileIndex, SrcFileLine);
#else
                VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_MOV_I,  RET_IS_GPR,MyRetRegNo,  ARG_IS_NOTING,0,  ARG_IS_IMM,&vi,  SrcFileIndex, SrcFileLine);
#endif
                if(VertualCodeAdd(RootVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                break;
            }
            ++TokenIndex;
            if(ExpressionLogicalOrSub(RootRet, RootVCodeListHeader, LabelNo) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            if(ExpressionLogicalAnd(RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }

        *RootRet = MyRet;
        VCodeGen_Nop(&VCode, LabelNo, SrcFileIndex, SrcFileLine);
        if(VertualCodeAdd(RootVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }

    ExpressionDebugMsg(RootRet, "ExpressionLogicalOr", EXPRESSION_END, Line);
    return P3CC_OK;
}


//====================================================================================================================
static int ExpressionLogicalAndSub(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int LabelNo)
//====================================================================================================================
// [@\]  _AND(&&)̃Tu[`
// [] expression_analsys_result *Ret            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader   FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         Arg0RegNo;
    vertual_code                VCode;
    value_info                  vi;
    expression_analsys_result   Arg0;
    expression_analsys_result   Arg1;
    expression_analsys_result   TmpRet;
    int                         SrcFileIndex;
    int                         SrcFileLine;

    ExpressionResultInit(&Arg0);
    ExpressionResultInit(&Arg1);
    ExpressionResultInit(&TmpRet);

    SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
    SrcFileLine = TokenSrcLineGet(TokenIndex);

    //==== pf ===============
    VertualCodeSideEffectListConnect(RootVCodeListHeader, &SideEffectVCodeHeader);//===pf

    if(RootRet->Method == RETURN_METHOD_NUMERIC){
        if(RootRet->Value.Num == 0){
            vi.LabelNo = LabelNo;
            VCodeGen_Jump(&VCode, PLABEL_NON, OPECODE_JP_I, COND_ALWAYS, OPERAND_TYPE_LABEL, &vi, SrcFileIndex, SrcFileLine);
            if(VertualCodeAdd(RootVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }
    }
    else{// RootRet->Method == RETURN_METHOD_REG
        Arg0 = *RootRet;
        Arg0RegNo = RootRet->Value.RegNo;
        ExpressionNumericBody(&Arg1, 0, UNSIGN);
        if(ExpressionBinomialOperation(&TmpRet, RootVCodeListHeader, TOKEN_MINUS, &Arg0, &Arg1, Arg0RegNo, __LINE__) == P3CC_NG){
            PrintError(__FILE__, __LINE__, "", "", "");
            return P3CC_NG;
        }
        vi.LabelNo = LabelNo;
        VCodeGen_Jump(&VCode, PLABEL_NON, OPECODE_JP_I, COND_ZERO, OPERAND_TYPE_LABEL, &vi, SrcFileIndex, SrcFileLine);
        if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }
    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionLogicalAnd(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\]  _AND(&&)
// [] expression_analsys_result *Ret            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader   FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         Token;
    int                         MyRetRegNo;
    int                         LabelNo;
    expression_analsys_result   MyRet;
    vertual_code                VCode;
    value_info                  vi;
    int                         SrcFileIndex;
    int                         SrcFileLine;

    ExpressionDebugMsg(RootRet, "ExpressionLogicalAnd", EXPRESSION_START, Line);

    ExpressionResultInit(&MyRet);

    if(ExpressionBitOr(RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    Token = TokenGet(TokenIndex, __LINE__);
    if(Token == TOKEN_AND_AND){
        LabelNo = VertualCodeNewLabelNoGet();
        if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
#ifdef USE_MOVLI_FOR_LOGICAL_RESULT
        if(ExpressionNumericLoad(1, 0, UNSIGN, ExpressionNewGprNoGet(), &MyRet, RootVCodeListHeader, __LINE__) == P3CC_NG){PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
#else
        if(ExpressionNumericLoad(0, 0, UNSIGN, ExpressionNewGprNoGet(), &MyRet, RootVCodeListHeader, __LINE__) == P3CC_NG){PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
#endif
        while(1){
            Token = TokenGet(TokenIndex, __LINE__);
            if(Token != TOKEN_AND_AND){
                SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
                SrcFileLine = TokenSrcLineGet(TokenIndex);
                if(ExpressionLogicalAndSub(RootRet, RootVCodeListHeader, LabelNo) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                vi.NumLiteral = 1;
                MyRetRegNo = MyRet.Value.RegNo;
#ifdef USE_MOVLI_FOR_LOGICAL_RESULT
                VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_MOVL_I,  RET_IS_GPR,MyRetRegNo,  ARG_IS_NOTING,0,  ARG_IS_IMM,&vi,  SrcFileIndex, SrcFileLine);
#else
                VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_MOV_I,  RET_IS_GPR,MyRetRegNo,  ARG_IS_NOTING,0,  ARG_IS_IMM,&vi,  SrcFileIndex, SrcFileLine);
#endif
                if(VertualCodeAdd(RootVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                break;
            }
            ++TokenIndex;
            if(ExpressionLogicalAndSub(RootRet, RootVCodeListHeader, LabelNo) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            if(ExpressionBitOr(RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }

        *RootRet = MyRet;
        VCodeGen_Nop(&VCode, LabelNo, SrcFileIndex, SrcFileLine);
        if(VertualCodeAdd(RootVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }

    ExpressionDebugMsg(RootRet, "ExpressionLogicalAnd", EXPRESSION_END, Line);
    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionBitOr(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] rbgOR(|)
// [] expression_analsys_result *Ret            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader   FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         Token;
    int                         RetRegNo;
    expression_analsys_result   MyRet0;
    expression_analsys_result   MyRet1;
    vertual_code_list_header    MyVCodeListHeader1;
    vertual_code                VCode;
    value_info                  vi;
    int                         SrcFileIndex;
    int                         SrcFileLine;

    ExpressionDebugMsg(RootRet, "ExpressionBitOr", EXPRESSION_START, Line);

    ExpressionResultInit(&MyRet0);
    ExpressionResultInit(&MyRet1);

    if(ExpressionBitXor(RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    while(1){
        Token = TokenGet(TokenIndex, __LINE__);
        if(Token != TOKEN_OR) break;
        ++TokenIndex;
        if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        MyRet0 = *RootRet;
        VCodeListHeaderInit(&MyVCodeListHeader1);
        if(ExpressionBitXor(&MyRet1, &MyVCodeListHeader1, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, &MyRet1, &MyVCodeListHeader1, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(VertualCodeListConnect(RootVCodeListHeader, &MyVCodeListHeader1) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if     (MyRet0.Method == RETURN_METHOD_REG) RetRegNo = MyRet0.Value.RegNo;
        else if(MyRet1.Method == RETURN_METHOD_REG) RetRegNo = MyRet1.Value.RegNo;
        else                                        RetRegNo = 0;
        if(ExpressionBinomialOperation(RootRet, RootVCodeListHeader, Token, &MyRet0, &MyRet1, RetRegNo, __LINE__) == P3CC_NG){
            PrintError(__FILE__, __LINE__, "", "", "");
            return P3CC_NG;
        }
    }

    ExpressionDebugMsg(RootRet, "ExpressionBitOr", EXPRESSION_END, Line);
    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionBitXor(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] rbgXOR(^)
// [] expression_analsys_result *Ret            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader   FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         Token;
    int                         RetRegNo;
    expression_analsys_result   MyRet0;
    expression_analsys_result   MyRet1;
    vertual_code_list_header    MyVCodeListHeader1;
    vertual_code                VCode;
    value_info                  vi;
    int                         SrcFileIndex;
    int                         SrcFileLine;

    ExpressionDebugMsg(RootRet, "ExpressionBitXor", EXPRESSION_START, Line);

    ExpressionResultInit(&MyRet0);
    ExpressionResultInit(&MyRet1);

    if(ExpressionBitAnd(RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    while(1){
        Token = TokenGet(TokenIndex, __LINE__);
        if(Token != TOKEN_XOR) break;
        ++TokenIndex;
        if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        MyRet0 = *RootRet;
        VCodeListHeaderInit(&MyVCodeListHeader1);
        if(ExpressionBitAnd(&MyRet1, &MyVCodeListHeader1, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, &MyRet1, &MyVCodeListHeader1, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(VertualCodeListConnect(RootVCodeListHeader, &MyVCodeListHeader1) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if     (MyRet0.Method == RETURN_METHOD_REG) RetRegNo = MyRet0.Value.RegNo;
        else if(MyRet1.Method == RETURN_METHOD_REG) RetRegNo = MyRet1.Value.RegNo;
        else                                        RetRegNo = 0;
        if(ExpressionBinomialOperation(RootRet, RootVCodeListHeader, Token, &MyRet0, &MyRet1, RetRegNo, __LINE__) == P3CC_NG){
            PrintError(__FILE__, __LINE__, "", "", "");
            return P3CC_NG;
        }
    }

    ExpressionDebugMsg(RootRet, "ExpressionBitXor", EXPRESSION_END, Line);
    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionBitAnd(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] rbgAND(&)
// [] expression_analsys_result *Ret            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader   FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         Token;
    int                         RetRegNo;
    expression_analsys_result   MyRet0;
    expression_analsys_result   MyRet1;
    vertual_code_list_header    MyVCodeListHeader1;
    vertual_code                VCode;
    value_info                  vi;
    int                         SrcFileIndex;
    int                         SrcFileLine;

    ExpressionDebugMsg(RootRet, "ExpressionBitAnd", EXPRESSION_START, Line);

    ExpressionResultInit(&MyRet0);
    ExpressionResultInit(&MyRet1);

    if(ExpressionEquality(RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    while(1){
        Token = TokenGet(TokenIndex, __LINE__);
        if(Token != TOKEN_AMPERSAND) break;
        ++TokenIndex;
        if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        MyRet0 = *RootRet;
        VCodeListHeaderInit(&MyVCodeListHeader1);
        if(ExpressionEquality(&MyRet1, &MyVCodeListHeader1, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, &MyRet1, &MyVCodeListHeader1, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(VertualCodeListConnect(RootVCodeListHeader, &MyVCodeListHeader1) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if     (MyRet0.Method == RETURN_METHOD_REG) RetRegNo = MyRet0.Value.RegNo;
        else if(MyRet1.Method == RETURN_METHOD_REG) RetRegNo = MyRet1.Value.RegNo;
        else                                        RetRegNo = 0;
        if(ExpressionBinomialOperation(RootRet, RootVCodeListHeader, Token, &MyRet0, &MyRet1, RetRegNo, __LINE__) == P3CC_NG){
            PrintError(__FILE__, __LINE__, "", "", "");
            return P3CC_NG;
        }
    }

    ExpressionDebugMsg(RootRet, "ExpressionBitAnd", EXPRESSION_END, Line);
    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionEquality(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] 񓙎(!=, ==)
// [] expression_analsys_result *Ret            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader   FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         Token;
    int                         RetRegNo;
    int                         ResRegNo;
    int                         RetVal;
    int                         LabelNo;
    unsigned long               ConditionCode;
    expression_analsys_result   TmpRet;
    expression_analsys_result   MyRet0;
    expression_analsys_result   MyRet1;
    vertual_code_list_header    MyVCodeListHeader1;
    vertual_code                VCode;
    value_info                  vi;
    int                         SrcFileIndex;
    int                         SrcFileLine;

    ExpressionDebugMsg(RootRet, "ExpressionEquality", EXPRESSION_START, Line);

    ExpressionResultInit(&TmpRet);
    ExpressionResultInit(&MyRet0);
    ExpressionResultInit(&MyRet1);

    if(ExpressionInEquality(RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    while(1){
        Token = TokenGet(TokenIndex, __LINE__);
        if((Token != TOKEN_EQ_EQ) && (Token != TOKEN_NOT_EQ)) break;
        ++TokenIndex;
        if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        MyRet0 = *RootRet;
        VCodeListHeaderInit(&MyVCodeListHeader1);
        if(ExpressionInEquality(&MyRet1, &MyVCodeListHeader1, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, &MyRet1, &MyVCodeListHeader1, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(VertualCodeListConnect(RootVCodeListHeader, &MyVCodeListHeader1) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if((MyRet0.Method == RETURN_METHOD_NUMERIC) && (MyRet1.Method == RETURN_METHOD_NUMERIC)){
            if     (Token == TOKEN_EQ_EQ  ) RetVal = (MyRet0.Value.Num == MyRet1.Value.Num);
            else                            RetVal = (MyRet0.Value.Num != MyRet1.Value.Num);
            ExpressionNumericBody(RootRet, RetVal, UNSIGN);
        }
        else{
            SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
            SrcFileLine = TokenSrcLineGet(TokenIndex);

#ifdef USE_MOVLI_FOR_LOGICAL_RESULT
            if(ExpressionNumericLoad(1, 1, UNSIGN, ExpressionNewGprNoGet(), RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
#else
            if(ExpressionNumericLoad(0, 1, UNSIGN, ExpressionNewGprNoGet(), RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
#endif
            ResRegNo = RootRet->Value.RegNo;

            if(MyRet0.Method == RETURN_METHOD_REG) RetRegNo = MyRet0.Value.RegNo;
            else                                   RetRegNo = MyRet1.Value.RegNo;
            if(ExpressionBinomialOperation(&TmpRet, RootVCodeListHeader, TOKEN_MINUS, &MyRet0, &MyRet1, RetRegNo, __LINE__) == P3CC_NG){
                PrintError(__FILE__, __LINE__, "", "", "");
                return P3CC_NG;
            }

            if     (Token == TOKEN_EQ_EQ) ConditionCode = COND_ZERO;
            else                          ConditionCode = COND_NOT_ZERO;

            LabelNo = VertualCodeNewLabelNoGet();
            vi.LabelNo = LabelNo;
            VCodeGen_Jump(&VCode, PLABEL_NON, OPECODE_JP_I, ConditionCode, OPERAND_TYPE_LABEL, &vi, SrcFileIndex, SrcFileLine);
            if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            vi.NumLiteral = 0;
#ifdef USE_MOVLI_FOR_LOGICAL_RESULT
            VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_MOVL_I,  RET_IS_GPR,ResRegNo,  ARG_IS_NOTING,0,  ARG_IS_IMM,&vi,  SrcFileIndex, SrcFileLine);
#else
            VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_MOV_I,  RET_IS_GPR,ResRegNo,  ARG_IS_NOTING,0,  ARG_IS_IMM,&vi,  SrcFileIndex, SrcFileLine);
#endif
            if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            VCodeGen_Nop(&VCode, LabelNo, SrcFileIndex, SrcFileLine);
            if(VertualCodeAdd(RootVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }
    }

    ExpressionDebugMsg(RootRet, "ExpressionEquality", EXPRESSION_END, Line);
    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionInEquality(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] s(<,>,<=,>=)
// [] expression_analsys_result *Ret            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader   FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         Token;
    int                         RetRegNo;
    int                         ResRegNo;
    int                         RetVal;
    int                         LabelNo;
    unsigned long               ConditionCode;
    expression_analsys_result   TmpRet;
    expression_analsys_result   MyRet0;
    expression_analsys_result   MyRet1;
    vertual_code_list_header    MyVCodeListHeader1;
    vertual_code                VCode;
    value_info                  vi;
    int                         SrcFileIndex;
    int                         SrcFileLine;

    ExpressionDebugMsg(RootRet, "ExpressionInEquality", EXPRESSION_START, Line);

    ExpressionResultInit(&TmpRet);
    ExpressionResultInit(&MyRet0);
    ExpressionResultInit(&MyRet1);

    if(ExpressionShift(RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    while(1){
        Token = TokenGet(TokenIndex, __LINE__);
        if((Token != TOKEN_LESS) && (Token != TOKEN_GRATER) && (Token != TOKEN_LESS_EQ) && (Token != TOKEN_GRATER_EQ)) break;
        ++TokenIndex;
        if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        MyRet0 = *RootRet;
        VCodeListHeaderInit(&MyVCodeListHeader1);
        if(ExpressionShift(&MyRet1, &MyVCodeListHeader1, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, &MyRet1, &MyVCodeListHeader1, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(VertualCodeListConnect(RootVCodeListHeader, &MyVCodeListHeader1) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if((MyRet0.Method == RETURN_METHOD_NUMERIC) && (MyRet1.Method == RETURN_METHOD_NUMERIC)){
            if((MyRet0.TypeInfo.Sign == UNSIGN) && (MyRet1.TypeInfo.Sign == UNSIGN)){
                if     (Token == TOKEN_LESS  )  RetVal = (MyRet0.Value.Num <  MyRet1.Value.Num);
                else if(Token == TOKEN_GRATER)  RetVal = (MyRet0.Value.Num >  MyRet1.Value.Num);
                else if(Token == TOKEN_LESS_EQ) RetVal = (MyRet0.Value.Num <= MyRet1.Value.Num);
                else                            RetVal = (MyRet0.Value.Num >= MyRet1.Value.Num);
            }
            else{
                if     (Token == TOKEN_LESS  )  RetVal = ((int)MyRet0.Value.Num <  (int)MyRet1.Value.Num);
                else if(Token == TOKEN_GRATER)  RetVal = ((int)MyRet0.Value.Num >  (int)MyRet1.Value.Num);
                else if(Token == TOKEN_LESS_EQ) RetVal = ((int)MyRet0.Value.Num <= (int)MyRet1.Value.Num);
                else                            RetVal = ((int)MyRet0.Value.Num >= (int)MyRet1.Value.Num);
            }
            ExpressionNumericBody(RootRet, RetVal, UNSIGN);
        }
        else{
            SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
            SrcFileLine = TokenSrcLineGet(TokenIndex);

#ifdef USE_MOVLI_FOR_LOGICAL_RESULT
            if(ExpressionNumericLoad(1, 1, UNSIGN, ExpressionNewGprNoGet(), RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
#else
            if(ExpressionNumericLoad(0, 1, UNSIGN, ExpressionNewGprNoGet(), RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
#endif
            ResRegNo = RootRet->Value.RegNo;

            if(MyRet0.Method == RETURN_METHOD_REG) RetRegNo = MyRet0.Value.RegNo;
            else                                   RetRegNo = MyRet1.Value.RegNo;
            if(ExpressionBinomialOperation(&TmpRet, RootVCodeListHeader, TOKEN_MINUS, &MyRet0, &MyRet1, RetRegNo, __LINE__) == P3CC_NG){
                PrintError(__FILE__, __LINE__, "", "", "");
                return P3CC_NG;
            }

            if(TmpRet.TypeInfo.Sign == UNSIGN){
                if     (Token == TOKEN_LESS  )  ConditionCode = COND_UNSIGNED_LOWER;
                else if(Token == TOKEN_GRATER)  ConditionCode = COND_UNSIGNED_HIGHER;
                else if(Token == TOKEN_LESS_EQ) ConditionCode = COND_UNSIGNED_LOWER_OR_SAME;
                else                            ConditionCode = COND_UNSIGNED_HIGHER_OR_SAME;
            }
            else{
                if     (Token == TOKEN_LESS  )  ConditionCode = COND_SIGNED_LESS_THAN;
                else if(Token == TOKEN_GRATER)  ConditionCode = COND_SIGNED_GRATER_THAN;
                else if(Token == TOKEN_LESS_EQ) ConditionCode = COND_SIGNED_LESS_THAN_OR_EQ;
                else                            ConditionCode = COND_SIGNED_GRATER_THAN_OR_EQ;
            }
            LabelNo = VertualCodeNewLabelNoGet();
            vi.LabelNo = LabelNo;
            VCodeGen_Jump(&VCode, PLABEL_NON, OPECODE_JP_I, ConditionCode, OPERAND_TYPE_LABEL, &vi, SrcFileIndex, SrcFileLine);
            if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            vi.NumLiteral = 0;
#ifdef USE_MOVLI_FOR_LOGICAL_RESULT
            VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_MOVL_I,  RET_IS_GPR,ResRegNo,  ARG_IS_NOTING,0,  ARG_IS_IMM,&vi,  SrcFileIndex, SrcFileLine);
#else
            VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_MOV_I,  RET_IS_GPR,ResRegNo,  ARG_IS_NOTING,0,  ARG_IS_IMM,&vi,  SrcFileIndex, SrcFileLine);
#endif
            if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            VCodeGen_Nop(&VCode, LabelNo, SrcFileIndex, SrcFileLine);
            if(VertualCodeAdd(RootVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }
    }

    ExpressionDebugMsg(RootRet, "ExpressionInEquality", EXPRESSION_END, Line);
    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionShift(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] Vtg(<<,>>)
// [] expression_analsys_result *Ret            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader   FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         Token;
    int                         RetRegNo;
    expression_analsys_result   MyRet0;
    expression_analsys_result   MyRet1;
    vertual_code_list_header    MyVCodeListHeader1;
    vertual_code                VCode;
    value_info                  vi;
    int                         SrcFileIndex;
    int                         SrcFileLine;

    ExpressionDebugMsg(RootRet, "ExpressionShift", EXPRESSION_START, Line);

    ExpressionResultInit(&MyRet0);
    ExpressionResultInit(&MyRet1);

    if(ExpressionAddaptive(RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    while(1){
        Token = TokenGet(TokenIndex, __LINE__);
        if((Token != TOKEN_SHIFT_L) && (Token != TOKEN_SHIFT_R)) break;
        ++TokenIndex;
        if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        MyRet0 = *RootRet;
        VCodeListHeaderInit(&MyVCodeListHeader1);
        if(ExpressionAddaptive(&MyRet1, &MyVCodeListHeader1, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, &MyRet1, &MyVCodeListHeader1, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(VertualCodeListConnect(RootVCodeListHeader, &MyVCodeListHeader1) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if     (MyRet0.Method == RETURN_METHOD_REG) RetRegNo = MyRet0.Value.RegNo;
        else if(MyRet1.Method == RETURN_METHOD_REG) RetRegNo = MyRet1.Value.RegNo;
        else                                        RetRegNo = 0;
        if(ExpressionBinomialOperation(RootRet, RootVCodeListHeader, Token, &MyRet0, &MyRet1, RetRegNo, __LINE__) == P3CC_NG){
            PrintError(__FILE__, __LINE__, "", "", "");
            return P3CC_NG;
        }
    }

    ExpressionDebugMsg(RootRet, "ExpressionShift", EXPRESSION_END, Line);
    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionAddaptive(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] ZZ(+,-)
// [] expression_analsys_result *Ret            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader   FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         Token;
    int                         RetRegNo;
    expression_analsys_result   MyRet0;
    expression_analsys_result   MyRet1;
    vertual_code_list_header    MyVCodeListHeader1;
    vertual_code                VCode;
    value_info                  vi;
    int                         SrcFileIndex;
    int                         SrcFileLine;

    ExpressionDebugMsg(RootRet, "ExpressionAddaptive", EXPRESSION_START, Line);

    ExpressionResultInit(&MyRet0);
    ExpressionResultInit(&MyRet1);

    if(ExpressionMultiplicative(RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    while(1){
        Token = TokenGet(TokenIndex, __LINE__);
        if((Token != TOKEN_PLUS) && (Token != TOKEN_MINUS)) break;
        ++TokenIndex;
        if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        MyRet0 = *RootRet;
        VCodeListHeaderInit(&MyVCodeListHeader1);
        if(ExpressionMultiplicative(&MyRet1, &MyVCodeListHeader1, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, &MyRet1, &MyVCodeListHeader1, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(VertualCodeListConnect(RootVCodeListHeader, &MyVCodeListHeader1) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if     (MyRet0.Method == RETURN_METHOD_REG) RetRegNo = MyRet0.Value.RegNo;
        else if(MyRet1.Method == RETURN_METHOD_REG) RetRegNo = MyRet1.Value.RegNo;
        else                                        RetRegNo = 0;
        if(ExpressionBinomialOperation(RootRet, RootVCodeListHeader, Token, &MyRet0, &MyRet1, RetRegNo, __LINE__) == P3CC_NG){
            PrintError(__FILE__, __LINE__, "", "", "");
            return P3CC_NG;
        }
    }

    ExpressionDebugMsg(RootRet, "ExpressionAddaptive", EXPRESSION_END, Line);
    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionMultiplicative(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] 揜ZZ(*,/.%)
// [] expression_analsys_result *Ret            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader   FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         Token;
    int                         RetRegNo;
    expression_analsys_result   MyRet0;
    expression_analsys_result   MyRet1;
    vertual_code_list_header    MyVCodeListHeader1;
    vertual_code                VCode;
    value_info                  vi;
    int                         SrcFileIndex;
    int                         SrcFileLine;

    ExpressionDebugMsg(RootRet, "ExpressionMultiplicative", EXPRESSION_START, Line);

    ExpressionResultInit(&MyRet0);
    ExpressionResultInit(&MyRet1);

    if(ExpressionCast(RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    while(1){
        Token = TokenGet(TokenIndex, __LINE__);
        if((Token != TOKEN_ASTERISK) && (Token != TOKEN_DIV) && (Token != TOKEN_MOD)) break;
        ++TokenIndex;
        if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        MyRet0 = *RootRet;
        VCodeListHeaderInit(&MyVCodeListHeader1);
        if(ExpressionCast(&MyRet1, &MyVCodeListHeader1, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, &MyRet1, &MyVCodeListHeader1, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(VertualCodeListConnect(RootVCodeListHeader, &MyVCodeListHeader1) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if     (MyRet0.Method == RETURN_METHOD_REG) RetRegNo = MyRet0.Value.RegNo;
        else if(MyRet1.Method == RETURN_METHOD_REG) RetRegNo = MyRet1.Value.RegNo;
        else                                        RetRegNo = 0;
        if(ExpressionBinomialOperation(RootRet, RootVCodeListHeader, Token, &MyRet0, &MyRet1, RetRegNo, __LINE__) == P3CC_NG){
            PrintError(__FILE__, __LINE__, "", "", "");
            return P3CC_NG;
        }
    }

    ExpressionDebugMsg(RootRet, "ExpressionMultiplicative", EXPRESSION_END, Line);
    return P3CC_OK;
}
//====================================================================================================================
//static int ExpressionCastCheck(char Property, result_type_info *TypeInfo, variable *v)
static int ExpressionCastCheck(result_type_info *TypeInfo, variable *v)
//====================================================================================================================
// [@\] LXg̃`FbNiƂ肠mNGƁAmOK͂͂˂āA͌xoj
// [] result_type_info *TypeInfo   F̌^
// [] variable         *v          FCasť^
// [Ԓl] P3CC_OK/P3CC_NG
{
    if((TypeInfo->TypeFunction != 0) || (TypeInfo->FuncPointer != 0)){
        if((v->TypeFunction != 0) || (v->FuncPointer != 0)){
            if(TypeInfo->BasicTypeSize == ExpressionBasicTypeSizeGetV(v)){
                ;
            }
            else{
                PrintWarning(__FILE__, __LINE__, "Sł͂Ȃ\̂LXg", "", "");
            };
            return P3CC_OK;
        }
        else if(v->Pointer != 0){
            if(v->Type == TYPE_VOID){
                ;
            }
            else{
                PrintWarning(__FILE__, __LINE__, "Sł͂Ȃ\̂LXg", "", "");
            }
            return P3CC_OK;
        }
        else{
            if((v->StructInfo != NULL) || (v->DimInfo != NULL)){
                PrintError(__FILE__, __LINE__, "Ήs\ȃLXg", "", "");
                return P3CC_NG;
            }
            else{
                if((v->Type == TYPE_INT) || (v->Type == TYPE_LONG)){
                    ;
                }
                else{
                    PrintWarning(__FILE__, __LINE__, "Sł͂Ȃ\̂LXg", "", "");
                }
                return P3CC_OK;
            }
        }
    }
    else if(TypeInfo->Pointer != 0){
        if((v->TypeFunction != 0) || (v->FuncPointer != 0)){
            if(TypeInfo->Type == TYPE_VOID){
                ;
            }
            else{
                PrintWarning(__FILE__, __LINE__, "Sł͂Ȃ\̂LXg", "", "");
            };
            return P3CC_OK;
        }
        else if(v->Pointer != 0){
            if(TypeInfo->BasicTypeSize == ExpressionBasicTypeSizeGetV(v)){
                ;
            }
            else{
                PrintWarning(__FILE__, __LINE__, "Sł͂Ȃ\̂LXg", "", "");
            }
            return P3CC_OK;
        }
        else{
            if((v->StructInfo != NULL) || (v->DimInfo != NULL)){
                PrintError(__FILE__, __LINE__, "Ήs\ȃLXg", "", "");
                return P3CC_NG;
            }
            else{
                if((v->Type == TYPE_INT) || (v->Type == TYPE_LONG)){
                    ;
                }
                else{
                    PrintWarning(__FILE__, __LINE__, "Sł͂Ȃ\̂LXg", "", "");
                }
                return P3CC_OK;
            }
        }
    }
    else if(TypeInfo->StructInfo != NULL){
        if((v->TypeFunction != 0) || (v->FuncPointer != 0)){
            PrintError(__FILE__, __LINE__, "Ήs\ȃLXg", "", "");
            return P3CC_NG;
        }
        else if(v->Pointer != 0){
            PrintError(__FILE__, __LINE__, "Ήs\ȃLXg", "", "");
            return P3CC_NG;
        }
        else{
            if(v->DimInfo != NULL){
                PrintError(__FILE__, __LINE__, "Ήs\ȃLXg", "", "");
                return P3CC_NG;
            }
            else if(v->StructInfo != NULL){
                if(v->StructInfo == TypeInfo->StructInfo) return P3CC_OK;
                PrintError(__FILE__, __LINE__, "Ήs\ȃLXg", "", "");
                return P3CC_NG;
            }
            else{
                PrintError(__FILE__, __LINE__, "Ήs\ȃLXg", "", "");
                return P3CC_NG;
            }
        }
    }
    else{
        ;
    }
    return P3CC_OK;

}
//====================================================================================================================
static int ExpressionCast(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] LXg
// [] expression_analsys_result *RootRet            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader   FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int             Token;
    int             SaveIndex;
    int             Ret;
    variable        v;
    int             Flag;


    ExpressionDebugMsg(RootRet, "ExpressionCast", EXPRESSION_START, Line);

    SaveIndex = TokenIndex;
    Token = TokenGet(TokenIndex, __LINE__);
    
    if(Token == TOKEN_BRACKET_L){//=== "("n܂Ă΁A^̌
        VariableInit(&v);
        ++TokenIndex; // "("̎ֈړ
        //=== ^擾
        Ret = DeclarationVariable(CAST_ANALYSIS, &v);
        if(Ret == P3CC_NG){ PrintError(__FILE__, __LINE__, "LXg̊ʓ̌^͂Ɏs", "", ""); return P3CC_NG;}
        else if(Ret == P3CC_OK){// ^̐錾oo
            Flag = P3CC_OK;
            Token = TokenGet(TokenIndex, __LINE__);
            if(Token != TOKEN_BRACKET_R){ PrintError(__FILE__, __LINE__, "LXg̊ʓ̌^͂Ɏs", "", ""); return P3CC_NG;}
            ++TokenIndex; // ")"̎
            
            if(RootRet->CastFlag != 0){
                PrintError(__FILE__, __LINE__, "dLXgɂ͖ΉB", "", "");
                return P3CC_NG;
            }
            
            if(ExpressionPreFix(RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            
            if(RootRet->Method == RETURN_METHOD_NUMERIC){
                if(ExpressionNumericLoad(0, RootRet->Value.Num, RootRet->TypeInfo.Sign, ExpressionNewGprNoGet(), RootRet, RootVCodeListHeader, __LINE__) != P3CC_OK){
                    PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;
                }
            }
            else{
                //if(ExpressionCastCheck(RootRet->Property, &(RootRet->TypeInfo), &v) == P3CC_NG) return P3CC_NG;
                //Flag = ExpressionCastCheck(RootRet->Property, &(RootRet->TypeInfo), &v);
                Flag = ExpressionCastCheck(&(RootRet->TypeInfo), &v);
                if(RootRet->Property == RETURN_PROPERTY_ADDRESS){
                    //ANZẌׂɁǍ^ۑ
                    RootRet->CastFlag = 1;
                    RootRet->BaseTypeInfo = RootRet->TypeInfo;
                }
                else{//RootRet->Property == RETURN_PROPERTY_VALUE
                    ;
                }
            }
PrintExpAnaResult(RootRet, "--- Cast before ---");
            //^㏑
            RootRet->TypeInfo.Sign = v.Sign;
            RootRet->TypeInfo.Pointer = v.Pointer;
            RootRet->TypeInfo.Type = v.Type;
            RootRet->TypeInfo.TypeFunction = v.TypeFunction;
            RootRet->TypeInfo.FuncPointer = v.FuncPointer;
            RootRet->TypeInfo.ArgNum = v.ArgNum;
            RootRet->TypeInfo.BasicTypeSize = ExpressionBasicTypeSizeGetV(&v);
            RootRet->TypeInfo.ArgList = v.ArgList;
            RootRet->TypeInfo.DimInfo = v.DimInfo;
            RootRet->TypeInfo.StructInfo = v.StructInfo;

            if(RootRet->TypeInfo.BasicTypeSize == RootRet->BaseTypeInfo.BasicTypeSize) RootRet->BaseTypeInfo.Sign = v.Sign;
PrintExpAnaResult(RootRet, "--- Cast after ---");
            if(Flag == P3CC_NG) return P3CC_NG;
            
        }
        else{// (Ret == P3CC_ESCAPE) ^̐錾ooȂ
            TokenIndex = SaveIndex;
            if(ExpressionPreFix(RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }
    }
    else{
        if(ExpressionPreFix(RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }

    ExpressionDebugMsg(RootRet, "ExpressionCast", EXPRESSION_END, Line);

    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionPreFixDoublePlusMinus(int Token, expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] OuP(++,--)
// [] expression_analsys_result *Ret                  Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader   FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         OpToken;
    int                         AdrRegNo;
    int                         RetRegNo;
    vertual_code_list_header    MyVCodeListHeader0;
    expression_analsys_result   MyRet0;
    expression_analsys_result   NumRet;
    expression_analsys_result   WorkRet;
    vertual_code                VCode;
    value_info                  vi;
    int                         Size;
    int                         SrcFileIndex;
    int                         SrcFileLine;
    vertual_code                LastVCode;



    ExpressionDebugMsg(RootRet, "ExpressionPreFixDoublePlusMinus", EXPRESSION_START, Line);

    ExpressionResultInit(&MyRet0);
    ExpressionResultInit(&NumRet);
    ExpressionResultInit(&WorkRet);

    if((RootRet->Method == RETURN_METHOD_NUMERIC) || ((RootRet->Method == RETURN_METHOD_REG) && (RootRet->Property == RETURN_PROPERTY_VALUE))){
        //Ӗ̂ȂOu++orOu--Ȃ
        PrintError(__FILE__, __LINE__, "Ou", "CurrentTokenBuf", "ɂ͍ӒlKv");
        return P3CC_NG;
    }
    else{//((RootRet->Method == RETURN_METHOD_REG) && (RootRet->Property == RETURN_PROPERTY_ADDRESS))
        SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
        SrcFileLine = TokenSrcLineGet(TokenIndex);
        VCodeListHeaderInit(&MyVCodeListHeader0);
        WorkRet = *RootRet;
        AdrRegNo = WorkRet.Value.RegNo;
        LastVCode = *(RootVCodeListHeader->Last);

        if((LastVCode.OpCode.Code == OPECODE_ADD_I) 
                && (LastVCode.OpRand1.Type == OPERAND_TYPE_SPR) && (LastVCode.OpRand1.ValueInfo.RegNo == SPR_FP) 
                && (LastVCode.OpRand2.Type == OPERAND_TYPE_VARIABLE)){
            if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, &WorkRet, &MyVCodeListHeader0, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            RetRegNo = WorkRet.Value.RegNo;
            ExpressionNumericBody(&NumRet, 1, UNSIGN);
            if(Token == TOKEN_DOUBLE_PLUS) OpToken = TOKEN_PLUS;
            else                           OpToken = TOKEN_MINUS;
            if(ExpressionBinomialOperation(&MyRet0, &MyVCodeListHeader0, OpToken, &WorkRet, &NumRet, RetRegNo, __LINE__) == P3CC_NG){
                PrintError(__FILE__, __LINE__, "", "", "");
                return P3CC_NG;
            }

            LastVCode.Prev = NULL;
            LastVCode.Next = NULL;
            LastVCode.LabelNo = PLABEL_NON;
            AdrRegNo = ExpressionNewGprNoGet();
            LastVCode.OpRand0.ValueInfo.RegNo = AdrRegNo;
            if(VertualCodeAdd(&MyVCodeListHeader0, &LastVCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

            Size = ExpressionResultSizeGet(&(MyRet0.TypeInfo));
            vi.NumLiteral = 0;
            VCodeGen_Store(&VCode, PLABEL_NON, Size, BASE_UPDATE_NO,  SRC_IS_GPR,RetRegNo, BASE_IS_GPR,AdrRegNo, OFFSET_IS_IMM,&vi,SrcFileIndex, SrcFileLine);
            if(VertualCodeAdd(&MyVCodeListHeader0, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            if(VertualCodeListConnect(RootVCodeListHeader, &MyVCodeListHeader0) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            RootRet->Property = RETURN_PROPERTY_VALUE;
        }
        else{
            if(ExpressionResultTrimRightSide(USE_NEW_REG, &WorkRet, &MyVCodeListHeader0, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            RetRegNo = WorkRet.Value.RegNo;
            ExpressionNumericBody(&NumRet, 1, UNSIGN);
            if(Token == TOKEN_DOUBLE_PLUS) OpToken = TOKEN_PLUS;
            else                           OpToken = TOKEN_MINUS;
            if(ExpressionBinomialOperation(&MyRet0, &MyVCodeListHeader0, OpToken, &WorkRet, &NumRet, RetRegNo, __LINE__) == P3CC_NG){
                PrintError(__FILE__, __LINE__, "", "", "");
                return P3CC_NG;
            }
            Size = ExpressionResultSizeGet(&(MyRet0.TypeInfo));
            vi.NumLiteral = 0;
            VCodeGen_Store(&VCode, PLABEL_NON, Size, BASE_UPDATE_NO,  SRC_IS_GPR,RetRegNo, BASE_IS_GPR,AdrRegNo, OFFSET_IS_IMM,&vi,SrcFileIndex, SrcFileLine);
            if(VertualCodeAdd(&MyVCodeListHeader0, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            if(VertualCodeListConnect(RootVCodeListHeader, &MyVCodeListHeader0) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }
    }
    ExpressionDebugMsg(RootRet, "ExpressionPreFixDoublePlusMinus", EXPRESSION_END, Line);

    return P3CC_OK;
}
/*
//====================================================================================================================
static int ExpressionPreFixDoublePlusMinus(int Token, expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] OuP(++,--)
// [] expression_analsys_result *Ret                  Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader   FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         OpToken;
    int                         AdrRegNo;
    int                         RetRegNo;
    vertual_code_list_header    MyVCodeListHeader0;
    expression_analsys_result   MyRet0;
    expression_analsys_result   NumRet;
    expression_analsys_result   WorkRet;
    vertual_code                VCode;
    value_info                  vi;
    int                         Size;
    int                         SrcFileIndex;
    int                         SrcFileLine;

    ExpressionDebugMsg(RootRet, "ExpressionPreFixDoublePlusMinus", EXPRESSION_START, Line);

    ExpressionResultInit(&MyRet0);
    ExpressionResultInit(&NumRet);
    ExpressionResultInit(&WorkRet);

    if((RootRet->Method == RETURN_METHOD_NUMERIC) || ((RootRet->Method == RETURN_METHOD_REG) && (RootRet->Method == RETURN_PROPERTY_VALUE))){
        //Ӗ̂ȂOu++orOu--Ȃ
        PrintError(__FILE__, __LINE__, "Ou", "CurrentTokenBuf", "ɂ͍ӒlKv");
        return P3CC_NG;
    }
    else{//((RootRet->Method == RETURN_METHOD_REG) && (RootRet->Method == RETURN_PROPERTY_ADDRESS))
        SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
        SrcFileLine = TokenSrcLineGet(TokenIndex);
        VCodeListHeaderInit(&MyVCodeListHeader0);
        WorkRet = *RootRet;
        AdrRegNo = WorkRet.Value.RegNo;
        if(ExpressionResultTrimRightSide(USE_NEW_REG, &WorkRet, &MyVCodeListHeader0, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        RetRegNo = WorkRet.Value.RegNo;
        ExpressionNumericBody(&NumRet, 1, UNSIGN);
        if(Token == TOKEN_DOUBLE_PLUS) OpToken = TOKEN_PLUS;
        else                           OpToken = TOKEN_MINUS;
        if(ExpressionBinomialOperation(&MyRet0, &MyVCodeListHeader0, OpToken, &WorkRet, &NumRet, RetRegNo, __LINE__) == P3CC_NG){
            PrintError(__FILE__, __LINE__, "", "", "");
            return P3CC_NG;
        }
        Size = ExpressionResultSizeGet(&(MyRet0.TypeInfo));
        vi.NumLiteral = 0;
        VCodeGen_Store(&VCode, PLABEL_NON, Size, BASE_UPDATE_NO,  SRC_IS_GPR,RetRegNo, BASE_IS_GPR,AdrRegNo, OFFSET_IS_IMM,&vi,SrcFileIndex, SrcFileLine);
        if(VertualCodeAdd(&MyVCodeListHeader0, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(VertualCodeListConnect(RootVCodeListHeader, &MyVCodeListHeader0) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }
    ExpressionDebugMsg(RootRet, "ExpressionPreFixDoublePlusMinus", EXPRESSION_END, Line);

    return P3CC_OK;
}
*/
//====================================================================================================================
static int ExpressionPreFixUnaryOperation(int Token, expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] OuP(P&,P*,~,P+,P-,!)
// [] expression_analsys_result *Ret                  Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader   FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         Size;
    int                         Sign;
    int                         RegNo;
    int                         ResRegNo;
    int                         LabelNo;
    expression_analsys_result   TmpRet;
    expression_analsys_result   Arg0;
    expression_analsys_result   Arg1;
    vertual_code                VCode;
    value_info                  vi;
    int                         SrcFileIndex;
    int                         SrcFileLine;

    ExpressionDebugMsg(RootRet, "ExpressionPreFixUnaryOperation", EXPRESSION_START, Line);

    ExpressionResultInit(&TmpRet);
    ExpressionResultInit(&Arg0);
    ExpressionResultInit(&Arg1);

    SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
    SrcFileLine = TokenSrcLineGet(TokenIndex);

    if(Token == TOKEN_AMPERSAND){
        if(RootRet->Property == RETURN_PROPERTY_ADDRESS){
            RootRet->Property = RETURN_PROPERTY_VALUE;
            if(RootRet->TypeInfo.TypeFunction == TYPE_FUNCTION_POINTER) RootRet->TypeInfo.FuncPointer += 1;
            else                                                        RootRet->TypeInfo.Pointer += 1;
        }
        else{
            PrintError(__FILE__, __LINE__, "s\"&\"B", "", "");
            return P3CC_NG;
        }
    }
    else if(Token == TOKEN_ASTERISK){
        if(RootRet->Property == RETURN_PROPERTY_ADDRESS){
            Size = ExpressionResultSizeGet(&(RootRet->TypeInfo));
            Sign = (int)RootRet->TypeInfo.Sign;
            RegNo = RootRet->Value.RegNo;
            vi.NumLiteral = 0;
            VCodeGen_Load(&VCode, PLABEL_NON, Size, Sign, BASE_UPDATE_NO, DST_IS_GPR,RegNo, BASE_IS_GPR,RegNo, OFFSET_IS_IMM, &vi, SrcFileIndex, SrcFileLine);
            if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }
        else{
            RootRet->Property = RETURN_PROPERTY_ADDRESS;
        }

        if(RootRet->TypeInfo.TypeFunction == TYPE_FUNCTION_POINTER){
            if(RootRet->TypeInfo.FuncPointer == 0){PrintError(__FILE__, __LINE__, "s\"*\"B", "", ""); return P3CC_NG;}
            RootRet->TypeInfo.FuncPointer -= 1;
        }
        else{
            if(RootRet->TypeInfo.Pointer == 0){PrintError(__FILE__, __LINE__, "s\"*\"B", "", ""); return P3CC_NG;}
            RootRet->TypeInfo.Pointer -= 1;
        }
    }
    else if(Token == TOKEN_PLUS){
        ;//P{͂ȂɂȂĂ悢
    }
    else if(Token == TOKEN_MINUS){
        ExpressionNumericBody(&Arg0, 0, SIGN);
        if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        RootRet->TypeInfo.Sign = SIGN;
        Arg1 = *RootRet;
        RegNo = RootRet->Value.RegNo;
        if(ExpressionBinomialOperation(RootRet, RootVCodeListHeader, TOKEN_MINUS, &Arg0, &Arg1, RegNo, __LINE__) == P3CC_NG){
            PrintError(__FILE__, __LINE__, "", "", "");
            return P3CC_NG;
        }
    }
    else if(Token == TOKEN_NOT){//~
        ExpressionNumericBody(&Arg0, -1, UNSIGN);
        if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        Arg1 = *RootRet;
        RegNo = RootRet->Value.RegNo;
        if(ExpressionBinomialOperation(RootRet, RootVCodeListHeader, TOKEN_XOR, &Arg0, &Arg1, RegNo, __LINE__) == P3CC_NG){
            PrintError(__FILE__, __LINE__, "", "", "");
            return P3CC_NG;
        }
    }
    else{//(Token == TOKEN_EXCLAMATION)
        if(RootRet->Method == RETURN_METHOD_NUMERIC){
            if(RootRet->Value.Num == 0) ExpressionNumericBody(&Arg0, 1, UNSIGN);
            else ExpressionNumericBody(&Arg0, 0, UNSIGN);
            *RootRet = Arg0;
        }
        else{
            if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            Arg0 = *RootRet;
            RegNo = RootRet->Value.RegNo;

            if(ExpressionNumericLoad(0, 1, UNSIGN, ExpressionNewGprNoGet(), RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
            ResRegNo = RootRet->Value.RegNo;

            ExpressionNumericBody(&Arg1, 0, UNSIGN);
            if(ExpressionBinomialOperation(&TmpRet, RootVCodeListHeader, TOKEN_MINUS, &Arg0, &Arg1, RegNo, __LINE__) == P3CC_NG){
                PrintError(__FILE__, __LINE__, "", "", "");
                return P3CC_NG;
            }
            LabelNo = VertualCodeNewLabelNoGet();
            vi.LabelNo = LabelNo;
            VCodeGen_Jump(&VCode, PLABEL_NON, OPECODE_JP_I, COND_ZERO, OPERAND_TYPE_LABEL, &vi, SrcFileIndex, SrcFileLine);
            if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            vi.NumLiteral = 0;
            VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_MOV_I,  RET_IS_GPR,ResRegNo,  ARG_IS_NOTING,0,  ARG_IS_IMM,&vi,  SrcFileIndex, SrcFileLine);
            if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            VCodeGen_Nop(&VCode, LabelNo, SrcFileIndex, SrcFileLine);
            if(VertualCodeAdd(RootVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }
    }
    ExpressionDebugMsg(RootRet, "ExpressionPreFixUnaryOperation", EXPRESSION_END, Line);
    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionPreFix(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] Ou
// [] expression_analsys_result *Ret                  Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader   FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         Token;
    int                         Size;
    expression_analsys_result   TmpArg;

    ExpressionDebugMsg(RootRet, "ExpressionPrefix", EXPRESSION_START, Line);

    ExpressionResultInit(&TmpArg);

    Token = TokenGet(TokenIndex, __LINE__);
    if((IsPrefixUnaryOperator(Token)) || (Token == TOKEN_DOUBLE_PLUS) || (Token == TOKEN_DOUBLE_MINUS) || (Token == TOKEN_SIZEOF)){//OuȂ
        ++TokenIndex;
        if(Token == TOKEN_SIZEOF){
            if(ExpressionSizeof(&Size, __LINE__) == P3CC_NG){PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
            ExpressionNumericBody(RootRet, Size, UNSIGN);
        }
        else if(IsPrefixUnaryOperator(Token)){// &, *, +, -, ~, !
            if(ExpressionCast(RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            if(ExpressionPreFixUnaryOperation(Token, RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }
        else{
            if(ExpressionPreFix(RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            if(ExpressionPreFixDoublePlusMinus(Token, RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }
    }
    else{//OułȂ
        if(ExpressionPostFix(RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }

    ExpressionDebugMsg(RootRet, "ExpressionPrefix", EXPRESSION_END, Line);

    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionPostFix(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] u
// [] expression_analsys_result *Ret                  Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader   FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         Token;
    int                         OpToken;
    int                         AdrBackUpRegNo;
    int                         AdrRegNo;
    int                         RetRegNo;
    vertual_code_list_header    MyVCodeListHeader0;
    expression_analsys_result   MyRet0;
    expression_analsys_result   TmpRet;
    expression_analsys_result   NumRet;
    expression_analsys_result   WorkRet;
    vertual_code                VCode;
    vertual_code                LastVCode;
    value_info                  vi;
    int                         Size;
    int                         SrcFileIndex;
    int                         SrcFileLine;

    ExpressionResultInit(&MyRet0);
    ExpressionResultInit(&TmpRet);
    ExpressionResultInit(&NumRet);
    ExpressionResultInit(&WorkRet);

    if(ExpressionPrimary(RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    Token = TokenGet(TokenIndex, __LINE__);
    if((Token != TOKEN_DOUBLE_PLUS) && (Token != TOKEN_DOUBLE_MINUS)) return P3CC_OK; //u++Au--ŖOKŔ

    ExpressionDebugMsg(RootRet, "ExpressionPostFix", EXPRESSION_START, Line);
    if((RootRet->Method == RETURN_METHOD_NUMERIC) || ((RootRet->Method == RETURN_METHOD_REG) && (RootRet->Method == RETURN_PROPERTY_VALUE))){
        //Ӗ̂Ȃu++oru--Ȃ
        //PrintWarning(__FILE__, __LINE__, "Ӗ̂Ȃu", "CurrentTokenBuf", "");
        PrintError(__FILE__, __LINE__, "u", "CurrentTokenBuf", "ɂ͍ӒlKv");
        return P3CC_NG;
    }
    else{//((RootRet->Method == RETURN_METHOD_REG) && (RootRet->Method == RETURN_PROPERTY_ADDRESS))
        //
        SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
        SrcFileLine = TokenSrcLineGet(TokenIndex);
        VCodeListHeaderInit(&MyVCodeListHeader0);
        WorkRet = *RootRet;
        AdrRegNo = WorkRet.Value.RegNo;
        AdrBackUpRegNo = ExpressionNewGprNoGet();
        LastVCode = *(RootVCodeListHeader->Last);
        
        if((LastVCode.OpCode.Code == OPECODE_ADD_I) 
                && (LastVCode.OpRand1.Type == OPERAND_TYPE_SPR) && (LastVCode.OpRand1.ValueInfo.RegNo == SPR_FP) 
                && (LastVCode.OpRand2.Type == OPERAND_TYPE_VARIABLE)){
            if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            RootVCodeListHeader->Last->OptimaizationHint.Copy = COPY_FOR_POSTFIX_EXPR;

            LastVCode.Prev = NULL;
            LastVCode.Next = NULL;
            LastVCode.LabelNo = PLABEL_NON;
            LastVCode.OpRand0.ValueInfo.RegNo = AdrBackUpRegNo;
            if(VertualCodeAdd(&MyVCodeListHeader0, &LastVCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            //p̃R[h
            WorkRet.Value.RegNo = AdrBackUpRegNo;
            if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, &WorkRet, &MyVCodeListHeader0, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            RetRegNo = WorkRet.Value.RegNo;
            ExpressionNumericBody(&NumRet, 1, UNSIGN);
            if(Token == TOKEN_DOUBLE_PLUS) OpToken = TOKEN_PLUS;
            else                           OpToken = TOKEN_MINUS;
            if(ExpressionBinomialOperation(&MyRet0, &MyVCodeListHeader0, OpToken, &WorkRet, &NumRet, RetRegNo, __LINE__) == P3CC_NG){
                PrintError(__FILE__, __LINE__, "", "", "");
                return P3CC_NG;
            }
            Size = ExpressionResultSizeGet(&(MyRet0.TypeInfo));
            vi.NumLiteral = 0;
            VCodeGen_Store(&VCode, PLABEL_NON, Size, BASE_UPDATE_NO,  SRC_IS_GPR,RetRegNo, BASE_IS_SPR,AdrBackUpRegNo, OFFSET_IS_IMM,&vi,SrcFileIndex, SrcFileLine);
            VCode.OpRand1 = LastVCode.OpRand1;
            VCode.OpRand2 = LastVCode.OpRand2;
            if(VertualCodeAdd(&MyVCodeListHeader0, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            if(VertualCodeListConnect(&SideEffectVCodeHeader, &MyVCodeListHeader0) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }
        else{
            //AhXۑĂ
            vi.RegNo = AdrRegNo;
            VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_MOV_R,  RET_IS_GPR,AdrBackUpRegNo, ARG_IS_NOTING,0,  ARG_IS_GPR,&vi, SrcFileIndex, SrcFileLine);
            if(VertualCodeAdd(RootVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            //p̃R[h
            WorkRet.Value.RegNo = AdrBackUpRegNo;
            if(ExpressionResultTrimRightSide(USE_NEW_REG, &WorkRet, &MyVCodeListHeader0, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            RetRegNo = WorkRet.Value.RegNo;
            ExpressionNumericBody(&NumRet, 1, UNSIGN);
            if(Token == TOKEN_DOUBLE_PLUS) OpToken = TOKEN_PLUS;
            else                           OpToken = TOKEN_MINUS;
            if(ExpressionBinomialOperation(&MyRet0, &MyVCodeListHeader0, OpToken, &WorkRet, &NumRet, RetRegNo, __LINE__) == P3CC_NG){
                PrintError(__FILE__, __LINE__, "", "", "");
                return P3CC_NG;
            }
            Size = ExpressionResultSizeGet(&(MyRet0.TypeInfo));
            vi.NumLiteral = 0;
            VCodeGen_Store(&VCode, PLABEL_NON, Size, BASE_UPDATE_NO,  SRC_IS_GPR,RetRegNo, BASE_IS_GPR,AdrBackUpRegNo, OFFSET_IS_IMM,&vi,SrcFileIndex, SrcFileLine);
            if(VertualCodeAdd(&MyVCodeListHeader0, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            if(VertualCodeListConnect(&SideEffectVCodeHeader, &MyVCodeListHeader0) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }
    }
    ++TokenIndex;
    ExpressionDebugMsg(RootRet, "ExpressionPostFix", EXPRESSION_END, Line);

    return P3CC_OK;
}

//====================================================================================================================
static int ExpressionFunctionEntry(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] ֐EntryPointWX^Ƀ[h
// [] expression_analsys_result *Ret            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader   FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         RegNo0;
    int                         LabelNo;
    literal_label_ext_info      ExtInfo;
    function                    *f;
    vertual_code                VCode;
    value_info                  vi;
    int                         SrcFileIndex;
    int                         SrcFileLine;
    int                         NoUseOfPcOffsetLoad;
#ifdef NO_USE_PC_OFFSET_LD
    NoUseOfPcOffsetLoad = P3CC_TRUE;
#else
    NoUseOfPcOffsetLoad = P3CC_FALSE;
#endif

    ExpressionDebugMsg(RootRet, "ExpressionFunctionEntry", EXPRESSION_START, Line);

    f = FunctionFind(TokenIdStrGet(TokenIndex));
    if(f == NULL){
        PrintError(__FILE__, __LINE__, "`̎ʎqB", "", "");
        return P3CC_NG;   //ʎqϐłȂNG
    }
    //ȍ~́A֐ł邱Ƃm肵ꍇ̏
    SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
    SrcFileLine = TokenSrcLineGet(TokenIndex);

    RegNo0 = ExpressionNewGprNoGet();
    RootRet->Value.RegNo = RegNo0;
    if(NoUseOfPcOffsetLoad == P3CC_TRUE){
         vi.func = f;
         VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_MOVH_I,  RET_IS_GPR,RegNo0,  ARG_IS_NOTING,0,  OPERAND_TYPE_FUNCTION_HI,&vi,  SrcFileIndex, SrcFileLine);
         if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
         VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_OR_I,    RET_IS_GPR,RegNo0,  ARG_IS_GPR,RegNo0, OPERAND_TYPE_FUNCTION_LO,&vi,  SrcFileIndex, SrcFileLine);
         if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }
    else{
        ExtInfo.f = f;
        LabelNo = LiteralLabelListFind(&ExtInfo);
        if(LabelNo < 0){//o^̏ꍇ
            LabelNo = VertualCodeNewLabelNoGet();
            if(LiteralLabelListAdd(LabelNo, LLABEL_FUNCTION, &ExtInfo) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }
        vi.LabelNo = LabelNo;
        VCodeGen_Load(&VCode, PLABEL_NON, SIZE_4, UNSIGN, BASE_UPDATE_NO,  DST_IS_GPR,RegNo0,  BASE_IS_SPR,SPR_PC,  OFFSET_IS_LABEL,&vi,  SrcFileIndex, SrcFileLine);
        if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }
    
    RootRet->Method = RETURN_METHOD_REG;
    RootRet->Property = RETURN_PROPERTY_VALUE;
    RootRet->TypeInfo.Sign    = f->Sign;
    RootRet->TypeInfo.Pointer = f->Pointer;
    RootRet->TypeInfo.Type    = f->Type;
    RootRet->TypeInfo.TypeFunction = TYPE_FUNCTION_POINTER;
    RootRet->TypeInfo.FuncPointer = 1;
    RootRet->TypeInfo.ArgNum    = f->ArgNum;
    RootRet->TypeInfo.BasicTypeSize= ExpressionBasicTypeSizeGetF(f);
    if((RootRet->TypeInfo.BasicTypeSize < 1) && (f->Type != TYPE_VOID)){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    RootRet->TypeInfo.ArgList = f->ArgList;
    RootRet->TypeInfo.DimInfo = NULL;
    RootRet->TypeInfo.StructInfo = f->StructInfo;

    ++TokenIndex;//ʎq̎

    ExpressionDebugMsg(RootRet, "ExpressionFunctionEntry", EXPRESSION_END, Line);

    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionArgList(variable *ArgList, int *ArgNum, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] ֐̈X^bNɐς
// [] variable ArgList                              FXg
// [] int *ArgNum                                   FX^bNɐς񂾈̌
// [] vertual_code_list_header *RootVCodeListHeader FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         i;
    int                         Token;
    int                         SrcFileIndex;
    int                         SrcFileLine;
    int                         RegNo;
    int                         Size;
    vertual_code                VCode;
    value_info                  vi;
    variable                    *Arg[MAX_ARG_NUM];
    expression_analsys_result   ArgRet[MAX_ARG_NUM];
    expression_analsys_result   MyRet0;
    vertual_code_list_header    ArgHeader[MAX_ARG_NUM];

    ExpressionDebugMsg(NULL, "ExpressionArgList", EXPRESSION_START, Line);
    ExpressionResultInit(&MyRet0);

#ifdef ARG_DELIVERY_METHOD1
    SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
    SrcFileLine = TokenSrcLineGet(TokenIndex);
#endif

    // ̏ȒPɋLq̂ŁÂܑȂe[uĂ
    for(i=0;i<MAX_ARG_NUM;i++){
        VCodeListHeaderInit(&ArgHeader[i]);
        ExpressionResultInit(&ArgRet[i]);
        if(ArgList != NULL){
            Arg[i] = ArgList;
            ArgList = ArgList->Next;
        }
        else{
            break;
        }
    }
    *ArgNum = i;

    //Ẍ̎𗧂Ă
    for(i=0;i<*ArgNum;i++){
        if(i > 0){
            Token = TokenGet(TokenIndex, __LINE__);
            if(Token != TOKEN_COMMA){ PrintError(__FILE__, __LINE__, "̐sH", "", ""); return P3CC_NG; }
            ++TokenIndex; // ","̎
        }

        if(ExpressionAssignment(&ArgRet[i], &ArgHeader[i], __LINE__) == P3CC_NG){
            PrintError(__FILE__, __LINE__, "̉͂ɎsB", "", "");
            return P3CC_NG;
        }
        if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, &ArgRet[i], &ArgHeader[i], __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

        //̌^r
        ExpressionSetResultByVariable(&MyRet0, Arg[i], __LINE__);
        if(ExpressionAssignTrim(&MyRet0, &ArgRet[i], &ArgHeader[i]) == P3CC_NG){ PrintError(__FILE__, __LINE__, "̌^sH", "", ""); return P3CC_NG; }
    }


#ifdef ARG_DELIVERY_METHOD0
    //̕тƂ͋tPUSHĂ
    for(i = *ArgNum - 1; i >= 0; i--){
        SrcFileIndex = ArgHeader[i].Last->SrcFileIndex;
        SrcFileLine  = ArgHeader[i].Last->SrcFileLine;
        VertualCodeListConnect(RootVCodeListHeader, &ArgHeader[i]);
        RegNo = ArgRet[i].Value.RegNo;
        //Size = ExpressionResultSizeGet(&(ArgRet[i].TypeInfo));
        Size = Arg[i]->TypeSize;
        vi.NumLiteral = (unsigned long)(-4);
        VCodeGen_Store(&VCode, PLABEL_NON, Size, BASE_UPDATE_BEFORE,  SRC_IS_GPR,RegNo, BASE_IS_SPR, SPR_SP, OFFSET_IS_IMM, &vi, SrcFileIndex, SrcFileLine);
        //VCodeGen_Push(&VCode, PLABEL_NON, SRC_IS_GPR,RegNo, SrcFileIndex, SrcFileLine);
        if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }
#endif
#ifdef ARG_DELIVERY_METHOD1
    //Ɉ̃TCYASPāA̕яSTĂ
    vi.NumLiteral = (unsigned long)((*ArgNum * 4));
    VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_SUB_I,  RET_IS_SPR,SPR_SP,  ARG_IS_SPR,SPR_SP,  ARG_IS_IMM,&vi,  SrcFileIndex, SrcFileLine);
    if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    for(i = 0; i < *ArgNum ; i++){
        SrcFileIndex = ArgHeader[i].Last->SrcFileIndex;
        SrcFileLine  = ArgHeader[i].Last->SrcFileLine;
        VertualCodeListConnect(RootVCodeListHeader, &ArgHeader[i]);
        RegNo = ArgRet[i].Value.RegNo;
        //Size = ExpressionResultSizeGet(&(ArgRet[i].TypeInfo));
        Size = Arg[i]->TypeSize;
        vi.NumLiteral = (unsigned long)((i * 4));
        VCodeGen_Store(&VCode, PLABEL_NON, Size, BASE_UPDATE_NO,  SRC_IS_GPR,RegNo, BASE_IS_SPR, SPR_SP, OFFSET_IS_IMM, &vi, SrcFileIndex, SrcFileLine);
        //VCodeGen_Push(&VCode, PLABEL_NON, SRC_IS_GPR,RegNo, SrcFileIndex, SrcFileLine);
        if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }
#endif

    ExpressionDebugMsg(NULL, "ExpressionArgList", EXPRESSION_END, Line);

    return P3CC_OK;
}

//====================================================================================================================
static int ExpressionFunctionCall(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] ֐Ăяo
// [] expression_analsys_result *Ret            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader   FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         Token;
    int                         RegNo0;
    int                         ArgNum;
    vertual_code                VCode;
    value_info                  vi;
    int                         CallCounterCopy;
    int                         SrcFileIndex;
    int                         SrcFileLine;
    char                        Property;
    char                        FuncPointer;
    expression_analsys_result   FuncRet;

    ExpressionDebugMsg(RootRet, "ExpressionFunctionCall", EXPRESSION_START, Line);

    ExpressionResultInit(&FuncRet);

    SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
    SrcFileLine = TokenSrcLineGet(TokenIndex);
    FuncRet = *RootRet;

//PrintExpAnaResult(RootRet, "ExpressionFunctionCall");

    if(RootRet->TypeInfo.TypeFunction != TYPE_FUNCTION_POINTER){
        PrintError(__FILE__, __LINE__, "֐Ăяỏ͎s(֐͊֐|C^łȂ)B", "", "");
        return P3CC_NG;
    }
    if(RootRet->Method != RETURN_METHOD_REG){
        PrintError(__FILE__, __LINE__, "֐Ăяỏ͎s(RpC̃oOH)B", "", "");
        return P3CC_NG;
    }


    Property    = RootRet->Property;
    FuncPointer = RootRet->TypeInfo.FuncPointer;
    if(Property == RETURN_PROPERTY_VALUE){ // ֐AhX
        if(FuncPointer != 1){
            PrintError(__FILE__, __LINE__, "֐Ăяỏ͎s(RpC̃oOH)B", "", "");
            return P3CC_NG;
        }
    }
    else{// ԐڎQ
        if(FuncPointer > 1){
            PrintError(__FILE__, __LINE__, "֐Ăяỏ͎s(炭֐|C^̑O * Ȃ)B", "", "");
            return P3CC_NG;
        }
        if(FuncPointer == 1){// ֐|C^̐オ
            RegNo0 = RootRet->Value.RegNo;
            vi.NumLiteral = 0;
            VCodeGen_Load(&VCode, PLABEL_NON, SIZE_4, UNSIGN, BASE_UPDATE_NO,  DST_IS_GPR,RegNo0,  BASE_IS_GPR,RegNo0,  OFFSET_IS_IMM,&vi,  SrcFileIndex, SrcFileLine);
            if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            RootRet->TypeInfo.FuncPointer -= 1;
        }
        //RegNo0 = RootRet->Value.RegNo;
        //vi.NumLiteral = 0;
        //VCodeGen_Load(&VCode, PLABEL_NON, SIZE_4, UNSIGN, BASE_UPDATE_NO,  DST_IS_GPR,RegNo0,  BASE_IS_GPR,RegNo0,  OFFSET_IS_IMM,&vi,  SrcFileIndex, SrcFileLine);
        //if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }
    RegNo0 = RootRet->Value.RegNo; //ѐۑ
//PrintExpAnaResult(RootRet, "ExpressionFunctionCall");


    Token = TokenGet(TokenIndex, __LINE__);
    if(Token != TOKEN_BRACKET_L){
        PrintError(__FILE__, __LINE__, "֐Ăяỏ͎sB", "", "");
        return P3CC_NG;
    }
    ++TokenIndex; // '('̎
    SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
    SrcFileLine = TokenSrcLineGet(TokenIndex);

    //==== XNb`WX^ޔ|Cg ===========
    ++CallCounter ;
    CallCounterCopy = CallCounter;
    VCodeGen_DummyCode(&VCode, PLABEL_NON, OPECODE_ESCAPE_REGS, CallCounterCopy, SrcFileIndex, SrcFileLine);
    if(VertualCodeAdd(RootVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    
    //==== ̉͂PUSH ===========
    ArgNum = 0;
    if(FuncRet.TypeInfo.ArgList != NULL){
        if((FuncRet.TypeInfo.ArgList->Type == TYPE_VOID) && (FuncRet.TypeInfo.ArgList->Pointer == 0)){
            ;//void^ȂȂɂȂ
        }
        else{
            if(ExpressionArgList(FuncRet.TypeInfo.ArgList, &ArgNum, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }
    }
    else{//(ArgList==NULL)͈XgȗꂽP[X
        if(ExpressionArgList(NULL, &ArgNum, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }

    //==== pf ===============
    VertualCodeSideEffectListConnect(RootVCodeListHeader, &SideEffectVCodeHeader);//===pf


    //==== ֐̌Ăяo ===========
    vi.RegNo = RegNo0;
    VCodeGen_Jump(&VCode, PLABEL_NON, OPECODE_CALL_R, COND_ALWAYS, OPERAND_TYPE_GPR, &vi, SrcFileIndex, SrcFileLine);
    if(VertualCodeAdd(RootVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    //==== SP̕A ===========
    if(ArgNum > 0){
        vi.NumLiteral = ArgNum * 4;
        VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_ADD_I,  RET_IS_SPR,SPR_SP, ARG_IS_SPR,SPR_SP,  ARG_IS_IMM,&vi, SrcFileIndex, SrcFileLine);
        if(VertualCodeAdd(RootVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }

    //==== XNb`WX^A|Cg ===========
    VCodeGen_DummyCode(&VCode, PLABEL_NON, OPECODE_RETURN_REGS, CallCounterCopy, SrcFileIndex, SrcFileLine);
    if(VertualCodeAdd(RootVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    //==== Ԃl̕ۑ ===========
    if((FuncRet.TypeInfo.Type == TYPE_VOID) && (FuncRet.TypeInfo.Pointer == 0)){
        ;
    }
    else{
        vi.RegNo = 0;
        VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_MOV_R,  RET_IS_GPR,RegNo0, ARG_IS_NOTING,0,  ARG_IS_GPR,&vi, SrcFileIndex, SrcFileLine);
        if(VertualCodeAdd(RootVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }

    //Ԃl̑
    *RootRet = FuncRet;
    RootRet->Method = RETURN_METHOD_REG;
    RootRet->Property = RETURN_PROPERTY_VALUE;
    //RootRet->TypeInfo.Sign    = f->Sign;
    //RootRet->TypeInfo.Pointer = f->Pointer;
    //RootRet->TypeInfo.Type    = f->Type;
    RootRet->TypeInfo.TypeFunction = TYPE_NOT_FUNCTION_POINTER;
    RootRet->TypeInfo.FuncPointer = 0;
    RootRet->TypeInfo.ArgNum    = 0;
    //RootRet->TypeInfo.BasicTypeSize= ExpressionBasicTypeSizeGetF(f);
    //if(RootRet->TypeInfo.BasicTypeSize < 1){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    RootRet->TypeInfo.ArgList = NULL;
    RootRet->TypeInfo.DimInfo = NULL;
    //RootRet->TypeInfo.StructInfo = f->StructInfo;

//PrintExpAnaResult(RootRet, "ExpressionFunctionCall");

    Token = TokenGet(TokenIndex, __LINE__);
    if(Token != TOKEN_BRACKET_R){
        PrintError(__FILE__, __LINE__, "֐Ăяỏ͎sB", "̐ႤH", "");
        return P3CC_NG;
    }
    ++TokenIndex; // ')'̎

    ExpressionDebugMsg(RootRet, "ExpressionFunctionCall", EXPRESSION_END, Line);
    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionPrimary(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] ꎟ
// [] expression_analsys_result *Ret            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader   FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         Token;
    cc1_numeric_literal         *p;
    vertual_code_list_header    MyVCodeListHeader0;
    expression_analsys_result   MyRet0;

    ExpressionDebugMsg(RootRet, "ExpressionPrimary", EXPRESSION_START, Line);

    ExpressionResultInit(&MyRet0);

    VCodeListHeaderInit(&MyVCodeListHeader0);

    Token = TokenGet(TokenIndex, __LINE__);
    if(Token == TOKEN_IDENTIFIER){
        if(ExpressionVariable(&MyRet0, &MyVCodeListHeader0, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        if(TokenGet(TokenIndex, __LINE__) == TOKEN_BRACKET_L){ //--- ֐Ăяỏ
            if(ExpressionFunctionCall(&MyRet0, &MyVCodeListHeader0, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }
        *RootRet = MyRet0;
        if(VertualCodeListConnect(RootVCodeListHeader, &MyVCodeListHeader0) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }
    else if(Token == TOKEN_NUMERIC_LITERAL){
        if(ExpressionNumeric(RootRet, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }
    else if(Token == TOKEN_STRING_LITERAL){
        if(ExpressionStringLiteral(RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }
    else if(Token == TOKEN_BRACKET_L){ // '('Ȃꎟ
        ++TokenIndex;   // '('̎
        if(ExpressionAssignment(&MyRet0, &MyVCodeListHeader0, __LINE__) == P3CC_NG){   //--- "()"̒g
            return P3CC_NG;
        }
//PrintExpAnaResult(&MyRet0, "ExpressionPrimary");
        if(TokenGet(TokenIndex, __LINE__) != TOKEN_BRACKET_R){   //--- ')'ǂ`FbN
            PrintError(__FILE__, __LINE__, "ʂ̑ΉH", "", "");
            return P3CC_NG;
        }
        ++TokenIndex;   // ')'̎

        Token = TokenGet(TokenIndex, __LINE__);
        if(Token == TOKEN_BRACKET_L){ // '('Ȃ֐Ăяo ߑłI
            if(ExpressionFunctionCall(&MyRet0, &MyVCodeListHeader0, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }
        else{
            if((Token == TOKEN_SQUARE_L) || (Token == TOKEN_PERIOD) || (Token == TOKEN_ARROW)){
                if(ExpressionStructAndArray(&MyRet0, &MyVCodeListHeader0, __LINE__) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            }
            //--- sS^̔z񂾂ꍇ̌㏈ begin
            if(MyRet0.TypeInfo.DimInfo != NULL){
                if(MyRet0.TypeInfo.TypeFunction) MyRet0.TypeInfo.FuncPointer += 1;
                else MyRet0.TypeInfo.Pointer += 1;
                MyRet0.Property = RETURN_PROPERTY_VALUE;
            }
            //--- sS^̔z񂾂ꍇ̌㏈ end
        }
        *RootRet = MyRet0;
        if(VertualCodeListConnect(RootVCodeListHeader, &MyVCodeListHeader0) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }
    else{//͕s\
        PrintError(__FILE__, __LINE__, "ꎟ͎sB", "", "");
        return P3CC_NG;
    }

    ExpressionDebugMsg(RootRet, "ExpressionPrimary", EXPRESSION_END, Line);

    return P3CC_OK;

}
//====================================================================================================================
static int ExpressionArrayDimGet(dimension_info *DimInfo)
//====================================================================================================================
// [@\] z̎擾
// [] dimension_info *Ret            Fʊi[
// [Ԓl] z̎
{
    int                         ArrayDim;
    ArrayDim = 0;
    while(1){
        if(DimInfo->ElementSize[ArrayDim] == 0) break;
        ++ArrayDim;
    }
    return ArrayDim;
}

//====================================================================================================================
static int ExpressionArray(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] z̎
// [] expression_analsys_result *Ret            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader   FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         Token;
    vertual_code_list_header    MyVCodeListHeader0;
    vertual_code_list_header    MyVCodeListHeader1;
    vertual_code_list_header    MyVCodeListHeader2;
    expression_analsys_result   MyRet0;
    expression_analsys_result   MyRet1;
    expression_analsys_result   MyRet2;
    expression_analsys_result   TmpRet;
    int                         RegNo0;
    int                         RegNo1;
    int                         RetRegNo;
    int                         ArrayDim;
    dimension_info              LocalDimInfo;
    dimension_info              *DimInfo;
    int                         ArrayDimCount;
    vertual_code                VCode;
    value_info                  vi;
    unsigned long               ElementSize;

    ExpressionDebugMsg(RootRet, "ExpressionArray", EXPRESSION_START, Line);

    ExpressionResultInit(&MyRet0);
    ExpressionResultInit(&MyRet1);
    ExpressionResultInit(&MyRet2);
    ExpressionResultInit(&TmpRet);

    if(RootRet->TypeInfo.DimInfo == NULL){
        if(RootRet->TypeInfo.Pointer == 0){
            PrintError(__FILE__, __LINE__, "z͎̉s(zH)B", "", "");
            return P3CC_NG;
        }
        else{
//PrintExpAnaResult(RootRet, "ExpressionArray");
            //--- |C^ȂΈꎟz񂠂
            if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){
                PrintError(__FILE__, __LINE__, "", "", "");
                return P3CC_NG;
            }
            RootRet->Property = RETURN_PROPERTY_ADDRESS;
            VariableArrayDimInfoInit(&LocalDimInfo);
            if(RootRet->TypeInfo.TypeFunction) RootRet->TypeInfo.FuncPointer -= 1;
            else RootRet->TypeInfo.Pointer -= 1;
            LocalDimInfo.ElementSize[0] = ExpressionResultSizeGet(&(RootRet->TypeInfo));
            DimInfo = &LocalDimInfo;
        }
    }
    else{
        DimInfo = RootRet->TypeInfo.DimInfo;
    }

    ArrayDim = ExpressionArrayDimGet(DimInfo);

    VCodeListHeaderInit(&MyVCodeListHeader0);

    ArrayDimCount = 0;
    while(1){
        VCodeListHeaderInit(&MyVCodeListHeader1);
        if(TokenGet(TokenIndex, __LINE__) != TOKEN_SQUARE_L) break;
        ++TokenIndex; // '['΂
        if(ExpressionAssignment(&MyRet1, &MyVCodeListHeader1, __LINE__) == P3CC_NG){   //--- "[ ]"̒g
            PrintError(__FILE__, __LINE__, "zIndex͎s", CurrentTokenBuf, "");
            return P3CC_NG;
        }
        if(TokenGet(TokenIndex, __LINE__) != TOKEN_SQUARE_R){   //--- ']'ǂ`FbN
            PrintError(__FILE__, __LINE__, "zIndex͎s", CurrentTokenBuf, "");
            return P3CC_NG;
        }
        //--- ExpressionAssignment()ԂĂl
        if(MyRet1.Method == RETURN_METHOD_NUMERIC){
            MyRet1.Value.Num = MyRet1.Value.Num * DimInfo->ElementSize[ArrayDimCount];
            if(ArrayDimCount == 0){//---P
                MyRet0 = MyRet1;
            }
            else{//---Q߈ȍ~
                if(MyRet0.Method == RETURN_METHOD_NUMERIC){
                    MyRet0.Value.Num = MyRet0.Value.Num + MyRet1.Value.Num;
                }
                else{// MyRet0.Method == RETURN_METHOD_REG
                    RetRegNo = MyRet0.Value.RegNo;
                    VCodeListHeaderInit(&MyVCodeListHeader2);
                    if(ExpressionBinomialOperation(&MyRet2, &MyVCodeListHeader2, TOKEN_PLUS, &MyRet0, &MyRet1, RetRegNo, __LINE__) == P3CC_NG){
                        PrintError(__FILE__, __LINE__, "", "", "");
                        return P3CC_NG;
                    }
                    MyRet0 = MyRet2;
                    if(VertualCodeListConnect(&MyVCodeListHeader1, &MyVCodeListHeader2) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                }
            }
            if(VertualCodeListConnect(&MyVCodeListHeader0, &MyVCodeListHeader1) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }
        else{ // MyRet1.Method == RETURN_METHOD_REG
            //--- EӒlɕϊ
            if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, &MyRet1, &MyVCodeListHeader1, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            ElementSize = DimInfo->ElementSize[ArrayDimCount];
            RetRegNo = MyRet1.Value.RegNo;
            if(ElementSize > 1){
                ExpressionNumericBody(&TmpRet, ElementSize, UNSIGN);
                VCodeListHeaderInit(&MyVCodeListHeader2);
                if(ExpressionBinomialOperation(&MyRet2, &MyVCodeListHeader2, TOKEN_ASTERISK, &MyRet1, &TmpRet, RetRegNo, __LINE__) == P3CC_NG){
                    PrintError(__FILE__, __LINE__, "", "", "");
                    return P3CC_NG;
                }
                if(VertualCodeListConnect(&MyVCodeListHeader1, &MyVCodeListHeader2) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                MyRet1 = MyRet2;
            }

            if(ArrayDimCount == 0){//---P
                MyRet0 = MyRet1;
            }
            else{//---Q߈ȍ~
                RegNo0 = MyRet0.Value.RegNo;
                RegNo1 = MyRet1.Value.RegNo;
                if(MyRet0.Method == RETURN_METHOD_NUMERIC){ RetRegNo = RegNo1;}//RegNo0͖Ȓl
                else{                                       RetRegNo = RegNo0;}//RegNo0͗LȒlBExpressionResultTrimRightSide()ς
                VCodeListHeaderInit(&MyVCodeListHeader2);
                if(ExpressionBinomialOperation(&MyRet2, &MyVCodeListHeader2, TOKEN_PLUS, &MyRet0, &MyRet1, RetRegNo, __LINE__) == P3CC_NG){
                    PrintError(__FILE__, __LINE__, "", "", "");
                    return P3CC_NG;
                }
                MyRet0 = MyRet2;
                if(VertualCodeListConnect(&MyVCodeListHeader1, &MyVCodeListHeader2) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            }
            if(VertualCodeListConnect(&MyVCodeListHeader0, &MyVCodeListHeader1) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }
        ++TokenIndex; // ']'΂
        ++ArrayDimCount;
        if(ArrayDimCount > ArrayDim){
            PrintError(__FILE__, __LINE__, "z̎H", "", "");
            return P3CC_NG;
        }
    }


    RetRegNo = RootRet->Value.RegNo;//x[XAhXi[Ă͂
    VCodeListHeaderInit(&MyVCodeListHeader2);
    if(ExpressionBinomialOperation(&MyRet2, &MyVCodeListHeader2, TOKEN_PLUS, RootRet, &MyRet0, RetRegNo, __LINE__) == P3CC_NG){
        PrintError(__FILE__, __LINE__, "", "", "");
        return P3CC_NG;
    }
    if(VertualCodeListConnect(&MyVCodeListHeader0, &MyVCodeListHeader2) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    if(VertualCodeListConnect(RootVCodeListHeader, &MyVCodeListHeader0) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    if(ArrayDimCount < ArrayDim){
        RootRet->TypeInfo.Pointer += 1;
        RootRet->Property = RETURN_PROPERTY_VALUE;
    }
    else{
        RootRet->TypeInfo.DimInfo = NULL;
    }


    ExpressionDebugMsg(RootRet, "ExpressionArray", EXPRESSION_END, Line);
    return P3CC_OK;
}

//====================================================================================================================
static int ExpressionBasicTypeSizeGetV(variable *v)
//====================================================================================================================
// [@\] {^̃TCYԂ
// [] variable
// [Ԓl] {^̃TCY
{
    if(v->Pointer == 0){
        return v->TypeSize;
    }
    else{
        if(v->StructInfo == NULL){
            if     (v->Type == TYPE_CHAR ) return SIZEOF_CHAR;
            else if(v->Type == TYPE_SHORT) return SIZEOF_SHORT;
            else if(v->Type == TYPE_INT  ) return SIZEOF_INT;
            else if(v->Type == TYPE_LONG ) return SIZEOF_LONG;
            else if(v->Type == TYPE_VOID ) return SIZEOF_VOID;
            else{
                PrintError(__FILE__, __LINE__, "Ή̌^", CurrentTokenBuf, "");
               return P3CC_NG;
            }
        }
        else{
            return v->StructInfo->StructSize;
        }
    }
}
//====================================================================================================================
static int ExpressionBasicTypeSizeGetF(function *f)
//====================================================================================================================
// [@\] {^̃TCYԂ
// [] variable
// [Ԓl] {^̃TCY
{
    if(f->Pointer == 0){
        return f->TypeSize;
    }
    else{
        if(f->StructInfo == NULL){
            if     (f->Type == TYPE_CHAR ) return SIZEOF_CHAR;
            else if(f->Type == TYPE_SHORT) return SIZEOF_SHORT;
            else if(f->Type == TYPE_INT  ) return SIZEOF_INT;
            else if(f->Type == TYPE_LONG ) return SIZEOF_LONG;
            else if(f->Type == TYPE_VOID ) return 0;
            else{
                PrintError(__FILE__, __LINE__, "Ή̌^", CurrentTokenBuf, "");
               return P3CC_NG;
            }
        }
        else{
            return f->StructInfo->StructSize;
        }
    }
}
//====================================================================================================================
static int ExpressionStruct(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] \̂̎
// [] expression_analsys_result *Ret            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader   FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         Token;
    vertual_code_list_header    MyVCodeListHeader0;
    expression_analsys_result   MyRet0;
    int                         RegNo;
    vertual_code                VCode;
    value_info                  vi;
    char                        *MemberName;
    variable                    *Member;

    int                         SrcFileIndex;
    int                         SrcFileLine;

    ExpressionDebugMsg(RootRet, "ExpressionStruct", EXPRESSION_START, Line);

    ExpressionResultInit(&MyRet0);

    if(RootRet->TypeInfo.StructInfo == NULL){
        PrintError(__FILE__, __LINE__, "\̈ȊO\̂ƂĈĂH", "", "");
        return P3CC_NG;
    }
    if((RootRet->Method != RETURN_METHOD_REG) || (RootRet->Property != RETURN_PROPERTY_ADDRESS)){
        PrintError(__FILE__, __LINE__, "\G[́AΉ̍\H", "", "");
        return P3CC_NG;
    }

    Token = TokenGet(TokenIndex, __LINE__);
    if(Token == TOKEN_PERIOD){
        if(RootRet->TypeInfo.Pointer > 0){
            PrintError(__FILE__, __LINE__, "\̃|C^Ȃ̂\"->\"łȂ\".\"ŃANZX悤ƂĂH", "", "");
            return P3CC_NG;
        }
        ++TokenIndex; // "."XLbv
    }
    else{ // Token == TOKEN_ARROW
        if(RootRet->TypeInfo.Pointer == 0){
            PrintError(__FILE__, __LINE__, "\̃|C^łȂ̂\".\"łȂ\"->\"ŃANZX悤ƂĂH", "", "");
            return P3CC_NG;
        }
        if(ExpressionResultTrimRightSide(NOT_USE_NEW_REG, RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){
            PrintError(__FILE__, __LINE__, "", "", "");
            return P3CC_NG;
        }
        RootRet->Property = RETURN_PROPERTY_ADDRESS;
        RootRet->TypeInfo.Pointer -= 1;
        if(RootRet->TypeInfo.Pointer != 0){
            PrintError(__FILE__, __LINE__, "͕s\ȍ\B", "", "");
            PrintError(__FILE__, __LINE__, "\"*\"ĂȂB", "", "");
            return P3CC_NG;
        }
        ++TokenIndex; // "->"XLbv
    }

    Token = TokenGet(TokenIndex, __LINE__);
    if(Token != TOKEN_IDENTIFIER){
        PrintError(__FILE__, __LINE__, "ʎq҂Ă鏊ɎʎqȊO", CurrentTokenBuf, "݂܂B");
        return P3CC_NG;
    }
    MemberName = TokenIdStrGet(TokenIndex);
    Member = StructMemberFind(RootRet->TypeInfo.StructInfo, MemberName);
    if(Member == NULL){
        PrintError(__FILE__, __LINE__, "`̍\̃o", CurrentTokenBuf, "");
        return P3CC_NG;
    }
    RegNo = RootRet->Value.RegNo;
    SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
    SrcFileLine = TokenSrcLineGet(TokenIndex);
    if(Member->Offset != 0){
        if(ExpressionNumericRangeCheck(OPECODE_ADD_I, (unsigned long)Member->Offset) == P3CC_OK){ //--- 
            vi.NumLiteral = (unsigned long)Member->Offset;
            VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_ADD_I,  RET_IS_GPR,RegNo,  ARG_IS_GPR,RegNo,  ARG_IS_IMM,&vi,  SrcFileIndex, SrcFileLine);
            if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }
        else{//--- REGɃ[hđ
            VCodeListHeaderInit(&MyVCodeListHeader0);
            if(ExpressionNumericLoad(0, (unsigned long)Member->Offset, UNSIGN, ExpressionNewGprNoGet(), &MyRet0, &MyVCodeListHeader0, __LINE__) != P3CC_OK){
                PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;
            }
            vi.RegNo = MyRet0.Value.RegNo;
            VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_ADD_R,  RET_IS_GPR,RegNo,  ARG_IS_GPR,RegNo,  ARG_IS_GPR,&vi,  SrcFileIndex, SrcFileLine);
            if(VertualCodeAdd(&MyVCodeListHeader0, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            if(VertualCodeListConnect(RootVCodeListHeader, &MyVCodeListHeader0) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }
    }
    ExpressionSetResultByVariable(RootRet, Member, __LINE__);

    ++TokenIndex; // ʎqXLbv

    ExpressionDebugMsg(RootRet, "ExpressionStruct", EXPRESSION_END, Line);

    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionStructAndArray(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] \̂Ɣz̎
// [] expression_analsys_result *Ret            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader   FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         Token;

    ExpressionDebugMsg(RootRet, "ExpressionStructAndArray", EXPRESSION_START, Line);

    while(1){
        Token = TokenGet(TokenIndex, __LINE__);
        if((Token != TOKEN_SQUARE_L) && (Token != TOKEN_PERIOD) && (Token != TOKEN_ARROW)) break;
        if(Token == TOKEN_SQUARE_L){
            if((RootRet->Property == RETURN_PROPERTY_ADDRESS) || (RootRet->TypeInfo.Pointer > 0) || (RootRet->TypeInfo.FuncPointer > 1)){
                if(ExpressionArray(RootRet, RootVCodeListHeader, __LINE__) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            }
            else{
                PrintError(__FILE__, __LINE__, "zƂăANZXłȂB", "", "");
                return P3CC_NG;
            }
        }
        else{//(Token == TOKEN_ARROW) || (Token == TOKEN_PERIOD)
            if(RootRet->Property != RETURN_PROPERTY_ADDRESS){
                PrintError(__FILE__, __LINE__, "\̂ƂăANZXłȂB", "", "");
                return P3CC_NG;
            }
            if(ExpressionStruct(RootRet, RootVCodeListHeader, __LINE__) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }
    }

    ExpressionDebugMsg(RootRet, "ExpressionStructAndArray", EXPRESSION_END, Line);
    return P3CC_OK;
}

//====================================================================================================================
static int ExpressionSetResultByVariable(expression_analsys_result *RootRet, variable *v, int Line)
//====================================================================================================================
// [@\] RootRetɕϐ̏ݒ肵ĕԂ
// [] expression_analsys_result *RootRetFʊi[
// [] variable *v   Fϐ̏
// [Ԓl] P3CC_OK/P3CC_NG
{
    RootRet->Method = RETURN_METHOD_REG;
    RootRet->Property = RETURN_PROPERTY_ADDRESS;
    RootRet->TypeInfo.Sign    = v->Sign;
    RootRet->TypeInfo.Pointer = v->Pointer;
    RootRet->TypeInfo.Type    = v->Type;
    RootRet->TypeInfo.TypeFunction = v->TypeFunction;
    RootRet->TypeInfo.FuncPointer = v->FuncPointer;
    RootRet->TypeInfo.ArgNum    = v->ArgNum;
    RootRet->TypeInfo.BasicTypeSize= ExpressionBasicTypeSizeGetV(v);
    if(RootRet->TypeInfo.BasicTypeSize < 0){ PrintError(__FILE__, Line, "", "", ""); return P3CC_NG; }
    RootRet->TypeInfo.ArgList = v->ArgList;
    RootRet->TypeInfo.DimInfo = v->DimInfo;
    RootRet->TypeInfo.StructInfo = v->StructInfo;
    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionSetResultByFunction(expression_analsys_result *RootRet, function *f, int Line)
//====================================================================================================================
// [@\] RootRetɕϐ̏ݒ肵ĕԂ
// [] expression_analsys_result *RootRetFʊi[
// [] variable *v   Fϐ̏
// [Ԓl] P3CC_OK/P3CC_NG
{
    RootRet->Method = RETURN_METHOD_REG;
    RootRet->Property = RETURN_PROPERTY_VALUE;
    RootRet->TypeInfo.Sign    = f->Sign;
    RootRet->TypeInfo.Pointer = f->Pointer;
    RootRet->TypeInfo.Type    = f->Type;
    RootRet->TypeInfo.TypeFunction = TYPE_NOT_FUNCTION_POINTER; //֐|C^Ԃ֐ɂ͑ΉȂ
    RootRet->TypeInfo.FuncPointer = 0;//֐|C^Ԃ֐ɂ͑ΉȂ
    RootRet->TypeInfo.ArgNum    = 0;//֐|C^Ԃ֐ɂ͑ΉȂ
    RootRet->TypeInfo.BasicTypeSize= ExpressionBasicTypeSizeGetF(f);
    if(RootRet->TypeInfo.BasicTypeSize < 0){ PrintError(__FILE__, Line, "", "", ""); return P3CC_NG; }
    RootRet->TypeInfo.ArgList = NULL;//֐|C^Ԃ֐ɂ͑ΉȂ
    RootRet->TypeInfo.DimInfo = NULL;//zԂ֐ɂ͑ΉȂ
    RootRet->TypeInfo.StructInfo = f->StructInfo;
    return P3CC_OK;
}

//====================================================================================================================
static int ExpressionVariable(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] ϐ
// [] expression_analsys_result *Ret            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader   FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         Token;
    int                         RegNo0;
    int                         RegNo1;
    int                         LabelNo;
    literal_label_ext_info      ExtInfo;
    vertual_code_list_header    MyVCodeListHeader0;
    expression_analsys_result   MyRet0;
    char                        *Id;
    variable                    *v;
    function                    *f;
    vertual_code                VCode;
    value_info                  vi;
    int                         SrcFileIndex;
    int                         SrcFileLine;
    int                         UseGpFlag;
    int                         NoUseOfPcOffsetLoad;
#ifdef NO_USE_PC_OFFSET_LD
    NoUseOfPcOffsetLoad = P3CC_TRUE;
#else
    NoUseOfPcOffsetLoad = P3CC_FALSE;
#endif

#ifdef USE_GP
 //----------------------------------------------------------------------------------
 // GPp~邩HF
 //        AGP΂ŃO[oϐANZX邱Ƃz肵ĂA
 //        O[oϐւ̃ANZXAhXvZXebv]vɂ邽߁A
 //        JŐÓIɃO[oϐAhX肷悤ɕύXBł悤ɂĂ
 //----------------------------------------------------------------------------------
    UseGpFlag = P3CC_TRUE;
#else
    UseGpFlag = P3CC_FALSE;
#endif          


    ExpressionDebugMsg(RootRet, "ExpressionVariable", EXPRESSION_START, Line);

    ExpressionResultInit(&MyRet0);

    Id = TokenIdStrGet(TokenIndex);
    v = ArgFind(Id, CurrentFuncInfo);
    if(v == NULL){
        v = VariableFind(Id, CurrentFuncInfo);
        if(v == NULL){
            f = FunctionFind(Id);
            if(f == NULL){
                PrintError(__FILE__, __LINE__, "`̎ʎqB", Id, "");
                return P3CC_NG;   //ʎqϐłȂNG
            }
        }
    }
    //ȍ~́Aϐł邱Ƃm肵ꍇ̏
    SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
    SrcFileLine = TokenSrcLineGet(TokenIndex);
    VCodeListHeaderInit(&MyVCodeListHeader0);

    if(v == NULL){//֐̏ꍇ
        if(ExpressionFunctionEntry(&MyRet0, &MyVCodeListHeader0, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }
    else{// ʂ̕ϐ̏ꍇ
        if((v->Scope == SCOPE_AT) || (v->Scope == SCOPE_ARG)){//[Jϐ
            RegNo1 = ExpressionNewGprNoGet();
            MyRet0.Value.RegNo = RegNo1;
            vi.var = v;
            VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_ADD_I,  RET_IS_GPR,RegNo1,  ARG_IS_SPR,SPR_FP,  ARG_IS_VAR,&vi,  SrcFileIndex, SrcFileLine);
            if(VertualCodeAdd(&MyVCodeListHeader0, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

        }
        else{//O[oϐStaticϐ
            if(SmallMemory == P3CC_TRUE){
                if(UseGpFlag != P3CC_TRUE){
                    PrintError(__FILE__, __LINE__, "RpCݒ̕sB", "-sIvVwɂ炸GPgȂݒɂȂĂB", "");
                    return P3CC_NG;
                }
                RegNo1 = ExpressionNewGprNoGet();
                MyRet0.Value.RegNo = RegNo1;
                vi.var = v;
                VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_ADD_I,  RET_IS_GPR,RegNo1,  ARG_IS_SPR,SPR_GP,  ARG_IS_VAR,&vi,  SrcFileIndex, SrcFileLine);
                if(VertualCodeAdd(&MyVCodeListHeader0, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            }
            else{
                RegNo0 = ExpressionNewGprNoGet();
                MyRet0.Value.RegNo = RegNo0;
                if(NoUseOfPcOffsetLoad == P3CC_TRUE){
                    vi.var = v;
                    VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_MOVH_I,  RET_IS_GPR,RegNo0,  ARG_IS_NOTING,0,  OPERAND_TYPE_VARIABLE_HI,&vi,  SrcFileIndex, SrcFileLine);
                    if(VertualCodeAdd(&MyVCodeListHeader0, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                    VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_OR_I,    RET_IS_GPR,RegNo0,  ARG_IS_GPR,RegNo0, OPERAND_TYPE_VARIABLE_LO,&vi,  SrcFileIndex, SrcFileLine);
                    if(VertualCodeAdd(&MyVCodeListHeader0, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                    if(UseGpFlag == P3CC_TRUE){
                        vi.RegNo = RegNo0;
                        VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_ADD_R,  RET_IS_GPR,RegNo0,  ARG_IS_SPR,SPR_GP,  ARG_IS_GPR,&vi,  SrcFileIndex, SrcFileLine);
                        if(VertualCodeAdd(&MyVCodeListHeader0, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                    }
                }
                else{
                    ExtInfo.v = v;
                    LabelNo = LiteralLabelListFind(&ExtInfo);
                    if(LabelNo < 0){//o^̏ꍇ
                        LabelNo = VertualCodeNewLabelNoGet();
                        if(LiteralLabelListAdd(LabelNo, LLABEL_VARIABLE, &ExtInfo) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                    }
                    vi.LabelNo = LabelNo;
                    VCodeGen_Load(&VCode, PLABEL_NON, SIZE_4, UNSIGN, BASE_UPDATE_NO,  DST_IS_GPR,RegNo0,  BASE_IS_SPR,SPR_PC,  OFFSET_IS_LABEL,&vi,  SrcFileIndex, SrcFileLine);
                    if(VertualCodeAdd(&MyVCodeListHeader0, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                    if(UseGpFlag == P3CC_TRUE){
                        vi.RegNo = RegNo0;
                        VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_ADD_R,  RET_IS_GPR,RegNo0,  ARG_IS_SPR,SPR_GP,  ARG_IS_GPR,&vi,  SrcFileIndex, SrcFileLine);
                        if(VertualCodeAdd(&MyVCodeListHeader0, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                    }
                }
            }
        }
        ExpressionSetResultByVariable(&MyRet0, v, __LINE__);
        ++TokenIndex;//ʎq̎
        Token = TokenGet(TokenIndex, __LINE__);
        if((Token == TOKEN_SQUARE_L) || (Token == TOKEN_PERIOD) || (Token == TOKEN_ARROW)){
            if(ExpressionStructAndArray(&MyRet0, &MyVCodeListHeader0, __LINE__) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }
        //--- sS^̔z񂾂ꍇ̌㏈ begin
        if(MyRet0.TypeInfo.DimInfo != NULL){
            if(MyRet0.TypeInfo.TypeFunction) MyRet0.TypeInfo.FuncPointer += 1;
            else MyRet0.TypeInfo.Pointer += 1;
            MyRet0.Property = RETURN_PROPERTY_VALUE;
        }
    }
    *RootRet = MyRet0;
    if(VertualCodeListConnect(RootVCodeListHeader, &MyVCodeListHeader0) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    ExpressionDebugMsg(RootRet, "ExpressionVariable", EXPRESSION_END, Line);

    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionResultInit(expression_analsys_result *ExprRes)
//====================================================================================================================
// [@\] 萔i{́j
// [] expression_analsys_result *Ret            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader   FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    ExprRes->Method = RETURN_METHOD_NUMERIC;
    ExprRes->Property = RETURN_PROPERTY_VALUE;
    ExprRes->CastFlag = 0;
    ExprRes->Value.Num = 0;
    
    ExprRes->TypeInfo.Sign = UNSIGN;
    ExprRes->TypeInfo.Pointer = 0;
    ExprRes->TypeInfo.Type = TYPE_NOTYPE;
    ExprRes->TypeInfo.TypeFunction = TYPE_NOT_FUNCTION_POINTER;
    ExprRes->TypeInfo.FuncPointer = 0;
    ExprRes->TypeInfo.ArgNum = 0;
    ExprRes->TypeInfo.BasicTypeSize = SIZEOF_LONG;
    ExprRes->TypeInfo.ArgList = NULL;
    ExprRes->TypeInfo.DimInfo = NULL;
    ExprRes->TypeInfo.StructInfo = NULL;
    
    ExprRes->BaseTypeInfo.Sign = UNSIGN;
    ExprRes->BaseTypeInfo.Pointer = 0;
    ExprRes->BaseTypeInfo.Type = TYPE_NOTYPE;
    ExprRes->BaseTypeInfo.TypeFunction = TYPE_NOT_FUNCTION_POINTER;
    ExprRes->BaseTypeInfo.FuncPointer = 0;
    ExprRes->BaseTypeInfo.ArgNum = 0;
    ExprRes->BaseTypeInfo.BasicTypeSize = SIZEOF_LONG;
    ExprRes->BaseTypeInfo.ArgList = NULL;
    ExprRes->BaseTypeInfo.DimInfo = NULL;
    ExprRes->BaseTypeInfo.StructInfo = NULL;
    return P3CC_OK;
}

//====================================================================================================================
static int ExpressionNumericBody(expression_analsys_result *RootRet, int Num, char Sign)
//====================================================================================================================
// [@\] 萔i{́j
// [] expression_analsys_result *Ret            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader   FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    RootRet->Method = RETURN_METHOD_NUMERIC;
    RootRet->Property = RETURN_PROPERTY_VALUE;
    RootRet->Value.Num = Num;
    RootRet->TypeInfo.Sign = Sign;
    RootRet->TypeInfo.Pointer = 0;
    RootRet->TypeInfo.Type = TYPE_NOTYPE;
    RootRet->TypeInfo.TypeFunction = TYPE_NOT_FUNCTION_POINTER;
    RootRet->TypeInfo.FuncPointer = 0;
    RootRet->TypeInfo.ArgNum = 0;
    RootRet->TypeInfo.BasicTypeSize = SIZEOF_LONG;
    RootRet->TypeInfo.ArgList = NULL;
    RootRet->TypeInfo.DimInfo = NULL;
    RootRet->TypeInfo.StructInfo = NULL;
    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionNumeric(expression_analsys_result *RootRet, int Line)
//====================================================================================================================
// [@\] 萔ibp[j
// [] expression_analsys_result *Ret            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader   FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int     Num;
    ExpressionDebugMsg(RootRet, "ExpressionNumeric", EXPRESSION_START, Line);

    Num = TokenNumLiteralValueGet(TokenIndex);
    ExpressionNumericBody(RootRet, Num, UNSIGN);
    ++TokenIndex;

    ExpressionDebugMsg(RootRet, "ExpressionNumeric", EXPRESSION_END, Line);
    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionStringLiteral(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] 񃊃e
// [] expression_analsys_result *Ret            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader   FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         SrcFileIndex;
    int                         SrcFileLine;
    int                         RegNo0;
    vertual_code                VCode;
    value_info                  vi;
    literal_label_ext_info      ExtInfo;
    int                         LabelNo;
    int                         NoUseOfPcOffsetLoad;
#ifdef NO_USE_PC_OFFSET_LD
    NoUseOfPcOffsetLoad = P3CC_TRUE;
#else
    NoUseOfPcOffsetLoad = P3CC_FALSE;
#endif

    ExpressionDebugMsg(RootRet, "ExpressionStringLiteral", EXPRESSION_START, Line);

    SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
    SrcFileLine = TokenSrcLineGet(TokenIndex);

    RegNo0 = ExpressionNewGprNoGet();
    RootRet->Value.RegNo = RegNo0;
    RootRet->Method = RETURN_METHOD_REG;
    RootRet->Property = RETURN_PROPERTY_VALUE;
    RootRet->TypeInfo.Sign = SIGN;
    RootRet->TypeInfo.Pointer = 1;
    RootRet->TypeInfo.Type = TYPE_CHAR;
    RootRet->TypeInfo.TypeFunction = TYPE_NOT_FUNCTION_POINTER;
    RootRet->TypeInfo.FuncPointer = 0;
    RootRet->TypeInfo.ArgNum = 0;
    RootRet->TypeInfo.BasicTypeSize = SIZEOF_CHAR;
    RootRet->TypeInfo.ArgList = NULL;
    RootRet->TypeInfo.StructInfo = NULL;
    RootRet->TypeInfo.DimInfo = NULL;


    ExtInfo.Str = TokenStrLiteralGet(TokenIndex);
    ++TokenIndex;
    LabelNo = LiteralLabelListFind(&ExtInfo);
    if(LabelNo < 0){//o^̏ꍇ
        LabelNo = VertualCodeNewLabelNoGet();
        if(LiteralLabelListAdd(LabelNo, LLABEL_STRING_LITERAL, &ExtInfo) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }
    vi.LabelNo = LabelNo;
    if(NoUseOfPcOffsetLoad == P3CC_TRUE){
         VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_MOVH_I,  RET_IS_GPR,RegNo0,  ARG_IS_NOTING,0,  OPERAND_TYPE_LABEL_ADR_HI,&vi,  SrcFileIndex, SrcFileLine);
         if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
         VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_OR_I,    RET_IS_GPR,RegNo0,  ARG_IS_GPR,RegNo0, OPERAND_TYPE_LABEL_ADR_LO,&vi,  SrcFileIndex, SrcFileLine);
         if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }
    else{
        VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_ADD_I,  RET_IS_GPR,RegNo0,  ARG_IS_SPR,SPR_PC,  OFFSET_IS_LABEL,&vi,  SrcFileIndex, SrcFileLine);
        if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }

    ExpressionDebugMsg(RootRet, "ExpressionStringLiteral", EXPRESSION_END, Line);

    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionResultSizeGet(result_type_info *TypeInfo)
//====================================================================================================================
// [@\] ݂̎̉͌ʂ̃TCY擾
// [] result_type_info *TypeInfo
// [Ԓl] ݂̎̉͌ʂ̃TCY
{
    int     Size;

    if(TypeInfo->TypeFunction != TYPE_FUNCTION_POINTER){
        if(TypeInfo->Pointer == 0){
            Size = TypeInfo->BasicTypeSize;
        }
        else{
            Size = SIZEOF_POINTER;
        }
    }
    else{//TYPE_FUNCTION_POINTER
        if(TypeInfo->FuncPointer == 0){
            Size = SIZEOF_POINTER;
        }
        else{
            Size = SIZEOF_POINTER;
        }
    }

    return Size;
}
//====================================================================================================================
static int ExpressionResultTrimRightSide(int Option, expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] ̉͌ʂ̒iRETURN_PROPERTY_ADDRESSRETURN_PROPERTY_VALUE֕ϊj
// [] int Option    F0FVWX^gȂA1FVWX^g
// [] expression_analsys_result *RootRet        Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader   FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         SrcFileIndex;
    int                         SrcFileLine;
    int                         DstRegNo;
    int                         BaseRegNo;
    int                         Size;
    int                         Sign;
    vertual_code                VCode;
    value_info                  vi;

    ExpressionDebugMsg(RootRet, "ExpressionResultTrimRightSide", EXPRESSION_START, Line);

    SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
    SrcFileLine = TokenSrcLineGet(TokenIndex);

//PrintExpAnaResult(RootRet, "ExpressionFunctionCall");

    if(RootRet->Method == RETURN_METHOD_REG){
        if(RootRet->Property == RETURN_PROPERTY_ADDRESS){
            RootRet->Property = RETURN_PROPERTY_VALUE;
            if(RootRet->CastFlag){
                Size = ExpressionResultSizeGet(&(RootRet->BaseTypeInfo));
                Sign = (int)RootRet->BaseTypeInfo.Sign;
                RootRet->CastFlag = 0;
            }
            else{
                Size = ExpressionResultSizeGet(&(RootRet->TypeInfo));
                Sign = (int)RootRet->TypeInfo.Sign;
            }
            BaseRegNo = RootRet->Value.RegNo;
            if(Option == NOT_USE_NEW_REG){
                DstRegNo = BaseRegNo;
            }
            else{
                DstRegNo = ExpressionNewGprNoGet();
            }
            vi.NumLiteral = 0;
            VCodeGen_Load(&VCode, PLABEL_NON, Size, Sign, BASE_UPDATE_NO, DST_IS_GPR,DstRegNo, BASE_IS_GPR,BaseRegNo, OFFSET_IS_IMM, &vi, SrcFileIndex, SrcFileLine);
            if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            RootRet->Value.RegNo = DstRegNo;
        }
        else{//(RootRet->Method == RETURN_PROPERTY_VALUE)
            ;
        }
    }
    else{//(RootRet->Method == RETURN_METHOD_NUMERIC)
        if(RootRet->Property == RETURN_PROPERTY_ADDRESS){
            PrintError(__FILE__, __LINE__, "RpC̃oOH", CurrentTokenBuf, "");
            return P3CC_NG;
        }
        else{//(MyRet1.Method == RETURN_PROPERTY_VALUE)
            ;
        }
    }

    ExpressionDebugMsg(RootRet, "ExpressionResultTrimRightSide", EXPRESSION_END, Line);

    return P3CC_OK;

}
//====================================================================================================================
static int ExpressionChkOperationAndItem(int Token, expression_analsys_result *Arg0, expression_analsys_result *Arg1)
//====================================================================================================================
// [@\] sKȉZȂP3CC_NGԂBKȂP3CC_OK
// [] int TokenFZq̃g[N
// [] expression_analsys_result *Arg0F
// [] expression_analsys_result *Arg1FP̏ꍇNULL
// [Ԓl] P3CC_OK/P3CC_NG
{
    if(Arg0 == NULL){ PrintError(__FILE__, __LINE__, "RpC̃oO", "", ""); return P3CC_NG; }
    if(Token == TOKEN_NOT){// ~  P
        if((Arg0->TypeInfo.Pointer != 0) || ((Arg0->TypeInfo.TypeFunction != 0) && (Arg0->TypeInfo.FuncPointer != 0))){
            PrintError(__FILE__, __LINE__, "|C^֑΂sȉZ", "", "");
            return P3CC_NG;
        }
        if(ExpressionChkStruct(Arg0) == P3CC_TRUE){
            PrintError(__FILE__, __LINE__, "\֑̂΂sȉZ", "", "");
            return P3CC_NG;
        }
        return P3CC_OK;
    }
    else if(Token == TOKEN_EXCLAMATION){// P!
        if(ExpressionChkStruct(Arg0) == P3CC_TRUE){
            PrintError(__FILE__, __LINE__, "\֑̂΂sȉZ", "", "");
            return P3CC_NG;
        }
        return P3CC_OK;
    }
    else if((Token == TOKEN_NOT) || (Token == TOKEN_DOUBLE_MINUS)){// P++ or P--
        if(ExpressionChkStruct(Arg0) == P3CC_TRUE){
            PrintError(__FILE__, __LINE__, "\֑̂΂sȉZ", "", "");
            return P3CC_NG;
        }
        return P3CC_OK;
    }
    else if(((Token == TOKEN_PLUS) || (Token == TOKEN_MINUS)) && (Arg1 == NULL)){// P+ or P-
        if((Arg0->TypeInfo.Pointer != 0) || ((Arg0->TypeInfo.TypeFunction != 0) && (Arg0->TypeInfo.FuncPointer != 0))){
            PrintError(__FILE__, __LINE__, "|C^֑΂sȉZ", "", "");
            return P3CC_NG;
        }
        if(ExpressionChkStruct(Arg0) == P3CC_TRUE){
            PrintError(__FILE__, __LINE__, "\֑̂΂sȉZ", "", "");
            return P3CC_NG;
        }
        return P3CC_OK;
    }
    else if((Token == TOKEN_AMPERSAND) && (Arg1 == NULL)){// P&
        if(Arg0->Method == RETURN_METHOD_NUMERIC){
            PrintError(__FILE__, __LINE__, "萔̃AhX͌vZs\", "", "");
            return P3CC_NG;
        }
        return P3CC_OK;
    }
    else if((Token == TOKEN_ASTERISK) && (Arg1 == NULL)){// P*
        if((Arg0->TypeInfo.Pointer != 0) || ((Arg0->TypeInfo.TypeFunction != 0) && (Arg0->TypeInfo.FuncPointer != 0))){
            return  P3CC_OK;
        }
        PrintError(__FILE__, __LINE__, "|C^ȊO֑΂sȉZ (*)", "", "");
        return  P3CC_NG;
    }
    else if((Token == TOKEN_PLUS) || (Token == TOKEN_MINUS)){// 2+ or 2-
        if(Arg1 == NULL){ PrintError(__FILE__, __LINE__, "RpC̃oO", "", ""); return P3CC_NG; }
        if((Arg0->TypeInfo.Pointer != 0) || ((Arg0->TypeInfo.TypeFunction != 0) && (Arg0->TypeInfo.FuncPointer != 0))){
            if((Arg1->TypeInfo.Pointer != 0) || ((Arg1->TypeInfo.TypeFunction != 0) && (Arg1->TypeInfo.FuncPointer != 0))){
                PrintError(__FILE__, __LINE__, "|C^֑΂sȉZ", "", "");
                return P3CC_NG;
            }
            if(ExpressionChkStruct(Arg1) == P3CC_TRUE){
                PrintError(__FILE__, __LINE__, "|C^֑΂sȉZ", "", "");
                return P3CC_NG;
            }
            return  P3CC_OK;
        }
        else if(ExpressionChkStruct(Arg0) == P3CC_TRUE){
            if((Arg0->Method == RETURN_METHOD_REG) && (Arg0->Property == RETURN_PROPERTY_ADDRESS )
                    && (((Arg1->Method == RETURN_METHOD_REG) && (Arg1->Property == RETURN_PROPERTY_VALUE )) || (Arg1->Method == RETURN_METHOD_NUMERIC))){
                return  P3CC_OK;
            }
            else{
                PrintError(__FILE__, __LINE__, "\֑̂΂sȉZ", "", "");
                return P3CC_NG;
            }
        }
        else{
            if(ExpressionChkStruct(Arg1) == P3CC_TRUE){
                PrintError(__FILE__, __LINE__, "\֑̂΂sȉZ", "", "");
                return P3CC_NG;
            }
            if(Token == TOKEN_MINUS){
                if((Arg1->TypeInfo.Pointer != 0) || ((Arg1->TypeInfo.TypeFunction != 0) && (Arg1->TypeInfo.FuncPointer != 0))){
                    PrintError(__FILE__, __LINE__, "|C^֑΂sȉZ", "", "");
                    return P3CC_NG;
                }
            }
            return  P3CC_OK;
        }
    }
    else if(   (Token == TOKEN_ASTERISK ) || (Token == TOKEN_DIV  ) || (Token == TOKEN_MOD) // 2 */%
            || (Token == TOKEN_AMPERSAND) || (Token == TOKEN_OR   ) || (Token == TOKEN_XOR) // 2 &|^
            || (Token == TOKEN_SHIFT_L  ) || (Token == TOKEN_SHIFT_R) ){ //2>><<
        if(Arg1 == NULL){ PrintError(__FILE__, __LINE__, "RpC̃oO", "", ""); return P3CC_NG; }
        if((Arg0->TypeInfo.Pointer != 0) || ((Arg0->TypeInfo.TypeFunction != 0) && (Arg0->TypeInfo.FuncPointer != 0))){
            PrintError(__FILE__, __LINE__, "|C^֑΂sȉZ", "", "");
            return  P3CC_NG;
        }
        else if(ExpressionChkStruct(Arg0) == P3CC_TRUE){
            PrintError(__FILE__, __LINE__, "\֑̂΂sȉZ", "", "");
            return P3CC_NG;
        }
        else{
            if((Arg1->TypeInfo.Pointer != 0) || ((Arg1->TypeInfo.TypeFunction != 0) && (Arg1->TypeInfo.FuncPointer != 0))){
                PrintError(__FILE__, __LINE__, "|C^֑΂sȉZ", "", "");
                return P3CC_NG;
            }
            if(ExpressionChkStruct(Arg1) == P3CC_TRUE){
                PrintError(__FILE__, __LINE__, "|C^֑΂sȉZ", "", "");
                return P3CC_NG;
            }
            return  P3CC_OK;
        }
    }
    else if(   (Token == TOKEN_AND_AND) || (Token == TOKEN_OR_OR     ) // 2&& or 2||
            || (Token == TOKEN_LESS   ) || (Token == TOKEN_GRATER    ) // 2 <>
            || (Token == TOKEN_LESS_EQ) || (Token == TOKEN_GRATER_EQ ) // 2 <= >=
            || (Token == TOKEN_EQ_EQ  ) || (Token == TOKEN_NOT_EQ    )){ //2 == !=
        if(Arg1 == NULL){ PrintError(__FILE__, __LINE__, "RpC̃oO", "", ""); return P3CC_NG; }
        if((ExpressionChkStruct(Arg0) == P3CC_TRUE) || (ExpressionChkStruct(Arg1) == P3CC_TRUE)){
            PrintError(__FILE__, __LINE__, "\֑̂΂sȉZ", "", "");
            return P3CC_NG;
        }
        return P3CC_OK;
    }
    else{
        PrintError(__FILE__, __LINE__, "RpC̃oO", "", "");
        return P3CC_NG;
    }
}
//====================================================================================================================
static int ExpressionUpperRankResultGet(expression_analsys_result *RootRet, expression_analsys_result *Arg0, expression_analsys_result *Arg1)
//====================================================================================================================
// [@\] Arg0Arg1ǂ|C^łȂA萔łȂꍇɁAʂ̌^RootRetɓĕԂ
//        (long double  double  float  ) unsigned long int  long int  unsigned int  int > unsigned short > short > unsigned char > char
//        _ɂ͖Ή
// [] Arg0Arg1ǂ|C^łȂA萔łȂĂяoŕۏ
// [] expression_analsys_result *RootRetF
// [] expression_analsys_result *Arg0   F
// [] expression_analsys_result *Arg1   F
// [Ԓl] P3CC_OK/P3CC_NG
{
    int     Arg0Size;
    int     Arg1Size;
    int     Arg0Sign;
    //int     Arg1Sign;

    Arg0Size = Arg0->TypeInfo.BasicTypeSize;
    Arg1Size = Arg1->TypeInfo.BasicTypeSize;
    Arg0Sign = Arg0->TypeInfo.Sign;
    //Arg1Sign = Arg1->TypeInfo.Sign;
    if(Arg0Size >  Arg1Size){
        *RootRet = *Arg0;
    }
    else if(Arg0Size == Arg1Size){
        if(Arg0Sign == UNSIGN){
            *RootRet = *Arg0;
        }
        else{
            *RootRet = *Arg1;
        }
    }
    else{
        *RootRet = *Arg1;
    }
    return P3CC_OK;
}

//====================================================================================================================
static int ExpressionPointerUnitSizeGet(expression_analsys_result *RootRet)
//====================================================================================================================
// [@\] |C^Z鎞̒PʃTCY
// [] expression_analsys_result *RootRet  F^
// [Ԓl] TCY
{
    int                         Size;
    if(RootRet->TypeInfo.TypeFunction != TYPE_FUNCTION_POINTER){
        if(RootRet->TypeInfo.Pointer == 1){
            Size = RootRet->TypeInfo.BasicTypeSize;
        }
        else{
            Size = SIZEOF_POINTER;
        }
    }
    else{
        Size = SIZEOF_POINTER;
    }
    return Size;
}
//====================================================================================================================
static int ExpressionBinomialOperation(
    expression_analsys_result   *RootRet,
    vertual_code_list_header    *RootVCodeListHeader,
    int                         Token,
    expression_analsys_result   *Arg0,
    expression_analsys_result   *Arg1,
    int                         RetRegNo,
    int                         Line
)
//====================================================================================================================
// [@\] _ZȊÔQZ(+,-,*,/,%,&,|,^,<<,>>)̃R[h𐶐āARootRetƁARootVCodeListHeader֌ʂԂ
// [] Arg0Arg1́AExpressionResultTrimRightSide()ς݂ł邱
// [] expression_analsys_result *RootRet            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader FR[hi[
// [] int Token                           FZ(+,-,*,/,%,&,|,^,<<,>>)ɑΉTOKENR[h
// [] expression_analsys_result *Arg0     F
// [] expression_analsys_result *Arg1     FE
// [] int RetRegNo                        FʂWX^Ԃ̏ꍇɁAԂli[郌WX^̎w
// [Ԓl] P3CC_OK/P3CC_NG
{
    unsigned char               OpCode;
    expression_analsys_result   TmpArg;
    expression_analsys_result   WorkArg0;
    expression_analsys_result   WorkArg1;
    int                         Size;
    int                         Arg0Reg;
    int                         Arg1Reg;
    vertual_code                VCode;
    value_info                  vi;
    int                         SrcFileIndex;
    int                         SrcFileLine;

    ExpressionDebugMsg(RootRet, "ExpressionBinomialOperation", EXPRESSION_START, Line);

    ExpressionResultInit(&TmpArg);
    ExpressionResultInit(&WorkArg0);
    ExpressionResultInit(&WorkArg1);

    if(ExpressionChkBinomialOpToken(Token) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
    if(ExpressionChkOperationAndItem(Token, Arg0, Arg1) == P3CC_NG){
        PrintError(__FILE__, __LINE__, "", "", "");
PrintExpAnaResult(Arg0, "Arg0");
PrintExpAnaResult(Arg1, "Arg1");
        return P3CC_NG;
    }

    SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
    SrcFileLine = TokenSrcLineGet(TokenIndex);

    //*Arg0*Arg1󂳂Ȃ׃Rs[
    WorkArg0 = *Arg0;
    WorkArg1 = *Arg1;

    //Method = RETURN_METHOD_NUMERIC,RETURN_METHOD_NUMERIC
    if((WorkArg0.Method == RETURN_METHOD_NUMERIC) && (WorkArg1.Method == RETURN_METHOD_NUMERIC)){
        *RootRet = WorkArg0;
        if     (Token == TOKEN_PLUS     ){RootRet->Value.Num = WorkArg0.Value.Num +  WorkArg1.Value.Num;}
        else if(Token == TOKEN_MINUS    ){RootRet->Value.Num = WorkArg0.Value.Num -  WorkArg1.Value.Num;}
        else if(Token == TOKEN_ASTERISK ){RootRet->Value.Num = WorkArg0.Value.Num *  WorkArg1.Value.Num;}
        else if(Token == TOKEN_DIV      ){
            if(WorkArg1.Value.Num == 0){PrintError(__FILE__, __LINE__, "0ɂ鏜Z", "", ""); return P3CC_NG; }
            if((WorkArg0.TypeInfo.Sign == UNSIGN) && (WorkArg1.TypeInfo.Sign == UNSIGN)){
                RootRet->Value.Num = WorkArg0.Value.Num /  WorkArg1.Value.Num;
            }
            else if((WorkArg0.TypeInfo.Sign == SIGN) && (WorkArg1.TypeInfo.Sign == UNSIGN)){
                (int)RootRet->Value.Num = (int)WorkArg0.Value.Num /  (int)WorkArg1.Value.Num;
            }
            else if((WorkArg0.TypeInfo.Sign == UNSIGN) && (WorkArg1.TypeInfo.Sign == SIGN)){
                (int)RootRet->Value.Num = (int)WorkArg0.Value.Num /  (int)WorkArg1.Value.Num;
            }
            else{
                (int)RootRet->Value.Num = (int)WorkArg0.Value.Num /  (int)WorkArg1.Value.Num;
            }
        }
        else if(Token == TOKEN_MOD      ){
            if(WorkArg1.Value.Num == 0){PrintError(__FILE__, __LINE__, "0ɂ鏜Z", "", ""); return P3CC_NG; }
            if((WorkArg0.TypeInfo.Sign == UNSIGN) && (WorkArg1.TypeInfo.Sign == UNSIGN)){
                RootRet->Value.Num = WorkArg0.Value.Num %  WorkArg1.Value.Num;
            }
            else if((WorkArg0.TypeInfo.Sign == SIGN) && (WorkArg1.TypeInfo.Sign == UNSIGN)){
                (int)RootRet->Value.Num = (int)WorkArg0.Value.Num %  (int)WorkArg1.Value.Num;
            }
            else if((WorkArg0.TypeInfo.Sign == UNSIGN) && (WorkArg1.TypeInfo.Sign == SIGN)){
                (int)RootRet->Value.Num = (int)WorkArg0.Value.Num %  (int)WorkArg1.Value.Num;
            }
            else{
                (int)RootRet->Value.Num = (int)WorkArg0.Value.Num %  (int)WorkArg1.Value.Num;
            }
        }
        else if(Token == TOKEN_AMPERSAND){RootRet->Value.Num = WorkArg0.Value.Num &  WorkArg1.Value.Num;}
        else if(Token == TOKEN_XOR      ){RootRet->Value.Num = WorkArg0.Value.Num ^  WorkArg1.Value.Num;}
        else if(Token == TOKEN_OR       ){RootRet->Value.Num = WorkArg0.Value.Num |  WorkArg1.Value.Num;}
        else if(Token == TOKEN_SHIFT_L  ){RootRet->Value.Num = WorkArg0.Value.Num << WorkArg1.Value.Num;}
        else /*(Token == TOKEN_SHIFT_R)*/{
            if(WorkArg0.TypeInfo.Sign == UNSIGN) RootRet->Value.Num = WorkArg0.Value.Num >> WorkArg1.Value.Num;
            else  (int)RootRet->Value.Num = (int)WorkArg0.Value.Num >> (int)WorkArg1.Value.Num;
        }
//fprintf(LogFile, "0x%08x, 0x%08x, 0x%08x\n", RootRet->Value.Num, WorkArg0.Value.Num, WorkArg1.Value.Num);
//fprintf(LogFile, "0x%08x, 0x%08x, 0x%08x\n", RootRet->TypeInfo.Sign, WorkArg0.TypeInfo.Sign, WorkArg1.TypeInfo.Sign);
    }
    //Method = RETURN_METHOD_REG,RETURN_METHOD_REG
    else if((WorkArg0.Method == RETURN_METHOD_REG) && (WorkArg1.Method == RETURN_METHOD_REG)){
        if((WorkArg0.TypeInfo.Pointer == 0) && (WorkArg0.TypeInfo.TypeFunction == 0)
                    && (WorkArg1.TypeInfo.Pointer == 0) && (WorkArg1.TypeInfo.TypeFunction == 0)){//ϐm(ǂ|C^łȂ)
            Arg0Reg = WorkArg0.Value.RegNo;
            Arg1Reg = WorkArg1.Value.RegNo;
            vi.RegNo = Arg1Reg;
            ExpressionBinomialOpCodeGet(Token, ARG_IS_GPR, &OpCode, WorkArg0.TypeInfo.Sign, WorkArg1.TypeInfo.Sign);//ExpressionChkBinomialOpToken()Ŕς݂̈׃G[`FbNsv
            VCodeGen_Operation(&VCode, PLABEL_NON, OpCode,  RET_IS_GPR,RetRegNo,  ARG_IS_GPR,Arg0Reg,  ARG_IS_GPR,&vi,  SrcFileIndex, SrcFileLine);
            if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            ExpressionUpperRankResultGet(RootRet, &WorkArg0, &WorkArg1);//ʂ̌^RootRetɐݒ
            RootRet->Value.RegNo = RetRegNo;
        }
        else{//Е|C^
            //ExpressionChkOperationAndItemŃ`FbNς݂Ȃ̂ŁAǂ炩|C^Ȃ΁A͕ϐł邱Ƃm肵Ă
            if((WorkArg0.TypeInfo.Pointer != 0) || ((WorkArg0.TypeInfo.TypeFunction != 0) && (WorkArg0.TypeInfo.FuncPointer != 0))){
                ; //WorkArg0|C^
            }
            else{
                TmpArg = WorkArg0; WorkArg0 = WorkArg1; WorkArg1 = TmpArg; //WorkArg0|C^ɂȂ悤ւ
            }
            Size = ExpressionPointerUnitSizeGet(&WorkArg0);
            if(Size > 1){//TCYPȂATCY
                ExpressionNumericBody(&TmpArg, Size, UNSIGN);
                Arg1Reg = ExpressionNewGprNoGet();
                if(ExpressionBinomialOperation(RootRet, RootVCodeListHeader, TOKEN_ASTERISK, &WorkArg1, &TmpArg, Arg1Reg, __LINE__) == P3CC_NG){
                    PrintError(__FILE__, __LINE__, "", "", "");
                    return P3CC_NG;
                }
            }
            else{
                Arg1Reg = WorkArg1.Value.RegNo;
            }
            if((Token == TOKEN_PLUS) || (Token == TOKEN_MINUS)){
                Arg0Reg = WorkArg0.Value.RegNo;
                vi.RegNo = Arg1Reg;
                ExpressionBinomialOpCodeGet(Token, ARG_IS_GPR, &OpCode, WorkArg0.TypeInfo.Sign, WorkArg1.TypeInfo.Sign);//ExpressionChkBinomialOpToken()Ŕς݂̈׃G[`FbNsv
                VCodeGen_Operation(&VCode, PLABEL_NON, OpCode,  RET_IS_GPR,RetRegNo,  ARG_IS_GPR,Arg0Reg,  ARG_IS_GPR,&vi,  SrcFileIndex, SrcFileLine);
                if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                *RootRet = WorkArg0;//|C^̌^RootRetɐݒ
                RootRet->Value.RegNo = RetRegNo;
            }
            else{
                PrintError(__FILE__, __LINE__, "炭RpC̃oO", "", "");
                return P3CC_NG;
            }
        }
    }
    //Method = RETURN_METHOD_NUMERIC,RETURN_METHOD_REG  or RETURN_METHOD_REG,RETURN_METHOD_NUMERIC
    else{
        //(/,%,<<,>>)̏ꍇi(Arg0)ƉE(Arg1)łȂZjŁAA萔̏ꍇ
        if(((Token == TOKEN_MINUS) || (Token == TOKEN_DIV) || (Token == TOKEN_MOD)
                || (Token == TOKEN_SHIFT_L) || (Token == TOKEN_SHIFT_R)) && (WorkArg0.Method == RETURN_METHOD_NUMERIC)){
            if((WorkArg1.TypeInfo.Pointer != 0) || ((WorkArg1.TypeInfo.TypeFunction != 0) && (WorkArg1.TypeInfo.FuncPointer != 0))){//WorkArg1|C^
                //ExpressionChkOperationAndItemŃ`FbNς݂Ȃ̂ŁAWorkArg1|C^Ȃ΁AoO
                PrintError(__FILE__, __LINE__, "炭RpC̃oO", "", "");
                return P3CC_NG;
            }
            if(ExpressionNumericLoad(0, WorkArg0.Value.Num, WorkArg0.TypeInfo.Sign, ExpressionNewGprNoGet(), RootRet, RootVCodeListHeader, __LINE__) != P3CC_OK){
                PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;
            }
            Arg0Reg  = RootRet->Value.RegNo;
            Arg1Reg  = WorkArg1.Value.RegNo;
            vi.RegNo = Arg1Reg;
            ExpressionBinomialOpCodeGet(Token, ARG_IS_GPR, &OpCode, WorkArg0.TypeInfo.Sign, WorkArg1.TypeInfo.Sign);//ExpressionChkBinomialOpToken()Ŕς݂̈׃G[`FbNsv
            VCodeGen_Operation(&VCode, PLABEL_NON, OpCode,  RET_IS_GPR,RetRegNo,  ARG_IS_GPR,Arg0Reg,  ARG_IS_GPR,&vi,  SrcFileIndex, SrcFileLine);
            if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            *RootRet = WorkArg1;//WorkArg1̌^RootRetɐݒ
            RootRet->Value.RegNo = RetRegNo;
        }
        //(/,%,<<,>>)̏ꍇi(Arg0)ƉE(Arg1)łȂZjŁAAE萔̏ꍇÁA(+,,*,&,|,^)̏ꍇiEƍȉZ)
        //̃P[Xł́Alw艉Z߂g
        else{
            if(WorkArg0.Method == RETURN_METHOD_REG){ ; }//WorkArg1萔
            else{ TmpArg = WorkArg0; WorkArg0 = WorkArg1; WorkArg1 = TmpArg; }//WorkArg1萔ɂȂ悤ɓւ
            if((WorkArg0.TypeInfo.Pointer != 0) || ((WorkArg0.TypeInfo.TypeFunction != 0) && (WorkArg0.TypeInfo.FuncPointer != 0))){//WorkArg0|C^
                //ExpressionChkOperationAndItemŃ`FbNς݂Ȃ̂ŁAWorkArg0|C^Ȃ΁AZł邱ƂۏႳ
                Size = ExpressionPointerUnitSizeGet(&WorkArg0);
                WorkArg1.Value.Num = WorkArg1.Value.Num * Size;
            }
            if(((Token == TOKEN_DIV) || (Token == TOKEN_MOD)) && (WorkArg1.Value.Num == 0)){
                PrintError(__FILE__, __LINE__, "0ɂ鏜Z", "", "");
                return P3CC_NG;
            }
            ExpressionBinomialOpCodeGet(Token, ARG_IS_IMM, &OpCode, WorkArg0.TypeInfo.Sign, WorkArg1.TypeInfo.Sign);//ExpressionChkBinomialOpToken()Ŕς݂̈׃G[`FbNsv
            if(ExpressionNumericRangeCheck(OpCode, WorkArg1.Value.Num) == P3CC_OK){ //--- lw\͈
                Arg0Reg = WorkArg0.Value.RegNo;
                vi.NumLiteral = WorkArg1.Value.Num;
                if((OpCode == OPECODE_MUL_I) && ((vi.NumLiteral == 1) || (vi.NumLiteral == 2) || (vi.NumLiteral == 4))){
                    if(vi.NumLiteral == 1){
                        RetRegNo = Arg0Reg;
                    }
                    else if(vi.NumLiteral == 2){
                        vi.RegNo = Arg0Reg;
                        VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_ADD_R,  RET_IS_GPR,RetRegNo,  ARG_IS_GPR,Arg0Reg,  ARG_IS_GPR,&vi,  SrcFileIndex, SrcFileLine);
                        if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                    }
                    else{
                        vi.RegNo = Arg0Reg;
                        VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_ADD_R,  RET_IS_GPR,RetRegNo,  ARG_IS_GPR,Arg0Reg,  ARG_IS_GPR,&vi,  SrcFileIndex, SrcFileLine);
                        if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                        vi.RegNo = RetRegNo;
                        VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_ADD_R,  RET_IS_GPR,RetRegNo,  ARG_IS_GPR,RetRegNo,  ARG_IS_GPR,&vi,  SrcFileIndex, SrcFileLine);
                        if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                    }
                }
                else{
                    VCodeGen_Operation(&VCode, PLABEL_NON, OpCode,  RET_IS_GPR,RetRegNo,  ARG_IS_GPR,Arg0Reg,  ARG_IS_IMM,&vi,  SrcFileIndex, SrcFileLine);
                    if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                }
            }
            else{//--- lws͈
                if(ExpressionNumericLoad(0, WorkArg1.Value.Num, WorkArg0.TypeInfo.Sign, ExpressionNewGprNoGet(), RootRet, RootVCodeListHeader, __LINE__) != P3CC_OK){
                    PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;
                }
                ExpressionBinomialOpCodeGet(Token, ARG_IS_GPR, &OpCode, WorkArg0.TypeInfo.Sign, WorkArg1.TypeInfo.Sign);//ExpressionChkBinomialOpToken()Ŕς݂̈׃G[`FbNsv
                Arg0Reg  = WorkArg0.Value.RegNo;
                vi.RegNo = RootRet->Value.RegNo;
                VCodeGen_Operation(&VCode, PLABEL_NON, OpCode,  RET_IS_GPR,RetRegNo,  ARG_IS_GPR,Arg0Reg,  ARG_IS_GPR,&vi,  SrcFileIndex, SrcFileLine);
                if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            }
            *RootRet = WorkArg0;//WorkArg0̌^RootRetɐݒ
            RootRet->Value.RegNo = RetRegNo;
        }
    }
    ExpressionDebugMsg(RootRet, "ExpressionBinomialOperation", EXPRESSION_END, Line);
    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionNumericRangeCheck(unsigned char Code, unsigned long Numeric)
//====================================================================================================================
// [@\] ZʂƂɁAlAlZ\Ȕ͈͂ǂ`FbN
// [] unsigned char Code                  FZ
// [] unsigned long Numeric               Fl
// [Ԓl] P3CC_OK:lZ\, P3CC_NG:lZs
{
    //--- gO[v ----
    if((Code == OPECODE_ADD_I) || (Code == OPECODE_SUB_I) || (Code == OPECODE_MUL_I)
            || (Code == OPECODE_DIVU_I) || (Code == OPECODE_DIV_I) || (Code == OPECODE_MODU_I) || (Code == OPECODE_MOD_I)){
        if((((int)Numeric) <= 32767) && (((int)Numeric) >= -32768)){
            return P3CC_OK;
        }
        else{
            return P3CC_NG;
        }
    }
    //--- gȂ ----
    else if((Code == OPECODE_AND_I) || (Code == OPECODE_OR_I) || (Code == OPECODE_XOR_I)){
        if((Numeric & 0xFFFF0000) == 0){
            return P3CC_OK;
        }
        else{
            return P3CC_NG;
        }
    }
    //--- ֌WȂO[v ----
    else if((Code == OPECODE_LSR_I) || (Code == OPECODE_LSL_I) || (Code == OPECODE_ASR_I)){
        return P3CC_OK;
    }
    else{
        return P3CC_NG;
    }
}

//====================================================================================================================
//static int ExpressionNumericLoad(unsigned long Num, char Sign, int RegNo, expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
static int ExpressionNumericLoad(int Mode, unsigned long Num, char Sign, int RegNo, expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] lWX^Ƀ[h
// [] uint Mode                          F0=ʏ탂[h, 1=_Z0/1ݒ肷郂[h
// [] unsigned long Num                  F鐔l
// [] char Sign                          FRootRetɐݒ肷SIGN/UNSIGND
// [] int  RegNo                         Fl[h郌WX^w
// [] expression_analsys_result *RootRet        Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader   FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         SrcFileIndex;
    int                         SrcFileLine;
    vertual_code                VCode;
    value_info                  vi;
    literal_label_ext_info      ExtInfo;
    int                         LabelNo;
    int                         NoUseOfPcOffsetLoad;
#ifdef NO_USE_PC_OFFSET_LD
    NoUseOfPcOffsetLoad = P3CC_TRUE;
#else
    NoUseOfPcOffsetLoad = P3CC_FALSE;
#endif

    ExpressionDebugMsg(RootRet, "ExpressionNumericLoad", EXPRESSION_START, Line);

    if(RootVCodeListHeader->Last == NULL){
        SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
        SrcFileLine  = TokenSrcLineGet(TokenIndex);
    }
    else{
        SrcFileIndex = RootVCodeListHeader->Last->SrcFileIndex;
        SrcFileLine  = RootVCodeListHeader->Last->SrcFileLine;
    }

    RootRet->Value.RegNo = RegNo;
    RootRet->Method = RETURN_METHOD_REG;
    RootRet->Property = RETURN_PROPERTY_VALUE;
    RootRet->TypeInfo.Sign = Sign;
    RootRet->TypeInfo.Pointer = 0;
    RootRet->TypeInfo.Type = TYPE_NOTYPE;
    RootRet->TypeInfo.TypeFunction = TYPE_NOT_FUNCTION_POINTER;
    RootRet->TypeInfo.FuncPointer = 0;
    RootRet->TypeInfo.ArgNum = 0;
    RootRet->TypeInfo.BasicTypeSize = SIZEOF_LONG;
    RootRet->TypeInfo.ArgList = NULL;
    RootRet->TypeInfo.StructInfo = NULL;
    RootRet->TypeInfo.DimInfo = NULL;

    if(((((int)Num) <= 32767) && (((int)Num) >= -32768)) || ((Num & 0xFFFF0000) == 0) || ((Num & 0xFFFF) == 0)){
        if((((int)Num) <= 32767) && (((int)Num) >= -32768)){ // MOV_I
            vi.NumLiteral = Num;
            if(Mode == 0){
                VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_MOV_I,  RET_IS_GPR,RegNo,  ARG_IS_NOTING,0,  ARG_IS_IMM,&vi,  SrcFileIndex, SrcFileLine);
            }
            else{
                VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_MOVL_I,  RET_IS_GPR,RegNo,  ARG_IS_NOTING,0,  ARG_IS_IMM,&vi,  SrcFileIndex, SrcFileLine);
            }
        }
        else if((Num & 0xFFFF0000) == 0){// MOVL_I
            vi.NumLiteral = Num;
            VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_MOVL_I,  RET_IS_GPR,RegNo,  ARG_IS_NOTING,0,  ARG_IS_IMM,&vi,  SrcFileIndex, SrcFileLine);
        }
        else{// MOVH_I
            vi.NumLiteral = (Num >> 16);
            VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_MOVH_I,  RET_IS_GPR,RegNo,  ARG_IS_NOTING,0,  ARG_IS_IMM,&vi,  SrcFileIndex, SrcFileLine);
        }
        if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }
    else{//32bitl
        if(NoUseOfPcOffsetLoad == P3CC_TRUE){
            vi.NumLiteral = (Num >> 16);
            VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_MOVH_I,  RET_IS_GPR,RegNo,  ARG_IS_NOTING,0,  ARG_IS_IMM,&vi,  SrcFileIndex, SrcFileLine);
            if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            vi.NumLiteral = Num & 0xFFFFFFFF;
            VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_OR_I,    RET_IS_GPR,RegNo,  ARG_IS_GPR,RegNo, ARG_IS_IMM,&vi,  SrcFileIndex, SrcFileLine);
            if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }
        else{
            ExtInfo.Num = Num;
            LabelNo = LiteralLabelListFind(&ExtInfo);
            if(LabelNo < 0){//o^̏ꍇ
                LabelNo = VertualCodeNewLabelNoGet();
                if(LiteralLabelListAdd(LabelNo, LLABEL_NUMERIC_LITERAL, &ExtInfo) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            }
            vi.LabelNo = LabelNo;
            VCodeGen_Load(&VCode, PLABEL_NON, SIZE_4, UNSIGN, BASE_UPDATE_NO,  DST_IS_GPR,RegNo,  BASE_IS_SPR,SPR_PC,  OFFSET_IS_LABEL,&vi,  SrcFileIndex, SrcFileLine);
            if(VertualCodeAdd(RootVCodeListHeader, &VCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }
    }

    ExpressionDebugMsg(RootRet, "ExpressionNumericLoad", EXPRESSION_END, Line);

    return P3CC_OK;
}


//====================================================================================================================
static int ExpressionAssignTrim(expression_analsys_result *LeftRet, expression_analsys_result *RightRet, vertual_code_list_header *RightVCodeListHeader)
//====================================================================================================================
// [@\] ^̃`FbN{AÖق̌^ϊ\ȂAEӂ̌^ӂ̌^ɍ킹
//        RightVCodeListHeaderNULLȂA^`FbN݂̂{
// [] expression_analsys_result *LeftRet        F
// [] expression_analsys_result *RightRet       FE
// [] vertual_code_list_header *RightVCodeListHeader FEӃR[hi[(̒lNULLȂR[hsȂi^̃`FbN̂݁j)
// [Ԓl] P3CC_OK/P3CC_NG
{
    char                        *sign;
    char                        *type;
    char                        Msg[256];
//PrintExpAnaResult(LeftRet, "");
//PrintExpAnaResult(RightRet, "E");

    if(LeftRet->CastFlag){
        if(ExpressionResultSizeGet(&(LeftRet->TypeInfo)) != ExpressionResultSizeGet(&(LeftRet->BaseTypeInfo))){
            PrintError(__FILE__, __LINE__, "ӎɑ΂sȃLXgB", "", "");
            return P3CC_OK;
        }
    }

    if(LeftRet->TypeInfo.TypeFunction == TYPE_FUNCTION_POINTER){
        if(RightRet->TypeInfo.TypeFunction == TYPE_FUNCTION_POINTER){
             return P3CC_OK;
        }
        else if((RightRet->TypeInfo.Pointer != 0) && (RightRet->TypeInfo.Type == TYPE_VOID)){
            return P3CC_OK;
        }
        else{
            PrintError(__FILE__, __LINE__, "sȑH", CurrentTokenBuf, "");
            return P3CC_NG;
        }
    }
    else{
        if(LeftRet->TypeInfo.Type == TYPE_VOID){//============================= TYPE_VOID ========================================
            if((LeftRet->TypeInfo.Pointer != 0) && ((RightRet->TypeInfo.Pointer != 0) || (RightRet->TypeInfo.TypeFunction != 0))){
                return P3CC_OK;
            }
            else{
                PrintError(__FILE__, __LINE__, "sȑH", CurrentTokenBuf, "");
                return P3CC_NG;
            }
        }
        else if(LeftRet->TypeInfo.Type == TYPE_CHAR){//============================= TYPE_CHAR ========================================
            if((LeftRet->TypeInfo.Pointer != 0) && (RightRet->TypeInfo.Pointer != 0)){
                if((RightRet->TypeInfo.Type == TYPE_CHAR) && (LeftRet->TypeInfo.Sign == RightRet->TypeInfo.Sign)){
                    return P3CC_OK;
                }
                else{
                    if(WarningLevel1){
                        PrintWarning(__FILE__, __LINE__, "^̈قȂ|C^m̑", "", "");
                    }
                    return P3CC_OK;
                }
            }
            else if((LeftRet->TypeInfo.Pointer != 0) && (RightRet->TypeInfo.Pointer == 0)){
                if(RightRet->Method == RETURN_METHOD_NUMERIC){
                    if(WarningLevel1){
                        PrintWarning(__FILE__, __LINE__, "|C^ɒ萔悤ƂĂ܂B", "", "");
                    }
                    if(RightVCodeListHeader != NULL){
                        if(ExpressionNumericLoad(0, RightRet->Value.Num, RightRet->TypeInfo.Sign, ExpressionNewGprNoGet(), RightRet, RightVCodeListHeader, __LINE__) == P3CC_NG){
                            PrintError(__FILE__, __LINE__, "", "", "");
                            return P3CC_NG;
                        }
                    }
                    return P3CC_OK;
                }
                else{
                    PrintError(__FILE__, __LINE__, "sȑH", CurrentTokenBuf, "");
                    return P3CC_NG;
                }
            }
            else if((LeftRet->TypeInfo.Pointer == 0) && (RightRet->TypeInfo.Pointer != 0)){
                PrintError(__FILE__, __LINE__, "sȑH", CurrentTokenBuf, "");
                return P3CC_NG;
            }
            else{
                if(RightRet->Method == RETURN_METHOD_NUMERIC){
                    if(((LeftRet->TypeInfo.Sign == SIGN) && ((((int)(RightRet->Value.Num)) > 127) || (((int)(RightRet->Value.Num)) < -128)))
                                || ((LeftRet->TypeInfo.Sign == UNSIGN) && ((RightRet->Value.Num & 0xFFFFFF00) != 0))){
                        if(WarningLevel1){
                            PrintWarning(__FILE__, __LINE__, "\Ȕ͈͂𒴂Ă܂B", CurrentTokenBuf, "");
//fprintf(stderr, "%08x\n",RightRet->Value.Num);
                        }
                    }
                    if(RightVCodeListHeader != NULL){
                        if(ExpressionNumericLoad(0, RightRet->Value.Num, RightRet->TypeInfo.Sign, ExpressionNewGprNoGet(), RightRet, RightVCodeListHeader, __LINE__) == P3CC_NG){
                            PrintError(__FILE__, __LINE__, "", "", "");
                            return P3CC_NG;
                        }
                    }
                    return P3CC_OK;
                }
                else{
                    if(RightRet->TypeInfo.Type == TYPE_NOTYPE){
                        return P3CC_OK;
                    }
                    else if((RightRet->TypeInfo.Type == TYPE_CHAR) && (LeftRet->TypeInfo.Sign == RightRet->TypeInfo.Sign)){
                        return P3CC_OK;
                    }
                    else{
                        if(LeftRet->TypeInfo.Sign == SIGN) sign = "signed";
                        else                               sign = "ungned";
                        if(WarningLevel1){
                            sprintf(Msg, "%s charɁA%s charȊǑ^(%s)", sign, sign, CurrentTokenBuf);
                            PrintWarning(__FILE__, __LINE__, Msg, "", "");
                        }
                        return P3CC_OK;
                    }
                }
            }
        }
        else if(LeftRet->TypeInfo.Type == TYPE_SHORT){//============================= TYPE_SHORT ========================================
            if((LeftRet->TypeInfo.Pointer != 0) && (RightRet->TypeInfo.Pointer != 0)){
                if((RightRet->TypeInfo.Type == TYPE_SHORT) && (LeftRet->TypeInfo.Sign == RightRet->TypeInfo.Sign)){
                    return P3CC_OK;
                }
                else{
                    if(WarningLevel1){
                        PrintWarning(__FILE__, __LINE__, "^̈قȂ|C^m̑B", "", "");
                    }
                    return P3CC_OK;
                }
            }
            else if((LeftRet->TypeInfo.Pointer != 0) && (RightRet->TypeInfo.Pointer == 0)){
                if(RightRet->Method == RETURN_METHOD_NUMERIC){
                    if(WarningLevel1){
                        PrintWarning(__FILE__, __LINE__, "|C^ɒ萔悤ƂĂ܂B", "", "");
                    }
                    if(RightVCodeListHeader != NULL){
                        if(ExpressionNumericLoad(0, RightRet->Value.Num, RightRet->TypeInfo.Sign, ExpressionNewGprNoGet(), RightRet, RightVCodeListHeader, __LINE__) == P3CC_NG){
                            PrintError(__FILE__, __LINE__, "", "", "");
                            return P3CC_NG;
                        }
                    }
                    return P3CC_OK;
                }
                else{
                    PrintError(__FILE__, __LINE__, "sȑH", CurrentTokenBuf, "");
                    return P3CC_NG;
                }
            }
            else if((LeftRet->TypeInfo.Pointer == 0) && (RightRet->TypeInfo.Pointer != 0)){
                PrintError(__FILE__, __LINE__, "sȑH", "", "");
                return P3CC_NG;
            }
            else{
                if(RightRet->Method == RETURN_METHOD_NUMERIC){
                    if(((LeftRet->TypeInfo.Sign == SIGN) && ((((int)(RightRet->Value.Num)) > 32767) || (((int)(RightRet->Value.Num)) < -32768)))
                                || ((LeftRet->TypeInfo.Sign == UNSIGN) && ((RightRet->Value.Num & 0xFFFF0000) != 0))){
                        if(WarningLevel1){
                            PrintWarning(__FILE__, __LINE__, "\Ȕ͈͂𒴂Ă܂B", "", "");
                        }
                    }
                    if(RightVCodeListHeader != NULL){
                        if(ExpressionNumericLoad(0, RightRet->Value.Num, RightRet->TypeInfo.Sign, ExpressionNewGprNoGet(), RightRet, RightVCodeListHeader, __LINE__) == P3CC_NG){
                            PrintError(__FILE__, __LINE__, "", "", "");
                            return P3CC_NG;
                        }
                    }
                    return P3CC_OK;
                }
                else{
                    if((RightRet->TypeInfo.Type == TYPE_NOTYPE) || (RightRet->TypeInfo.Type == TYPE_CHAR)){
                        return P3CC_OK;
                    }
                    else if((RightRet->TypeInfo.Type == TYPE_SHORT) && (LeftRet->TypeInfo.Sign == RightRet->TypeInfo.Sign)){
                        return P3CC_OK;
                    }
                    else{
                        if(LeftRet->TypeInfo.Sign == SIGN) sign = "signed";
                        else                               sign = "ungned";
                        if(WarningLevel1){
                            sprintf(Msg, "%s shortɁA%s shortȊǑ^(%s)", sign, sign, CurrentTokenBuf);
                            PrintWarning(__FILE__, __LINE__, Msg, "", "");
                        }
                        return P3CC_OK;
                    }
                }
            }
        }
        else if((LeftRet->TypeInfo.Type == TYPE_INT) || (LeftRet->TypeInfo.Type == TYPE_LONG)){//===== TYPE_INT/TYPE_LONG ==================================
            if((LeftRet->TypeInfo.Pointer != 0) && (RightRet->TypeInfo.Pointer != 0)){
                if(((RightRet->TypeInfo.Type == TYPE_INT) || (RightRet->TypeInfo.Type == TYPE_LONG)) && (LeftRet->TypeInfo.Sign == RightRet->TypeInfo.Sign)){
                    return P3CC_OK;
                }
                else{
                    if(WarningLevel1){
                        PrintWarning(__FILE__, __LINE__, "^̈قȂ|C^m̑B", "", "");
                    }
                    return P3CC_OK;
                }
            }
            else if((LeftRet->TypeInfo.Pointer != 0) && (RightRet->TypeInfo.Pointer == 0)){
                if(RightRet->Method == RETURN_METHOD_NUMERIC){
                    if(WarningLevel1){
                        PrintWarning(__FILE__, __LINE__, "|C^ɒ萔悤ƂĂ܂B", "", "");
                    }
                    if(RightVCodeListHeader != NULL){
                        if(ExpressionNumericLoad(0, RightRet->Value.Num, RightRet->TypeInfo.Sign, ExpressionNewGprNoGet(), RightRet, RightVCodeListHeader, __LINE__) == P3CC_NG){
                            PrintError(__FILE__, __LINE__, "", "", "");
                            return P3CC_NG;
                        }
                    }
                    return P3CC_OK;
                }
                else{
                    PrintError(__FILE__, __LINE__, "sȑH", CurrentTokenBuf, "");
                    return P3CC_NG;
                }
            }
            else if((LeftRet->TypeInfo.Pointer == 0) && (RightRet->TypeInfo.Pointer != 0)){
                PrintError(__FILE__, __LINE__, "sȑH", "", "");
                return P3CC_NG;
            }
            else{
                if(RightRet->Method == RETURN_METHOD_NUMERIC){
                    if(RightVCodeListHeader != NULL){
                        if(ExpressionNumericLoad(0, RightRet->Value.Num, RightRet->TypeInfo.Sign, ExpressionNewGprNoGet(), RightRet, RightVCodeListHeader, __LINE__) == P3CC_NG){
                            PrintError(__FILE__, __LINE__, "", "", "");
                            return P3CC_NG;
                        }
                    }
                    return P3CC_OK;
                }
                else{
                    if((RightRet->TypeInfo.Type == TYPE_NOTYPE) || (RightRet->TypeInfo.Type == TYPE_CHAR) || (RightRet->TypeInfo.Type == TYPE_SHORT)){
                        return P3CC_OK;
                    }
                    else if(((RightRet->TypeInfo.Type == TYPE_INT) || (RightRet->TypeInfo.Type == TYPE_LONG)) && (LeftRet->TypeInfo.Sign == RightRet->TypeInfo.Sign)){
                        return P3CC_OK;
                    }
                    else{
                        if(LeftRet->TypeInfo.Sign == SIGN) sign = "signed";
                        else                               sign = "ungned";
                        if(LeftRet->TypeInfo.Type == TYPE_INT) type = "int";
                        else                                   type = "long";
                        if(WarningLevel1){
                            sprintf(Msg, "%s %sɁA%s %sȊǑ^(%s)", sign, type, sign, type, CurrentTokenBuf);
                            PrintWarning(__FILE__, __LINE__, Msg, "", "");
                        }
                        return P3CC_OK;
                    }
                }
            }
        }
        else if(LeftRet->TypeInfo.Type == TYPE_STRUCT){//============================= TYPE_STRUCT ========================================
            if((LeftRet->TypeInfo.Pointer != 0) && (RightRet->TypeInfo.Pointer != 0)){
                if((RightRet->TypeInfo.Type == TYPE_STRUCT) && (LeftRet->TypeInfo.StructInfo == RightRet->TypeInfo.StructInfo)){
                    return P3CC_OK;
                }
                else{
                    if(WarningLevel1){
                        PrintWarning(__FILE__, __LINE__, "^̈قȂ|C^m̑B", "", "");
                    }
                    return P3CC_OK;
                }
            }
            else if((LeftRet->TypeInfo.Pointer != 0) && (RightRet->TypeInfo.Pointer == 0)){
                if(RightRet->Method == RETURN_METHOD_NUMERIC){
                    if(WarningLevel1){
                        PrintWarning(__FILE__, __LINE__, "|C^ɒ萔悤ƂĂ܂B", "", "");
                    }
                    if(RightVCodeListHeader != NULL){
                        if(ExpressionNumericLoad(0, RightRet->Value.Num, RightRet->TypeInfo.Sign, ExpressionNewGprNoGet(), RightRet, RightVCodeListHeader, __LINE__) == P3CC_NG){
                            PrintError(__FILE__, __LINE__, "", "", "");
                            return P3CC_NG;
                        }
                    }
                    return P3CC_OK;
                }
                else{
                    PrintError(__FILE__, __LINE__, "sȑH", CurrentTokenBuf, "");
                    return P3CC_NG;
                }
            }
            else if((LeftRet->TypeInfo.Pointer == 0) && (RightRet->TypeInfo.Pointer != 0)){
                PrintError(__FILE__, __LINE__, "sȑH", "", "");
                return P3CC_NG;
            }
            else{
                PrintError(__FILE__, __LINE__, "\̂̑ɂ͖Ή", "", "");
                return P3CC_NG;
            }
        }
        else if(LeftRet->TypeInfo.Type == TYPE_NOTYPE){//============================= TYPE_NOTYPE ========================================
            PrintError(__FILE__, __LINE__, "ӂ̌^H", "", "");
            return P3CC_NG;
        }
        else{
            PrintError(__FILE__, __LINE__, "Ή̌^B", "", "");
            return P3CC_NG;
        }
    }
}
//====================================================================================================================
static int ExpressionChkStruct(expression_analsys_result *Ret)
//====================================================================================================================
// [@\] \̂ۂ`FbN
// [] expression_analsys_result *Ret
// [Ԓl] P3CC_TRUE/P3CC_FALSE
{
    if(Ret->TypeInfo.StructInfo   == NULL) return P3CC_FALSE;
    if(Ret->TypeInfo.Pointer      != 0   ) return P3CC_FALSE;
    if(Ret->TypeInfo.TypeFunction != 0   ) return P3CC_FALSE;
    if(Ret->TypeInfo.FuncPointer  != 0   ) return P3CC_FALSE;
    //if(Ret->Method  != RETURN_METHOD_REG ) return P3CC_FALSE;
    //if(Ret->Property!= RETURN_PROPERTY_ADDRESS ) return P3CC_FALSE;
    return P3CC_TRUE;
}

//====================================================================================================================
static int ExpressionConvAssignToken2OpToken(int Token)
//====================================================================================================================
// [@\] Zg[NɑΉ鉉Zg[NԂ
// [] g[N (+=, -=, *=, /=, %=, &=, |=, ^=, <<=, >>=̂ꂩłKv)
// [Ԓl]
{
    if(Token == TOKEN_PLUS_EQ   )   return TOKEN_PLUS;
    if(Token == TOKEN_MINUS_EQ  )   return TOKEN_MINUS;
    if(Token == TOKEN_MULT_EQ   )   return TOKEN_ASTERISK;
    if(Token == TOKEN_DIV_EQ    )   return TOKEN_DIV;
    if(Token == TOKEN_MOD_EQ    )   return TOKEN_MOD;
    if(Token == TOKEN_AND_EQ    )   return TOKEN_AMPERSAND;
    if(Token == TOKEN_XOR_EQ    )   return TOKEN_XOR;
    if(Token == TOKEN_OR_EQ     )   return TOKEN_OR;
    if(Token == TOKEN_SHIFT_L_EQ)   return TOKEN_SHIFT_L;
    if(Token == TOKEN_SHIFT_R_EQ)   return TOKEN_SHIFT_R;
    return P3CC_NG;
}
//====================================================================================================================
static int ExpressionBinomialOpCodeGet(int Token, int Imm, unsigned char *OpCode, char Sign0, char Sign1)
//====================================================================================================================
// [@\] ZqɑΉOPR[hOpCodeɓĕԂ
// [] TokenFZq̂ꂩi[ĂKv
// [] ImmFARG_IS_IMMFREG-ImmZA ARG_IS_IMMȊOFREG-REGZA
// [Ԓl] P3CC_OK/P3CC_NG
{
    if(Token == TOKEN_PLUS      ){*OpCode = (Imm == ARG_IS_IMM)? OPECODE_ADD_I: OPECODE_ADD_R; return P3CC_OK;}
    if(Token == TOKEN_MINUS     ){*OpCode = (Imm == ARG_IS_IMM)? OPECODE_SUB_I: OPECODE_SUB_R; return P3CC_OK;}
    if(Token == TOKEN_ASTERISK  ){*OpCode = (Imm == ARG_IS_IMM)? OPECODE_MUL_I: OPECODE_MUL_R; return P3CC_OK;}
    if(Token == TOKEN_DIV       ){
        if((Sign0 == UNSIGN) || (Sign1 == UNSIGN)) *OpCode = (Imm == ARG_IS_IMM)? OPECODE_DIVU_I: OPECODE_DIVU_R;
        else                                       *OpCode = (Imm == ARG_IS_IMM)? OPECODE_DIV_I: OPECODE_DIV_R;
        return P3CC_OK;
    }
    if(Token == TOKEN_MOD       ){
        if((Sign0 == UNSIGN) || (Sign1 == UNSIGN)) *OpCode = (Imm == ARG_IS_IMM)? OPECODE_MODU_I: OPECODE_MODU_R;
        else                                       *OpCode = (Imm == ARG_IS_IMM)? OPECODE_MOD_I: OPECODE_MOD_R;
        return P3CC_OK;
    }
    if(Token == TOKEN_AMPERSAND ){*OpCode = (Imm == ARG_IS_IMM)? OPECODE_AND_I: OPECODE_AND_R; return P3CC_OK;}
    if(Token == TOKEN_XOR       ){*OpCode = (Imm == ARG_IS_IMM)? OPECODE_XOR_I: OPECODE_XOR_R; return P3CC_OK;}
    if(Token == TOKEN_OR        ){*OpCode = (Imm == ARG_IS_IMM)? OPECODE_OR_I : OPECODE_OR_R ; return P3CC_OK;}
    if(Token == TOKEN_SHIFT_L   ){*OpCode = (Imm == ARG_IS_IMM)? OPECODE_LSL_I: OPECODE_LSL_R; return P3CC_OK;}
    if(Token == TOKEN_SHIFT_R   ){
        if(Sign0 == UNSIGN) *OpCode = (Imm == ARG_IS_IMM)? OPECODE_LSR_I: OPECODE_LSR_I;
        else                *OpCode = (Imm == ARG_IS_IMM)? OPECODE_ASR_I: OPECODE_ASR_I;
        return P3CC_OK;
    }
    return P3CC_NG;
}
//====================================================================================================================
static int ExpressionChkBinomialOpToken(int Token)
//====================================================================================================================
// [@\] Token(+,-,*,/,%,&,|,^,<<,>>)̂ꂩłOKԂ
// [] TokenF
// [Ԓl] P3CC_OK/P3CC_NG
{
    if(Token == TOKEN_PLUS      ){return P3CC_OK;}
    if(Token == TOKEN_MINUS     ){return P3CC_OK;}
    if(Token == TOKEN_ASTERISK  ){return P3CC_OK;}
    if(Token == TOKEN_DIV       ){return P3CC_OK;}
    if(Token == TOKEN_MOD       ){return P3CC_OK;}
    if(Token == TOKEN_AMPERSAND ){return P3CC_OK;}
    if(Token == TOKEN_XOR       ){return P3CC_OK;}
    if(Token == TOKEN_OR        ){return P3CC_OK;}
    if(Token == TOKEN_SHIFT_L   ){return P3CC_OK;}
    if(Token == TOKEN_SHIFT_R   ){return P3CC_OK;}
    return P3CC_NG;
}
//====================================================================================================================
static int ExpressionOptiHintAdd(expression_analsys_result *RootRet, vertual_code_list_header *VCodeListHeader)
//====================================================================================================================
// [@\] ̃R[hɍœKqgt
// [] vertual_code_list_header *vertual_code_list_header
// [Ԓl] P3CC_OK/P3CC_NG
{
    vertual_code    *vc;
    int             BranchExistFlag;
    int             ResultRegNo;

    if(RootRet->Method == RETURN_METHOD_NUMERIC) return P3CC_OK;

    //------ ̎n܂ƏIɂ邵
    vc = VCodeListHeader->Entry;
    while(1){
        if(vc == NULL) break;
        if(vc->Prev == NULL)        vc->OptimaizationHint.Position = EXPRESSION_START;
        else if(vc->Next == NULL)   vc->OptimaizationHint.Position = EXPRESSION_END;
        else                        vc->OptimaizationHint.Position = EXPRESSION_INSIDE;
        vc = vc->Next;
    }

    //------ 򂪂邩ǂ
    BranchExistFlag = P3CC_FALSE;
    vc = VCodeListHeader->Entry;
    while(1){
        if(vc == NULL) break;
        if(vc->OpCode.Type == OPECODE_TYPE_JP) BranchExistFlag = P3CC_TRUE;
        vc = vc->Next;
    }

    ResultRegNo = RootRet->Value.RegNo;
    if(BranchExistFlag == P3CC_FALSE){
        //̒ԃR[hɕ򂪂Ȃ΁AԃR[hXgK猟āAResultRegNoւ̑ŏɏoʒuɈ
        vc = VCodeListHeader->Last;
        while(1){
            if(vc == NULL) break;
            if(((vc->OpCode.Type == OPECODE_TYPE_LD) || (vc->OpCode.Type == OPECODE_TYPE_OP))
            && (vc->OpRand0.Type == OPERAND_TYPE_GPR) && (vc->OpRand0.ValueInfo.RegNo == ResultRegNo)){
                vc->OptimaizationHint.Result = EXPRESSION_RESULT;
                break;
            }
            vc = vc->Prev;
        }
    }
    else{
        //̒ԃR[hɕ򂪂΁AԃR[hXg𓪂猟āAׂĂResultRegNoւ̑Ɉ
        vc = VCodeListHeader->Entry;
        while(1){
            if(vc == NULL) break;
            if(((vc->OpCode.Type == OPECODE_TYPE_LD) || (vc->OpCode.Type == OPECODE_TYPE_OP))
            && (vc->OpRand0.Type == OPERAND_TYPE_GPR) && (vc->OpRand0.ValueInfo.RegNo == ResultRegNo)){
                vc->OptimaizationHint.Result = EXPRESSION_RESULT;
            }
            vc = vc->Next;
        }
    }

    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionOptiVCodeCount(int *NumOfVCode, vertual_code_list_header *RootVCodeListHeader)
//====================================================================================================================
// [@\] ԃR[hJEg
// [] int *NumOfVCode FJEgʊi[
// [] vertual_code_list_header *RootVCodeListHeader FΏۂ̃R[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                 Counter;
    vertual_code                *VCode;

    VCode = RootVCodeListHeader->Entry;
    Counter = 0;
    while(1){
        if(VCode == NULL) break;
        ++Counter;
        VCode = VCode->Next;
    }
    *NumOfVCode = Counter;
    return P3CC_OK;
}
//====================================================================================================================
static vertual_reg_list *ExpressionOptiVRegListFind(int VRegNo, vertual_reg_list **VRegList)
//====================================================================================================================
// [@\] VRegList(zWX^Xg)ɁAVRegNo܂܂Ă΂̗vfw|C^ԂA܂܂ĂȂNULLԂ
// [] int VRegNo                    F[@\]̍QƁB
// [] vertual_reg_list *VRegList    F[@\]̍QƁBNULLłȂO
// [Ԓl] [@\]̍QƁB
{
    vertual_reg_list *p;
    p = *VRegList;
    while(1){
        if(p == NULL) break;
        if(p->RegNo == VRegNo) return p;
        p = p->Next;
    }
    return NULL;
}
//====================================================================================================================
static int ExpressionOptiVRegListAdd(vertual_reg_list **VRegList, vertual_reg_list *VRegListMember)
//====================================================================================================================
// [@\] VRegList(zWX^Xg)VRegListMemberǉB
// [] vertual_reg_list *VRegListMember  F[@\]̍QƁBNULLłȂO
// [] vertual_reg_list *VRegList        F[@\]̍QƁBNULLłȂO
// [Ԓl] [@\]̍QƁB
{
    vertual_reg_list *p;

    if(*VRegList == NULL){
        *VRegList = VRegListMember;
    }
    else{
        p = *VRegList;
        while(1){
            if(p->Next == NULL){
                p->Next = VRegListMember;
                VRegListMember->Prev = p;
                break;
            }
            p = p->Next;
        }
    }
    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionOptiVRegListFree(vertual_reg_list **VRegList)
//====================================================================================================================
// [@\] VRegList(zWX^Xg)
// [] vertual_reg_list *VRegListMember  F[@\]̍QƁBNULLłȂO
// [] vertual_reg_list *VRegList        F[@\]̍QƁBNULLłȂO
// [Ԓl] [@\]̍QƁB
{
    vertual_reg_list *p;
    vertual_reg_list *Next;

    p = *VRegList;
    while(p != NULL){
        Next = p->Next;
        free(p);
        p = Next;
    }
    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionOptiUsedVRegListGet(vertual_reg_list **VRegList, int *NumOfUsedReg, int *NumOfVCode, vertual_code *EntryVCode, vertual_code *TargetVCode)
//====================================================================================================================
// [@\] ԃR[hXgEntryVCodeTargetVCode܂ł̊ԂŎgpĂ郌WX^̃XgVRegListɓĕԂ
//        łɁAgpWX^*NumOfUsedRegցAԃR[h*NumOfVCodeւĕԂ
// [] vertual_reg_list *VRegList                    F[@\]̍QƁBNULLŌĂяoK{Bgpς݃WX^PȂ΁Â܂NULLԂB
// [] vertual_code *TargetVCode                     F[@\]̍QƁBNULLłȂARootVCodeListHeaderɑ݂邱ƂۏႳĂO
// [] vertual_code_list_header *RootVCodeListHeader F[@\]̍QƁBNULLłȂ
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         i;
    int                         VRegNo;
    vertual_code                *VCode;
    vertual_reg_list            *VRegListMember;
    v_operand                   *OpRand[3];
    char                        Msg[10];

    sprintf(Msg,"%d",MAX_NUM_OF_VERTUAL_REG);

    if(*VRegList != NULL){ PrintError(__FILE__, __LINE__, "RpC̃oO(VRegListNULLłȂ)", "", ""); return P3CC_NG;}

    *NumOfUsedReg = 0;
    *NumOfVCode = 0;
    VCode = EntryVCode;
    while(1){
        if(VCode == NULL) break;
        if((VCode->OpCode.Type == OPECODE_TYPE_JP) || (VCode->OpCode.Type == OPECODE_TYPE_LD)
                || (VCode->OpCode.Type == OPECODE_TYPE_ST) || (VCode->OpCode.Type == OPECODE_TYPE_OP)){
            OpRand[0] = &VCode->OpRand0;
            OpRand[1] = &VCode->OpRand1;
            OpRand[2] = &VCode->OpRand2;
            for(i = 0; i < 3; i++){
                if((OpRand[i]->Type == OPERAND_TYPE_GPR) && (OpRand[i]->ValueInfo.RegNo != 0)){ // R0͊֐̕Ԓlp
                    VRegNo = OpRand[i]->ValueInfo.RegNo;
                    VRegListMember = ExpressionOptiVRegListFind(VRegNo, VRegList);
                    if(VRegListMember == NULL){
                        VRegListMember = calloc(1, sizeof(vertual_reg_list));
                        if(VRegListMember == NULL){ PrintError(__FILE__, __LINE__, "̍œKp̍Ɨ̈mێsB", "", ""); return P3CC_NG;}
                        VRegListMember->Next = NULL;
                        VRegListMember->Prev = NULL;
                        VRegListMember->RegNo = VRegNo;
                        VRegListMember->UsedTimes = 1;
                        VRegListMember->Result = P3CC_FALSE;
                        if((i == 0)
                        && ((VCode->OpCode.Type == OPECODE_TYPE_LD) || (VCode->OpCode.Type == OPECODE_TYPE_OP))
                        && (VCode->OptimaizationHint.Result == EXPRESSION_RESULT)){
                            VRegListMember->Result = P3CC_TRUE;
                        }
                        else{
                            VRegListMember->Result = P3CC_FALSE;
                        }
                        ExpressionOptiVRegListAdd(VRegList, VRegListMember);
                        *NumOfUsedReg += 1;
                        if(*NumOfUsedReg >= MAX_NUM_OF_VERTUAL_REG){
                            PrintError(__FILE__, __LINE__, "zWX^̎gp", Msg, "𒴂Ă܂B");
                            return P3CC_NG;
                        }
                    }
                    else{
                        VRegListMember->UsedTimes += 1;
                        if((i == 0)
                        && ((VCode->OpCode.Type == OPECODE_TYPE_LD) || (VCode->OpCode.Type == OPECODE_TYPE_OP))
                        && (VCode->OptimaizationHint.Result == EXPRESSION_RESULT)){
                            VRegListMember->Result = P3CC_TRUE;
                        }
                    }
                }
            }
        }
        *NumOfVCode += 1;
        if(VCode == TargetVCode) break;
        VCode = VCode->Next;
    }
    return P3CC_OK;
}

//====================================================================================================================
static int ExpressionOptiVRegIsUsed(int VRegNo, vertual_code *EntryVCode, vertual_code *TargetVCode)
//====================================================================================================================
// [@\] ԃR[hXgEntryVCodeTargetVCode܂ł̊ԂVRegNoQƂĂP3CC_TRUEԂ
// [] vertual_reg_list *VRegList                    F[@\]̍QƁBNULLŌĂяoK{Bgpς݃WX^PȂ΁Â܂NULLԂB
// [] vertual_code *TargetVCode                     F[@\]̍QƁBNULLłȂARootVCodeListHeaderɑ݂邱ƂۏႳĂO
// [] vertual_code_list_header *RootVCodeListHeader F[@\]̍QƁBNULLłȂ
// [Ԓl] P3CC_TRUE/P3CC_FALSE
{
    int                         i;
    vertual_code                *VCode;

    VCode = EntryVCode;
    while(1){
        if(VCode == NULL) break;
        if((VCode->OpCode.Type == OPECODE_TYPE_JP) || (VCode->OpCode.Type == OPECODE_TYPE_LD)
                || (VCode->OpCode.Type == OPECODE_TYPE_ST) || (VCode->OpCode.Type == OPECODE_TYPE_OP)){
            if(VCode->OpCode.Type == OPECODE_TYPE_ST){
                if((VCode->OpRand0.Type == OPERAND_TYPE_GPR) && (VCode->OpRand0.ValueInfo.RegNo == VRegNo)) return P3CC_TRUE;
            }
            if((VCode->OpRand1.Type == OPERAND_TYPE_GPR) && (VCode->OpRand1.ValueInfo.RegNo == VRegNo)) return P3CC_TRUE;
            if(VCode->OpCode.Type != OPECODE_TYPE_JP){
                if((VCode->OpRand2.Type == OPERAND_TYPE_GPR) && (VCode->OpRand2.ValueInfo.RegNo == VRegNo)) return P3CC_TRUE;
            }
        }
        if(VCode == TargetVCode) break;
        VCode = VCode->Next;
    }
    return P3CC_FALSE;
}

//====================================================================================================================
static int ExpressionOpti120(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] Pʂł̍œK
//        [Jϐ̃[h/XgȀ璷p^[oăR[hk
//        (1)
//              ADD_X,      R0001, XXXXX, XXXX
//              LDW_I,      R0001, R0001, 0(0x0000),
//          
//              LDW_I,      R0001, FP,    FpOffsetOf(a)
//          Ɉk
//
//        (1)
//              ADD_X,      R0001, XXXXX, XXXX
//              STW_I,      R0001, R0001, 0(0x0000),
//          
//              STW_I,      R0001, FP,    FpOffsetOf(a)
//          Ɉk
// [] expression_analsys_result *RootRet            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         NumOfVCodeBefore;
    int                         NumOfVCodeAfter;
    vertual_code                *VCode0;
    vertual_code                *VCode1;
    int                         OpCode0BackUp;

    ExpressionDebugMsg(RootRet, "ExpressionOpti120", EXPRESSION_START, Line);

    while(1){
        if(ExpressionOptiVCodeCount(&NumOfVCodeBefore, RootVCodeListHeader) == P3CC_NG){PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
        if((RootVCodeListHeader->Entry != NULL) && (RootVCodeListHeader->Entry != RootVCodeListHeader->Last)){
            VCode0 = RootVCodeListHeader->Entry;
            while(1){
                if(VCode0 == NULL) break;
                VCode1 = VCode0->Next;
                if(VCode1 == NULL) break;
                if((VCode1->LabelNo == PLABEL_NON)

                && ((VCode0->OpCode.Code == OPECODE_ADD_I) || (VCode0->OpCode.Code == OPECODE_ADD_R))
                && (VCode0->OpRand0.Type == OPERAND_TYPE_GPR)
                //&& (VCode0->OpRand1.Type == OPERAND_TYPE_SPR) && (VCode0->OpRand1.ValueInfo.RegNo == SPR_FP)
                //&& (VCode0->OpRand2.Type == OPERAND_TYPE_VARIABLE)

                && (VCode1->OpRand0.Type == OPERAND_TYPE_GPR)
                && (VCode1->OpRand1.Type == OPERAND_TYPE_GPR)
                && (VCode1->OpRand2.Type == OPERAND_TYPE_SHORT_IMM)
                && (VCode1->OpRand2.ValueInfo.NumLiteral == 0)

                && (VCode0->OpRand0.ValueInfo.RegNo == VCode1->OpRand1.ValueInfo.RegNo)

                && (((VCode1->OpCode.Type == OPECODE_TYPE_ST)
                &&   (VCode0->OptimaizationHint.Result != EXPRESSION_RESULT)
                &&   (ExpressionOptiVRegIsUsed(VCode0->OpRand0.ValueInfo.RegNo, VCode1->Next, RootVCodeListHeader->Last) == P3CC_FALSE))

                ||  ((VCode1->OpCode.Type == OPECODE_TYPE_LD)
                &&   ((VCode0->OpRand0.ValueInfo.RegNo == VCode1->OpRand0.ValueInfo.RegNo)
                ||    ((VCode0->OptimaizationHint.Result != EXPRESSION_RESULT)
                &&     (ExpressionOptiVRegIsUsed(VCode0->OpRand0.ValueInfo.RegNo, VCode1->Next, RootVCodeListHeader->Last) == P3CC_FALSE)))))){

                    OpCode0BackUp = VCode0->OpCode.Code;
                    VCode0->OpCode = VCode1->OpCode;
                    if(OpCode0BackUp == OPECODE_ADD_R){
                        VCode0->OpCode.Code = SwapVCodeOffsetType(VCode1->OpCode.Code);
                    }
                    VCode0->OpRand0.ValueInfo.RegNo = VCode1->OpRand0.ValueInfo.RegNo;
                    VCode0->OptimaizationHint.Result = VCode1->OptimaizationHint.Result;
                    VCode0->OptimaizationHint.Copy  = VCode1->OptimaizationHint.Copy;
                    VCode0->Next = VCode1->Next;
                    if(VCode1->Next != NULL){
                        VCode1->Next->Prev = VCode0;
                    }
                    else{
                        RootVCodeListHeader->Last = VCode0;
                    }
                    free(VCode1);
                }
                VCode0 = VCode0->Next;
            }
        }
        if(ExpressionOptiVCodeCount(&NumOfVCodeAfter, RootVCodeListHeader) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
        if(NumOfVCodeBefore == NumOfVCodeAfter) break;
    }

    ExpressionDebugMsg(RootRet, "ExpressionOpti120", EXPRESSION_END, Line);

    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionOpti110(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] Pʂł̍œK
//        ϐ̃ItZbgvZiɍ\̂̃oQƎj̏璷p^[oăR[hk
//        ()
//              ADD_I,      R0002, FP,    FpOffsetOf(s1)
//              ADD_I,      R0002, R0002, 4(0x0004),
//          
//              ADD_I,      R0002, FP,    FpOffsetOf(s1) + 4
//          Ɉk
// [] expression_analsys_result *RootRet            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         NumOfVCodeBefore;
    int                         NumOfVCodeAfter;
    vertual_code                *VCode0;
    vertual_code                *VCode1;

    ExpressionDebugMsg(RootRet, "ExpressionOpti110", EXPRESSION_START, Line);

    while(1){
        if(ExpressionOptiVCodeCount(&NumOfVCodeBefore, RootVCodeListHeader) == P3CC_NG){PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
        if((RootVCodeListHeader->Entry != NULL) && (RootVCodeListHeader->Entry != RootVCodeListHeader->Last)){
            VCode0 = RootVCodeListHeader->Entry;
            while(1){
                if(VCode0 == NULL) break;
                VCode1 = VCode0->Next;
                if(VCode1 == NULL) break;
                if((VCode1->LabelNo == PLABEL_NON)
                && (VCode0->OpCode.Code == OPECODE_ADD_I)
                && (VCode1->OpCode.Code == OPECODE_ADD_I)
                && (VCode0->OpRand0.Type == OPERAND_TYPE_GPR)
                && (VCode0->OpRand1.Type == OPERAND_TYPE_SPR)  && (VCode0->OpRand1.ValueInfo.RegNo == SPR_FP)
                && (VCode0->OpRand2.Type == OPERAND_TYPE_VARIABLE)
                && (VCode1->OpRand0.Type == OPERAND_TYPE_GPR)
                && (VCode1->OpRand1.Type == OPERAND_TYPE_GPR)
                && (VCode1->OpRand2.Type == OPERAND_TYPE_SHORT_IMM)
                && (VCode0->OpRand0.ValueInfo.RegNo == VCode1->OpRand0.ValueInfo.RegNo)
                && (VCode1->OpRand0.ValueInfo.RegNo == VCode1->OpRand1.ValueInfo.RegNo)){
                    VCode0->OpRand2.VariableOffset += VCode1->OpRand2.ValueInfo.NumLiteral;
                    VCode0->OptimaizationHint.Result = VCode1->OptimaizationHint.Result;
                    VCode0->Next = VCode1->Next;
                    if(VCode1->Next != NULL){
                        VCode1->Next->Prev = VCode0;
                    }
                    else{
                        RootVCodeListHeader->Last = VCode0;
                    }
                    free(VCode1);
                }
                VCode0 = VCode0->Next;
            }
        }
        if(ExpressionOptiVCodeCount(&NumOfVCodeAfter, RootVCodeListHeader) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
        if(NumOfVCodeBefore == NumOfVCodeAfter) break;
    }

    ExpressionDebugMsg(RootRet, "ExpressionOpti110", EXPRESSION_END, Line);

    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionOpti130(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] Pʂł̍œK
//        ϐ̃ItZbgvZiɍ\̂̃oQƎj̏璷p^[oăR[hk
//        ()
//              ADD_I,      R0002, R0002, 40(0x0028),
//              ADD_I,      R0002, R0002, 4(0x0004),
//          
//              ADD_I,      R0002, R0002, 44(0x002C),
//          Ɉk
// [] expression_analsys_result *RootRet            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         NumOfVCodeBefore;
    int                         NumOfVCodeAfter;
    vertual_code                *VCode0;
    vertual_code                *VCode1;
    int                         Imm;

    ExpressionDebugMsg(RootRet, "ExpressionOpti130", EXPRESSION_START, Line);

    while(1){
        if(ExpressionOptiVCodeCount(&NumOfVCodeBefore, RootVCodeListHeader) == P3CC_NG){PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
        if((RootVCodeListHeader->Entry != NULL) && (RootVCodeListHeader->Entry != RootVCodeListHeader->Last)){
            VCode0 = RootVCodeListHeader->Entry;
            while(1){
                if(VCode0 == NULL) break;
                VCode1 = VCode0->Next;
                if(VCode1 == NULL) break;
                if((VCode1->LabelNo == PLABEL_NON)
                && (VCode0->OpCode.Code == OPECODE_ADD_I)
                && (VCode1->OpCode.Code == OPECODE_ADD_I)
                && (VCode0->OpRand0.Type == OPERAND_TYPE_GPR)
                && (VCode0->OpRand1.Type == OPERAND_TYPE_GPR)
                && (VCode0->OpRand2.Type == OPERAND_TYPE_SHORT_IMM)
                && (VCode1->OpRand0.Type == OPERAND_TYPE_GPR)
                && (VCode1->OpRand1.Type == OPERAND_TYPE_GPR)
                && (VCode1->OpRand2.Type == OPERAND_TYPE_SHORT_IMM)
                && (VCode0->OpRand0.ValueInfo.RegNo == VCode0->OpRand1.ValueInfo.RegNo)
                && (VCode0->OpRand0.ValueInfo.RegNo == VCode1->OpRand0.ValueInfo.RegNo)
                && (VCode1->OpRand0.ValueInfo.RegNo == VCode1->OpRand1.ValueInfo.RegNo)){
                    Imm = (int)VCode0->OpRand2.ValueInfo.NumLiteral + (int)VCode1->OpRand2.ValueInfo.NumLiteral;
                    if((Imm <= 32767) && (Imm > -32768)){
                        VCode0->OpRand2.ValueInfo.NumLiteral = Imm;
                        VCode0->Next = VCode1->Next;
                        if(VCode1->Next != NULL){
                            VCode1->Next->Prev = VCode0;
                        }
                        else{
                            RootVCodeListHeader->Last = VCode0;
                        }
                        free(VCode1);
                    }
                }
                VCode0 = VCode0->Next;
            }
        }
        if(ExpressionOptiVCodeCount(&NumOfVCodeAfter, RootVCodeListHeader) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
        if(NumOfVCodeBefore == NumOfVCodeAfter) break;
    }

    ExpressionDebugMsg(RootRet, "ExpressionOpti130", EXPRESSION_END, Line);

    return P3CC_OK;
}

//====================================================================================================================
static int ExpressionOptiIsRegRegOp(char OpCode)
//====================================================================================================================
// [@\] WX^Ԃ̂QZȂP3CC_TRUEԂ
// [] char OpCodeFIyR[h
// [Ԓl] P3CC_TRUE/P3CC_FALSE
{
    if(OpCode == OPECODE_LDW_R     ) return P3CC_TRUE;
    if(OpCode == OPECODE_LDW_UB_R  ) return P3CC_TRUE;
    if(OpCode == OPECODE_LDW_UA_R  ) return P3CC_TRUE;
    if(OpCode == OPECODE_LDH_R     ) return P3CC_TRUE;
    if(OpCode == OPECODE_LDH_UB_R  ) return P3CC_TRUE;
    if(OpCode == OPECODE_LDH_UA_R  ) return P3CC_TRUE;
    if(OpCode == OPECODE_LDB_R     ) return P3CC_TRUE;
    if(OpCode == OPECODE_LDB_UB_R  ) return P3CC_TRUE;
    if(OpCode == OPECODE_LDB_UA_R  ) return P3CC_TRUE;
    if(OpCode == OPECODE_LDSH_R    ) return P3CC_TRUE;
    if(OpCode == OPECODE_LDSH_UB_R ) return P3CC_TRUE;
    if(OpCode == OPECODE_LDSH_UA_R ) return P3CC_TRUE;
    if(OpCode == OPECODE_LDSB_R    ) return P3CC_TRUE;
    if(OpCode == OPECODE_LDSB_UB_R ) return P3CC_TRUE;
    if(OpCode == OPECODE_LDSB_UA_R ) return P3CC_TRUE;

    if(OpCode == OPECODE_STW_R     ) return P3CC_TRUE;
    if(OpCode == OPECODE_STW_UB_R  ) return P3CC_TRUE;
    if(OpCode == OPECODE_STW_UA_R  ) return P3CC_TRUE;
    if(OpCode == OPECODE_STH_R     ) return P3CC_TRUE;
    if(OpCode == OPECODE_STH_UB_R  ) return P3CC_TRUE;
    if(OpCode == OPECODE_STH_UA_R  ) return P3CC_TRUE;
    if(OpCode == OPECODE_STB_R     ) return P3CC_TRUE;
    if(OpCode == OPECODE_STB_UB_R  ) return P3CC_TRUE;
    if(OpCode == OPECODE_STB_UA_R  ) return P3CC_TRUE;

    if(OpCode == OPECODE_ADD_R     ) return P3CC_TRUE;
    //if(OpCode == OPECODE_SUB_R     ) return P3CC_TRUE;
    if(OpCode == OPECODE_AND_R     ) return P3CC_TRUE;
    if(OpCode == OPECODE_OR_R      ) return P3CC_TRUE;
    if(OpCode == OPECODE_XOR_R     ) return P3CC_TRUE;
    //if(OpCode == OPECODE_LSR_R     ) return P3CC_TRUE;
    //if(OpCode == OPECODE_LSL_R     ) return P3CC_TRUE;
    //if(OpCode == OPECODE_ASR_R     ) return P3CC_TRUE;
    if(OpCode == OPECODE_MUL_R     ) return P3CC_TRUE;
    //if(OpCode == OPECODE_DIVU_R    ) return P3CC_TRUE;
    //if(OpCode == OPECODE_DIV_R     ) return P3CC_TRUE;
    //if(OpCode == OPECODE_MODU_R    ) return P3CC_TRUE;
    //if(OpCode == OPECODE_MOD_R     ) return P3CC_TRUE;
    return P3CC_FALSE;
}
//====================================================================================================================
static int ExpressionOpti140(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] Pʂł̍œK
//        ϐ̃ItZbgvZiɍ\̂̃oQƎj̏璷p^[oăR[hk
//        ()
//              ADD_I,      R0002, RXXXX, XXXXX,
//              ADD_R,      RXXXX, RXXXX, R0002,
//          
//              ADD_I,      R0002, RXXXX, XXXXX,
//              ADD_R,      RXXXX, R0002, RXXXX,
//          Ɉk
// [] expression_analsys_result *RootRet            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         NumOfVCodeBefore;
    int                         NumOfVCodeAfter;
    vertual_code                *VCode0;
    vertual_code                *VCode1;
    v_operand                   TmpOpRand;

    ExpressionDebugMsg(RootRet, "ExpressionOpti140", EXPRESSION_START, Line);

    while(1){
        if(ExpressionOptiVCodeCount(&NumOfVCodeBefore, RootVCodeListHeader) == P3CC_NG){PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
        if((RootVCodeListHeader->Entry != NULL) && (RootVCodeListHeader->Entry != RootVCodeListHeader->Last)){

            VCode0 = RootVCodeListHeader->Entry;
            while(1){
                if(VCode0 == NULL) break;
                VCode1 = VCode0->Next;
                if(VCode1 == NULL) break;
                if(((VCode0->OpCode.Type == OPECODE_TYPE_LD) || (VCode0->OpCode.Type == OPECODE_TYPE_OP))
                && (VCode0->OpRand0.Type == OPERAND_TYPE_GPR)
                && (ExpressionOptiIsRegRegOp(VCode1->OpCode.Code) == P3CC_TRUE)
                && (VCode1->OpRand1.Type == OPERAND_TYPE_GPR)
                && (VCode1->OpRand2.Type == OPERAND_TYPE_GPR)
                && (VCode0->OpRand0.ValueInfo.RegNo == VCode1->OpRand2.ValueInfo.RegNo)){
                    TmpOpRand = VCode1->OpRand1;
                    VCode1->OpRand1 = VCode1->OpRand2;
                    VCode1->OpRand2 = TmpOpRand;
                }
                VCode0 = VCode0->Next;
            }

        }
        if(ExpressionOptiVCodeCount(&NumOfVCodeAfter, RootVCodeListHeader) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
        if(NumOfVCodeBefore == NumOfVCodeAfter) break;
    }

    ExpressionDebugMsg(RootRet, "ExpressionOpti140", EXPRESSION_END, Line);

    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionOpti150(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] Pʂł̍œK
//        ++i/--i̍œK
//        (1)
//              addi,    r1,  fp,  FpOffsetOf(i)
//              ldwi,    r2,  r1,  0x0000
//              addi,    r2,  r2,  0x0001
//              stwi,    r2,  r1,  0x0000
//          
//              ldwi,    r1,  fp,  FpOffsetOf(i)
//              addi,    r1,  r1,  0x0001
//              stwi,    r1,  fp,  FpOffsetOf(i)
//          Ɉk
//
//        (2)
//              addi,    r1,  fp,  FpOffsetOf(i)
//              ldwi,    r2,  r1,  0x0000
//              addi,    r2,  r2,  0x0001
//              stwi,    r2,  r1,  0x0000
//              ldwi,    r1,  r1,  0x0000
//          
//              ldwi,    r1,  fp,  FpOffsetOf(i)
//              addi,    r1,  r1,  0x0001
//              stwi,    r1,  fp,  FpOffsetOf(i)
//          Ɉk
// [] expression_analsys_result *RootRet            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         NumOfVCode;
    vertual_code                *VCode0;
    vertual_code                *VCode1;
    vertual_code                *VCode2;
    vertual_code                *VCode3;
    vertual_code                *VCode4;

    if(ExpressionOptiVCodeCount(&NumOfVCode, RootVCodeListHeader) == P3CC_NG){PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
    if((NumOfVCode < 4) || (NumOfVCode > 5)) return P3CC_OK;

    VCode0 = RootVCodeListHeader->Entry;
    VCode1 = VCode0->Next;
    VCode2 = VCode1->Next;
    VCode3 = VCode2->Next;
    if(NumOfVCode == 5) VCode4 = VCode3->Next;
    else                VCode4 = NULL;

    if(VCode0->LabelNo != PLABEL_NON) return P3CC_OK;
    if(VCode1->LabelNo != PLABEL_NON) return P3CC_OK;
    if(VCode2->LabelNo != PLABEL_NON) return P3CC_OK;
    if(VCode3->LabelNo != PLABEL_NON) return P3CC_OK;
    if(NumOfVCode == 5){
        if(VCode4->LabelNo != PLABEL_NON) return P3CC_OK;
    }

    ExpressionDebugMsg(RootRet, "ExpressionOpti150", EXPRESSION_START, Line);

    if(((VCode0->OpCode.Code == OPECODE_ADD_I)      && (VCode0->OpRand0.Type == OPERAND_TYPE_GPR)
    &&  (VCode0->OpRand1.Type == OPERAND_TYPE_SPR)  && (VCode0->OpRand1.ValueInfo.RegNo == SPR_FP)
    &&  (VCode0->OpRand2.Type == OPERAND_TYPE_VARIABLE))

    && ((VCode1->OpCode.Type == OPECODE_TYPE_LD)    && (VCode1->OpRand0.Type == OPERAND_TYPE_GPR)
    &&  (VCode1->OpRand1.Type == OPERAND_TYPE_GPR)  && (VCode1->OpRand2.Type == OPERAND_TYPE_SHORT_IMM)
    &&  (VCode1->OpRand2.ValueInfo.NumLiteral == 0))

    && (((VCode2->OpCode.Code == OPECODE_ADD_I) || (VCode2->OpCode.Code == OPECODE_SUB_I))     && (VCode2->OpRand0.Type == OPERAND_TYPE_GPR)
    &&  (VCode2->OpRand1.Type == OPERAND_TYPE_GPR)  && (VCode2->OpRand2.Type == OPERAND_TYPE_SHORT_IMM))

    && ((VCode3->OpCode.Type == OPECODE_TYPE_ST)    && (VCode3->OpRand0.Type == OPERAND_TYPE_GPR)
    &&  (VCode3->OpRand1.Type == OPERAND_TYPE_GPR)  && (VCode3->OpRand2.Type == OPERAND_TYPE_SHORT_IMM)
    &&  (VCode3->OpRand2.ValueInfo.NumLiteral == 0))

    && (VCode0->OpRand0.ValueInfo.RegNo == VCode1->OpRand1.ValueInfo.RegNo)
    && (VCode0->OpRand0.ValueInfo.RegNo == VCode3->OpRand1.ValueInfo.RegNo)
    && (VCode1->OpRand0.ValueInfo.RegNo == VCode2->OpRand0.ValueInfo.RegNo)
    && (VCode1->OpRand0.ValueInfo.RegNo == VCode2->OpRand1.ValueInfo.RegNo)
    && (VCode1->OpRand0.ValueInfo.RegNo == VCode3->OpRand0.ValueInfo.RegNo)
    && (VCode0->OpRand0.ValueInfo.RegNo == (int)RootRet->Value.RegNo) && (RootRet->Method == RETURN_METHOD_REG)){
        if(NumOfVCode == 4){
//        ()
//              addi,    r1,  fp,  FpOffsetOf(i)
//              ldwi,    r2,  r1,  0x0000
//              addi,    r2,  r2,  0x0001
//              stwi,    r2,  r1,  0x0000
//          
//              ldwi,    r1,  fp,  FpOffsetOf(i)
//              addi,    r1,  r1,  0x0001
//              stwi,    r1,  fp,  FpOffsetOf(i)
//          Ɉk
            VCode0->OpCode = VCode1->OpCode;
            VCode2->OpRand0 = VCode0->OpRand0;
            VCode2->OpRand1 = VCode0->OpRand0;
            VCode3->OpRand0 = VCode0->OpRand0;
            VCode3->OpRand1 = VCode0->OpRand1;
            VCode3->OpRand2 = VCode0->OpRand2;
            VCode0->Next = VCode2;
            VCode2->Prev = VCode0;
            free(VCode1);
        }
        else{
            if((VCode4->OpCode.Type == OPECODE_TYPE_LD)    && (VCode4->OpRand0.Type == OPERAND_TYPE_GPR)
            && (VCode4->OpRand1.Type == OPERAND_TYPE_GPR)  && (VCode4->OpRand2.Type == OPERAND_TYPE_SHORT_IMM)
            && (VCode4->OpRand2.ValueInfo.NumLiteral == 0)
            && (VCode0->OpRand0.ValueInfo.RegNo == VCode4->OpRand0.ValueInfo.RegNo)
            && (VCode0->OpRand0.ValueInfo.RegNo == VCode4->OpRand1.ValueInfo.RegNo)){
//        (2)
//              addi,    r1,  fp,  FpOffsetOf(i)
//              ldwi,    r2,  r1,  0x0000
//              addi,    r2,  r2,  0x0001
//              stwi,    r2,  r1,  0x0000
//              ldwi,    r1,  r1,  0x0000
//          
//              ldwi,    r1,  fp,  FpOffsetOf(i)
//              addi,    r1,  r1,  0x0001
//              stwi,    r1,  fp,  FpOffsetOf(i)
//          Ɉk
                VCode0->OpCode = VCode1->OpCode;
                VCode2->OpRand0 = VCode0->OpRand0;
                VCode2->OpRand1 = VCode0->OpRand0;
                VCode3->OpRand0 = VCode0->OpRand0;
                VCode3->OpRand1 = VCode0->OpRand1;
                VCode3->OpRand2 = VCode0->OpRand2;
                VCode0->Next = VCode2;
                VCode2->Prev = VCode0;
                VCode3->Next = NULL;
                RootVCodeListHeader->Last = VCode3;
                free(VCode1);
                free(VCode4);
            }
        }
    }

    ExpressionDebugMsg(RootRet, "ExpressionOpti150", EXPRESSION_END, Line);

    return P3CC_OK;
}

//====================================================================================================================
static int ExpressionOpti151(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] Pʂł̍œK
//        i++/i--̍œK
//        ()
//              addi,    r1,  fp,  FpOffsetOf(i)
//              movr,    r3,  r1
//              ldwi,    r2,  r3,  0x0000
//              addi,    r2,  r2,  0x0004
//              stwi,    r2,  r3,  0x0000
//          
//              ldwi,    r1,  fp,  FpOffsetOf(i)
//              addi,    r1,  r1,  0x0004
//              stwi,    r1,  fp,  FpOffsetOf(i)
//          Ɉk
// [] expression_analsys_result *RootRet            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         NumOfVCode;
    vertual_code                *VCode0;
    vertual_code                *VCode1;
    vertual_code                *VCode2;
    vertual_code                *VCode3;
    vertual_code                *VCode4;

    if(ExpressionOptiVCodeCount(&NumOfVCode, RootVCodeListHeader) == P3CC_NG){PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
    if(NumOfVCode != 5) return P3CC_OK;

    VCode0 = RootVCodeListHeader->Entry;
    VCode1 = VCode0->Next;
    VCode2 = VCode1->Next;
    VCode3 = VCode2->Next;
    VCode4 = VCode3->Next;

    if(VCode0->LabelNo != PLABEL_NON) return P3CC_OK;
    if(VCode1->LabelNo != PLABEL_NON) return P3CC_OK;
    if(VCode2->LabelNo != PLABEL_NON) return P3CC_OK;
    if(VCode3->LabelNo != PLABEL_NON) return P3CC_OK;
    if(VCode4->LabelNo != PLABEL_NON) return P3CC_OK;

    ExpressionDebugMsg(RootRet, "ExpressionOpti151", EXPRESSION_START, Line);

    if(((VCode0->OpCode.Code == OPECODE_ADD_I)      && (VCode0->OpRand0.Type == OPERAND_TYPE_GPR)
    &&  (VCode0->OpRand1.Type == OPERAND_TYPE_SPR)  && (VCode0->OpRand1.ValueInfo.RegNo == SPR_FP)
    &&  (VCode0->OpRand2.Type == OPERAND_TYPE_VARIABLE))

    && ((VCode1->OpCode.Code == OPECODE_MOV_R)    && (VCode1->OpRand0.Type == OPERAND_TYPE_GPR)
    &&  (VCode1->OpRand2.Type == OPERAND_TYPE_GPR))

    && ((VCode2->OpCode.Type == OPECODE_TYPE_LD)    && (VCode2->OpRand0.Type == OPERAND_TYPE_GPR)
    &&  (VCode2->OpRand1.Type == OPERAND_TYPE_GPR)  && (VCode2->OpRand2.Type == OPERAND_TYPE_SHORT_IMM)
    &&  (VCode2->OpRand2.ValueInfo.NumLiteral == 0))

    && (((VCode3->OpCode.Code == OPECODE_ADD_I) || (VCode3->OpCode.Code == OPECODE_SUB_I))     && (VCode3->OpRand0.Type == OPERAND_TYPE_GPR)
    &&  (VCode3->OpRand1.Type == OPERAND_TYPE_GPR)  && (VCode3->OpRand2.Type == OPERAND_TYPE_SHORT_IMM))

    && ((VCode4->OpCode.Type == OPECODE_TYPE_ST)    && (VCode4->OpRand0.Type == OPERAND_TYPE_GPR)
    &&  (VCode4->OpRand1.Type == OPERAND_TYPE_GPR)  && (VCode4->OpRand2.Type == OPERAND_TYPE_SHORT_IMM)
    &&  (VCode4->OpRand2.ValueInfo.NumLiteral == 0))

    && (VCode0->OpRand0.ValueInfo.RegNo == VCode1->OpRand2.ValueInfo.RegNo)
    && (VCode1->OpRand0.ValueInfo.RegNo == VCode2->OpRand1.ValueInfo.RegNo)
    && (VCode1->OpRand0.ValueInfo.RegNo == VCode4->OpRand1.ValueInfo.RegNo)

    && (VCode2->OpRand0.ValueInfo.RegNo == VCode3->OpRand0.ValueInfo.RegNo)
    && (VCode2->OpRand0.ValueInfo.RegNo == VCode3->OpRand1.ValueInfo.RegNo)
    && (VCode2->OpRand0.ValueInfo.RegNo == VCode4->OpRand0.ValueInfo.RegNo)){
//        ()
//              addi,    r1,  fp,  FpOffsetOf(i)
//              movr,    r3,  r1
//              ldwi,    r2,  r3,  0x0000
//              addi,    r2,  r2,  0x0004
//              stwi,    r2,  r3,  0x0000
//          
//              ldwi,    r1,  fp,  FpOffsetOf(i)
//              addi,    r1,  r1,  0x0004
//              stwi,    r1,  fp,  FpOffsetOf(i)
//          Ɉk
        VCode0->OpCode = VCode2->OpCode;
        VCode3->OpRand0 = VCode0->OpRand0;
        VCode3->OpRand1 = VCode0->OpRand0;
        VCode4->OpRand0 = VCode0->OpRand0;
        VCode4->OpRand1 = VCode0->OpRand1;
        VCode4->OpRand2 = VCode0->OpRand2;
        VCode0->Next = VCode3;
        VCode3->Prev = VCode0;
        free(VCode1);
        free(VCode2);
    }

    ExpressionDebugMsg(RootRet, "ExpressionOpti151", EXPRESSION_END, Line);

    return P3CC_OK;
}


//====================================================================================================================
static vertual_reg_list *ExpressionOptiFindNotReferredReg(vertual_reg_list *VRegList, vertual_code *VCodeEntry, vertual_code *VCodeLast)
//====================================================================================================================
// [@\] VRegListɊ܂܂郌WX^ŁAVCodeEntry`VCodeLastŎQƂĂȂWX^T
//        AOƂVRegListɊ܂܂郌WX^ResulttO(̌ʂԂWX^)Ă郌WX^̓X[
// [] vertual_reg_list *VRegListFWX^̃Xg
// [] vertual_code VCodeEntry   FR[h擪
// [] vertual_code VCodeLast    FR[hI[
// [Ԓl] VRegLisẗʒuwBȂNULLԂ
{
    int                         VRegNo;
    int                         ReferredCounter;
    vertual_code                *VCode;
    vertual_reg_list            *Result;

    while(1){
        if(VRegList == NULL){
            Result = NULL;
            break;
        }
        if(VRegList->Result != P3CC_TRUE){
            VRegNo = (unsigned long)VRegList->RegNo;
            ReferredCounter = 0;
            VCode = VCodeEntry;
            while(1){
                if(VCode == NULL) break;
                if(VCode->OpCode.Type == OPECODE_TYPE_JP){
                    if((VCode->OpRand1.Type == OPERAND_TYPE_GPR) && (VRegNo == VCode->OpRand1.ValueInfo.RegNo)) ++ReferredCounter;
                }
                else if(VCode->OpCode.Type == OPECODE_TYPE_ST){
                    if((VCode->OpRand0.Type == OPERAND_TYPE_GPR) && (VRegNo == VCode->OpRand0.ValueInfo.RegNo)) ++ReferredCounter;
                    if((VCode->OpRand1.Type == OPERAND_TYPE_GPR) && (VRegNo == VCode->OpRand1.ValueInfo.RegNo)) ++ReferredCounter;
                    if((VCode->OpRand2.Type == OPERAND_TYPE_GPR) && (VRegNo == VCode->OpRand2.ValueInfo.RegNo)) ++ReferredCounter;
                }
                else if((VCode->OpCode.Type == OPECODE_TYPE_LD) || (VCode->OpCode.Type == OPECODE_TYPE_OP)){
                    if((VCode->OpRand1.Type == OPERAND_TYPE_GPR) && (VRegNo == VCode->OpRand1.ValueInfo.RegNo)) ++ReferredCounter;
                    if((VCode->OpRand2.Type == OPERAND_TYPE_GPR) && (VRegNo == VCode->OpRand2.ValueInfo.RegNo)) ++ReferredCounter;
                }
                else{
                    ;
                }
                if(VCode == VCodeLast){
                    break;
                }
                VCode = VCode->Next;
            }
            if(ReferredCounter == 0){
                Result = VRegList;
                break;
            }
        }
        VRegList = VRegList->Next;
    }
    return Result;
}
//====================================================================================================================
static int ExpressionOptiReplaceReg(int VRegBefore, int VRegAfter, expression_analsys_result *RootRet, vertual_code *VCodeEntry)
//====================================================================================================================
// [@\] VCodeEntryȍ~̃R[hŁAVRegBeforeVRegAfter֒uBKv΁ARootRet̒g
// [] int VRegBefore                    F[@\]Q
// [] int VRegAfter                     F[@\]Q
// [] expression_analsys_result *RootRetF[@\]Q
// [] vertual_code *VCodeEntry          F[@\]Q
// [Ԓl] P3CC_OK/NG
{
    vertual_code                *VCode;

    ExpressionDebugMsg(RootRet, "ExpressionOptiReplaceReg", EXPRESSION_START, __LINE__);

    VCode = VCodeEntry;
    while(1){
        if(VCode == NULL) break;
        if((VCode->OpRand0.Type == OPERAND_TYPE_GPR) && (VCode->OpRand0.ValueInfo.RegNo == VRegBefore)){
            VCode->OpRand0.ValueInfo.RegNo = VRegAfter;
            if((VCode->OpCode.Type == OPECODE_TYPE_LD) || (VCode->OpCode.Type == OPECODE_TYPE_OP)){
                if(VCode->OptimaizationHint.Result == EXPRESSION_RESULT){
                    RootRet->Value.RegNo = VRegAfter;
                }
            }
        }
        if((VCode->OpRand1.Type == OPERAND_TYPE_GPR) && (VCode->OpRand1.ValueInfo.RegNo == VRegBefore)) VCode->OpRand1.ValueInfo.RegNo = VRegAfter;
        if((VCode->OpRand2.Type == OPERAND_TYPE_GPR) && (VCode->OpRand2.ValueInfo.RegNo == VRegBefore)) VCode->OpRand2.ValueInfo.RegNo = VRegAfter;
        VCode = VCode->Next;
    }

    ExpressionDebugMsg(RootRet, "ExpressionOptiReplaceReg", EXPRESSION_END, __LINE__);
    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionOpti310(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] gpWX^팸ɃgC
// [] expression_analsys_result *RootRet            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         NumOfVCodeBefore;
    int                         NumOfVCodeAfter;
    int                         NumOfUsedVRegBefore;
    int                         NumOfUsedVRegAfter;
    vertual_reg_list            *VRegListBrfore;
    vertual_reg_list            *VRegListAfter;
    vertual_code                *VCodeEntry;
    vertual_code                *VCodeLast;
    vertual_code                *VCode;
    int                         NumOfVCode;
    int                         NumOfUsedVReg;
    vertual_reg_list            *VRegList;
    vertual_reg_list            *ReplaceTarget;
    int                         NewVRegNo;


    VRegListBrfore = NULL;
    VRegListAfter  = NULL;
    if(ExpressionOptiUsedVRegListGet(&VRegListBrfore, &NumOfUsedVRegBefore, &NumOfVCodeBefore, RootVCodeListHeader->Entry, RootVCodeListHeader->Last) == P3CC_NG){
        PrintError(__FILE__, __LINE__, "", "", "");
        return P3CC_NG;
    }
    //if(NumOfUsedVRegBefore <= 2) return P3CC_OK;
    //if(NumOfVCodeBefore <= 2) return P3CC_OK;

    ExpressionDebugMsg(RootRet, "ExpressionOpti310", EXPRESSION_START, Line);
    if(ExpressionOptimizeDbgFlag){
        fprintf(LogFile, "\n------------ y̎gpWX^zœKO ------------\n");
        PrintVertualCodeList(RootVCodeListHeader->Entry);
        fprintf(LogFile, "ԃR[hXebvF%d\n", NumOfVCodeBefore);
        fprintf(LogFile, "gpWX^@@@F%d\n", NumOfUsedVRegBefore);
        PrintVertualRegList(VRegListBrfore);
        //PrintExpAnaResult(RootRet, "ExpressionOpti310(before)");
    }

    //------------------------------------------------------
    VCodeEntry = RootVCodeListHeader->Entry;
    VCodeLast = RootVCodeListHeader->Entry;
    VCode = VCodeEntry->Next;
    while(1){
        if(VCode == NULL) break;
        //--WX^ɒlR[hۂ`FbN
        if(((VCode->OpCode.Type == OPECODE_TYPE_LD) || (VCode->OpCode.Type == OPECODE_TYPE_OP)) && (VCode->OpRand0.Type ==OPERAND_TYPE_GPR)){
            NewVRegNo = VCode->OpRand0.ValueInfo.RegNo;//NewVRegNo = Vɒl郌WX^
            if(NewVRegNo != 0){
                //--VCodeOɎgpĂ郌WX^̃Xg쐬
                VRegList = NULL;
                if(ExpressionOptiUsedVRegListGet(&VRegList, &NumOfUsedVReg, &NumOfVCode, VCodeEntry, VCode->Prev) == P3CC_NG){
                    PrintError(__FILE__, __LINE__, "", "", "");
                    return P3CC_NG;
                }
                //--NewVRegNoO܂ł̃R[hŎgpς݂ǂ`FbN
                if(ExpressionOptiVRegListFind(NewVRegNo, &VRegList) == NULL){//ʂNULLȂAgp(VKWX^)
                    //--VRegListɊ܂܂郌WX^ŁAȍ~̃R[hɏoȂWX^T
//fprintf(LogFile, "NewRegFind! R%04d\n",NewVRegNo);
                    ReplaceTarget = ExpressionOptiFindNotReferredReg(VRegList, VCode->Next, VCodeLast);
                    if(ReplaceTarget != NULL){
                        ExpressionOptiReplaceReg(NewVRegNo, ReplaceTarget->RegNo, RootRet, VCode);
                    }
                }
                ExpressionOptiVRegListFree(&VRegList);
            }
        }
        VCode = VCode->Next;
    }
    //------------------------------------------------------

    if(ExpressionOptiUsedVRegListGet(&VRegListAfter, &NumOfUsedVRegAfter, &NumOfVCodeAfter,RootVCodeListHeader->Entry, RootVCodeListHeader->Last) == P3CC_NG){
        PrintError(__FILE__, __LINE__, "", "", "");
        return P3CC_NG;
    }
    if(ExpressionOptimizeDbgFlag){
        fprintf(LogFile, "gpWX^팸ʁF%d -> %d\n", NumOfUsedVRegBefore, NumOfUsedVRegAfter);
        //PrintVertualCodeList(RootVCodeListHeader->Entry);
        //PrintExpAnaResult(RootRet, "ExpressionOpti310(after)");
    }

    ExpressionOptiVRegListFree(&VRegListBrfore);
    ExpressionOptiVRegListFree(&VRegListAfter);
    ExpressionDebugMsg(RootRet, "ExpressionOpti310", EXPRESSION_END, Line);
    return P3CC_OK;
}
//====================================================================================================================
//static int ExpressionOptiVRegListSwap(vertual_reg_list **VRegList, vertual_reg_list *Reg0 , vertual_reg_list *Reg1)
static int ExpressionOptiVRegListSwap(vertual_reg_list *Reg0 , vertual_reg_list *Reg1)
//====================================================================================================================
// [@\] VRegList̗vfReg0Reg1ւ
// [] vertual_reg_list **VRegList
// [Ԓl] P3CC_OK/P3CC_NG
{
    vertual_reg_list            *Next0;
    vertual_reg_list            *Prev0;
    vertual_reg_list            *Next1;
    vertual_reg_list            *Prev1;
    vertual_reg_list             Tmp;

    Prev0 = Reg0->Prev;
    Next0 = Reg0->Next;
    Prev1 = Reg1->Prev;
    Next1 = Reg1->Next;

    Tmp = *Reg0;
    *Reg0 = *Reg1;
    *Reg1 = Tmp;
    Reg0->Prev = Prev0;
    Reg0->Next = Next0;
    Reg1->Prev = Prev1;
    Reg1->Next = Next1;
/*
    if(Next0 != Reg1){
        Reg0->Prev = Prev1;
        Reg1->Next = Next0;
        if(Next0 != NULL) Next0->Prev = Reg1;
        if(Prev1 != NULL) Prev1->Next = Reg0;
        else              *VRegList =   Reg0;
    }
    else{
        Reg0->Prev = Reg1;
        Reg1->Next = Reg0;
    }
    Reg0->Next = Next1;
    Reg1->Prev = Prev0;
    if(Prev0 != NULL) Prev0->Next = Reg1;
    else              *VRegList =   Reg1;
    if(Next1 != NULL) Next1->Prev = Reg0;
*/
    return P3CC_OK;

}
//====================================================================================================================
static int ExpressionOptiVRegListSort(vertual_reg_list **VRegList, int NumOfUsedVReg)
//====================================================================================================================
// [@\] VRegList̐擪ʊi[pWX^ɁAȊOgppx̍ɂȂׂȂ
// [] vertual_reg_list **VRegList
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         i;
    vertual_reg_list            *vr0;
    vertual_reg_list            *vr1;
    vertual_reg_list            *VRegListTop;

    vr0 = *VRegList;
    while(1){
        if(vr0 == NULL){
            PrintError(__FILE__, __LINE__, "œK̎̒ԃR[hɌʂi[ׂ̃WX^݂ȂB", "", "");
            return P3CC_NG;
        }
        if(vr0->Result == P3CC_TRUE) break;
        vr0 = vr0->Next;
    }

    VRegListTop = *VRegList;
    if((vr0 != VRegListTop) && (VRegListTop->Next != NULL)){//Xg̐擪vr0(̏ꍇ͌ʊi[WX^)ł͂ȂAXg̃oQȏ
        //ExpressionOptiVRegListSwap(VRegList, vr0, VRegListTop);
        ExpressionOptiVRegListSwap(vr0, VRegListTop);
    }

    for(i = 0; i < NumOfUsedVReg -2 ; i++){
        VRegListTop = *VRegList;
        vr0 = VRegListTop->Next;
        while(1){
            if(vr0 == NULL) break;
            vr1 = vr0->Next;
            if(vr1 == NULL) break;
            if(vr1->UsedTimes > vr0->UsedTimes){
                //ExpressionOptiVRegListSwap(VRegList, vr0, vr1);
                ExpressionOptiVRegListSwap(vr0, vr1);
            }
            else{
                vr0 = vr0->Next;
            }
        }
    }

    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionOpti320(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] ăWX^t
//        iʊi[pWX^R1ɁAȊOgppx̍R2犄tȂj
// [] expression_analsys_result *RootRet            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         NewRegNo;
    int                         CurrentRegNo;
    int                         NumOfVCodeBefore;
    int                         NumOfUsedVRegBefore;
    vertual_reg_list            *VRegListBrfore;
    vertual_reg_list            *VRegList;
    vertual_code                *VCode;

    VRegListBrfore = NULL;
    if(ExpressionOptiUsedVRegListGet(&VRegListBrfore, &NumOfUsedVRegBefore, &NumOfVCodeBefore, RootVCodeListHeader->Entry, RootVCodeListHeader->Last) == P3CC_NG){
        PrintError(__FILE__, __LINE__, "", "", "");
        return P3CC_NG;
    }
    //if(NumOfUsedVRegBefore <= 2) return P3CC_OK;
    //if(NumOfVCodeBefore <= 2) return P3CC_OK;

    ExpressionDebugMsg(RootRet, "ExpressionOpti320", EXPRESSION_START, Line);
    if(ExpressionOptimizeDbgFlag != 0){
        fprintf(LogFile, "\n------------ yWX^Ċ蓖āzœKO ------------\n");
        PrintVertualCodeList(RootVCodeListHeader->Entry);
        fprintf(LogFile, "ԃR[hXebvF%d\n", NumOfVCodeBefore);
        fprintf(LogFile, "gpWX^@@@F%d\n", NumOfUsedVRegBefore);
        PrintVertualRegList(VRegListBrfore);
    }

    //VRegListBrfore̐擪ʊi[pWX^ɁAȊOgppx̍ɂȂׂȂ
    ExpressionOptiVRegListSort(&VRegListBrfore, NumOfUsedVRegBefore);
    if(ExpressionOptimizeDbgFlag){
        PrintVertualRegList(VRegListBrfore);
        PrintExpAnaResult(RootRet, "ExpressionOpti320(before)");
    }


    //Ƃ肠AR[h̃WX^NoɁAMAX_NUM_OF_VERTUAL_REGZBR0͊֐̕ԒlpȂ̂ŏȂ
    VCode = RootVCodeListHeader->Entry;
    while(1){
        if(VCode == NULL) break;
        if((VCode->OpRand0.Type == OPERAND_TYPE_GPR) && (VCode->OpRand0.ValueInfo.RegNo != 0)) VCode->OpRand0.ValueInfo.RegNo += MAX_NUM_OF_VERTUAL_REG;
        if((VCode->OpRand1.Type == OPERAND_TYPE_GPR) && (VCode->OpRand1.ValueInfo.RegNo != 0)) VCode->OpRand1.ValueInfo.RegNo += MAX_NUM_OF_VERTUAL_REG;
        if((VCode->OpRand2.Type == OPERAND_TYPE_GPR) && (VCode->OpRand2.ValueInfo.RegNo != 0)) VCode->OpRand2.ValueInfo.RegNo += MAX_NUM_OF_VERTUAL_REG;
        VCode = VCode->Next;
    }
    //WX^Nôӂ蒼
    NewRegNo = FIRST_REAL_REG_NO;
    VRegList = VRegListBrfore;
    while(1){
        if(VRegList == NULL) break;
        CurrentRegNo = VRegList->RegNo + MAX_NUM_OF_VERTUAL_REG;
        VCode = RootVCodeListHeader->Entry;
        while(1){
            if(VCode == NULL) break;
            if((VCode->OpRand0.Type == OPERAND_TYPE_GPR) && (VCode->OpRand0.ValueInfo.RegNo == CurrentRegNo)) VCode->OpRand0.ValueInfo.RegNo = NewRegNo;
            if((VCode->OpRand1.Type == OPERAND_TYPE_GPR) && (VCode->OpRand1.ValueInfo.RegNo == CurrentRegNo)) VCode->OpRand1.ValueInfo.RegNo = NewRegNo;
            if((VCode->OpRand2.Type == OPERAND_TYPE_GPR) && (VCode->OpRand2.ValueInfo.RegNo == CurrentRegNo)) VCode->OpRand2.ValueInfo.RegNo = NewRegNo;
            VCode = VCode->Next;
        }
        VRegList = VRegList->Next;
        ++NewRegNo;
    }

    RootRet->Value.RegNo = FIRST_REAL_REG_NO;

    ExpressionOptiVRegListFree(&VRegListBrfore);
    ExpressionDebugMsg(RootRet, "ExpressionOpti320", EXPRESSION_END, Line);
    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionOptiTmpVarNameGet(char *Name, int Number)
//====================================================================================================================
// [@\] ꎞϐ(WX^ȂɈꎞIɎgp)擾
// [] ȗ
// [Ԓl] P3CC_OK/P3CC_NG
{
    sprintf(Name, "tmp@r%d",Number);
    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionOptiAddTmpVar(int NumOfAddTmpVar)
//====================================================================================================================
// [@\] gpWX^NUM_OF_SCRATCH_REG𒴂Ăꍇ̏
// [] int   NumOfAddTmpVar;ǉKvȃ[Jϐ
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         i;
    variable                    v;
    char                        Name[MAX_IDENTIFIER_CHAR];


    VariableInit(&v);

    for(i = 0; i < NumOfAddTmpVar; i++){
        ExpressionOptiTmpVarNameGet(Name,  i + (NUM_OF_SCRATCH_REG - NUM_OF_TMP_REG) + 1);
        if(VariableFindBody(Name, CurrentFuncInfo->VariableList) == NULL){//o^Ȃǉo^
            v.FuncName = CurrentFuncInfo->FuncName;
            v.Name = calloc(1, MAX_IDENTIFIER_CHAR);
            if(v.Name == NULL){PrintError(__FILE__, __LINE__, "[Jϐ̕ϐi[p̈mێs", "", "");  return P3CC_NG; }
            strcpy(v.Name, Name);
            if(VariableListAdd(&v, CurrentFuncInfo) == P3CC_NG){PrintError(__FILE__, __LINE__, "", "", "");  return P3CC_NG; }
        }
    }
    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionOpti330(expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] gpWX^NUM_OF_SCRATCH_REG𒴂Ăꍇ̏
// [] expression_analsys_result *RootRet            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         NumOfVCodeBefore;
    int                         NumOfUsedVRegBefore;
    vertual_reg_list            *VRegListBrfore;
    int                         NumOfAddTmpVar;//ǉKvȃ[Jϐ
    int                         MaxRealRegNo;//̒l傫WX^Noϊ̑Ώ
    unsigned long               TmpRegNo0;
    unsigned long               TmpRegNo1;
    unsigned long               TmpRegNo2;
    vertual_code                *VCode;
    vertual_code                NewVCode;
    value_info                  vi;
    int                         SrcFileIndex;
    int                         SrcFileLine;
    char                        Name[MAX_IDENTIFIER_CHAR];


    VRegListBrfore = NULL;
    if(ExpressionOptiUsedVRegListGet(&VRegListBrfore, &NumOfUsedVRegBefore, &NumOfVCodeBefore, RootVCodeListHeader->Entry, RootVCodeListHeader->Last) == P3CC_NG){
        PrintError(__FILE__, __LINE__, "", "", "");
        return P3CC_NG;
    }
    if(NumOfUsedVRegBefore <= NUM_OF_SCRATCH_REG) return P3CC_OK;
    if(NumOfVCodeBefore < 1) return P3CC_OK;

    ExpressionDebugMsg(RootRet, "ExpressionOpti330", EXPRESSION_START, Line);
    if(ExpressionOptimizeDbgFlag){
        fprintf(LogFile, "\n------------ yWX^蓖āzœKO ------------\n");
        PrintVertualCodeList(RootVCodeListHeader->Entry);
        fprintf(LogFile, "ԃR[hXebvF%d\n", NumOfVCodeBefore);
        fprintf(LogFile, "gpWX^@@@F%d\n", NumOfUsedVRegBefore);
        PrintVertualRegList(VRegListBrfore);
        PrintExpAnaResult(RootRet, "ExpressionOpti330(before)");
    }
    //ǉ郍[Jϐo^
    MaxRealRegNo = (NUM_OF_SCRATCH_REG - NUM_OF_TMP_REG);
    NumOfAddTmpVar = NumOfUsedVRegBefore - MaxRealRegNo;
    
//=======================================================================================================================
//======= XNb`WX^ȂȂ̓삪sȂ̂ŁAƂ肠AG[\ĈُIƂ ==========
//=======================================================================================================================
/*
    if(NumOfAddTmpVar > 0){
        PrintError(__FILE__, __LINE__, "================================================================", "", "");
        PrintError(__FILE__, __LINE__, "= ̃RpC̔\͂𒴂镡GȎo܂B          ", "", "");
        PrintError(__FILE__, __LINE__, "= (ׂ̃XNb`WX^܂)              ", "", "");
        PrintError(__FILE__, __LINE__, "= ̂悤ȃP[Xł́Ao͂ꂽR[h̓삪sȂ̂ŁA  ", "", "");
        PrintError(__FILE__, __LINE__, "= RpC̏𒆒fAIĂ܂B                ", "", "");
        PrintError(__FILE__, __LINE__, "= ł̖@́AƂȂGȎA      ", "", "");
        PrintError(__FILE__, __LINE__, "= ̊ȒPȎɕ鎖łB                              ", "", "");
        PrintError(__FILE__, __LINE__, "= ()                                                          ", "", "");
        PrintError(__FILE__, __LINE__, "=   (ύXO)                                                    ", "", "");
        PrintError(__FILE__, __LINE__, "=    result = P + Q * R;                   ", "", "");
        PrintError(__FILE__, __LINE__, "=                                                               ", "", "");
        PrintError(__FILE__, __LINE__, "=   (ύX)                                                    ", "", "");
        PrintError(__FILE__, __LINE__, "=     a = P;                                             ", "", "");
        PrintError(__FILE__, __LINE__, "=     b = Q;                                             ", "", "");
        PrintError(__FILE__, __LINE__, "=     c = R;                                             ", "", "");
        PrintError(__FILE__, __LINE__, "=     result = a + b * c;                                       ", "", "");
        PrintError(__FILE__, __LINE__, "================================================================", "", "");
        return P3CC_NG;
    }
*/

    if(ExpressionOptiAddTmpVar(NumOfAddTmpVar) == P3CC_NG){PrintError(__FILE__, __LINE__, "", "", "");  return P3CC_NG; }

    //WX^݂ȂWX^Noɑ΂鑀AꎟϐgɕϊB
    SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
    SrcFileLine = TokenSrcLineGet(TokenIndex);
    TmpRegNo0 = (unsigned long)MaxRealRegNo + 1;
    TmpRegNo1 = (unsigned long)TmpRegNo0 + 1;
    TmpRegNo2 = (unsigned long)TmpRegNo1 + 1;
    VCode = RootVCodeListHeader->Entry;

    while(1){
        if(VCode == NULL) break;
        if((VCode->OpRand1.Type == OPERAND_TYPE_GPR) && (VCode->OpRand1.ValueInfo.RegNo > MaxRealRegNo)){
            ExpressionOptiTmpVarNameGet(Name, VCode->OpRand1.ValueInfo.RegNo);
            vi.var = VariableFindBody(Name, CurrentFuncInfo->VariableList);
            if(vi.var == NULL){PrintError(__FILE__, __LINE__, "炭RpC̃oOB", "", "");  return P3CC_NG; }
            VCodeGen_Load(&NewVCode, PLABEL_NON, SIZE_4, UNSIGN, BASE_UPDATE_NO,  DST_IS_GPR,TmpRegNo1,  BASE_IS_SPR,SPR_FP,  OFFSET_IS_VAR,&vi,  SrcFileIndex, SrcFileLine);
            NewVCode.OptimaizationHint.Position = VCode->OptimaizationHint.Position;
            if(VertualCodeInsertPrev(RootVCodeListHeader, VCode, &NewVCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            VCode->OpRand1.ValueInfo.RegNo = TmpRegNo1;
        }
        if((VCode->OpRand2.Type == OPERAND_TYPE_GPR) && (VCode->OpRand2.ValueInfo.RegNo > MaxRealRegNo)){
            ExpressionOptiTmpVarNameGet(Name, VCode->OpRand2.ValueInfo.RegNo);
            vi.var = VariableFindBody(Name, CurrentFuncInfo->VariableList);
            if(vi.var == NULL){PrintError(__FILE__, __LINE__, "炭RpC̃oOB", "", "");  return P3CC_NG; }
            VCodeGen_Load(&NewVCode, PLABEL_NON, SIZE_4, UNSIGN, BASE_UPDATE_NO,  DST_IS_GPR,TmpRegNo2,  BASE_IS_SPR,SPR_FP,  OFFSET_IS_VAR,&vi,  SrcFileIndex, SrcFileLine);
            NewVCode.OptimaizationHint.Position = VCode->OptimaizationHint.Position;
            if(VertualCodeInsertPrev(RootVCodeListHeader, VCode, &NewVCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            VCode->OpRand2.ValueInfo.RegNo = TmpRegNo2;
        }
        if((VCode->OpRand0.Type == OPERAND_TYPE_GPR) && (VCode->OpRand0.ValueInfo.RegNo > MaxRealRegNo)){
            ExpressionOptiTmpVarNameGet(Name, VCode->OpRand0.ValueInfo.RegNo);
            vi.var = VariableFindBody(Name, CurrentFuncInfo->VariableList);
            if(vi.var == NULL){PrintError(__FILE__, __LINE__, "炭RpC̃oOB", "", "");  return P3CC_NG; }
            if(VCode->OpCode.Type == OPECODE_TYPE_ST){
                VCodeGen_Load(&NewVCode, PLABEL_NON, SIZE_4, UNSIGN, BASE_UPDATE_NO,  DST_IS_GPR,TmpRegNo0,  BASE_IS_SPR,SPR_FP,  OFFSET_IS_VAR,&vi,  SrcFileIndex, SrcFileLine);
                NewVCode.OptimaizationHint.Position = VCode->OptimaizationHint.Position;
                if(VertualCodeInsertPrev(RootVCodeListHeader, VCode, &NewVCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                VCode->OpRand0.ValueInfo.RegNo = TmpRegNo0;
            }
            else{
                VCodeGen_Store(&NewVCode, PLABEL_NON, SIZE_4, BASE_UPDATE_NO,  SRC_IS_GPR,TmpRegNo0, BASE_IS_SPR, SPR_FP, OFFSET_IS_VAR,&vi, SrcFileIndex, SrcFileLine);
                NewVCode.OptimaizationHint.Position = VCode->OptimaizationHint.Position;
                if(VertualCodeInsertNext(RootVCodeListHeader, VCode, &NewVCode) != P3CC_OK){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
                VCode->OpRand0.ValueInfo.RegNo = TmpRegNo0;
                VCode = VCode->Next;
            }

        }
        VCode = VCode->Next;
    }

    ExpressionOptiVRegListFree(&VRegListBrfore);
    ExpressionDebugMsg(RootRet, "ExpressionOpti330", EXPRESSION_END, Line);
    return P3CC_OK;
}
//====================================================================================================================
static int ExpressionOptimize(int Mode, expression_analsys_result *RootRet, vertual_code_list_header *RootVCodeListHeader, int Line)
//====================================================================================================================
// [@\] Pʂł̍œK
// [] int  Mode                                     FKEEP_RESULTFԂlԂR[hی삷^NOT_KEEP_RESULTFی삵Ȃ
// [] expression_analsys_result *RootRet            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
#ifdef OPTIMAIZE_EXPR_ENABLE
    int                         NumOfVCodeBefore;
    int                         NumOfVCodeAfter;
    int                         NumOfUsedVRegBefore;
    int                         NumOfUsedVRegAfter;
    vertual_reg_list            *VRegListBrfore;
    vertual_reg_list            *VRegListAfter;
    int                         TmpNumOfVCodeBefore;
    int                         TmpNumOfVCodeAfter;


    ExpressionDebugMsg(RootRet, "ExpressionOptimize", EXPRESSION_START, Line);
    if(ExpressionOptiHintAdd(RootRet, RootVCodeListHeader) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    VRegListBrfore =NULL;
    VRegListAfter  =NULL;
    if(ExpressionOptiUsedVRegListGet(&VRegListBrfore, &NumOfUsedVRegBefore, &NumOfVCodeBefore, RootVCodeListHeader->Entry, RootVCodeListHeader->Last) == P3CC_NG){
        PrintError(__FILE__, __LINE__, "", "", "");
        return P3CC_NG;
    }
    if(ExpressionOptimizeDbgFlag){
        fprintf(LogFile, "\n------------ yzœKO ------------\n");
        PrintVertualCodeList(RootVCodeListHeader->Entry);
        fprintf(LogFile, "ԃR[hXebvF%d\n", NumOfVCodeBefore);
        fprintf(LogFile, "gpWX^@@@F%d\n", NumOfUsedVRegBefore);
        PrintVertualRegList(VRegListBrfore);
    }


    //ԂlKԂƁI
    if(RootRet->Method == RETURN_METHOD_NUMERIC){
        ;//l萔̏ꍇ͍œKȂ
    }
    else{
        //100ԑ́APȃp^[}b`Oɂ璷Ȗ߃p^[̈k
        while(1){
            if(ExpressionOptiVCodeCount(&TmpNumOfVCodeBefore, RootVCodeListHeader) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
            if(ExpressionOpti110(RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
            if(ExpressionOpti120(RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
            if(ExpressionOpti130(RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
            if(ExpressionOpti140(RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}

            if(Mode == NOT_KEEP_RESULT){
                if(ExpressionOpti150(RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
                if(ExpressionOpti151(RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
            }
            if(ExpressionOptiVCodeCount(&TmpNumOfVCodeAfter, RootVCodeListHeader) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
            if(TmpNumOfVCodeBefore == TmpNumOfVCodeAfter) break;
        }

        //300ԑ́AWX^팸֘A
        if(ExpressionOpti310(RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;} //gpWX^팸
        if(ExpressionOpti320(RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;} //WX^ԍȂт

        if(ExpressionOptiVCodeCount(&TmpNumOfVCodeBefore, RootVCodeListHeader) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
        if(ExpressionOpti330(RootRet, RootVCodeListHeader, __LINE__) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;} //WX^WX^(10)𒴂Ăꍇ̏
        if(ExpressionOptiVCodeCount(&TmpNumOfVCodeAfter, RootVCodeListHeader) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
        if(TmpNumOfVCodeAfter/TmpNumOfVCodeBefore > 3){
            PrintInfo(__FILE__, __LINE__, "̌vZɕKvȕWX^sׁǍvZɕKvȎsXebv傫ȂĂ܂B", "", "");
            PrintInfo(__FILE__, __LINE__, "Pȕ̎ɕ鎖𐄏܂B", "", "");
        }
    }

    if(ExpressionOptiUsedVRegListGet(&VRegListAfter, &NumOfUsedVRegAfter, &NumOfVCodeAfter,RootVCodeListHeader->Entry, RootVCodeListHeader->Last) == P3CC_NG){
        PrintError(__FILE__, __LINE__, "", "", "");
        return P3CC_NG;
    }
    if(ExpressionOptimizeDbgFlag){
        fprintf(LogFile, "\n------------ yzœK ------------\n");
        PrintVertualCodeList(RootVCodeListHeader->Entry);
        fprintf(LogFile, "ԃR[hXebvF%d -> %d\n", NumOfVCodeBefore, NumOfVCodeAfter);
        fprintf(LogFile, "gpWX^@@@F%d -> %d\n", NumOfUsedVRegBefore, NumOfUsedVRegAfter);
        PrintVertualRegList(VRegListAfter);
        fprintf(LogFile, "\n");
    }
    if(CurrentFuncInfo->MaxNumOfUsedVReg < NumOfUsedVRegAfter) CurrentFuncInfo->MaxNumOfUsedVReg = NumOfUsedVRegAfter;

    ExpressionOptiVRegListFree(&VRegListBrfore);
    ExpressionOptiVRegListFree(&VRegListAfter);

    ExpressionDebugMsg(RootRet, "ExpressionOptimize", EXPRESSION_END, Line);
#endif
    return P3CC_OK;
}

//====================================================================================================================
static void ExpressionDebugMsg(expression_analsys_result *RootRet, char *Func, int Status, int Line)
//====================================================================================================================
// [@\] ̓fobObZ[W
// [] expression_analsys_result *Ret            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader   FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    char  DbgTokenBuf[MAX_SOURCE_LINE_CHAR];
    char  *Sts;

    if(ExpressionDebugFlag2) PrintExpAnaResult(RootRet, Func);

    if(ExpressionDebugFlag){
        if(Status != EXPRESSION_START){
             --DebugMsgIndentCounter;
        }
        PrintSpace(DebugMsgIndentCounter);
        Token2String(TokenIndex, DbgTokenBuf);
        if(Status == EXPRESSION_START){
            Sts = "Start";
        }
        else{
            Sts = "End";
        }
        fprintf(LogFile, "%s %s %d %s\n", Func, Sts, Line, DbgTokenBuf);
        if(Status == EXPRESSION_START){
            ++DebugMsgIndentCounter;
            //if(ExpressionDebugFlag2) PrintExpAnaResult(RootRet, Func);
        }
    }
}
//====================================================================================================================
static int SwapVCodeOffsetType(int VOpCode)
//====================================================================================================================
// [@\] VOpCodelItZbgwȂ΁AΉ郌WX^ItZbgw̖߂ԂB
// [] int VOpCode            FԃR[h̖߃R[h
// [Ԓl] ꍇ[@\]̍QƁAsP3CC_NG
{
    if     (VOpCode == OPECODE_JP_R     ) return OPECODE_JP_I    ;
    else if(VOpCode == OPECODE_JP_I     ) return OPECODE_JP_R    ;
    else if(VOpCode == OPECODE_CALL_R   ) return OPECODE_CALL_I  ;
    else if(VOpCode == OPECODE_CALL_I   ) return OPECODE_CALL_R  ;
    else if(VOpCode == OPECODE_LDW_R    ) return OPECODE_LDW_I   ;
    else if(VOpCode == OPECODE_LDW_I    ) return OPECODE_LDW_R   ;
    else if(VOpCode == OPECODE_LDW_UB_R ) return OPECODE_LDW_UB_I;
    else if(VOpCode == OPECODE_LDW_UB_I ) return OPECODE_LDW_UB_R;
    else if(VOpCode == OPECODE_LDW_UA_R ) return OPECODE_LDW_UA_I;
    else if(VOpCode == OPECODE_LDW_UA_I ) return OPECODE_LDW_UA_R;
    else if(VOpCode == OPECODE_LDH_R    ) return OPECODE_LDH_I   ;
    else if(VOpCode == OPECODE_LDH_I    ) return OPECODE_LDH_R   ;
    else if(VOpCode == OPECODE_LDH_UB_R ) return OPECODE_LDH_UB_I;
    else if(VOpCode == OPECODE_LDH_UB_I ) return OPECODE_LDH_UB_R;
    else if(VOpCode == OPECODE_LDH_UA_R ) return OPECODE_LDH_UA_I;
    else if(VOpCode == OPECODE_LDH_UA_I ) return OPECODE_LDH_UA_R;
    else if(VOpCode == OPECODE_LDB_R    ) return OPECODE_LDB_I   ;
    else if(VOpCode == OPECODE_LDB_I    ) return OPECODE_LDB_R   ;
    else if(VOpCode == OPECODE_LDB_UB_R ) return OPECODE_LDB_UB_I;
    else if(VOpCode == OPECODE_LDB_UB_I ) return OPECODE_LDB_UB_R;
    else if(VOpCode == OPECODE_LDB_UA_R ) return OPECODE_LDB_UA_I;
    else if(VOpCode == OPECODE_LDB_UA_I ) return OPECODE_LDB_UA_R;
    else if(VOpCode == OPECODE_LDSH_R   ) return OPECODE_LDSH_I  ;
    else if(VOpCode == OPECODE_LDSH_I   ) return OPECODE_LDSH_R  ;
    else if(VOpCode == OPECODE_LDSH_UB_R) return OPECODE_LDSH_UB_I;
    else if(VOpCode == OPECODE_LDSH_UB_I) return OPECODE_LDSH_UB_R;
    else if(VOpCode == OPECODE_LDSH_UA_R) return OPECODE_LDSH_UA_I;
    else if(VOpCode == OPECODE_LDSH_UA_I) return OPECODE_LDSH_UA_R;
    else if(VOpCode == OPECODE_LDSB_R   ) return OPECODE_LDSB_I  ;
    else if(VOpCode == OPECODE_LDSB_I   ) return OPECODE_LDSB_R  ;
    else if(VOpCode == OPECODE_LDSB_UB_R) return OPECODE_LDSB_UB_I;
    else if(VOpCode == OPECODE_LDSB_UB_I) return OPECODE_LDSB_UB_R;
    else if(VOpCode == OPECODE_LDSB_UA_R) return OPECODE_LDSB_UA_I;
    else if(VOpCode == OPECODE_LDSB_UA_I) return OPECODE_LDSB_UA_R;
    else if(VOpCode == OPECODE_STW_R    ) return OPECODE_STW_I   ;
    else if(VOpCode == OPECODE_STW_I    ) return OPECODE_STW_R   ;
    else if(VOpCode == OPECODE_STW_UB_R ) return OPECODE_STW_UB_I;
    else if(VOpCode == OPECODE_STW_UB_I ) return OPECODE_STW_UB_R;
    else if(VOpCode == OPECODE_STW_UA_R ) return OPECODE_STW_UA_I;
    else if(VOpCode == OPECODE_STW_UA_I ) return OPECODE_STW_UA_R;
    else if(VOpCode == OPECODE_STH_R    ) return OPECODE_STH_I   ;
    else if(VOpCode == OPECODE_STH_I    ) return OPECODE_STH_R   ;
    else if(VOpCode == OPECODE_STH_UB_R ) return OPECODE_STH_UB_I;
    else if(VOpCode == OPECODE_STH_UB_I ) return OPECODE_STH_UB_R;
    else if(VOpCode == OPECODE_STH_UA_R ) return OPECODE_STH_UA_I;
    else if(VOpCode == OPECODE_STH_UA_I ) return OPECODE_STH_UA_R;
    else if(VOpCode == OPECODE_STB_R    ) return OPECODE_STB_I   ;
    else if(VOpCode == OPECODE_STB_I    ) return OPECODE_STB_R   ;
    else if(VOpCode == OPECODE_STB_UB_R ) return OPECODE_STB_UB_I;
    else if(VOpCode == OPECODE_STB_UB_I ) return OPECODE_STB_UB_R;
    else if(VOpCode == OPECODE_STB_UA_R ) return OPECODE_STB_UA_I;
    else if(VOpCode == OPECODE_STB_UA_I ) return OPECODE_STB_UA_R;
    else if(VOpCode == OPECODE_ADD_R    ) return OPECODE_ADD_I   ;
    else if(VOpCode == OPECODE_ADD_I    ) return OPECODE_ADD_R   ;
    else if(VOpCode == OPECODE_SUB_R    ) return OPECODE_SUB_I   ;
    else if(VOpCode == OPECODE_SUB_I    ) return OPECODE_SUB_R   ;
    else if(VOpCode == OPECODE_AND_R    ) return OPECODE_AND_I   ;
    else if(VOpCode == OPECODE_AND_I    ) return OPECODE_AND_R   ;
    else if(VOpCode == OPECODE_OR_R     ) return OPECODE_OR_I    ;
    else if(VOpCode == OPECODE_OR_I     ) return OPECODE_OR_R    ;
    else if(VOpCode == OPECODE_XOR_R    ) return OPECODE_XOR_I   ;
    else if(VOpCode == OPECODE_XOR_I    ) return OPECODE_XOR_R   ;
    else if(VOpCode == OPECODE_LSR_R    ) return OPECODE_LSR_I   ;
    else if(VOpCode == OPECODE_LSR_I    ) return OPECODE_LSR_R   ;
    else if(VOpCode == OPECODE_LSL_R    ) return OPECODE_LSL_I   ;
    else if(VOpCode == OPECODE_LSL_I    ) return OPECODE_LSL_R   ;
    else if(VOpCode == OPECODE_ASR_R    ) return OPECODE_ASR_I   ;
    else if(VOpCode == OPECODE_ASR_I    ) return OPECODE_ASR_R   ;
    else if(VOpCode == OPECODE_MUL_R    ) return OPECODE_MUL_I   ;
    else if(VOpCode == OPECODE_MUL_I    ) return OPECODE_MUL_R   ;
    else if(VOpCode == OPECODE_DIVU_R   ) return OPECODE_DIVU_I  ;
    else if(VOpCode == OPECODE_DIVU_I   ) return OPECODE_DIVU_R  ;
    else if(VOpCode == OPECODE_DIV_R    ) return OPECODE_DIV_I   ;
    else if(VOpCode == OPECODE_DIV_I    ) return OPECODE_DIV_R   ;
    else if(VOpCode == OPECODE_MODU_R   ) return OPECODE_MODU_I  ;
    else if(VOpCode == OPECODE_MODU_I   ) return OPECODE_MODU_R  ;
    else if(VOpCode == OPECODE_MOD_R    ) return OPECODE_MOD_I   ;
    else if(VOpCode == OPECODE_MOD_I    ) return OPECODE_MOD_R   ;
    else return P3CC_NG;
}
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 萔֘A
// 萔̎ŁAċAI\͂Ă݂
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//====================================================================================================================
static int ConstantExpressionTop(void)
//====================================================================================================================
// [@\] 萔̉
// [Ԓl] 萔̌
{
    int Ret;

    Ret = ConstantExpressionBitOr();
    if(ConstantExpressionDebugFlag){
        fprintf(LogFile, "ConstantExpression = %d, 0x%08x\n", Ret, Ret);
    }
    return Ret;
}
//====================================================================================================================
static int ConstantExpressionBitOr(void)
//====================================================================================================================
// [@\] 萔rbgả
// [Ԓl] 萔rbgǎ
{
    int     Token;
    int     Arg0;
    int     Arg1;

    Arg0 = ConstantExpressionBitXor();
    while(1){
        Token = TokenGet(TokenIndex, __LINE__);
        if(Token != TOKEN_OR) break;
        ++TokenIndex;
        Arg1 = ConstantExpressionBitXor();
        Arg0 = Arg0 | Arg1;

        if(ConstantExpressionDebugFlag){
            fprintf(LogFile, "ConstantExpressionBitOr = %d, 0x%08x\n", Arg0, Arg0);
        }

    }

    return Arg0;
}
//====================================================================================================================
static int ConstantExpressionBitXor(void)
//====================================================================================================================
// [@\] 萔rbgả
// [Ԓl] 萔rbgǎ
{
    int     Token;
    int     Arg0;
    int     Arg1;

    Arg0 = ConstantExpressionBitAnd();
    while(1){
        Token = TokenGet(TokenIndex, __LINE__);
        if(Token != TOKEN_XOR) break;
        ++TokenIndex;
        Arg1 = ConstantExpressionBitAnd();
        Arg0 = Arg0 ^ Arg1;

        if(ConstantExpressionDebugFlag){
            fprintf(LogFile, "ConstantExpressionBitXor = %d, 0x%08x\n", Arg0, Arg0);
        }

    }

    return Arg0;
}
//====================================================================================================================
static int ConstantExpressionBitAnd(void)
//====================================================================================================================
// [@\] 萔rbgώ̉
// [Ԓl] 萔rbgώ̌
{
    int     Token;
    int     Arg0;
    int     Arg1;

    Arg0 = ConstantExpressionShift();
    while(1){
        Token = TokenGet(TokenIndex, __LINE__);
        if(Token != TOKEN_AMPERSAND) break;
        ++TokenIndex;
        Arg1 = ConstantExpressionShift();
        Arg0 = Arg0 & Arg1;

        if(ConstantExpressionDebugFlag){
            fprintf(LogFile, "ConstantExpressionBitAnd = %d, 0x%08x\n", Arg0, Arg0);
        }

    }
    return Arg0;
}
//====================================================================================================================
static int ConstantExpressionShift(void)
//====================================================================================================================
// [@\] 萔Vtg̉
// [Ԓl] 萔Vtǧ
{
    int     Token;
    int     Arg0;
    int     Arg1;

    Arg0 = ConstantExpressionAddaptive();
    while(1){
        Token = TokenGet(TokenIndex, __LINE__);
        if((Token != TOKEN_SHIFT_L) && (Token != TOKEN_SHIFT_R)) break;
        ++TokenIndex;
        Arg1 = ConstantExpressionAddaptive();
        if(Token == TOKEN_SHIFT_L) Arg0 = Arg0 << Arg1;
        else Arg0 = Arg0 >> Arg1;

        if(ConstantExpressionDebugFlag){
            fprintf(LogFile, "ConstantExpressionShift = %d, 0x%08x\n", Arg0, Arg0);
        }
    }

    return Arg0;
}
//====================================================================================================================
static int ConstantExpressionAddaptive(void)
//====================================================================================================================
// [@\] 萔Z̉
// [Ԓl] 萔Ž
{
    int     Token;
    int     Arg0;
    int     Arg1;

    Arg0 = ConstantExpressionMultiplicative();
    while(1){
        Token = TokenGet(TokenIndex, __LINE__);
        if((Token != TOKEN_PLUS) && (Token != TOKEN_MINUS)) break;
        ++TokenIndex;
        Arg1 = ConstantExpressionMultiplicative();
        if(Token == TOKEN_PLUS) Arg0 = Arg0 + Arg1;
        else Arg0 = Arg0 - Arg1;

        if(ConstantExpressionDebugFlag){
            fprintf(LogFile, "ConstantExpressionAddaptive = %d, 0x%08x\n", Arg0, Arg0);
        }

    }
    return Arg0;
}
//====================================================================================================================
static int ConstantExpressionMultiplicative(void)
//====================================================================================================================
// [@\] 萔揜Z̉
// [Ԓl] 萔揜Ž
{
    int     Token;
    int     Arg0;
    int     Arg1;

    Arg0 = ConstantExpressionPrimary();
    while(1){
        Token = TokenGet(TokenIndex, __LINE__);
        if((Token != TOKEN_ASTERISK) && (Token != TOKEN_DIV) && (Token != TOKEN_MOD)) break;
        ++TokenIndex;
        Arg1 = ConstantExpressionPrimary();
        if(Token == TOKEN_ASTERISK) Arg0 = Arg0 * Arg1;
        else if(Token == TOKEN_DIV) Arg0 = Arg0 / Arg1;
        else                        Arg0 = Arg0 % Arg1;

        if(ConstantExpressionDebugFlag){
            fprintf(LogFile, "ConstantExpressionMultiplicative = %d, 0x%08x\n", Arg0, Arg0);
        }
    }

    return Arg0;
}
//====================================================================================================================
static int ConstantExpressionPrimary(void)
//====================================================================================================================
// [@\] 萔ꎟ̉
// [Ԓl] 萔ꎟ̌
{
    int     Ret;
    int     Token;

    Token = TokenGet(TokenIndex, __LINE__);
    if(Token == TOKEN_BRACKET_L){ // "()"ň͂܂ꂽ
        ++TokenIndex;
        Ret = ConstantExpressionTop();
        Token = TokenGet(TokenIndex, __LINE__);
        if(Token != TOKEN_BRACKET_R){
            ++ConstantExpressionErrorFlag;
            PrintError(__FILE__, __LINE__, "s\ȃg[N", CurrentTokenBuf, "");
        }
        else{
            ++TokenIndex;
        }
    }
    else if(Token == TOKEN_SIZEOF){ //=== sizeofZq
        ++TokenIndex;
        if(ExpressionSizeof(&Ret, __LINE__) == P3CC_NG){
            ++ConstantExpressionErrorFlag;
            PrintError(__FILE__, __LINE__, "s\ȃg[N", CurrentTokenBuf, "");
        }
    }
    else if(Token == TOKEN_NUMERIC_LITERAL){    //=== l
        Ret = TokenNumLiteralValueGet(TokenIndex);
        ++TokenIndex;
    }
    else if(Token == TOKEN_PLUS){   //=== P{
        ++TokenIndex;
        Ret = ConstantExpressionPrimary();
    }
    else if(Token == TOKEN_MINUS){  //=== P|
        ++TokenIndex;
        Ret = 0 - ConstantExpressionPrimary();
    }
    else{
        ++ConstantExpressionErrorFlag;
        Ret = 0;
        PrintError(__FILE__, __LINE__, "s\ȃg[N", CurrentTokenBuf, "");
    }

    if(ConstantExpressionDebugFlag){
        fprintf(LogFile, "ConstantExpressionPrimary = %d, 0x%08x\n", Ret, Ret);
    }

    return Ret;
}
//====================================================================================================================
static int ExpressionSizeof(int *Size, int Line)
//====================================================================================================================
// [@\] sizeofZ
// [Ԓl] SizeɌʂ̒l
// [Ԓl] P3CC_OK/P3CC_NG s
{
    int             Token;
    int             SaveIndex;
    int             Ret;
    variable        v;
    //expression_analsys_result   MyRet;
    //vertual_code_list_header    MyVCodeListHeader;

    char                        *Id;
    variable                    *vp;


    ExpressionDebugMsg(NULL, "ExpressionSizeof", EXPRESSION_START, Line);

    //ExpressionResultInit(&MyRet);

    Token = TokenGet(TokenIndex, __LINE__);
    if(Token == TOKEN_BRACKET_L){//=== "("n܂Ă΁A^̌
        VariableInit(&v);
        ++TokenIndex; // "("̎ֈړ
        SaveIndex = TokenIndex;
        //=== ^擾
        Ret = DeclarationVariable(CAST_ANALYSIS, &v);
        if(Ret == P3CC_NG){ PrintError(__FILE__, __LINE__, "sizeof()̊ʓ̌^͂Ɏs", "", ""); return P3CC_NG;}
        if(Ret == P3CC_OK){// ^̐錾oo
            *Size = v.TotalSize;
            if(v.ArgList != NULL) VariableListFree(v.ArgList);
            if(v.DimInfo != NULL) free(v.DimInfo);
        }
        else{// (Ret == P3CC_ESCAPE) ^̐錾ooȂ
            TokenIndex = SaveIndex;//TokenIndex߂
            Token = TokenGet(TokenIndex, __LINE__);
            if(Token == TOKEN_NUMERIC_LITERAL){
                *Size = SIZEOF_INT;
                ++TokenIndex;
            }
            else if(Token == TOKEN_STRING_LITERAL){
                *Size = strlen(TokenStrLiteralGet(TokenIndex)) + 1;
                ++TokenIndex;
            }
            else{
                if((Token == TOKEN_IDENTIFIER) && (TokenGet(TokenIndex + 1, __LINE__) == TOKEN_BRACKET_R)){
                    Id = TokenIdStrGet(TokenIndex);
                    vp = ArgFind(Id, CurrentFuncInfo);
                    if(vp == NULL){
                        vp = VariableFind(Id, CurrentFuncInfo);
                        if(vp == NULL){
                              PrintError(__FILE__, __LINE__, "`̎ʎqB", Id, "");
                              return P3CC_NG;   //ʎqϐłȂNG
                        }
                    }
                    *Size = vp->TotalSize;
                    ++TokenIndex;
                }
                else{
                    PrintError(__FILE__, __LINE__, "sizeof()̊ʓ̌^͂ɎsB", "̂ƂAPȃP[X݂̂ɑΉB", "");
                    return P3CC_NG;
                }
                //VCodeListHeaderInit(&MyVCodeListHeader);
                //if(ExpressionAssignment(&MyRet, &MyVCodeListHeader, __LINE__) == P3CC_NG){PrintError(__FILE__, __LINE__, "sizeof()̊ʓ̌^͂Ɏs", "", ""); return P3CC_NG; }
                //*Size = ExpressionResultSizeGet(&(MyRet.TypeInfo));
                //VertualCodeListFree(&MyVCodeListHeader);
                //PrintExpAnaResult(&MyRet, "SIZEOF");
            }
        }
        Token = TokenGet(TokenIndex, __LINE__);
        if(Token != TOKEN_BRACKET_R){ PrintError(__FILE__, __LINE__, "sizeof()̊ʓ̌^͂Ɏs", "", ""); return P3CC_NG;}
        ++TokenIndex; // ")"̎
    }
    else{
        PrintError(__FILE__, __LINE__, "sizeof()̊ʓ̌^͂ɎsB", "̂ƂAPȃP[X݂̂ɑΉB", "");
        return P3CC_NG;
        //if(ExpressionPreFix(&MyRet, &MyVCodeListHeader, __LINE__) == P3CC_NG){PrintError(__FILE__, __LINE__, "sizeof()̊ʓ̌^͂Ɏs", "", ""); return P3CC_NG; }
        //*Size = ExpressionResultSizeGet(&(MyRet.TypeInfo));
        //VertualCodeListFree(&MyVCodeListHeader);
    }

    ExpressionDebugMsg(NULL, "ExpressionSizeof", EXPRESSION_END, Line);
    return P3CC_OK;
}
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// R[h̍œK
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//====================================================================================================================
static int FunctionOptimize(vertual_code_list_header *RootVCodeListHeader)
//====================================================================================================================
// [@\] ֐Pʂł̍œK
// [] vertual_code_list_header *VCodeListHeader FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         NumOfVCodeBefore;
    int                         NumOfVCodeAfter;
    int                         NumOfUsedVRegBefore;
    int                         NumOfUsedVRegAfter;
    int                         MaxRegNo;
    vertual_reg_list            *VRegListBrfore;
    vertual_reg_list            *VRegListAfter;
#ifdef LEAF_FUNCTION_OPTIMAIZE
    int                         Leaf;       // NOT_LEAF_FUNC:[t֐łȂALEAF_FUNCF[t֐
    int                         NumOfVarOnReg; // WX^Ɋ蓖Ăϐ̌
#endif

#ifdef VAR_ON_REG_ENABLE
    vertual_code_list_header    MyVCodeListHeader;
#endif

    if(RootVCodeListHeader->Entry == NULL){
        if(RootVCodeListHeader->Last == NULL) return P3CC_OK;
        else{
            PrintError(__FILE__, __LINE__, "RpC̃oOB", "", "");
            return P3CC_NG;
        }
    }

    FunctionOptimizeDebugMsg("FunctionOptimize", OPTIMIZE_START);

    VRegListBrfore = NULL;
    VRegListAfter = NULL;
    if(ExpressionOptiUsedVRegListGet(&VRegListBrfore, &NumOfUsedVRegBefore, &NumOfVCodeBefore, RootVCodeListHeader->Entry, RootVCodeListHeader->Last) == P3CC_NG){
        PrintError(__FILE__, __LINE__, "", "", "");
        return P3CC_NG;
    }
    if(FunctionOptimizeDebugFlag){
        fprintf(LogFile, "\n------------ y֐Ŝ̍œKOz ------------\n");
        PrintVertualCodeList(RootVCodeListHeader->Entry);
        fprintf(LogFile, "ԃR[hXebvF%d\n", NumOfVCodeBefore);
        fprintf(LogFile, "gpWX^@@@F%d\n", NumOfUsedVRegBefore);
        if(VRegListBrfore != NULL) PrintVertualRegList(VRegListBrfore);
    }
    
    if(EnableRemoveNop == P3CC_TRUE){
        if(FunctionOptimizeRemoveNop(RootVCodeListHeader) == P3CC_NG) return P3CC_NG;
        if(FunctionOptimizeDebugFlag){
            if(ExpressionOptiUsedVRegListGet(&VRegListAfter, &NumOfUsedVRegAfter, &NumOfVCodeAfter,RootVCodeListHeader->Entry, RootVCodeListHeader->Last) == P3CC_NG){
                PrintError(__FILE__, __LINE__, "", "", "");
                return P3CC_NG;
            }
            fprintf(LogFile, "\n------------ y֐Ŝ̍œK(NOP)z ------------\n");
            //PrintVertualCodeList(RootVCodeListHeader->Entry);
            fprintf(LogFile, "ԃR[hXebvF%d\n", NumOfVCodeAfter);
            fprintf(LogFile, "gpWX^@@@F%d\n", NumOfUsedVRegAfter);
            if(VRegListAfter != NULL){  PrintVertualRegList(VRegListAfter); ExpressionOptiVRegListFree(&VRegListAfter); VRegListAfter = NULL; }
        }
    }
#ifdef OPTIMAIZE_BRANCH_ENABLE
    EnableBranchOptimaize = P3CC_TRUE;
#else
    EnableBranchOptimaize = P3CC_FALSE;
#endif

    if(EnableBranchOptimaize == P3CC_TRUE){
        if(FunctionOptimizeBranch(RootVCodeListHeader) == P3CC_NG) return P3CC_NG;
        if(FunctionOptimizeDebugFlag){
            if(ExpressionOptiUsedVRegListGet(&VRegListAfter, &NumOfUsedVRegAfter, &NumOfVCodeAfter,RootVCodeListHeader->Entry, RootVCodeListHeader->Last) == P3CC_NG){
                PrintError(__FILE__, __LINE__, "", "", "");
                return P3CC_NG;
            }
            fprintf(LogFile, "\n------------ y֐Ŝ̍œK()z ------------\n");
            //PrintVertualCodeList(RootVCodeListHeader->Entry);
            fprintf(LogFile, "ԃR[hXebvF%d\n", NumOfVCodeAfter);
            fprintf(LogFile, "gpWX^@@@F%d\n", NumOfUsedVRegAfter);
            if(VRegListAfter != NULL){  PrintVertualRegList(VRegListAfter); ExpressionOptiVRegListFree(&VRegListAfter); VRegListAfter = NULL; }
        }
    }
    
    // ֐ĂяoWX^ԐڂAPCΑlwɕύX\ȃP[X́APCΑlwɕύX悤ɍœK
    FunctionOptimizeCall(RootVCodeListHeader);
    if(EnableRemoveNop == P3CC_TRUE){
        if(FunctionOptimizeRemoveNop(RootVCodeListHeader) == P3CC_NG) return P3CC_NG;
    }
    
    // gp̈ӖȂR[h(œK̎c[)폜
    if(FunctionOptiRemoveDisuseCode(RootVCodeListHeader) == P3CC_NG) return P3CC_NG;

    // returnɁAŊ֐o(WX^A̓)փWv閽߂}̂ŁAsvȏꍇč폜
    if(FunctionOptimizeRemoveLastJump(RootVCodeListHeader) == P3CC_NG) return P3CC_NG;

    // gpWX^No𐮗
    if(FunctionOptiTrimRegNo(RootVCodeListHeader) == P3CC_NG) return P3CC_NG;


    if(ExpressionOptiUsedVRegListGet(&VRegListAfter, &NumOfUsedVRegAfter, &NumOfVCodeAfter,RootVCodeListHeader->Entry, RootVCodeListHeader->Last) == P3CC_NG){
        PrintError(__FILE__, __LINE__, "", "", "");
        return P3CC_NG;
    }
    if(VRegListAfter != NULL){//gpWX^
        MaxRegNo = FunctionOptimizeMaxRegNoGet(VRegListAfter); //Ԑ̑傫REGT[`
        if(NumOfUsedVRegAfter != MaxRegNo){ //ėpWX^r1gĂ̂ŁAgpWX^ƍő僌WX^No͓ɂȂBoO
            PrintError(__FILE__, __LINE__, "RpC̃oOB", "", "");
            PrintVertualRegList(VRegListAfter);
            return P3CC_NG;
        }
        CurrentFuncInfo->MaxNumOfUsedVReg = MaxRegNo;
    }
    else{//gpWX^Ȃ
        CurrentFuncInfo->MaxNumOfUsedVReg = 0;
    }
    
    if(FunctionOptimizeDebugFlag){
        fprintf(LogFile, "\n------------ y֐Ŝ̍œK(ϐ̃WX^ւ̊蓖đO)z ------------\n");
        //PrintVertualCodeList(RootVCodeListHeader->Entry);
        fprintf(LogFile, "ԃR[hXebvF%d\n", NumOfVCodeAfter);
        fprintf(LogFile, "gpWX^@@@F%d\n", NumOfUsedVRegAfter);
        if(VRegListAfter != NULL){  PrintVertualRegList(VRegListAfter); ExpressionOptiVRegListFree(&VRegListAfter); VRegListAfter = NULL; }
    }

#ifdef VAR_ON_REG_ENABLE
    //======== ϐWX^Ɋ蓖ĂœK ===============
    FunctionOptiVariableOptiInfoGet(CurrentFuncInfo->ArgList, RootVCodeListHeader);
    FunctionOptiVariableOptiInfoGet(CurrentFuncInfo->VariableList, RootVCodeListHeader);
    FunctionOptiSelectVarOnReg(CurrentFuncInfo);
    
    FunctionOptiVar2Reg(CurrentFuncInfo, RootVCodeListHeader);
    
    VCodeListHeaderInit(&MyVCodeListHeader);
    if(FunctionOptiCopyArg2Reg(CurrentFuncInfo, &MyVCodeListHeader) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    if(VertualCodeListConnect(&MyVCodeListHeader, RootVCodeListHeader) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    *RootVCodeListHeader = MyVCodeListHeader;

#ifdef LEAF_FUNCTION_OPTIMAIZE
    //======== [t֐̏ꍇ́AXNb`WX^Lp悤ɍœK ===============
    if(FunctionOptiUsedRegTblSet(CurrentFuncInfo, RootVCodeListHeader->Entry) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }; //gpς݃WX^
    Leaf = FunctionLeafCheck(RootVCodeListHeader); // [t
    if((Leaf == LEAF_FUNC) && (CurrentFuncInfo->NumOfVarOnReg > 0) && (CurrentFuncInfo->NumOfUsedScratchReg < NUM_OF_SCRATCH_REG)){
        if(FunctionOptiLeafFunc(CurrentFuncInfo, RootVCodeListHeader) == P3CC_NG){ PrintError(__FILE__, __LINE__, "[t֐̃WX^usB", "", ""); return P3CC_NG; };
    }
#endif

    if(ExpressionOptiUsedVRegListGet(&VRegListAfter, &NumOfUsedVRegAfter, &NumOfVCodeAfter,RootVCodeListHeader->Entry, RootVCodeListHeader->Last) == P3CC_NG){
        PrintError(__FILE__, __LINE__, "", "", "");
        return P3CC_NG;
    }

    if(FunctionOptimizeDebugFlag){
        fprintf(LogFile, "\n------------ y֐Ŝ̍œK(ϐ̃WX^ւ̊蓖Č)z ------------\n");
        //PrintVertualCodeList(RootVCodeListHeader->Entry);
        fprintf(LogFile, "ԃR[hXebvF%d\n", NumOfVCodeAfter);
        fprintf(LogFile, "gpWX^@@@F%d\n", NumOfUsedVRegAfter);
        if(VRegListAfter != NULL){  PrintVertualRegList(VRegListAfter); ExpressionOptiVRegListFree(&VRegListAfter); VRegListAfter = NULL; }
    }

#endif

    if(EnableRemoveNop == P3CC_TRUE){
        if(FunctionOptimizeRemoveNop(RootVCodeListHeader) == P3CC_NG) return P3CC_NG;
        if(FunctionOptimizeDebugFlag){
            if(ExpressionOptiUsedVRegListGet(&VRegListAfter, &NumOfUsedVRegAfter, &NumOfVCodeAfter,RootVCodeListHeader->Entry, RootVCodeListHeader->Last) == P3CC_NG){
                PrintError(__FILE__, __LINE__, "", "", "");
                return P3CC_NG;
            }
            fprintf(LogFile, "\n------------ y֐Ŝ̍œK(NOP(2))z ------------\n");
            //PrintVertualCodeList(RootVCodeListHeader->Entry);
            fprintf(LogFile, "ԃR[hXebvF%d\n", NumOfVCodeAfter);
            fprintf(LogFile, "gpWX^@@@F%d\n", NumOfUsedVRegAfter);
            if(VRegListAfter != NULL){  PrintVertualRegList(VRegListAfter); ExpressionOptiVRegListFree(&VRegListAfter); VRegListAfter = NULL; }
        }
    }
    
#ifdef USE_MOVLI_FOR_LOGICAL_RESULT
    // WX^̍œKîPj
    if(FunctionOptimizeMovr(RootVCodeListHeader) == P3CC_NG) return P3CC_NG;
#endif

#ifdef REMOVE_NO_USED_RETURN
    // WX^̍œKîQj
    if(FunctionOptimizeMovr2(RootVCodeListHeader) == P3CC_NG) return P3CC_NG;
#endif

    // JP߂̔ѐ悪JP߂̏ꍇ́AڂJP߂̔ѐAJP߂̔ѐ֕ύXœK
    FunctionOptimizeBranch2(RootVCodeListHeader);

    // 璷ȃp^[œK
    FunctionOptimizeBranch3(RootVCodeListHeader);

#ifdef NOUSE_REG_OFFSET_LDST
    FunctionOptimizeTest001(RootVCodeListHeader);
#endif

    // ֐R[ÕXNb`WX^ޔ
    if(FunctionOptimizeEscapeReg(RootVCodeListHeader) == P3CC_NG) return P3CC_NG;

    if(FunctionOptimizeDebugFlag){
        if(ExpressionOptiUsedVRegListGet(&VRegListAfter, &NumOfUsedVRegAfter, &NumOfVCodeAfter,RootVCodeListHeader->Entry, RootVCodeListHeader->Last) == P3CC_NG){
            PrintError(__FILE__, __LINE__, "", "", "");
            return P3CC_NG;
        }
        fprintf(LogFile, "\n------------ y֐Ŝ̍œK(SĂ̍œK)z ------------\n");
        PrintVertualCodeList(RootVCodeListHeader->Entry);
        fprintf(LogFile, "ԃR[hXebvF%d\n", NumOfVCodeAfter);
        fprintf(LogFile, "gpWX^@@@F%d\n", NumOfUsedVRegAfter);
        if(VRegListAfter != NULL){  PrintVertualRegList(VRegListAfter); ExpressionOptiVRegListFree(&VRegListAfter); VRegListAfter = NULL; }
    }

    //gpς݃WX^Č㑱ׂ̏̈Ƀe[u쐬
    if(FunctionOptiUsedRegTblSet(CurrentFuncInfo, RootVCodeListHeader->Entry) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }; //gpς݃WX^

    if(VRegListBrfore != NULL) ExpressionOptiVRegListFree(&VRegListBrfore);
    if(VRegListAfter  != NULL) ExpressionOptiVRegListFree(&VRegListAfter);

    FunctionOptimizeDebugMsg("FunctionOptimize", OPTIMIZE_END);

    return P3CC_OK;
}
//====================================================================================================================
static int FunctionOptiLeafFuncSub(function *f, int RegNoOrg, int RegNoNew)
//====================================================================================================================
// [@\] ϐɕt^ꂽWX^No̒u
// [] function *f
// [Ԓl] P3CC_OK/P3CC_NG
{
    variable                *arg;
    variable                *local;

    arg = f->ArgList;
    while(1){
        if(arg == NULL) break;
        if((arg->OptiInfo.RegEna == REG_ENA) && (arg->OptiInfo.RegNo == RegNoOrg)){
            arg->OptiInfo.RegNo = RegNoNew;
            return P3CC_OK;
        }
        arg = arg->Next;
    }
    local = f->VariableList;
    while(1){
        if(local == NULL) break;
        if((local->OptiInfo.RegEna == REG_ENA) && (local->OptiInfo.RegNo == RegNoOrg)){
            local->OptiInfo.RegNo = RegNoNew;
            break;
        }
        local = local->Next;
    }
    return P3CC_OK;
}

//====================================================================================================================
static int FunctionOptiLeafFunc(function *f, vertual_code_list_header *RootVCodeListHeader)
//====================================================================================================================
// [@\] [t֐ŁAXNb`WX^ɗ]Tꍇ́AȂׂXNb`WX^ɕϐ
//        蓖Ă悤ɍœK
// [] function *f
// [Ԓl] P3CC_OK/P3CC_NG
{
    int             i, j;
    char            ScratchRegTbl[NUM_OF_SCRATCH_REG + 1]; // XNb`WX^Noƒu郌WX^NȏΉ\

    for(i=1; i < NUM_OF_SCRATCH_REG + 1; i++){
        if(f->UsedRegTbl[i] != 0) ScratchRegTbl[i] = i; // indexƊi[lȂus
        else                      ScratchRegTbl[i] = 0; // i[l0Ȃu
    }

    for(j=NUM_OF_SCRATCH_REG + 1; j < NUM_OF_VER_ON_REG + NUM_OF_SCRATCH_REG + 1; j++){
        if(f->UsedRegTbl[j] != 0){
            for(i = 1; i < NUM_OF_SCRATCH_REG + 1; i++){
                if(ScratchRegTbl[i] == 0){
                    ScratchRegTbl[i] = j; // j=uΏRegNo
                    break;
                }
            }
        }
    }

    for(i=1; i < NUM_OF_SCRATCH_REG + 1; i++){
        if((ScratchRegTbl[i] != 0) && (ScratchRegTbl[i] != i)){
            FunctionOptiReplaceRegNo(ScratchRegTbl[i], i, RootVCodeListHeader); // WX^Nou
            FunctionOptiLeafFuncSub(f, ScratchRegTbl[i], i);
        }
    }
    
    return P3CC_OK;
}
//====================================================================================================================
static int FunctionOptiUsedRegTblSet(function *f, vertual_code *VCode)
//====================================================================================================================
// [@\] gpς݃WX^e[u쐬
// [] function *f
// [] vertual_code *VCode
// [Ԓl] P3CC_OK
{
    int             i;
    int             Num;

    for(i = 0; i < NUM_OF_VER_ON_REG + NUM_OF_SCRATCH_REG + 1; i++){
        f->UsedRegTbl[i] = 0;
    }
    
    while(1){
        if(VCode == NULL) break;
        if(VCode->OpCode.Type == OPECODE_TYPE_JP){
            if(VCode->OpRand1.Type == OPERAND_TYPE_GPR){
                if((VCode->OpRand1.ValueInfo.RegNo > 0) && (VCode->OpRand1.ValueInfo.RegNo < NUM_OF_VER_ON_REG + NUM_OF_SCRATCH_REG + 1)){
                    f->UsedRegTbl[VCode->OpRand1.ValueInfo.RegNo] = 1;
                }
                else{
                    if(VCode->OpRand0.ValueInfo.RegNo != 0){
                        PrintError(__FILE__, __LINE__, "WX^蓖ĎsB", "", "");
                        return P3CC_NG;
                    }
                }
            }
        }
        if((VCode->OpCode.Type == OPECODE_TYPE_LD) || (VCode->OpCode.Type == OPECODE_TYPE_OP) || (VCode->OpCode.Type == OPECODE_TYPE_ST)){
            if(VCode->OpRand0.Type == OPERAND_TYPE_GPR){
                if((VCode->OpRand0.ValueInfo.RegNo > 0) && (VCode->OpRand0.ValueInfo.RegNo < NUM_OF_VER_ON_REG + NUM_OF_SCRATCH_REG + 1)){
                    f->UsedRegTbl[VCode->OpRand0.ValueInfo.RegNo] = 1;
                }
                else{
                    if(VCode->OpRand0.ValueInfo.RegNo != 0){
                        PrintError(__FILE__, __LINE__, "WX^蓖ĎsB", "", "");
                        return P3CC_NG;
                    }
                }
            }
            if(VCode->OpRand1.Type == OPERAND_TYPE_GPR){
                if((VCode->OpRand1.ValueInfo.RegNo > 0) && (VCode->OpRand1.ValueInfo.RegNo < NUM_OF_VER_ON_REG + NUM_OF_SCRATCH_REG + 1)){
                    f->UsedRegTbl[VCode->OpRand1.ValueInfo.RegNo] = 1;
                }
                else{
                    if(VCode->OpRand2.ValueInfo.RegNo != 0){
                        PrintError(__FILE__, __LINE__, "WX^蓖ĎsB", "", "");
                        return P3CC_NG;
                    }
                }
            }
            if(VCode->OpRand2.Type == OPERAND_TYPE_GPR){
                if((VCode->OpRand2.ValueInfo.RegNo > 0) && (VCode->OpRand2.ValueInfo.RegNo < NUM_OF_VER_ON_REG + NUM_OF_SCRATCH_REG + 1)){
                    f->UsedRegTbl[VCode->OpRand2.ValueInfo.RegNo] = 1;
                }
                else{
                    if(VCode->OpRand2.ValueInfo.RegNo != 0){
                        PrintError(__FILE__, __LINE__, "WX^蓖ĎsB", "", "");
                        return P3CC_NG;
                    }
                }
            }
        }
        VCode = VCode->Next;
    }
    Num = 0;
    for(i = 0; i < NUM_OF_VER_ON_REG + NUM_OF_SCRATCH_REG + 1; i++){
        if(f->UsedRegTbl[i] != 0) ++Num;
    }
    f->MaxNumOfUsedVReg = Num;

    Num = 0;
    for(i = 0; i < NUM_OF_SCRATCH_REG + 1; i++){
        if(f->UsedRegTbl[i] != 0) ++Num;
    }
    f->NumOfUsedScratchReg = Num;

    Num = 0;
    for(i = NUM_OF_SCRATCH_REG + 1; i < NUM_OF_VER_ON_REG + NUM_OF_SCRATCH_REG + 1; i++){
        if(f->UsedRegTbl[i] != 0) ++Num;
    }
    f->NumOfVarOnReg = Num;
    
    return P3CC_OK;
}
//====================================================================================================================
static int FunctionOptiVar2RegSub2(vertual_code *VCode, int BeforeRegNo, int AfterRegNo)
//====================================================================================================================
// [@\] VCodeȍ~̃R[hŁABeforeRegNoQƂĂ̂AAfterRegNoQƂ悤ɒu
// [] vertual_code *VCode
// [] int BeforeRegNo
// [] int AfterRegNo
// [Ԓl] P3CC_OK
{
    while(1){
        if(VCode == NULL) break;
        if(VCode->OpCode.Type == OPECODE_TYPE_LD){ // LOAD
            if((VCode->OpRand1.Type == OPERAND_TYPE_GPR) && (VCode->OpRand1.ValueInfo.RegNo == BeforeRegNo)){
                VCode->OpRand1.ValueInfo.RegNo = AfterRegNo;
            }
            if((VCode->OpRand2.Type == OPERAND_TYPE_GPR) && (VCode->OpRand2.ValueInfo.RegNo == BeforeRegNo)){
                VCode->OpRand2.ValueInfo.RegNo = AfterRegNo;
            }
            if((VCode->OpRand0.Type == OPERAND_TYPE_GPR) && (VCode->OpRand0.ValueInfo.RegNo == BeforeRegNo)){
                break; // BeforeRegNo̒lꂽ
            }
        }
        if(VCode->OpCode.Type == OPECODE_TYPE_OP){ // CALC
            if((VCode->OpRand1.Type == OPERAND_TYPE_GPR) && (VCode->OpRand1.ValueInfo.RegNo == BeforeRegNo)){
                VCode->OpRand1.ValueInfo.RegNo = AfterRegNo;
            }
            if((VCode->OpRand2.Type == OPERAND_TYPE_GPR) && (VCode->OpRand2.ValueInfo.RegNo == BeforeRegNo)){
                VCode->OpRand2.ValueInfo.RegNo = AfterRegNo;
            }
            if((VCode->OpRand0.Type == OPERAND_TYPE_GPR) && (VCode->OpRand0.ValueInfo.RegNo == BeforeRegNo)){
                break; // BeforeRegNo̒lꂽ
            }
        }
        if(VCode->OpCode.Type == OPECODE_TYPE_ST){ // STORE
            if((VCode->OpRand0.Type == OPERAND_TYPE_GPR) && (VCode->OpRand0.ValueInfo.RegNo == BeforeRegNo)){
                VCode->OpRand0.ValueInfo.RegNo = AfterRegNo;
            }
            if((VCode->OpRand1.Type == OPERAND_TYPE_GPR) && (VCode->OpRand1.ValueInfo.RegNo == BeforeRegNo)){
                VCode->OpRand1.ValueInfo.RegNo = AfterRegNo;
            }
            if((VCode->OpRand2.Type == OPERAND_TYPE_GPR) && (VCode->OpRand2.ValueInfo.RegNo == BeforeRegNo)){
                VCode->OpRand2.ValueInfo.RegNo = AfterRegNo;
            }
        }
        if(VCode->OpCode.Type == OPECODE_TYPE_JP){ // JUMP
            if((VCode->OpRand1.Type == OPERAND_TYPE_GPR) && (VCode->OpRand1.ValueInfo.RegNo == BeforeRegNo)){
                VCode->OpRand1.ValueInfo.RegNo = AfterRegNo;
            }
        }
        VCode = VCode->Next;
    }
    return P3CC_OK;
}
//====================================================================================================================
static int FunctionOptiVar2RegSub(variable *v, vertual_code_list_header *RootVCodeListHeader)
//====================================================================================================================
// [@\] WX^ɒuϐQƂR[hu
// [] function *f
// [] variable *v
// [Ԓl] LQ
{
    vertual_code    *VCode;
    vertual_code    *NextVCode;
    vertual_code    *PrevVCode;
    vertual_code    NewVCode;
    value_info      vi;
    int             LabelNo;
    int             DstReg;
    int             SrcReg;
    
    VCode = RootVCodeListHeader->Entry;
    while(1){
        if(VCode == NULL) break;
        NextVCode = VCode->Next;
        if(((VCode->OpCode.Type == OPECODE_TYPE_LD) || (VCode->OpCode.Type == OPECODE_TYPE_ST)) && (VCode->OpRand0.Type == OPERAND_TYPE_GPR)
        && (VCode->OpRand1.Type == OPERAND_TYPE_SPR) && (VCode->OpRand1.ValueInfo.RegNo == SPR_FP)
        && (VCode->OpRand2.Type == OPERAND_TYPE_VARIABLE) && (VCode->OpRand2.ValueInfo.var == v)){
            if(VCode->OpCode.Type == OPECODE_TYPE_LD){
                DstReg = VCode->OpRand0.ValueInfo.RegNo;
                if((VCode->OptimaizationHint.Copy == COPY_FOR_POSTFIX_EXPR)
                || ((DstReg > NUM_OF_SCRATCH_REG) &&  (DstReg <= (NUM_OF_SCRATCH_REG + NUM_OF_VER_ON_REG)))){
                    // MOVɒu
                    vi.RegNo = v->OptiInfo.RegNo;
                    VCodeGen_Operation(&NewVCode, PLABEL_NON, OPECODE_MOV_R,  RET_IS_GPR,DstReg, ARG_IS_NOTING,0,  ARG_IS_GPR,&vi, 0, 0);
                    VCode->OpCode = NewVCode.OpCode;
                    VCode->OpRand0 = NewVCode.OpRand0;
                    VCode->OpRand1 = NewVCode.OpRand1;
                    VCode->OpRand2 = NewVCode.OpRand2;
                }
                else{
                    VCodeGen_Nop(&NewVCode, PLABEL_NON, 0,0);
                    //ȍ~̖߂̎QƂ
fprintf(LogFile, "\n********** y֐Ŝ̍œK(ϐ̃WX^ւ̊蓖(WX^uO) R%d -> R%dz **********\n", DstReg, v->OptiInfo.RegNo);
PrintVertualCodeList(RootVCodeListHeader->Entry);
                    FunctionOptiVar2RegSub2(VCode->Next, DstReg, v->OptiInfo.RegNo);
fprintf(LogFile, "\n********** y֐Ŝ̍œK(ϐ̃WX^ւ̊蓖(WX^u) R%d -> R%dz **********\n", DstReg, v->OptiInfo.RegNo);
PrintVertualCodeList(RootVCodeListHeader->Entry);
fprintf(LogFile, "********** y R%d -> R%dz **********\n", DstReg, v->OptiInfo.RegNo);
PrintVertualCodeList(VCode->Next);

                    if(VCode->LabelNo == PLABEL_NON){//x
                        if((VCode->Prev == NULL) && (VCode->Next == NULL)){
                            // NOPɒu
                            VCode->OpCode = NewVCode.OpCode;
                            VCode->OpRand0 = NewVCode.OpRand0;
                            VCode->OpRand1 = NewVCode.OpRand1;
                            VCode->OpRand2 = NewVCode.OpRand2;
                        }
                        else if((VCode->Prev == NULL) && (VCode->Next != NULL)){ 
                            RootVCodeListHeader->Entry = VCode->Next;
                            VCode->Next->Prev = NULL;
                            free(VCode);
                        }
                        else if((VCode->Prev != NULL) && (VCode->Next == NULL)){
                            RootVCodeListHeader->Last  = VCode->Prev;
                            VCode->Prev->Next = NULL;
                            free(VCode);
                        }
                        else{
                            VCode->Prev->Next = VCode->Next;
                            VCode->Next->Prev = VCode->Prev;
                            free(VCode);
                        }
                    }
                    else{//xt
                        // NOPɒu
                        VCode->OpCode = NewVCode.OpCode;
                        VCode->OpRand0 = NewVCode.OpRand0;
                        VCode->OpRand1 = NewVCode.OpRand1;
                        VCode->OpRand2 = NewVCode.OpRand2;
                    }
                }
            }
            else{//(VCode->OpCode.Type == OPECODE_TYPE_ST)
                SrcReg = VCode->OpRand0.ValueInfo.RegNo;
                PrevVCode = VCode->Prev;
                // O̖߂ A̖߂Z߁AA̖߂̌ʊi[悪AXgA߂̃\[X
                if((PrevVCode != NULL) && (PrevVCode->OpCode.Type == OPECODE_TYPE_OP) && (PrevVCode->OptimaizationHint.Copy != COPY_FOR_POSTFIX_EXPR)
                && (PrevVCode->OpRand0.Type == OPERAND_TYPE_GPR) && (PrevVCode->OpRand0.ValueInfo.RegNo == SrcReg)){
/*
fprintf(LogFile, "\n********** y֐Ŝ̍œK(ϐ̃WX^ւ̊蓖(WX^uO) R%d -> R%dz **********\n", SrcReg, v->OptiInfo.RegNo );
PrintVertualCodeList(RootVCodeListHeader->Entry);
                    FunctionOptiVar2RegSub2(VCode->Next, SrcReg, v->OptiInfo.RegNo);
fprintf(LogFile, "\n********** y֐Ŝ̍œK(ϐ̃WX^ւ̊蓖(WX^u) R%d -> R%dz **********\n", SrcReg, v->OptiInfo.RegNo);
PrintVertualCodeList(RootVCodeListHeader->Entry);
fprintf(LogFile, "********** y R%d -> R%dz **********\n", SrcReg, v->OptiInfo.RegNo);
PrintVertualCodeList(VCode->Next);
*/
                    if((((PrevVCode->OpCode.Code == OPECODE_MOV_I) || (PrevVCode->OpCode.Code == OPECODE_MOVL_I)) 
                    && ((PrevVCode->OpRand2.ValueInfo.NumLiteral == 0) || (PrevVCode->OpRand2.ValueInfo.NumLiteral == 1))) // MOVIߊAl01Ȃ
                    || ((SrcReg > NUM_OF_SCRATCH_REG) &&  (SrcReg <= (NUM_OF_SCRATCH_REG + NUM_OF_VER_ON_REG)))){
                        // MOVɒu
                        DstReg = v->OptiInfo.RegNo;
                        vi.RegNo = SrcReg;
                        VCodeGen_Operation(&NewVCode, PLABEL_NON, OPECODE_MOV_R,  RET_IS_GPR,DstReg, ARG_IS_NOTING,0,  ARG_IS_GPR,&vi, 0, 0);
                        VCode->OpCode = NewVCode.OpCode;
                        VCode->OpRand0 = NewVCode.OpRand0;
                        VCode->OpRand1 = NewVCode.OpRand1;
                        VCode->OpRand2 = NewVCode.OpRand2;
                    }
                    else{
                        //ỎZ߂̌ʊi[
                        PrevVCode->OpRand0.ValueInfo.RegNo = v->OptiInfo.RegNo;
                    
                        VCodeGen_Nop(&NewVCode, PLABEL_NON, 0,0);
                        if(VCode->LabelNo == PLABEL_NON){//x
                            if((VCode->Prev == NULL) && (VCode->Next == NULL)){
                                // NOPɒu
                                VCode->OpCode = NewVCode.OpCode;
                                VCode->OpRand0 = NewVCode.OpRand0;
                                VCode->OpRand1 = NewVCode.OpRand1;
                                VCode->OpRand2 = NewVCode.OpRand2;
                            }
                            else if((VCode->Prev == NULL) && (VCode->Next != NULL)){ 
                                RootVCodeListHeader->Entry = VCode->Next;
                                VCode->Next->Prev = NULL;
                                free(VCode);
                            }
                            else if((VCode->Prev != NULL) && (VCode->Next == NULL)){
                                RootVCodeListHeader->Last  = VCode->Prev;
                                VCode->Prev->Next = NULL;
                                free(VCode);
                            }
                            else{
                                VCode->Prev->Next = VCode->Next;
                                VCode->Next->Prev = VCode->Prev;
                                free(VCode);
                            }
                        }
                        else{//xt
                            // NOPɒu
                            VCode->OpCode = NewVCode.OpCode;
                            VCode->OpRand0 = NewVCode.OpRand0;
                            VCode->OpRand1 = NewVCode.OpRand1;
                            VCode->OpRand2 = NewVCode.OpRand2;
                        }
                    }
                }
                else{
                    // MOVɒu
                    DstReg = v->OptiInfo.RegNo;
                    vi.RegNo = SrcReg;
                    VCodeGen_Operation(&NewVCode, PLABEL_NON, OPECODE_MOV_R,  RET_IS_GPR,DstReg, ARG_IS_NOTING,0,  ARG_IS_GPR,&vi, 0, 0);
                    VCode->OpCode = NewVCode.OpCode;
                    VCode->OpRand0 = NewVCode.OpRand0;
                    VCode->OpRand1 = NewVCode.OpRand1;
                    VCode->OpRand2 = NewVCode.OpRand2;
                }
            }
        }
        VCode = NextVCode;
    }
    return P3CC_OK;
}
//====================================================================================================================
static int FunctionOptiVar2Reg(function *f, vertual_code_list_header *RootVCodeListHeader)
//====================================================================================================================
// [@\] WX^ɒuϐQƂR[hu
// [] function *f
// [Ԓl] P3CC_OK/P3CC_NG
{
    variable                *arg;
    variable                *local;

    arg = f->ArgList;
    while(1){
        if(arg == NULL) break;
        if((arg->OptiInfo.RegEna == REG_ENA) && (arg->OptiInfo.RegNo != 0)){
            FunctionOptiVar2RegSub(arg, RootVCodeListHeader);
        }
        arg = arg->Next;
    }
    local = f->VariableList;
    while(1){
        if(local == NULL) break;
        if((local->OptiInfo.RegEna == REG_ENA) && (local->OptiInfo.RegNo != 0)){
            FunctionOptiVar2RegSub(local, RootVCodeListHeader);
        }
        local = local->Next;
    }
    return P3CC_OK;
}
//====================================================================================================================
static int FunctionOptiCopyArg2Reg(function *f, vertual_code_list_header *MyVCodeListHeader)
//====================================================================================================================
// [@\] WX^ɒuWX^ɃRs[R[h𐶐
// [] function *f
// [] vertual_code_list_header *MyVCodeListHeader
// [Ԓl] LQ
{
    vertual_code    VCode;
    value_info      vi;
    variable        *arg;
    int             RegNo;
    int             Size;
    int             Sign;
    int             SrcFileIndex;
    int             SrcFileLine;
    
    SrcFileIndex = f->SrcFileIndexOfFuncEntry;
    SrcFileLine = f->SrcFileLineOfFuncEntry;
    arg = f->ArgList;
    while(1){
        if(arg == NULL) break;
        if((arg->OptiInfo.RegEna == REG_ENA) && (arg->OptiInfo.RegNo != 0)){
            vi.var = arg;
            RegNo = arg->OptiInfo.RegNo;
            Size = arg->TypeSize;
            Sign = arg->Sign;
            VCodeGen_Load(&VCode, PLABEL_NON, Size, Sign, BASE_UPDATE_NO,  DST_IS_GPR,RegNo,  BASE_IS_SPR,SPR_FP,  OFFSET_IS_VAR,&vi,  SrcFileIndex, SrcFileLine);
            if(VertualCodeAdd(MyVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
        }
        arg = arg->Next;
    }
    return P3CC_OK;
}

//====================================================================================================================
static int FunctionOptiSelectVarOnRegSub(function  *f, variable *v)
//====================================================================================================================
// [@\] variable_refcount_table̒ŁAłRefCount̏Ȃoƒu
// [] function  *f              F֐
// [] int   FirstNoOfUseableReg Fgp\ȃe[uCfbNX̐擪
// [] int   variable            FrΏۂvariable
// [Ԓl] LQ
{
    int             i;
    unsigned long   RefCountMin;
    int             IndexMin;
    unsigned long   RefCount;
    
    RefCountMin = 0x7FFFFFFF;
    for(i = NUM_OF_SCRATCH_REG + 1; i < NUM_OF_SCRATCH_REG + NUM_OF_VER_ON_REG + 1; i++){
        if(f->RegVsVar.v[i] == NULL){
            RefCount = 0;
        }
        else{
            RefCount = f->RegVsVar.v[i]->OptiInfo.RefCount;
        }
        if(RefCount < RefCountMin){
            RefCountMin = RefCount;
            IndexMin = i;
        }
    }
    if(RefCountMin < v->OptiInfo.RefCount){
        f->RegVsVar.v[IndexMin] = v;
    }
    return P3CC_OK;
}
//====================================================================================================================
static int FunctionOptiSelectVarOnReg(function *f)
//====================================================================================================================
// [@\] WX^ɒuϐ肷
// [] function *f
// [Ԓl] LQ
{
    int                     i;
    variable                *arg;
    variable                *local;
    
    for(i = 0; i < NUM_OF_SCRATCH_REG + NUM_OF_VER_ON_REG + 1; i++){
        f->RegVsVar.v[i] = NULL;
    }
    arg = f->ArgList;
    while(1){
        if(arg == NULL) break;
        if(arg->OptiInfo.RegEna == REG_ENA){
            FunctionOptiSelectVarOnRegSub(f, arg);
        }
        arg = arg->Next;
    }
    local = f->VariableList;
    while(1){
        if(local == NULL) break;
        if(local->OptiInfo.RegEna == REG_ENA){
            FunctionOptiSelectVarOnRegSub(f, local);
        }
        local = local->Next;
    }

    for(i = NUM_OF_SCRATCH_REG + 1; i < NUM_OF_SCRATCH_REG + NUM_OF_VER_ON_REG + 1; i++){
        if(f->RegVsVar.v[i] != NULL){
            f->RegVsVar.v[i]->OptiInfo.RegNo = i;
        }
    }

    return P3CC_OK;
}
//====================================================================================================================
static int FunctionOptiVariableOptiInfoGet(variable *VList, vertual_code_list_header *RootVCodeListHeader)
//====================================================================================================================
// [@\] WX^ɒuϐ肷ׂ̏擾
// [] variable *VList
// [Ԓl] LQ
{
    vertual_code    *VCode;
    variable        *var;
    char            RegEna;         // REG_DIS/REG_ENA
    unsigned long   RefCount;       // QƉ񐔃JE^
    int             i;
    int             AddValue;
    var = VList;
    while(1){
        if(var == NULL) break;
        var->OptiInfo.RegEna = REG_DIS;
        var->OptiInfo.RegNo = 0;
        RefCount = 0;
        if(var->DimInfo == NULL){
            if(    ((var->Pointer != 0) || (var->TypeFunction !=0) || (var->FuncPointer != 0)) 
            || ((var->Type == TYPE_CHAR) || (var->Type == TYPE_SHORT) || (var->Type == TYPE_INT) || (var->Type == TYPE_LONG))){
                VCode = RootVCodeListHeader->Entry;
                while(1){
                    if(VCode == NULL){
                        RegEna = REG_ENA;
                        break;
                    }
                    if((VCode->OpCode.Type == OPECODE_TYPE_OP) && (VCode->OpRand1.Type == OPERAND_TYPE_SPR) && (VCode->OpRand1.ValueInfo.RegNo == SPR_FP) 
                    && (VCode->OpRand2.Type == OPERAND_TYPE_VARIABLE) && (VCode->OpRand2.ValueInfo.var == var)){
                        RegEna = REG_DIS;
                        break;
                    }
                    if((VCode->OpCode.Type == OPECODE_TYPE_LD) && (VCode->OpRand1.Type == OPERAND_TYPE_SPR) && (VCode->OpRand1.ValueInfo.RegNo == SPR_FP)
                    && (VCode->OpRand2.Type == OPERAND_TYPE_VARIABLE) && (VCode->OpRand2.ValueInfo.var == var)){
                        AddValue = 1;
                        for(i = 0; i < VCode->OptimaizationHint.LoopLevel; i++){
                            if(AddValue < (0x7FFFFFFF/10)){
                                AddValue = AddValue * 10;
                            }
                        }
                        if(RefCount < (0x7FFFFFFF/10)){
                            RefCount = RefCount + AddValue;
                        }
                    }
                    VCode = VCode->Next;
                }
            }
        }
        var->OptiInfo.RegEna = RegEna;
        var->OptiInfo.RefCount = RefCount;
        var = var->Next;
    }
    return P3CC_OK;
}

//====================================================================================================================
static int FunctionOptimizeMaxRegNoGet(vertual_reg_list *VRegList)
//====================================================================================================================
// [@\] gpĂėpWX^No̍őlԂBs0̐
// [] vertual_reg_list *VRegList
// [Ԓl] LQ
{
    vertual_reg_list *p;
    int              MaxRegNo;

    MaxRegNo = 0;
    p = VRegList;
    while(1){
        if(p == NULL) break;
        if(p->RegNo > MaxRegNo) MaxRegNo = p->RegNo;
        p = p->Next;
    }
    return MaxRegNo;
}
//====================================================================================================================
static int FunctionOptimizeRemoveLastJump(vertual_code_list_header *RootVCodeListHeader)
//====================================================================================================================
// [@\] ԍŌ̃R[hAjpi,     al,  PcOffsetOf(_@0001)ȂA폜
// [] vertual_code_list_header *VCodeListHeader FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         NumOfVCode;
    vertual_code                *VCode0;

    if(ExpressionOptiVCodeCount(&NumOfVCode, RootVCodeListHeader) == P3CC_NG){PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
    if(NumOfVCode < 2) return P3CC_OK;
    VCode0 = RootVCodeListHeader->Last;
    if(VCode0 == NULL) {PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
    if((VCode0->OpCode.Code == OPECODE_JP_I)
    && (VCode0->OpRand0.ValueInfo.Condition == COND_ALWAYS)
    && (VCode0->OpRand1.ValueInfo.LabelNo == PLABEL_FUNC_EXIT)){
        if(VCode0->Prev == NULL){PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
        if(VCode0->LabelNo == PLABEL_NON){
            RootVCodeListHeader->Last = VCode0->Prev;
            VCode0->Prev->Next = NULL;
            free(VCode0);
        }
        else{
            VCode0->OpCode.Type = OPECODE_TYPE_OTHER;
            VCode0->OpCode.Code = OPECODE_NOP;
            VCode0->OpRand0.Type = OPERAND_TYPE_NOTHING;
            VCode0->OpRand1.Type = OPERAND_TYPE_NOTHING;
            VCode0->OpRand2.Type = OPERAND_TYPE_NOTHING;
        }
    }
    return P3CC_OK;
}
//====================================================================================================================
static int FunctionOptimizeRemoveNop(vertual_code_list_header *RootVCodeListHeader)
//====================================================================================================================
// [@\] svNOP̍폜
// [] vertual_code_list_header *VCodeListHeader FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         NumOfVCodeBefore;
    int                         NumOfVCodeAfter;
    vertual_code                *VCode0;
    vertual_code                *VCode1;

    FunctionOptimizeDebugMsg("FunctionOptimizeRemoveNop", OPTIMIZE_START);

    while(1){
        if(ExpressionOptiVCodeCount(&NumOfVCodeBefore, RootVCodeListHeader) == P3CC_NG){PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
        if((RootVCodeListHeader->Entry != NULL) && (RootVCodeListHeader->Entry != RootVCodeListHeader->Last)){
            VCode0 = RootVCodeListHeader->Entry;
            while(1){
                if(VCode0 == NULL) break;
                VCode1 = VCode0->Next;
                if(VCode1 == NULL) break;
                if((VCode0->OpCode.Code == OPECODE_NOP) && (VCode1->OpCode.Code != OPECODE_NOP)){
                    if((VCode1->OpCode.Code == OPECODE_JP_I) && (VCode0->LabelNo == VCode1->OpRand1.ValueInfo.LabelNo)){
                        ;//̏ꃋ[vɂȂp^[łNOP폜Ȃ
                    }
                    else{
                        if((VCode0->LabelNo != PLABEL_NON) && (VCode1->LabelNo != PLABEL_NON)){
                            FunctionOptimizeChangeJumpTargetLabel(RootVCodeListHeader, VCode0->LabelNo, VCode1->LabelNo);
                        }
                        VCode1->LabelNo = VCode0->LabelNo;
                        VCode1->Prev = VCode0->Prev;
                        if(VCode0->Prev != NULL){
                            VCode0->Prev->Next = VCode1;
                        }
                        else{
                            RootVCodeListHeader->Entry = VCode1;
                        }
                        free(VCode0);
                        VCode0 = VCode1;
                    }
                }
                VCode0 = VCode0->Next;
            }
        }
        if(ExpressionOptiVCodeCount(&NumOfVCodeAfter, RootVCodeListHeader) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
        if(NumOfVCodeBefore == NumOfVCodeAfter) break;
    }

    FunctionOptimizeDebugMsg("FunctionOptimizeRemoveNop", OPTIMIZE_END);
    return P3CC_OK;
}
//====================================================================================================================
static unsigned long InverseCondisionCodeGet(unsigned long Condition)
//====================================================================================================================
// [@\] t̏R[hԂ
{
    if(Condition == COND_ALWAYS                   ) return COND_ALWAYS;
    if(Condition == COND_ZERO                     ) return COND_NOT_ZERO;
    if(Condition == COND_NOT_ZERO                 ) return COND_ZERO;
    if(Condition == COND_UNSIGNED_HIGHER_OR_SAME  ) return COND_UNSIGNED_LOWER;
    if(Condition == COND_UNSIGNED_LOWER           ) return COND_UNSIGNED_HIGHER_OR_SAME;
    if(Condition == COND_MINUS                    ) return COND_PLUS;
    if(Condition == COND_PLUS                     ) return COND_MINUS;
    if(Condition == COND_OVERFLOW                 ) return COND_NOT_OVERFLOW;
    if(Condition == COND_NOT_OVERFLOW             ) return COND_OVERFLOW;
    if(Condition == COND_UNSIGNED_HIGHER          ) return COND_UNSIGNED_LOWER_OR_SAME;
    if(Condition == COND_UNSIGNED_LOWER_OR_SAME   ) return COND_UNSIGNED_HIGHER;
    if(Condition == COND_SIGNED_GRATER_THAN_OR_EQ ) return COND_SIGNED_LESS_THAN;
    if(Condition == COND_SIGNED_LESS_THAN         ) return COND_SIGNED_GRATER_THAN_OR_EQ;
    if(Condition == COND_SIGNED_GRATER_THAN       ) return COND_SIGNED_LESS_THAN_OR_EQ;
    /*if(Condition == COND_SIGNED_LESS_THAN_OR_EQ   )*/ return COND_SIGNED_GRATER_THAN;
}

//====================================================================================================================
static int FunctionOptiCheckRegRefer(int RegNo, vertual_code *VCode)
//====================================================================================================================
// [@\] VCodeڍs̃R[hRegNoQƂĂ邩ۂ`FbN
// [] int RegNo@@@@@@FmFΏۂRegNo
// [] vertual_code *VCode@FmFΏۂ̃R[h̐擪
// [Ԓl] QƂĂP3CC_OKAȂP3CC_NG
{
    while(1){
        if(VCode == NULL) break;
        if(VCode->OpCode.Type == OPECODE_TYPE_JP){
            if((VCode->OpRand1.Type == OPERAND_TYPE_GPR) && (RegNo == VCode->OpRand1.ValueInfo.RegNo)) return P3CC_OK;
        }
        else if(VCode->OpCode.Type == OPECODE_TYPE_ST){
            if((VCode->OpRand0.Type == OPERAND_TYPE_GPR) && (RegNo == VCode->OpRand0.ValueInfo.RegNo)) return P3CC_OK;
            if((VCode->OpRand1.Type == OPERAND_TYPE_GPR) && (RegNo == VCode->OpRand1.ValueInfo.RegNo)) return P3CC_OK;
            if((VCode->OpRand2.Type == OPERAND_TYPE_GPR) && (RegNo == VCode->OpRand2.ValueInfo.RegNo)) return P3CC_OK;
        }
        else if((VCode->OpCode.Type == OPECODE_TYPE_LD) ||  (VCode->OpCode.Type == OPECODE_TYPE_OP)){
            if((VCode->OpRand1.Type == OPERAND_TYPE_GPR) && (RegNo == VCode->OpRand1.ValueInfo.RegNo)) return P3CC_OK;
            if((VCode->OpRand2.Type == OPERAND_TYPE_GPR) && (RegNo == VCode->OpRand2.ValueInfo.RegNo)) return P3CC_OK;
            if((VCode->OpRand0.Type == OPERAND_TYPE_GPR) && (RegNo == VCode->OpRand0.ValueInfo.RegNo)) return P3CC_NG;
        }
        else{
            ;
        }
        VCode = VCode->Next;
    }

    return P3CC_NG;
}
//====================================================================================================================
static int FunctionOptiReplaceRegNo(int RegNoOrg, int RegNoNew, vertual_code_list_header *RootVCodeListHeader)
//====================================================================================================================
// [@\] RegNoRegNoOrgRegNoNewɂ
// [] vertual_code_list_header *RootVCodeListHeader FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    vertual_code                *VCode;
    
    VCode = RootVCodeListHeader->Entry;
    while(1){
        if(VCode == NULL) break;
        if((VCode->OpRand0.Type == OPERAND_TYPE_GPR) && (VCode->OpRand0.ValueInfo.RegNo == RegNoOrg)) VCode->OpRand0.ValueInfo.RegNo = RegNoNew;
        if((VCode->OpRand1.Type == OPERAND_TYPE_GPR) && (VCode->OpRand1.ValueInfo.RegNo == RegNoOrg)) VCode->OpRand1.ValueInfo.RegNo = RegNoNew;
        if((VCode->OpRand2.Type == OPERAND_TYPE_GPR) && (VCode->OpRand2.ValueInfo.RegNo == RegNoOrg)) VCode->OpRand2.ValueInfo.RegNo = RegNoNew;
        VCode = VCode->Next;
    }
    return P3CC_OK;
}
//====================================================================================================================
static int FunctionOptiTrimRegNo(vertual_code_list_header *RootVCodeListHeader)
//====================================================================================================================
// [@\] RegNor1珇ɂ
// [] vertual_code_list_header *RootVCodeListHeader FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         NumOfVCode;
    int                         NumOfUsedVReg;
    vertual_reg_list            *VRegList;
    vertual_reg_list            *p;
    int                         NewRegNo;

    VRegList  = NULL;
    if(ExpressionOptiUsedVRegListGet(&VRegList, &NumOfUsedVReg, &NumOfVCode,RootVCodeListHeader->Entry, RootVCodeListHeader->Last) == P3CC_NG){
        PrintError(__FILE__, __LINE__, "", "", "");
        return P3CC_NG;
    }
    if(VRegList == NULL) return P3CC_OK;
    p = VRegList;
    while(1){
        if(p == NULL) break;
        FunctionOptiReplaceRegNo(p->RegNo, p->RegNo + 100, RootVCodeListHeader);
        p = p->Next;
    }
    NewRegNo = 1;
    p = VRegList;
    while(1){
        if(p == NULL) break;
        FunctionOptiReplaceRegNo(p->RegNo + 100, NewRegNo, RootVCodeListHeader);
        p = p->Next;
        ++NewRegNo;
    }
    return P3CC_OK;
}
//====================================================================================================================
static int FunctionUseLocalCheck(vertual_code_list_header *RootVCodeListHeader)
//====================================================================================================================
// [@\] ֐FPgĂ邩ǂ`FbN
// [] vertual_code_list_header *RootVCodeListHeader FR[hi[
// [Ԓl] 0:[t֐łȂA0ȊOF[t֐
{
    vertual_code                *VCode;
    
    VCode = RootVCodeListHeader->Entry;
    while(1){
        if(VCode == NULL) break;
        if((VCode->OpCode.Type == OPECODE_TYPE_JP) && (VCode->OpRand1.Type == OPERAND_TYPE_SPR) && (VCode->OpRand1.ValueInfo.RegNo == SPR_FP)){
            return USE_LOCAL_AND_ARG;
        }
        if((VCode->OpCode.Type == OPECODE_TYPE_LD) || (VCode->OpCode.Type == OPECODE_TYPE_ST) || (VCode->OpCode.Type == OPECODE_TYPE_OP)){
            if((VCode->OpRand0.Type == OPERAND_TYPE_SPR) && (VCode->OpRand0.ValueInfo.RegNo == SPR_FP)) return USE_LOCAL_AND_ARG;
            if((VCode->OpRand1.Type == OPERAND_TYPE_SPR) && (VCode->OpRand1.ValueInfo.RegNo == SPR_FP)) return USE_LOCAL_AND_ARG;
            if((VCode->OpRand2.Type == OPERAND_TYPE_SPR) && (VCode->OpRand2.ValueInfo.RegNo == SPR_FP)) return USE_LOCAL_AND_ARG;
        }

        VCode = VCode->Next;
    }
    return NO_USE_LOCAL_AND_ARG;
}
//====================================================================================================================
static int FunctionLeafCheck(vertual_code_list_header *RootVCodeListHeader)
//====================================================================================================================
// [@\] RegNor1珇ɂ
// [] vertual_code_list_header *RootVCodeListHeader FR[hi[
// [Ԓl] 0:[t֐łȂA0ȊOF[t֐
{
    vertual_code                *VCode;
    
    VCode = RootVCodeListHeader->Entry;
    while(1){
        if(VCode == NULL) break;
        if((VCode->OpCode.Type == OPECODE_TYPE_JP) && ((VCode->OpCode.Code == OPECODE_CALL_R) || (VCode->OpCode.Code == OPECODE_CALL_I))) return NOT_LEAF_FUNC;
        VCode = VCode->Next;
    }
    return LEAF_FUNC;
}
//====================================================================================================================
static int FunctionOptiRemoveDisuseCode(vertual_code_list_header *RootVCodeListHeader)
//====================================================================================================================
// [@\] gp̃R[h폜
//        ()
//              LDW_I,      R0001, FP,    FpOffsetOf(hoge)
//              LDW_I,      R0002, FP,    FpOffsetOf(hoge)
//              ADD_I,      R0002, R0002, 1(0x0001),
//              STW_I,      R0002, FP,    FpOffsetOf(hoge)
//              
//          
//              LDW_I,      R0002, FP,    FpOffsetOf(hoge)
//              ADD_I,      R0002, R0002, 1(0x0001),
//              STW_I,      R0002, FP,    FpOffsetOf(hoge)
//          Ɉk
// [] vertual_code_list_header *RootVCodeListHeader FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         NumOfVCode;
    int                         Ret;
    int                         RegNo;
    vertual_code                *VCode;
    vertual_code                *NextVCode;

    if(ExpressionOptiVCodeCount(&NumOfVCode, RootVCodeListHeader) == P3CC_NG){PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
    if(NumOfVCode < 2) return P3CC_OK;
    VCode = RootVCodeListHeader->Entry;
    while(1){
        if(VCode == NULL) break;
        NextVCode = VCode->Next;
        if(((VCode->OpCode.Type == OPECODE_TYPE_LD)/* || (VCode->OpCode.Type == OPECODE_TYPE_OP)*/) && (VCode->OpRand0.Type == OPERAND_TYPE_GPR) && (VCode->OpRand0.ValueInfo.RegNo != 0)){
            RegNo = VCode->OpRand0.ValueInfo.RegNo;
            Ret = FunctionOptiCheckRegRefer(RegNo, VCode->Next);
            if(Ret == P3CC_NG){
                if(VCode->LabelNo == PLABEL_NON){
                    if((VCode->Prev == NULL) && (VCode->Next == NULL)){
                        ;
                    }
                    else if((VCode->Prev == NULL) && (VCode->Next != NULL)){
                        RootVCodeListHeader->Entry = VCode->Next;
                        VCode->Next->Prev = NULL;
                        free(VCode);
                    }
                    else if((VCode->Prev != NULL) && (VCode->Next == NULL)){
                        RootVCodeListHeader->Last = VCode->Prev;
                        VCode->Prev->Next = NULL;
                        free(VCode);
                    }
                    else{
                        VCode->Prev->Next = VCode->Next;
                        VCode->Next->Prev = VCode->Prev;
                        free(VCode);
                    }
                }
            }
        }
        VCode = NextVCode;
    }

    return P3CC_OK;
}

//====================================================================================================================
static int FunctionOptimizeBranch(vertual_code_list_header *RootVCodeListHeader)
//====================================================================================================================
// [@\] ̍œKiT^IȃR[hœKj
//        (P)œKO
//             _@0005:         ldwi,    r2,  fp,  FpOffsetOf(EnumParIn)        // if(EnumParIn ==  1) 
//                             movi,    r1,  0x0001                            
//                             subi,    r2,  r2,  0x0001                       
//                             jpi,     eq,  PcOffsetOf(_@0006)                
//                             movi,    r1,  0x0000                            
//             _@0006:         subi,    r1,  r1,  0x0000                       
//                             jpi,     eq,  PcOffsetOf(_@0007)                
//
//             œK
//             _@0005:         ldwi,    r2,  fp,  FpOffsetOf(EnumParILEn)        // if(EnumParIn ==  1) 
//                             subi,    r2,  r2,  0x0001                       
//                             jpi,     ne,  PcOffsetOf(_@0007)                
//
//
//        (Q)œKO
//                            ldwi,    r2,  pc,  PcOffsetOf(_@0011)           // if (IntGlob > 100) *EnumParOut = 1; 
//                            ldwr,    r2,  gp,  r2                           // 
//                            movi,    r1,  0x0001                            // 
//                            subi,    r2,  r2,  0x0064                       // 
//                            jpi,     gt,  PcOffsetOf(_@0012)                // 
//                            movi,    r1,  0x0000                            // 
//            _@0012:         subi,    r1,  r1,  0x0000                       // 
//                            jpi,     eq,  PcOffsetOf(_@0013)                // 
//
//             œK
//                            ldwi,    r2,  pc,  PcOffsetOf(_@0011)           // if (IntGlob > 100) *EnumParOut = 1; 
//                            ldwr,    r2,  gp,  r2                           // 
//                            subi,    r2,  r2,  0x0064                       // 
//                            jpi,     le,  PcOffsetOf(_@0013)                // 
// [] vertual_code_list_header *VCodeListHeader FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         NumOfVCodeBefore;
    unsigned long               NewCondition;  //R[h
    unsigned long               NewLabelNo;    //R[h
    int                         Flag;
    int                         i;
    vertual_code                *VcBase;
    vertual_code                *VcPtr;
    vertual_code                *VcAry[6];
    
    FunctionOptimizeDebugMsg("FunctionOptimizeBranch", OPTIMIZE_START);

    if(ExpressionOptiVCodeCount(&NumOfVCodeBefore, RootVCodeListHeader) == P3CC_NG){PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
    if(NumOfVCodeBefore >= 6){ 
        VcBase = RootVCodeListHeader->Entry;
        while(1){
            Flag = P3CC_OK;
            VcPtr = VcBase;
            for(i = 0; i < 6; i++){
                if(VcPtr == NULL){  Flag = P3CC_NG; break; }
                VcAry[i] = VcPtr;
                VcPtr = VcPtr->Next;
            }
            if(Flag == P3CC_NG) break;
            if( 
#ifdef USE_MOVLI_FOR_LOGICAL_RESULT
                    ((VcAry[0]->OpCode.Code == OPECODE_MOVL_I) 
#else
                    ((VcAry[0]->OpCode.Code == OPECODE_MOV_I)
#endif
                && (VcAry[0]->OpRand0.Type == OPERAND_TYPE_GPR) 
                &&   (VcAry[0]->OpRand2.Type == OPERAND_TYPE_SHORT_IMM) && (VcAry[0]->OpRand2.ValueInfo.NumLiteral == 1))
                &&  ((VcAry[1]->OpCode.Type == OPECODE_TYPE_OP))
                &&  ((VcAry[2]->OpCode.Code == OPECODE_JP_I) && (VcAry[2]->OpRand0.Type == OPERAND_TYPE_CONDITION) && (VcAry[2]->OpRand0.ValueInfo.Condition != COND_ALWAYS)
                &&   (VcAry[2]->OpRand1.Type == OPERAND_TYPE_LABEL))
#ifdef USE_MOVLI_FOR_LOGICAL_RESULT
                &&  ((VcAry[3]->OpCode.Code == OPECODE_MOVL_I) 
#else
                &&  ((VcAry[3]->OpCode.Code == OPECODE_MOV_I) 
#endif
                && (VcAry[3]->OpRand0.Type == OPERAND_TYPE_GPR) && (VcAry[0]->OpRand0.ValueInfo.RegNo == VcAry[3]->OpRand0.ValueInfo.RegNo)
                &&   (VcAry[3]->OpRand2.Type == OPERAND_TYPE_SHORT_IMM) && (VcAry[3]->OpRand2.ValueInfo.NumLiteral == 0))
                &&  ((VcAry[4]->OpCode.Code == OPECODE_SUB_I) && (VcAry[4]->OpRand0.Type == OPERAND_TYPE_GPR) && (VcAry[4]->OpRand1.Type == OPERAND_TYPE_GPR)
                &&   (VcAry[4]->OpRand0.ValueInfo.RegNo == VcAry[4]->OpRand1.ValueInfo.RegNo) && (VcAry[4]->OpRand0.ValueInfo.RegNo == VcAry[3]->OpRand0.ValueInfo.RegNo)
                &&   (VcAry[4]->LabelNo == VcAry[2]->OpRand1.ValueInfo.LabelNo))
                &&  ((VcAry[5]->OpCode.Code == OPECODE_JP_I) && (VcAry[5]->OpRand0.Type == OPERAND_TYPE_CONDITION) 
                &&   ((VcAry[5]->OpRand0.ValueInfo.Condition == COND_ZERO) || (VcAry[5]->OpRand0.ValueInfo.Condition == COND_NOT_ZERO))
                &&   (VcAry[5]->OpRand1.Type == OPERAND_TYPE_LABEL))
            ){
                if(VcAry[5]->OpRand0.ValueInfo.Condition == COND_ZERO){
                    NewCondition = InverseCondisionCodeGet(VcAry[2]->OpRand0.ValueInfo.Condition);
                }
                else{
                    NewCondition = VcAry[2]->OpRand0.ValueInfo.Condition;
                }
                VcAry[2]->OpRand0.ValueInfo.Condition = NewCondition;
                VcAry[2]->OpRand1.ValueInfo.LabelNo = VcAry[5]->OpRand1.ValueInfo.LabelNo;
                VcAry[1]->Prev = VcAry[0]->Prev;
                if(VcAry[1]->Prev == NULL){
                    RootVCodeListHeader->Entry = VcAry[1];
                }
                else{
                    VcAry[1]->Prev->Next = VcAry[1];
                }
                VcAry[2]->Next = VcAry[5]->Next;
                if(VcAry[2]->Next == NULL){
                    RootVCodeListHeader->Last = VcAry[2];
                }
                else{
                    VcAry[2]->Next->Prev = VcAry[2];
                }
                VcBase = VcPtr;
            }
            else{
                VcBase = VcBase->Next;
            }
        }
    }
    FunctionOptimizeDebugMsg("FunctionOptimizeBranch", OPTIMIZE_END);
    return P3CC_OK;
}

//====================================================================================================================
static int FunctionOptimizeCall(vertual_code_list_header *RootVCodeListHeader)
//====================================================================================================================
// [@\]  ֐ĂяoWX^ԐڂAPCΑlwɕύX\ȃP[X́A
//         PCΑlwɕύX悤ɍœK
//   [œKO]
//     movhi,   r1,  EntryPointHiOf(֐) 
//     ori,     r1,  r1,  EntryPointLoOf(֐)    
//     callr,   al,  r1 
//
//   [œK]
//     callr,   al,  PcOffsetOf(֐)
//
// [] vertual_code_list_header *VCodeListHeader FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    vertual_code                *VCode0;
    vertual_code                *VCode1;
    vertual_code                *VCode2;
    vertual_code                NopVCode;
    int                         RegNo;
    
    FunctionOptimizeDebugMsg("FunctionOptimizeCall", OPTIMIZE_START);
    VCodeGen_Nop(&NopVCode, PLABEL_NON, 0,0);
    VCode0 = RootVCodeListHeader->Entry;
    while(1){
        if(VCode0 == NULL) break;
        VCode1 = VCode0->Next;
        if(VCode1 == NULL) break;
        if((VCode0->OpCode.Code == OPECODE_MOVH_I) && (VCode0->OpRand0.Type == OPERAND_TYPE_GPR) && (VCode0->OpRand2.Type == OPERAND_TYPE_FUNCTION_HI)
        && (VCode1->OpCode.Code == OPECODE_OR_I  ) && (VCode1->OpRand0.Type == OPERAND_TYPE_GPR) && (VCode1->OpRand1.Type == OPERAND_TYPE_GPR) 
        && (VCode1->OpRand2.Type == OPERAND_TYPE_FUNCTION_LO) && (VCode0->OpRand0.ValueInfo.RegNo == VCode1->OpRand0.ValueInfo.RegNo) 
        && (VCode1->OpRand0.ValueInfo.RegNo == VCode1->OpRand1.ValueInfo.RegNo) && (VCode0->OpRand2.ValueInfo.func == VCode1->OpRand2.ValueInfo.func)){ 
            RegNo = VCode0->OpRand0.ValueInfo.RegNo;
            VCode2 = VCode1->Next;
            while(1){
                if(VCode2 == NULL) break;
                if(((VCode2->OpCode.Type == OPECODE_TYPE_LD) || (VCode2->OpCode.Type == OPECODE_TYPE_OP)) 
                && (VCode2->OpRand0.Type == OPERAND_TYPE_GPR) && (VCode2->OpRand0.ValueInfo.RegNo == RegNo)){
                    // RegNõWX^XVĂ甲
                    break;
                }
                if((VCode2->OpCode.Type == OPECODE_TYPE_JP) && (VCode2->OpCode.Code == OPECODE_CALL_R) 
                && (VCode2->OpRand1.Type == OPERAND_TYPE_GPR) && (VCode2->OpRand1.ValueInfo.RegNo == RegNo)){
                    //VCode2CALL_Iɒu
                    VCode2->OpCode.Code = OPECODE_CALL_I;
                    VCode2->OpRand1.Type = OPERAND_TYPE_PC_OFFSET_OFFUNCTION;
                    VCode2->OpRand1.ValueInfo.func = VCode1->OpRand2.ValueInfo.func;
                    
                    //VCode0VCode1NOPɒu
                    VCode0->OpCode = NopVCode.OpCode;
                    VCode0->OpRand0 = NopVCode.OpRand0;
                    VCode0->OpRand1 = NopVCode.OpRand1;
                    VCode0->OpRand2 = NopVCode.OpRand2;
                    
                    VCode1->OpCode = NopVCode.OpCode;
                    VCode1->OpRand0 = NopVCode.OpRand0;
                    VCode1->OpRand1 = NopVCode.OpRand1;
                    VCode1->OpRand2 = NopVCode.OpRand2;
                }
                VCode2 = VCode2->Next;
            }
        }
        VCode0 = VCode0->Next;
    }
    FunctionOptimizeDebugMsg("FunctionOptimizeCall", OPTIMIZE_END);
    return P3CC_OK;
}

//====================================================================================================================
static int FunctionOptimizeEscapeRegSub0(vertual_code *VCode, char Tbl[])
//====================================================================================================================
// [@\] VCodeȍ~̃R[hŎQƂĂ郌WX^TāATbl1𗧂ĂiTbl̃CfbNXRegNoj
// [] vertual_code_list_header *VCodeListHeader FR[hi[
// [Ԓl] QƂĂ郌WX^
{
    int     i, j;
    int     Ret;
    
    j = 0;
    for(i = 1; i < NUM_OF_SCRATCH_REG + 1; i++){
        Ret = FunctionOptiCheckRegRefer(i, VCode);
        if(Ret == P3CC_OK){
            Tbl[i] = 1;
            ++j;
        }
        else{
            Tbl[i] = 0;
        }
    }
    return j;
}

//====================================================================================================================
static int FunctionOptimizeEscapeReg(vertual_code_list_header *RootVCodeListHeader)
//====================================================================================================================
// [@\] ֐ĂяoOɑޔKvȃXNb`WX^Tđޔ
// [] vertual_code_list_header *VCodeListHeader FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    vertual_code                *VCodeEscape;
    vertual_code                *VCodeReturn;
    vertual_code                *NextVCode;
    vertual_code                NewVCode;
    value_info                  vi;
    unsigned long               EscapeNo;
    int                         NumOfEscapeReg;
    char                        EscapeRegTbl[NUM_OF_SCRATCH_REG + 1];
    int                         SrcFileIndex;
    int                         SrcFileLine;
    int                         i, j;

    FunctionOptimizeDebugMsg("FunctionOptimizeEscapeReg", OPTIMIZE_START);
    VCodeEscape = RootVCodeListHeader->Entry;
    while(1){
        if(VCodeEscape == NULL) break;
        NextVCode = VCodeEscape->Next;
        if(VCodeEscape->OpCode.Code == OPECODE_ESCAPE_REGS){
            EscapeNo = VCodeEscape->OpRand0.ValueInfo.NumLiteral;
            VCodeReturn = VCodeEscape->Next;
            while(1){
                if(VCodeReturn == NULL){
                    PrintError(__FILE__, __LINE__, "XNb`WX^ޔsB", "炭RpC̃oO", "");
                    return P3CC_NG;
                }
                if((VCodeReturn->OpCode.Code == OPECODE_RETURN_REGS) && (VCodeReturn->OpRand0.ValueInfo.NumLiteral == EscapeNo)){
                    NumOfEscapeReg = FunctionOptimizeEscapeRegSub0(VCodeReturn->Next, EscapeRegTbl);
                    if(NumOfEscapeReg > 0){
                        //----- ESCAPE --------
                        SrcFileIndex  = VCodeEscape->SrcFileIndex;
                        SrcFileLine   = VCodeEscape->SrcFileLine;
                        vi.NumLiteral = (unsigned long)((NumOfEscapeReg * 4));
                        VCodeGen_Operation(&NewVCode, PLABEL_NON, OPECODE_SUB_I,  RET_IS_SPR,SPR_SP,  ARG_IS_SPR,SPR_SP,  ARG_IS_IMM,&vi,  SrcFileIndex, SrcFileLine);
                        VCodeEscape->OpCode  = NewVCode.OpCode ;
                        VCodeEscape->OpRand0 = NewVCode.OpRand0;
                        VCodeEscape->OpRand1 = NewVCode.OpRand1;
                        VCodeEscape->OpRand2 = NewVCode.OpRand2;
                        for(i = 1, j = 0; i < NUM_OF_SCRATCH_REG + 1; i++){
                            if(EscapeRegTbl[i] != 0){
                                vi.NumLiteral = (unsigned long)((j * 4));
                                VCodeGen_Store(&NewVCode, PLABEL_NON, SIZE_4, BASE_UPDATE_NO,  SRC_IS_GPR,i, BASE_IS_SPR, SPR_SP, OFFSET_IS_IMM, &vi, SrcFileIndex, SrcFileLine);
                                VertualCodeInsertNext(RootVCodeListHeader, VCodeEscape, &NewVCode);
                                ++j;
                            }
                        }
                        //----- RETURN --------
                        SrcFileIndex  = VCodeReturn->SrcFileIndex;
                        SrcFileLine   = VCodeReturn->SrcFileLine;
                        vi.NumLiteral = (unsigned long)((NumOfEscapeReg * 4));
                        VCodeGen_Operation(&NewVCode, PLABEL_NON, OPECODE_ADD_I,  RET_IS_SPR,SPR_SP,  ARG_IS_SPR,SPR_SP,  ARG_IS_IMM,&vi,  SrcFileIndex, SrcFileLine);
                        VCodeReturn->OpCode  = NewVCode.OpCode ;
                        VCodeReturn->OpRand0 = NewVCode.OpRand0;
                        VCodeReturn->OpRand1 = NewVCode.OpRand1;
                        VCodeReturn->OpRand2 = NewVCode.OpRand2;
                        for(i = 1, j = 0; i < NUM_OF_SCRATCH_REG + 1; i++){
                            if(EscapeRegTbl[i] != 0){
                                vi.NumLiteral = (unsigned long)((j * 4));
                                VCodeGen_Store(&NewVCode, PLABEL_NON, SIZE_4, BASE_UPDATE_NO,  SRC_IS_GPR,i, BASE_IS_SPR, SPR_SP, OFFSET_IS_IMM, &vi, SrcFileIndex, SrcFileLine);
                                VertualCodeInsertPrev(RootVCodeListHeader, VCodeReturn, &NewVCode);
                                ++j;
                            }
                        }
                    }
                    else{
                        if(VCodeEscape->LabelNo != PLABEL_NON){
                            if((VCodeEscape->Next != NULL) && (VCodeEscape->Next->LabelNo == PLABEL_NON)){
                                VCodeEscape->Next->LabelNo = VCodeEscape->LabelNo;
                                VertualCodeRemove(RootVCodeListHeader, VCodeEscape);
                            }
                            else{
                                VCodeGen_Nop(&NewVCode, PLABEL_NON, 0,0);
                                VCodeEscape->OpCode  = NewVCode.OpCode ;
                                VCodeEscape->OpRand0 = NewVCode.OpRand0;
                                VCodeEscape->OpRand1 = NewVCode.OpRand1;
                                VCodeEscape->OpRand2 = NewVCode.OpRand2;
                            }
                        }
                        else{
                            VertualCodeRemove(RootVCodeListHeader, VCodeEscape);
                        }
                        VertualCodeRemove(RootVCodeListHeader, VCodeReturn);
                    }
                    break;
                }
                VCodeReturn = VCodeReturn->Next;
            }
        }
        VCodeEscape = NextVCode;
    }
    FunctionOptimizeDebugMsg("FunctionOptimizeEscapeReg", OPTIMIZE_END);
    return P3CC_OK;
}

//====================================================================================================================
static int FunctionOptimizeTest001(vertual_code_list_header *RootVCodeListHeader)
//====================================================================================================================
// [@\] ItZbgWX^Ŏw肷^CvLD/ST߁i()LD, Rx, Rx, RxjgȂꍇ
//        ǂ̒x\邩Ă݂ (R0ɎgĂ̂ŁA܂ŃeXgp)
//@Ƃ肠̂Ȃ̂ŁAG[͍lȂ
// [] vertual_code_list_header *VCodeListHeader FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    vertual_code                *VCode0;
    vertual_code                NewVCode;
    vertual_code                *vcbuf;
    value_info                  vi;
    int                         BaseRegNo;
    int                         OffsetRegNo;
    int                         SrcFileIndex;
    int                         SrcFileLine;
    int                         OpCode;
    
    FunctionOptimizeDebugMsg("FunctionOptimizeTest001", OPTIMIZE_START);
    VCode0 = RootVCodeListHeader->Entry;
    while(1){
        if(VCode0 == NULL) break;
        if(((VCode0->OpCode.Type == OPECODE_TYPE_LD) || (VCode0->OpCode.Type == OPECODE_TYPE_ST)) && (VCode0->OpRand2.Type == OPERAND_TYPE_GPR)){
        //&& (VCode1->OpCode.Code == OPECODE_OR_I  ) && (VCode1->OpRand0.Type == OPERAND_TYPE_GPR) && (VCode1->OpRand1.Type == OPERAND_TYPE_GPR) 
        //&& (VCode1->OpRand2.Type == OPERAND_TYPE_FUNCTION_LO) && (VCode0->OpRand0.ValueInfo.RegNo == VCode1->OpRand0.ValueInfo.RegNo) 
        //&& (VCode1->OpRand0.ValueInfo.RegNo == VCode1->OpRand1.ValueInfo.RegNo) && (VCode0->OpRand2.ValueInfo.func == VCode1->OpRand2.ValueInfo.func)){ 
            SrcFileIndex  = VCode0->SrcFileIndex;
            SrcFileLine   = VCode0->SrcFileLine;
            BaseRegNo = VCode0->OpRand1.ValueInfo.RegNo;
            OffsetRegNo = VCode0->OpRand2.ValueInfo.RegNo;
            vi.RegNo = BaseRegNo;
            VCodeGen_Operation(&NewVCode, PLABEL_NON, OPECODE_ADD_R,  RET_IS_GPR,0,  ARG_IS_GPR,OffsetRegNo,  ARG_IS_GPR,&vi,  SrcFileIndex, SrcFileLine);
            vcbuf = calloc(1, sizeof(vertual_code));
            if(vcbuf == NULL){
                PrintError(__FILE__, __LINE__, "ԃR[hp̈mێsB", "", "");
                return P3CC_NG;
            }
            *vcbuf = NewVCode;
            // VCode0̑OɉZǉ
            VCode0->Prev->Next = vcbuf;
            vcbuf->Prev = VCode0->Prev;
            vcbuf->Next = VCode0;
            VCode0->Prev = vcbuf;
            // VCode0ύX
            VCode0->OpRand1.Type = OPERAND_TYPE_GPR;
            VCode0->OpRand1.ValueInfo.RegNo = 0;
            VCode0->OpRand2.Type = OPERAND_TYPE_SHORT_IMM;
            VCode0->OpRand2.ValueInfo.NumLiteral = 0;
            OpCode = VCode0->OpCode.Code;
            switch(OpCode){
                case   OPECODE_LDW_R       : OpCode = OPECODE_LDW_I    ; break;
                case   OPECODE_LDW_UB_R    : OpCode = OPECODE_LDW_UB_I ; break;
                case   OPECODE_LDW_UA_R    : OpCode = OPECODE_LDW_UA_I ; break;
                case   OPECODE_LDH_R       : OpCode = OPECODE_LDH_I    ; break;
                case   OPECODE_LDH_UB_R    : OpCode = OPECODE_LDH_UB_I ; break;
                case   OPECODE_LDH_UA_R    : OpCode = OPECODE_LDH_UA_I ; break;
                case   OPECODE_LDB_R       : OpCode = OPECODE_LDB_I    ; break;
                case   OPECODE_LDB_UB_R    : OpCode = OPECODE_LDB_UB_I ; break;
                case   OPECODE_LDB_UA_R    : OpCode = OPECODE_LDB_UA_I ; break;
                case   OPECODE_LDSH_R      : OpCode = OPECODE_LDSH_I   ; break;
                case   OPECODE_LDSH_UB_R   : OpCode = OPECODE_LDSH_UB_I; break;
                case   OPECODE_LDSH_UA_R   : OpCode = OPECODE_LDSH_UA_I; break;
                case   OPECODE_LDSB_R      : OpCode = OPECODE_LDSB_I   ; break;
                case   OPECODE_LDSB_UB_R   : OpCode = OPECODE_LDSB_UB_I; break;
                case   OPECODE_LDSB_UA_R   : OpCode = OPECODE_LDSB_UA_I; break;
                case   OPECODE_STW_R       : OpCode = OPECODE_STW_I    ; break;
                case   OPECODE_STW_UB_R    : OpCode = OPECODE_STW_UB_I ; break;
                case   OPECODE_STW_UA_R    : OpCode = OPECODE_STW_UA_I ; break;
                case   OPECODE_STH_R       : OpCode = OPECODE_STH_I    ; break;
                case   OPECODE_STH_UB_R    : OpCode = OPECODE_STH_UB_I ; break;
                case   OPECODE_STH_UA_R    : OpCode = OPECODE_STH_UA_I ; break;
                case   OPECODE_STB_R       : OpCode = OPECODE_STB_I    ; break;
                case   OPECODE_STB_UB_R    : OpCode = OPECODE_STB_UB_I ; break;
                case   OPECODE_STB_UA_R    : OpCode = OPECODE_STB_UA_I ; break;
            }
            VCode0->OpCode.Code = OpCode;
        }
        VCode0 = VCode0->Next;
    }
    FunctionOptimizeDebugMsg("FunctionOptimizeTest001", OPTIMIZE_END);
    return P3CC_OK;
}

//====================================================================================================================
static int FunctionOptimizeBranch3(vertual_code_list_header *RootVCodeListHeader)
//====================================================================================================================
// [@\] ȉ̂悤ȏ璷ȃp^[œK
//   [œKO]
//                jpi,     ne,  PcOffsetOf(_@0006)
//                jpi,     al,  PcOffsetOf(_@0004)
//    _@0006:     stbi,    r9,  r5,  0x0000       
//
//   [œK]
//                jpi,     eq,  PcOffsetOf(_@0004)
//    _@0006:     stbi,    r9,  r5,  0x0000       
//
// [] vertual_code_list_header *VCodeListHeader FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    vertual_code                *VCode0;
    vertual_code                *VCode1;
    vertual_code                *VCode2;
    int                         LabelNo;
    unsigned long               NewCondition;  //R[h
    
    FunctionOptimizeDebugMsg("FunctionOptimizeBranch3", OPTIMIZE_START);
    VCode0 = RootVCodeListHeader->Entry;
    while(1){
        if(VCode0 == NULL) break;
        VCode1 = VCode0->Next;
        if(VCode1 == NULL) break;
        VCode2 = VCode1->Next;
        if(VCode2 == NULL) break;
        if((VCode0->OpCode.Code == OPECODE_JP_I) && (VCode0->OpRand0.Type == OPERAND_TYPE_CONDITION) 
        && (VCode0->OpRand0.ValueInfo.Condition != COND_ALWAYS) && (VCode0->OpRand1.Type == OPERAND_TYPE_LABEL)
        && (VCode1->OpCode.Code == OPECODE_JP_I) && (VCode1->OpRand0.Type == OPERAND_TYPE_CONDITION) 
        && (VCode1->OpRand0.ValueInfo.Condition == COND_ALWAYS) && (VCode1->OpRand1.Type == OPERAND_TYPE_LABEL)
        && (VCode0->OpRand1.ValueInfo.LabelNo == VCode2->LabelNo)){
            LabelNo = VCode1->OpRand1.ValueInfo.LabelNo;
            NewCondition = InverseCondisionCodeGet(VCode0->OpRand0.ValueInfo.Condition);
            VCode0->OpRand1.ValueInfo.LabelNo = LabelNo;
            VCode0->OpRand0.ValueInfo.Condition = NewCondition;
            VCode0->Next = VCode2;
            VCode2->Prev = VCode0;
            free(VCode1);
        }
        VCode0 = VCode0->Next;
    }
    FunctionOptimizeDebugMsg("FunctionOptimizeBranch3", OPTIMIZE_END);
    return P3CC_OK;
}

//====================================================================================================================
static int FunctionOptimizeBranch2(vertual_code_list_header *RootVCodeListHeader)
//====================================================================================================================
// [@\] JP߂̔ѐ悪JP߂̏ꍇ́AڂJP߂̔ѐAJP߂̔ѐ֕ύXœK
// [] vertual_code_list_header *VCodeListHeader FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    vertual_code                *VCode0;
    vertual_code                *VCode1;
    int                         LabelNo;
    
    FunctionOptimizeDebugMsg("FunctionOptimizeBranch2", OPTIMIZE_START);
    VCode0 = RootVCodeListHeader->Entry;
    while(1){
        if(VCode0 == NULL) break;
        if((VCode0->OpCode.Code == OPECODE_JP_I) && (VCode0->OpRand1.Type == OPERAND_TYPE_LABEL)){
            LabelNo = VCode0->OpRand1.ValueInfo.LabelNo;
            VCode1 = RootVCodeListHeader->Entry;
            while(1){
                if(VCode1 == NULL) break;
                if((VCode1->LabelNo == LabelNo) && (VCode1->OpCode.Code == OPECODE_JP_I) && (VCode1->OpRand1.Type == OPERAND_TYPE_LABEL)
                && (VCode1->OpRand0.Type == OPERAND_TYPE_CONDITION) && (VCode1->OpRand0.ValueInfo.Condition == COND_ALWAYS)){
                    VCode0->OpRand1.ValueInfo.LabelNo = VCode1->OpRand1.ValueInfo.LabelNo;
                    break;
                }
                VCode1 = VCode1->Next;
            }
        }
        VCode0 = VCode0->Next;
    }
    FunctionOptimizeDebugMsg("FunctionOptimizeBranch2", OPTIMIZE_END);
    return P3CC_OK;
}


//====================================================================================================================
static int FunctionOptimizeMovr(vertual_code_list_header *RootVCodeListHeader)
//====================================================================================================================
// [@\] WX^̍œK
//          ij
//              movi,    r1,  0x0001
//              movr,    r8,  r1    
//          ̂悤ȃp^[ŁAȍ~̃R[hŁAr1QƂȂ̂ȂA
//              movi,    r8,  0x0001
//          ɕϊ
// [] vertual_code_list_header *VCodeListHeader FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         NumOfVCodeBefore;
    int                         ReplaceBeforeReg;
    int                         ReplaceAfterReg;
    vertual_code                *VCode0;
    vertual_code                *VCode1;
    
    FunctionOptimizeDebugMsg("FunctionOptimizeMovr", OPTIMIZE_START);

    VCode0 = RootVCodeListHeader->Entry;
    while(1){
        if(VCode0 == NULL) break;
        VCode1 = VCode0->Next;
        if(VCode1 == NULL) break;
        if(((VCode0->OpCode.Type == OPECODE_TYPE_LD) || (VCode0->OpCode.Type == OPECODE_TYPE_OP))
        && (VCode0->OpCode.Code != OPECODE_MOVL_I) && (VCode0->OpCode.Code != OPECODE_MOV_R)
        && (VCode1->OpCode.Type == OPECODE_TYPE_OP) && (VCode1->OpCode.Code == OPECODE_MOV_R)
        && (VCode0->OpRand0.Type == OPERAND_TYPE_GPR) && (VCode1->OpRand2.Type == OPERAND_TYPE_GPR) 
        && (VCode0->OpRand0.ValueInfo.RegNo == VCode1->OpRand2.ValueInfo.RegNo) && (VCode1->LabelNo == PLABEL_NON)){
//printf("");
            ReplaceBeforeReg = VCode0->OpRand0.ValueInfo.RegNo;
            ReplaceAfterReg  = VCode1->OpRand0.ValueInfo.RegNo;

            if((FunctionOptiCheckRegRefer(ReplaceBeforeReg, VCode1->Next) == P3CC_NG)                 // ȍ~̃R[hReplaceBeforeReg͎QƂĂȂ
            && (ReplaceBeforeReg >= FIRST_REAL_REG_NO) && (ReplaceBeforeReg <= NUM_OF_SCRATCH_REG)    // AReplaceBeforeRegXNb`WX^
            && ((ReplaceAfterReg == 0) || ((ReplaceAfterReg > NUM_OF_SCRATCH_REG)                     // AReplaceAfterRegr0́A
            &&  (ReplaceAfterReg <= (NUM_OF_SCRATCH_REG + NUM_OF_VER_ON_REG))))){                     // WX^ϐpWX^
//printf("");
                VCode0->OpRand0.ValueInfo.RegNo = ReplaceAfterReg;
                VCode0->Next = VCode1->Next;
                if(VCode0->Next != NULL){
                    VCode0->Next->Prev = VCode0;
                }
                else{
                    RootVCodeListHeader->Last = VCode0;
                }
                free(VCode1);
            }
//printf("\n");
        }
        VCode0 = VCode0->Next;
    }
            
    FunctionOptimizeDebugMsg("FunctionOptimizeMovr", OPTIMIZE_END);
    return P3CC_OK;
}

//====================================================================================================================
static int FunctionOptimizeMovr2(vertual_code_list_header *RootVCodeListHeader)
//====================================================================================================================
// [@\] WX^̍œK
//          ij
//              movr,    r1,  r0
//          ̂悤ȃp^[ŁAȍ~̃R[hŁAr1QƂȂ̂ȂR[ĥ̂폜
//          ɕϊ
// [] vertual_code_list_header *VCodeListHeader FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         NumOfVCodeBefore;
    int                         RegNo;
    vertual_code                *VCode0;
    vertual_code                *NextVCode;
    
    FunctionOptimizeDebugMsg("FunctionOptimizeMovr2", OPTIMIZE_START);

    VCode0 = RootVCodeListHeader->Entry;
    while(1){
        if(VCode0 == NULL) break;
        NextVCode = VCode0->Next;
        if((VCode0->OpCode.Type == OPECODE_TYPE_OP) && (VCode0->OpCode.Code == OPECODE_MOV_R)
        && (VCode0->OpRand0.Type == OPERAND_TYPE_GPR) && (VCode0->OpRand2.Type == OPERAND_TYPE_GPR) 
        && (VCode0->OpRand2.ValueInfo.RegNo == 0) && (VCode0->LabelNo == PLABEL_NON)){
            RegNo  = VCode0->OpRand0.ValueInfo.RegNo;
            if((FunctionOptiCheckRegRefer(RegNo, VCode0->Next) == P3CC_NG)        // ȍ~̃R[hRegNo͎QƂĂȂ
            && (RegNo >= FIRST_REAL_REG_NO) && (RegNo <= NUM_OF_SCRATCH_REG)){    // ARegNoXNb`WX^
                if((VCode0->Prev == NULL) && (VCode0->Next == NULL)){
                    ;
                }
                else if((VCode0->Prev == NULL) && (VCode0->Next != NULL)){
                    RootVCodeListHeader->Entry = VCode0->Next;
                    VCode0->Next->Prev = NULL;
                    free(VCode0);
                }
                else if((VCode0->Prev != NULL) && (VCode0->Next == NULL)){
                    RootVCodeListHeader->Last = VCode0->Prev;
                    VCode0->Prev->Next = NULL;
                    free(VCode0);
                }
                else{
                    VCode0->Prev->Next = VCode0->Next;
                    VCode0->Next->Prev = VCode0->Prev;
                    free(VCode0);
                }
            }
        }
        VCode0 = NextVCode;
    }
            
    FunctionOptimizeDebugMsg("FunctionOptimizeMovr2", OPTIMIZE_END);
    return P3CC_OK;
}


//====================================================================================================================
static int FunctionOptimizeChangeJumpTargetLabel(vertual_code_list_header *RootVCodeListHeader, int NewLabel, int OldLabel)
//====================================================================================================================
// [@\] 򖽗߂̕惉xOldLabelANewLabelɕtւ
// [] vertual_code_list_header *VCodeListHeader FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    vertual_code                *VCode0;

    FunctionOptimizeDebugMsg("FunctionOptimizeChangeJumpTargetLabel", OPTIMIZE_START);

    VCode0 = RootVCodeListHeader->Entry;
    while(1){
        if(VCode0 == NULL) break;
        if((VCode0->OpCode.Code == OPECODE_JP_I) || (VCode0->OpCode.Code == OPECODE_CALL_I)){
            if((VCode0->OpRand1.Type == OPERAND_TYPE_LABEL) && (VCode0->OpRand1.ValueInfo.LabelNo == OldLabel)){
                VCode0->OpRand1.ValueInfo.LabelNo = NewLabel;
            }
        }
        VCode0 = VCode0->Next;
    }


    FunctionOptimizeDebugMsg("FunctionOptimizeChangeJumpTargetLabel", OPTIMIZE_END);
    return P3CC_OK;
}


//====================================================================================================================
static void FunctionOptimizeDebugMsg(char *Func, int Status)
//====================================================================================================================
// [@\] ̓fobObZ[W
// [] expression_analsys_result *Ret            Fʊi[
// [] vertual_code_list_header *RootVCodeListHeader   FR[hi[
// [Ԓl] P3CC_OK/P3CC_NG
{
    char  *Sts;

    if(FunctionOptimizeDebugFlag){
        if(Status != OPTIMIZE_START){
             --DebugMsgIndentCounter;
        }
        PrintSpace(DebugMsgIndentCounter);
        if(Status == OPTIMIZE_START){
            Sts = "Start";
        }
        else{
            Sts = "End";
        }
        fprintf(LogFile, "%s %s\n", Func, Sts);
        if(Status == OPTIMIZE_START){
            ++DebugMsgIndentCounter;
        }
    }
}

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// ԃR[hn
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//====================================================================================================================
static int VertualCodeInit(vertual_code *VCode)
//====================================================================================================================
// [@\] ԃR[h
// []
// [Ԓl] P3CC_OK
{
    VCode -> Prev = NULL;
    VCode -> Next = NULL;
    VCode -> LabelNo = PLABEL_NON;
    VCode -> SrcFileIndex = 0;
    VCode -> SrcFileLine = 0;
    VCode -> OptimaizationHint.Position = EXPRESSION_OUTSIDE;
    VCode -> OptimaizationHint.Result = EXPRESSION_NOT_RESULT;
    VCode -> OptimaizationHint.Copy = NOT_COPY_FOR_POSTFIX_EXPR;
    VCode -> OptimaizationHint.LoopLevel = LoopLevel;
    VCode -> OpCode.Type = OPECODE_TYPE_OTHER;
    VCode -> OpCode.Code = OPECODE_NOP;
    VCode -> OpRand0.Type = OPERAND_TYPE_NOTHING;
    VCode -> OpRand0.ValueInfo.NumLiteral = 0;
    VCode -> OpRand0.VariableOffset = 0;
    VCode -> OpRand1.Type = OPERAND_TYPE_NOTHING;
    VCode -> OpRand1.ValueInfo.NumLiteral = 0;
    VCode -> OpRand1.VariableOffset = 0;
    VCode -> OpRand2.Type = OPERAND_TYPE_NOTHING;
    VCode -> OpRand2.ValueInfo.NumLiteral = 0;
    VCode -> OpRand2.VariableOffset = 0;
    return P3CC_OK;
}
//====================================================================================================================
static int VertualCodeInsertPrev(vertual_code_list_header *VCodeListHeader, vertual_code *VCodePosition, vertual_code *VCode)
//====================================================================================================================
// [@\] ԃR[h(VCode)XgVCodeListHeaderVCodePosition̒Oɑ}
// [] vertual_code *VCodePosition :}ʒu
// [] vertual_code *VCode         :}VCode
// [Ԓl] P3CC_OK
{
    vertual_code *vcbuf;


    vcbuf = calloc(1, sizeof(vertual_code));
    if(vcbuf == NULL){
        PrintError(__FILE__, __LINE__, "ԃR[hp̈mێsB", "", "");
        return P3CC_NG;
    }
    *vcbuf = *VCode;

    vcbuf->Prev = VCodePosition->Prev;
    vcbuf->Next = VCodePosition;
    if(VCodeListHeader->Entry == VCodePosition){
        VCodeListHeader->Entry = vcbuf;
    }
    else{
        VCodePosition->Prev->Next = vcbuf;
    }
    VCodePosition->Prev = vcbuf;
    return P3CC_OK;
}

//====================================================================================================================
static int VertualCodeInsertNext(vertual_code_list_header *VCodeListHeader, vertual_code *VCodePosition, vertual_code *VCode)
//====================================================================================================================
// [@\] ԃR[h(VCode)XgVCodeListHeaderVCodePosition̒ɑ}
// [] vertual_code *VCodePosition :}ʒu
// [] vertual_code *VCode         :}VCode
// [Ԓl] P3CC_OK
{
    vertual_code *vcbuf;


    vcbuf = calloc(1, sizeof(vertual_code));
    if(vcbuf == NULL){
        PrintError(__FILE__, __LINE__, "ԃR[hp̈mێsB", "", "");
        return P3CC_NG;
    }
    *vcbuf = *VCode;

    vcbuf->Prev = VCodePosition;
    vcbuf->Next = VCodePosition->Next;
    if(VCodeListHeader->Last == VCodePosition){
        VCodeListHeader->Last = vcbuf;
    }
    else{
        VCodePosition->Next->Prev = vcbuf;
    }
    VCodePosition->Next = vcbuf;
    return P3CC_OK;
}
//====================================================================================================================
static int VertualCodeRemove(vertual_code_list_header *VCodeListHeader, vertual_code *VCodePosition)
//====================================================================================================================
// [@\] ԃR[h(VCode)XgVCodeListHeaderVCodePosition폜
// [] vertual_code *VCodePosition :폜ʒu
// [Ԓl] P3CC_OK
{
    if(VCodeListHeader->Entry == VCodePosition){
        if(VCodeListHeader->Last == VCodePosition){
            VCodeListHeader->Entry = NULL;
            VCodeListHeader->Last  = NULL;
        }
        else{
            VCodeListHeader->Entry = VCodePosition->Next;
            VCodePosition->Next->Prev = NULL;
        }
    }
    else if(VCodeListHeader->Last == VCodePosition){
        VCodeListHeader->Last = VCodePosition->Prev;
        VCodePosition->Prev->Next = NULL;
    }
    else{
        VCodePosition->Prev->Next = VCodePosition->Next;
        VCodePosition->Next->Prev = VCodePosition->Prev;
    }
    free(VCodePosition);
    return P3CC_OK;
}


//====================================================================================================================
static int VertualCodeAdd(vertual_code_list_header *VCodeListHeader, vertual_code *VCode)
//====================================================================================================================
// [@\] ԃR[hXgɒǉ
// []
// [Ԓl] P3CC_OK
{
    vertual_code *vcbuf;


    if(PrintVCodeGenProcess){
        PrintVertualCodeBody(VCode);
    }

    vcbuf = calloc(1, sizeof(vertual_code));
    if(vcbuf == NULL){
        PrintError(__FILE__, __LINE__, "ԃR[hp̈mێsB", "", "");
        return P3CC_NG;
    }
    *vcbuf = *VCode;

    if(VCodeListHeader->Entry == NULL){
        VCodeListHeader->Entry = vcbuf;
        VCodeListHeader->Last = vcbuf;
    }
    else{
        VCodeListHeader->Last->Next = vcbuf;
        vcbuf->Prev = VCodeListHeader->Last;
        VCodeListHeader->Last = vcbuf;
    }
    return P3CC_OK;
}
//====================================================================================================================
static int VertualCodeListConnect(vertual_code_list_header *VCodeListHeaderPri, vertual_code_list_header *VCodeListHeaderSec)
//====================================================================================================================
// [@\] ԃR[hXgǂA
// []
// [Ԓl] P3CC_OK
{
    if(VCodeListHeaderPri->Entry == NULL){//̏ꍇ
        if(VCodeListHeaderSec->Entry != NULL){//Kg
            VCodeListHeaderPri->Entry = VCodeListHeaderSec->Entry;
            VCodeListHeaderPri->Last = VCodeListHeaderSec->Last;
        }
        else{//KgȂ
            ;
        }
    }
    else if(VCodeListHeaderSec->Entry != NULL){//gAKg
        VCodeListHeaderPri->Last->Next = VCodeListHeaderSec->Entry;
        VCodeListHeaderSec->Entry->Prev = VCodeListHeaderPri->Last;
        VCodeListHeaderPri->Last = VCodeListHeaderSec->Last;
    }
    else{//gAK͋
        ;
    }
    return P3CC_OK;
}
//====================================================================================================================
static int VertualCodeSideEffectListConnect(vertual_code_list_header *VCodeListHeaderPri, vertual_code_list_header *VCodeListHeaderSec)
//====================================================================================================================
// [@\] ԃR[hXgǂAipR[h̘Apj
//        VCodeListHeaderPriƁAVCodeListHeaderSecAAVCodeListHeaderSeĉ݂
// []
// [Ԓl] P3CC_OK
{
    VertualCodeListConnect(VCodeListHeaderPri, VCodeListHeaderSec);
    VCodeListHeaderInit(VCodeListHeaderSec);
    return P3CC_OK;
}

//====================================================================================================================
static int VertualCodeListFree(vertual_code_list_header *Header)
//====================================================================================================================
// [@\] ֐
// [] ֐̍\̂ւ̃|C^
// [Ԓl] FP3CC_OKAsFP3CC_NG
{
    vertual_code    *VCode;
    vertual_code    *Next;

    VCode = Header->Entry;
    while(VCode != NULL){
        Next = VCode->Next;
        free(VCode);
        VCode = Next;
    }
    return P3CC_OK;
}
//====================================================================================================================
static int IsOperandTypeReg(char OffsetType)
//====================================================================================================================
// [@\] Iyh^CvWX^ۂׂ
// [] F
// [Ԓl] FWX^ȂPAWX^ȊOȂ0
{
    if(OffsetType == OPERAND_TYPE_SPR) return P3CC_TRUE;
    if(OffsetType == OPERAND_TYPE_GPR) return P3CC_TRUE;
    return P3CC_FALSE;
}
//====================================================================================================================
static int VCodeGen_Nop(vertual_code *VCode, int LabelNo, int SrcFileIndex, int SrcFileLine)
//====================================================================================================================
// [@\] NOP߂𐶐
// [] F*VCode,         // ԃR[hi[
// [] FLabelNo         // xNoF0͊֐̓A1͊֐̏oA-1̓xȂALȊO͔Cӂ̃Wv
// [Ԓl] P3CC_OK or P3CC_NG
{
    VertualCodeInit(VCode);
    VCode->LabelNo = LabelNo;
    VCode->SrcFileIndex = SrcFileIndex;
    VCode->SrcFileLine = SrcFileLine;
    VCode->OpCode.Type = OPECODE_TYPE_OTHER;
    VCode->OpCode.Code = OPECODE_NOP;
    return P3CC_OK;
}
//====================================================================================================================
static int VCodeGen_ImmSet(vertual_code *VCode, int LabelNo, unsigned long Value, int SrcFileIndex, int SrcFileLine)
//====================================================================================================================
// [@\] _~[(IMMSET)𐶐
// [] F*VCode,         // ԃR[hi[
// [] FLabelNo         // xNoF0͊֐̓A1͊֐̏oA-1̓xȂALȊO͔Cӂ̃Wv
// [Ԓl] P3CC_OK or P3CC_NG
{
    VertualCodeInit(VCode);
    VCode->LabelNo = LabelNo;
    VCode->SrcFileIndex = SrcFileIndex;
    VCode->SrcFileLine = SrcFileLine;
    VCode->OpCode.Type = OPECODE_TYPE_DUMMY;
    VCode->OpCode.Code = OPECODE_IMMSET;
    VCode->OpRand0.Type = OPERAND_TYPE_LONG_IMM;
    VCode->OpRand0.ValueInfo.NumLiteral = Value;
    return P3CC_OK;
}

//====================================================================================================================
static int VCodeGen_DummyCode(vertual_code *VCode, int LabelNo,  int Operation, int CallCounter, int SrcFileIndex, int SrcFileLine)
//====================================================================================================================
// [@\] _~[($EscapeRegs$ / $ReturnRegs$)𐶐
// [] F*VCode,         // ԃR[hi[
// [] FLabelNo         // xNoF0͊֐̓A1͊֐̏oA-1̓xȂALȊO͔Cӂ̃Wv
// [] FOperation       // ^߂̃R[h
// [Ԓl] P3CC_OK or P3CC_NG
{
    VertualCodeInit(VCode);
    VCode->LabelNo = LabelNo;
    VCode->SrcFileIndex = SrcFileIndex;
    VCode->SrcFileLine = SrcFileLine;
    VCode->OpCode.Type = OPECODE_TYPE_DUMMY;
    VCode->OpCode.Code = Operation;
    VCode->OpRand0.Type = OPERAND_TYPE_LONG_IMM;
    VCode->OpRand0.ValueInfo.NumLiteral = CallCounter;
    return P3CC_OK;
}
//====================================================================================================================
static int VCodeGen_Jump(
    vertual_code    *VCode,         // ԃR[hi[
    int             LabelNo,        // xNoF0͊֐̓A1͊֐̏oA-1̓xȂA-2̓[U[`ALȊO͔Cӂ̃Wv
    char            Operation,      // OPR[h
    unsigned long   ConditionCode,  // R[h
    char            ArgType,        // ̃^CvFGPR(ėpREG) / LABEL(vOx)
    value_info      *vi,            // ̒l̏
    int             SrcFileIndex,   // \[Xt@Ce[uIndex
    int             SrcFileLine     // \[X̉C߂
)
//====================================================================================================================
// [@\] n߂𐶐
// []
// [Ԓl] P3CC_OK or P3CC_NG
{
    VertualCodeInit(VCode);
    VCode->LabelNo = LabelNo;
    VCode->SrcFileIndex = SrcFileIndex;
    VCode->SrcFileLine = SrcFileLine;
    VCode->OpCode.Type = OPECODE_TYPE_JP;
    VCode->OpCode.Code = Operation;
    VCode->OpRand0.Type = OPERAND_TYPE_CONDITION;
    VCode->OpRand0.ValueInfo.Condition = ConditionCode;
    VCode->OpRand1.Type = ArgType;
    if(vi != NULL){
        VCode->OpRand1.ValueInfo = *vi;
    }
    return P3CC_OK;
}
//====================================================================================================================
// [@\] Zn߂𐶐
// []
// [Ԓl] P3CC_OK or P3CC_NG


//====================================================================================================================
static int VCodeGen_Operation(
    vertual_code    *VCode,         // ԃR[hi[
    int             LabelNo,        // xNoF0͊֐̓A1͊֐̏oA-1̓xȂALȊO͔Cӂ̃Wv
    char            Operation,      // OPR[h
    char            ResRegType,     // ʊi[惌WX^^CvF GPR(ėpREG) / SPR(REG)
    unsigned long   ResRegNo,       // ʊi[惌WX^No
    char            Arg1RegType,    // PWX^^CvF GPR(ėpREG) / SPR(REG)
    unsigned long   Arg1RegNo,      // PWX^No
    char            Arg2Type,       // Q̃^CvFOFFSET_IS_GPR(ėpREG) / OFFSET_IS_IMM(l) / OFFSET_IS_VAR(ϐ) / OFFSET_IS_LABEL(vOx)
    value_info      *vi,            // Q̒l̏
    int             SrcFileIndex,   // \[Xt@Ce[uIndex
    int             SrcFileLine     // \[X̉C߂
)
//====================================================================================================================
// [@\] Zn߂𐶐
// []
// [Ԓl] P3CC_OK or P3CC_NG
{
    VertualCodeInit(VCode);
    VCode->LabelNo = LabelNo;
    VCode->SrcFileIndex = SrcFileIndex;
    VCode->SrcFileLine = SrcFileLine;
    VCode->OpCode.Type = OPECODE_TYPE_OP;
    VCode->OpCode.Code = Operation;
    VCode->OpRand0.Type = ResRegType;
    VCode->OpRand0.ValueInfo.RegNo = ResRegNo;
    VCode->OpRand1.Type = Arg1RegType;
    VCode->OpRand1.ValueInfo.RegNo = Arg1RegNo;
    VCode->OpRand2.Type = Arg2Type;
    if(vi != NULL){
        VCode->OpRand2.ValueInfo = *vi;
    }
    return P3CC_OK;
}
//====================================================================================================================
static int VCodeGen_Store(
    vertual_code    *VCode,         // ԃR[hi[
    int             LabelNo,        // xNoF0͊֐̓A1͊֐̏oA-1̓xȂALȊO͔Cӂ̃Wv
    int             Size,           // TCY@PCQCS
    int             BaseUpDate,     // BASE_UPDATE_NO(=0) / BASE_UPDATE_BEFORE(=1) / BASE_UPDATE_AFTER(=2)
    char            SrcRegType,     // \[XWX^^CvF GPR(ėpREG) / SPR(REG)
    unsigned long   SrcRegNo,       // \[XWX^No
    char            BaseRegType,    // x[XWX^^CvF GPR(ėpREG) / SPR(REG)
    unsigned long   BaseRegNo,      // x[XWX^No
    char            OffsetType,     // ItZbg̃^CvFOFFSET_IS_GPR(ėpREG) / OFFSET_IS_IMM(l) / OFFSET_IS_VAR(ϐ) / OFFSET_IS_LABEL(vOx)
    value_info      *vi,            // ItZbgl̏
    int             SrcFileIndex,   // \[Xt@Ce[uIndex
    int             SrcFileLine     // \[X̉C߂
)
//====================================================================================================================
// [@\] XgAn߂𐶐
// []
// [Ԓl] P3CC_OK or P3CC_NG
{
    VertualCodeInit(VCode);
    VCode->LabelNo = LabelNo;
    VCode->SrcFileIndex = SrcFileIndex;
    VCode->SrcFileLine = SrcFileLine;
    VCode->OpCode.Type = OPECODE_TYPE_ST;
    if(Size == SIZE_1){
        if(BaseUpDate == BASE_UPDATE_BEFORE)      VCode->OpCode.Code = (IsOperandTypeReg(OffsetType))? OPECODE_STB_UB_R : OPECODE_STB_UB_I;
        else if(BaseUpDate == BASE_UPDATE_AFTER)  VCode->OpCode.Code = (IsOperandTypeReg(OffsetType))? OPECODE_STB_UA_R : OPECODE_STB_UA_I;
        else                                      VCode->OpCode.Code = (IsOperandTypeReg(OffsetType))? OPECODE_STB_R    : OPECODE_STB_I;
    }
    else if(Size == SIZE_2){
        if(BaseUpDate == BASE_UPDATE_BEFORE)      VCode->OpCode.Code = (IsOperandTypeReg(OffsetType))? OPECODE_STH_UB_R : OPECODE_STH_UB_I;
        else if(BaseUpDate == BASE_UPDATE_AFTER)  VCode->OpCode.Code = (IsOperandTypeReg(OffsetType))? OPECODE_STH_UA_R : OPECODE_STH_UA_I;
        else                                      VCode->OpCode.Code = (IsOperandTypeReg(OffsetType))? OPECODE_STH_R    : OPECODE_STH_I;
    }
    else{
        if(BaseUpDate == BASE_UPDATE_BEFORE)      VCode->OpCode.Code = (IsOperandTypeReg(OffsetType))? OPECODE_STW_UB_R : OPECODE_STW_UB_I;
        else if(BaseUpDate == BASE_UPDATE_AFTER)  VCode->OpCode.Code = (IsOperandTypeReg(OffsetType))? OPECODE_STW_UA_R : OPECODE_STW_UA_I;
        else                                      VCode->OpCode.Code = (IsOperandTypeReg(OffsetType))? OPECODE_STW_R    : OPECODE_STW_I;
    }
    VCode->OpRand0.Type = SrcRegType;
    VCode->OpRand0.ValueInfo.RegNo = SrcRegNo;
    VCode->OpRand1.Type = BaseRegType;
    VCode->OpRand1.ValueInfo.RegNo = BaseRegNo;
    VCode->OpRand2.Type = OffsetType;
    VCode->OpRand2.ValueInfo = *vi;

    return P3CC_OK;
}
//====================================================================================================================
static int VCodeGen_Push(vertual_code *VCode, int LabelNo, char SrcRegType, unsigned long SrcRegNo, int SrcFileIndex, int SrcFileLine)
//====================================================================================================================
// [@\] PUSH߂𐶐
// [] F*VCode,         // ԃR[hi[
// [] FLabelNo         // xNoF0͊֐̓A1͊֐̏oA-1̓xȂALȊO͔Cӂ̃Wv
// [] FSrcRegType,     // \[XWX^^CvF GPR(ėpREG) / SPR(REG)
// [] FSrcRegNo,       // \[XWX^No
// [] FSrcFileIndex,   // \[Xt@Ce[uIndex
// [] FSrcFileLine,    // \[X̉C߂
// [Ԓl] P3CC_OK or P3CC_NG
{
    value_info vi;
    vi.NumLiteral = (unsigned long)(-4);
    return VCodeGen_Store(VCode, LabelNo, SIZE_4, BASE_UPDATE_BEFORE, SrcRegType, SrcRegNo, BASE_IS_SPR, SPR_SP, OFFSET_IS_IMM, &vi, SrcFileIndex, SrcFileLine);
}
//====================================================================================================================
static int VCodeGen_Load(
    vertual_code    *VCode,         // ԃR[hi[
    int             LabelNo,        // xNoF0͊֐̓A1͊֐̏oA-1̓xȂALȊO͔Cӂ̃Wv
    int             Size,           // TCY@PCQCS
    int             Sign,           // UNSIGN(=0) / SIGN(=1)
    int             BaseUpDate,     // BASE_UPDATE_NO(=0) / BASE_UPDATE_BEFORE(=1) / BASE_UPDATE_AFTER(=2)
    char            DstRegType,     // i[惌WX^^CvF GPR(ėpREG) / SPR(REG)
    unsigned long   DstRegNo,       // i[惌WX^No
    char            BaseRegType,    // x[XWX^^CvF GPR(ėpREG) / SPR(REG)
    unsigned long   BaseRegNo,      // x[XWX^No
    char            OffsetType,     // ItZbg̃^CvFOFFSET_IS_GPR(ėpREG) / OFFSET_IS_IMM(l) / OFFSET_IS_VAR(ϐ) / OFFSET_IS_LABEL(vOx)
    value_info      *vi,            // ItZbgl̏
    int             SrcFileIndex,   // \[Xt@Ce[uIndex
    int             SrcFileLine     // \[X̉C߂
)
//====================================================================================================================
// [@\] [hn߂𐶐
// []
// [Ԓl] P3CC_OK or P3CC_NG
{
    VertualCodeInit(VCode);
    VCode->LabelNo = LabelNo;
    VCode->SrcFileIndex = SrcFileIndex;
    VCode->SrcFileLine = SrcFileLine;
    VCode->OpCode.Type = OPECODE_TYPE_LD;
    if(Size == SIZE_1){
        if(Sign == UNSIGN){
            if(BaseUpDate == BASE_UPDATE_BEFORE)      VCode->OpCode.Code = (IsOperandTypeReg(OffsetType))? OPECODE_LDB_UB_R: OPECODE_LDB_UB_I;
            else if(BaseUpDate == BASE_UPDATE_AFTER)  VCode->OpCode.Code = (IsOperandTypeReg(OffsetType))? OPECODE_LDB_UA_R: OPECODE_LDB_UA_I;
            else                                      VCode->OpCode.Code = (IsOperandTypeReg(OffsetType))? OPECODE_LDB_R   : OPECODE_LDB_I;
        }
        else{
            if(BaseUpDate == BASE_UPDATE_BEFORE)      VCode->OpCode.Code = (IsOperandTypeReg(OffsetType))? OPECODE_LDSB_UB_R: OPECODE_LDSB_UB_I;
            else if(BaseUpDate == BASE_UPDATE_AFTER)  VCode->OpCode.Code = (IsOperandTypeReg(OffsetType))? OPECODE_LDSB_UA_R: OPECODE_LDSB_UA_I;
            else                                      VCode->OpCode.Code = (IsOperandTypeReg(OffsetType))? OPECODE_LDSB_R   : OPECODE_LDSB_I;
        }
    }
    else if(Size == SIZE_2){
        if(Sign == UNSIGN){
            if(BaseUpDate == BASE_UPDATE_BEFORE)      VCode->OpCode.Code = (IsOperandTypeReg(OffsetType))? OPECODE_LDH_UB_R : OPECODE_LDH_UB_I;
            else if(BaseUpDate == BASE_UPDATE_AFTER)  VCode->OpCode.Code = (IsOperandTypeReg(OffsetType))? OPECODE_LDH_UA_R : OPECODE_LDH_UA_I;
            else                                      VCode->OpCode.Code = (IsOperandTypeReg(OffsetType))? OPECODE_LDH_R    : OPECODE_LDH_I;
        }
        else{
            if(BaseUpDate == BASE_UPDATE_BEFORE)      VCode->OpCode.Code = (IsOperandTypeReg(OffsetType))? OPECODE_LDSH_UB_R : OPECODE_LDSH_UB_I;
            else if(BaseUpDate == BASE_UPDATE_AFTER)  VCode->OpCode.Code = (IsOperandTypeReg(OffsetType))? OPECODE_LDSH_UA_R : OPECODE_LDSH_UA_I;
            else                                      VCode->OpCode.Code = (IsOperandTypeReg(OffsetType))? OPECODE_LDSH_R    : OPECODE_LDSH_I;
        }
    }
    else{
        if(BaseUpDate == BASE_UPDATE_BEFORE)      VCode->OpCode.Code = (IsOperandTypeReg(OffsetType))? OPECODE_LDW_UB_R : OPECODE_LDW_UB_I;
        else if(BaseUpDate == BASE_UPDATE_AFTER)  VCode->OpCode.Code = (IsOperandTypeReg(OffsetType))? OPECODE_LDW_UA_R : OPECODE_LDW_UA_I;
        else                                      VCode->OpCode.Code = (IsOperandTypeReg(OffsetType))? OPECODE_LDW_R    : OPECODE_LDW_I;
    }
    VCode->OpRand0.Type = DstRegType;
    VCode->OpRand0.ValueInfo.RegNo = DstRegNo;
    VCode->OpRand1.Type = BaseRegType;
    VCode->OpRand1.ValueInfo.RegNo = BaseRegNo;
    VCode->OpRand2.Type = OffsetType;
    VCode->OpRand2.ValueInfo = *vi;

    return P3CC_OK;
}

//====================================================================================================================
static int VCodeGen_Pop(vertual_code *VCode, int LabelNo, char DstRegType, unsigned long DstRegNo, int SrcFileIndex, int SrcFileLine)
//====================================================================================================================
// [@\] POP߂𐶐
// [] F*VCode,         // ԃR[hi[
// [] FLabelNo         // xNoF0͊֐̓A1͊֐̏oA-1̓xȂALȊO͔Cӂ̃Wv
// [] FDstRegType,     // i[惌WX^^CvF GPR(ėpREG) / SPR(REG)
// [] FDstRegNo,       // i[惌WX^No
// [] FSrcFileIndex,   // \[Xt@Ce[uIndex
// [] FSrcFileLine,    // \[X̉C߂
// [Ԓl] P3CC_OK or P3CC_NG
{
    value_info vi;
    vi.NumLiteral = 4;
    return VCodeGen_Load(VCode, LabelNo, SIZE_4, UNSIGN, BASE_UPDATE_AFTER, DstRegType, DstRegNo, BASE_IS_SPR, SPR_SP, OFFSET_IS_IMM, &vi, SrcFileIndex, SrcFileLine);
}

#ifdef NO_ESCAPE_SCRATCH_REG
//====================================================================================================================
static unsigned long FunctinNumOfRegAsVarGet(function *f)
//====================================================================================================================
// [@\] ϐƂĎgp郌WX^̌Ԃ
// [] function *f
// [Ԓl] 
{
    int             i;
    unsigned long   NumOfUsedRegAsVariable;
    
    NumOfUsedRegAsVariable = 0;
    for(i = 0; i < NUM_OF_VER_ON_REG + NUM_OF_SCRATCH_REG + 1; i++){
        if(i > NUM_OF_SCRATCH_REG){
            if(f->UsedRegTbl[i] != 0) ++NumOfUsedRegAsVariable;
        }
    }
    return NumOfUsedRegAsVariable;
}
#endif


//====================================================================================================================
#ifdef ARG_DELIVERY_METHOD0
static int FunctionEntryVCodeGen(vertual_code_list_header  *EntryVCodeListHeader, function *f, int SrcFileIndex, int SrcFileLine)
#endif
#ifdef ARG_DELIVERY_METHOD1
static int FunctionEntryVCodeGen(vertual_code_list_header  *EntryVCodeListHeader, function *f, int Leaf, int NoLocal, int SrcFileIndex, int SrcFileLine)
#endif
//====================================================================================================================
// [@\] ֐̃R[h
// [Ԓl] P3CC_OK or P3CC_NG
{
    int             i;
    vertual_code    VCode;
    value_info      vi;
#ifdef ARG_DELIVERY_METHOD1
    int             j;
    unsigned long   NumOfUsedReg;
#endif

#ifdef ARG_DELIVERY_METHOD0
    // PUSH, LR, SP
    VCodeGen_Push(&VCode, PLABEL_FUNC_ENTRY, SRC_IS_SPR, SPR_LR, SrcFileIndex, SrcFileLine);
    if(VertualCodeAdd(EntryVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    // PUSH, FP, SP
    VCodeGen_Push(&VCode, PLABEL_NON, SRC_IS_SPR, SPR_FP, SrcFileIndex, SrcFileLine);
    if(VertualCodeAdd(EntryVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    // MOV, FP, SP
    vi.RegNo = SPR_SP;
    VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_MOV_R, RET_IS_SPR,SPR_FP, ARG_IS_NOTING,0,  ARG_IS_SPR,&vi, SrcFileIndex, SrcFileLine);
    if(VertualCodeAdd(EntryVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    // SUB, SP, SP, $SizeOfLocal$
    vi.NumLiteral = (unsigned long)f->SizeOfLocal;
    VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_SUB_I, RET_IS_SPR, SPR_SP, ARG_IS_SPR, SPR_SP, ARG_IS_IMM,&vi, SrcFileIndex, SrcFileLine);
    if(VertualCodeAdd(EntryVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    // $EscapeRegs$
    for(i = 1; i <= f->MaxNumOfUsedVReg; i++){
        VCodeGen_Push(&VCode, PLABEL_NON, SRC_IS_GPR, i, SrcFileIndex, SrcFileLine);
        if(VertualCodeAdd(EntryVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }
#endif
#ifdef ARG_DELIVERY_METHOD1
    // SUB, SP, SP, $SizeOfLocal$
#ifdef NO_ESCAPE_SCRATCH_REG
    NumOfUsedReg = FunctinNumOfRegAsVarGet(f);
#else
    NumOfUsedReg = (unsigned long)f->MaxNumOfUsedVReg;
#endif
    vi.NumLiteral = ((unsigned long)f->SizeOfLocal) + (NumOfUsedReg * 4) + 8;
    if(vi.NumLiteral > 0x7FFF){
        PrintError(__FILE__, __LINE__, "[JϐTCYI[o[B", "", ""); return P3CC_NG;
    }
    VCodeGen_Operation(&VCode, PLABEL_FUNC_ENTRY, OPECODE_SUB_I, RET_IS_SPR, SPR_SP, ARG_IS_SPR, SPR_SP, ARG_IS_IMM,&vi, SrcFileIndex, SrcFileLine);
    if(VertualCodeAdd(EntryVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    if(Leaf == NOT_LEAF_FUNC){
        // PUSH, LR, SP
        vi.NumLiteral = ((unsigned long)f->SizeOfLocal) + (NumOfUsedReg * 4) + 4;
        VCodeGen_Store(&VCode, PLABEL_NON, SIZE_4, BASE_UPDATE_NO,  SRC_IS_SPR,SPR_LR, BASE_IS_SPR, SPR_SP, OFFSET_IS_IMM, &vi, SrcFileIndex, SrcFileLine);
        if(VertualCodeAdd(EntryVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }
    
    if(NoLocal == USE_LOCAL_AND_ARG){
        // PUSH, FP, SP
        vi.NumLiteral = ((unsigned long)f->SizeOfLocal) + (NumOfUsedReg * 4) + 0;
        VCodeGen_Store(&VCode, PLABEL_NON, SIZE_4, BASE_UPDATE_NO,  SRC_IS_SPR,SPR_FP, BASE_IS_SPR, SPR_SP, OFFSET_IS_IMM, &vi, SrcFileIndex, SrcFileLine);
        if(VertualCodeAdd(EntryVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    
        // MOV, FP, SP
        vi.NumLiteral = ((unsigned long)f->SizeOfLocal) + (NumOfUsedReg * 4) + 0;
        VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_ADD_I, RET_IS_SPR,SPR_FP, ARG_IS_SPR, SPR_SP,  ARG_IS_IMM,&vi, SrcFileIndex, SrcFileLine);
        if(VertualCodeAdd(EntryVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }

    // $EscapeRegs$
    i = 1;
#ifdef NO_ESCAPE_SCRATCH_REG
    for(j = NUM_OF_SCRATCH_REG + 1; j <= NUM_OF_VER_ON_REG + NUM_OF_SCRATCH_REG + 1; j++){
#else
    for(j = 1; j <= NUM_OF_VER_ON_REG + NUM_OF_SCRATCH_REG + 1; j++){
#endif
        if(f->UsedRegTbl[j] != 0){
            vi.NumLiteral = (unsigned long)((NumOfUsedReg - i) * 4);
            VCodeGen_Store(&VCode, PLABEL_NON, SIZE_4, BASE_UPDATE_NO,  SRC_IS_GPR,j, BASE_IS_SPR, SPR_SP, OFFSET_IS_IMM, &vi, SrcFileIndex, SrcFileLine);
            if(VertualCodeAdd(EntryVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            ++i;
        }
    }

#endif
    return P3CC_OK;
}
//====================================================================================================================
//====================================================================================================================
#ifdef ARG_DELIVERY_METHOD0
static int FunctionExitVCodeGen(vertual_code_list_header  *ExitVCodeListHeader,  function *f)
#endif
#ifdef ARG_DELIVERY_METHOD1
static int FunctionExitVCodeGen(vertual_code_list_header  *ExitVCodeListHeader,  function *f, int Leaf, int NoLocal)
#endif
//====================================================================================================================
// [@\] ֐õR[h
// [Ԓl] P3CC_OK or P3CC_NG
{
    int             i, LabelFlag;
    vertual_code    VCode;
    int             SrcFileIndex;
    int             SrcFileLine;
    value_info      vi;
#ifdef ARG_DELIVERY_METHOD1
    int             j;
    unsigned long   NumOfUsedReg;
#endif

    SrcFileIndex = TokenSrcFileIndexGet(TokenIndex);
    SrcFileLine = TokenSrcLineGet(TokenIndex);
    LabelFlag = 0;

    //VCodeGen_Nop(&VCode, PLABEL_FUNC_EXIT, SrcFileIndex, SrcFileLine);
    //if(VertualCodeAdd(ExitVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

#ifdef ARG_DELIVERY_METHOD0
    // $ReturnRegs$
    for(i = f->MaxNumOfUsedVReg; i >= 1; i--){
        if(LabelFlag == 0){
            VCodeGen_Pop(&VCode, PLABEL_FUNC_EXIT, DST_IS_GPR, i, SrcFileIndex, SrcFileLine);
            LabelFlag = 1;
        }
        else{
            VCodeGen_Pop(&VCode, PLABEL_NON, DST_IS_GPR, i, SrcFileIndex, SrcFileLine);
        }
        if(VertualCodeAdd(ExitVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }

    // ADD, SP, SP, $SizeOfLocal$
    vi.NumLiteral = (unsigned long)f->SizeOfLocal;
    if(LabelFlag == 0){
        VCodeGen_Operation(&VCode, PLABEL_FUNC_EXIT, OPECODE_ADD_I, RET_IS_SPR, SPR_SP, ARG_IS_SPR, SPR_SP, ARG_IS_IMM,&vi, SrcFileIndex, SrcFileLine);
    }
    else{
        VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_ADD_I, RET_IS_SPR, SPR_SP, ARG_IS_SPR, SPR_SP, ARG_IS_IMM,&vi, SrcFileIndex, SrcFileLine);
    }
    if(VertualCodeAdd(ExitVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    // POP, FP, SP
    VCodeGen_Pop(&VCode, PLABEL_NON, DST_IS_SPR, SPR_FP, SrcFileIndex, SrcFileLine);
    if(VertualCodeAdd(ExitVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    // POP, LR, SP
    VCodeGen_Pop(&VCode, PLABEL_NON, DST_IS_SPR, SPR_LR, SrcFileIndex, SrcFileLine);
    if(VertualCodeAdd(ExitVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
#endif


#ifdef ARG_DELIVERY_METHOD1
    // $ReturnRegs$
    //for(i = f->MaxNumOfUsedVReg; i >= 1; i--){

#ifdef NO_ESCAPE_SCRATCH_REG
    NumOfUsedReg = FunctinNumOfRegAsVarGet(f);
    i = NumOfUsedReg;
    for(j = NUM_OF_VER_ON_REG + NUM_OF_SCRATCH_REG; j >= NUM_OF_SCRATCH_REG + 1; j--){
#else
    NumOfUsedReg = (unsigned long)f->MaxNumOfUsedVReg;
    i = NumOfUsedReg;
    for(j = NUM_OF_VER_ON_REG + NUM_OF_SCRATCH_REG; j >= 1; j--){
#endif
        if(f->UsedRegTbl[j] != 0){
            vi.NumLiteral = (unsigned long)((NumOfUsedReg - i) * 4);
            if(LabelFlag == 0){
                VCodeGen_Load(&VCode, PLABEL_FUNC_EXIT, SIZE_4, UNSIGN, BASE_UPDATE_NO,  DST_IS_GPR,j,  BASE_IS_SPR,SPR_SP,  OFFSET_IS_IMM,&vi,  SrcFileIndex, SrcFileLine);
                LabelFlag = 1;
            }
            else{
                VCodeGen_Load(&VCode, PLABEL_NON, SIZE_4, UNSIGN, BASE_UPDATE_NO,  DST_IS_GPR,j,  BASE_IS_SPR,SPR_SP,  OFFSET_IS_IMM,&vi,  SrcFileIndex, SrcFileLine);
            }
            if(VertualCodeAdd(ExitVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
            --i;
        }
    }

    if(NoLocal == USE_LOCAL_AND_ARG){
        // POP, FP, SP
        vi.NumLiteral = ((unsigned long)f->SizeOfLocal) + (NumOfUsedReg * 4) + 0;
        if(LabelFlag == 0){
            VCodeGen_Load(&VCode, PLABEL_FUNC_EXIT, SIZE_4, UNSIGN, BASE_UPDATE_NO,  DST_IS_SPR,SPR_FP,  BASE_IS_SPR,SPR_SP,  OFFSET_IS_IMM,&vi,  SrcFileIndex, SrcFileLine);
            LabelFlag = 1;
        }
        else{
            VCodeGen_Load(&VCode, PLABEL_NON, SIZE_4, UNSIGN, BASE_UPDATE_NO,  DST_IS_SPR,SPR_FP,  BASE_IS_SPR,SPR_SP,  OFFSET_IS_IMM,&vi,  SrcFileIndex, SrcFileLine);
        }
        if(VertualCodeAdd(ExitVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }
    
    if(Leaf == NOT_LEAF_FUNC){
        // POP, LR, SP
        vi.NumLiteral = ((unsigned long)f->SizeOfLocal) + (NumOfUsedReg * 4) + 4;
        if(LabelFlag == 0){
            VCodeGen_Load(&VCode, PLABEL_FUNC_EXIT, SIZE_4, UNSIGN, BASE_UPDATE_NO,  DST_IS_SPR,SPR_LR,  BASE_IS_SPR,SPR_SP,  OFFSET_IS_IMM,&vi,  SrcFileIndex, SrcFileLine);
            LabelFlag = 1;
        }
        else{
            VCodeGen_Load(&VCode, PLABEL_NON, SIZE_4, UNSIGN, BASE_UPDATE_NO,  DST_IS_SPR,SPR_LR,  BASE_IS_SPR,SPR_SP,  OFFSET_IS_IMM,&vi,  SrcFileIndex, SrcFileLine);
        }
        if(VertualCodeAdd(ExitVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }
    }

    // ADD, SP, SP, $SizeOfLocal$
    vi.NumLiteral = ((unsigned long)f->SizeOfLocal) + (NumOfUsedReg * 4) + 8;
    if(LabelFlag == 0){
        VCodeGen_Operation(&VCode, PLABEL_FUNC_EXIT, OPECODE_ADD_I, RET_IS_SPR, SPR_SP, ARG_IS_SPR, SPR_SP, ARG_IS_IMM,&vi, SrcFileIndex, SrcFileLine);
    }
    else{
        VCodeGen_Operation(&VCode, PLABEL_NON, OPECODE_ADD_I, RET_IS_SPR, SPR_SP, ARG_IS_SPR, SPR_SP, ARG_IS_IMM,&vi, SrcFileIndex, SrcFileLine);
    }
    if(VertualCodeAdd(ExitVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

#endif
    // RTS, AL
    vi.RegNo = SPR_LR;
    VCodeGen_Jump(&VCode, PLABEL_NON, OPECODE_DJP_R, COND_ALWAYS, ARG_IS_SPR, &vi, SrcFileIndex, SrcFileLine);
    if(VertualCodeAdd(ExitVCodeListHeader, &VCode) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    //le[u쐬
    if(ConvertLiteral2Immset(CurrentFuncInfo->LiteralLabelList, ExitVCodeListHeader, SrcFileIndex, SrcFileLine) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG; }

    return P3CC_OK;
}
//====================================================================================================================

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// x֘Ȁ
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//====================================================================================================================
static int LiteralLabelListAdd(int LabelNo, int Type, literal_label_ext_info *ExtInfo)
//====================================================================================================================
// [@\] lxe[uǉ
// []
// [Ԓl] P3CC_OK
{
    literal_label   *Lbuf, *L;

    if(CurrentFuncInfo == NULL){
        PrintError(__FILE__, __LINE__, "Jg֐|C^ki炭RpC̃oOjB", "", "");
        return P3CC_NG;
    }

    Lbuf = calloc(1, sizeof(literal_label));
    if(Lbuf == NULL){
        PrintError(__FILE__, __LINE__, "lxe[up̈mێsB", "", "");
        return P3CC_NG;
    }
    Lbuf->Next = NULL;
    Lbuf->LabelNo = LabelNo;
    Lbuf->Type = Type;
    Lbuf->ExtInfo = *ExtInfo;

    L = CurrentFuncInfo->LiteralLabelList;
    if(L == NULL){
        CurrentFuncInfo->LiteralLabelList = Lbuf;
    }
    else{
        while(1){
            if(L->Next == NULL) break;
            L = L->Next;
        }
        L->Next = Lbuf;
    }

    return P3CC_OK;
}
//====================================================================================================================
//static int LiteralLabelListFind(int Type, literal_label_ext_info *ExtInfo)
static int LiteralLabelListFind(literal_label_ext_info *ExtInfo)
//====================================================================================================================
// [@\] lxe[u
// []
// [Ԓl] ALabelNoi̐jԂBȂ-1Ԃ
{
    literal_label   *L;

    if(CurrentFuncInfo == NULL){
        PrintError(__FILE__, __LINE__, "Jg֐|C^ki炭RpC̃oOjB", "", "");
        return P3CC_NG;
    }

    L = CurrentFuncInfo->LiteralLabelList;
    while(1){
        if(L == NULL) break;
        //if((Type == L->Type) && (ExtInfo->Num == L->ExtInfo.Num)) return L->LabelNo;
        if(ExtInfo->Num == L->ExtInfo.Num) return L->LabelNo;
        L = L->Next;
    }

    return P3CC_NG;
}
//====================================================================================================================
static int ConvertLiteral2Immset(literal_label *LiteralLabelList, vertual_code_list_header *ExitVCodeListHeader, int SrcFileIndex, int SrcFileLine)
//====================================================================================================================
// [@\] lxe[uR[h
// [] vertual_code_list_header *VCodeListHeader,
// [Ԓl] P3CC_OK
{
    literal_label       *L;
    char                *Str;
    unsigned long       Val;
    vertual_code        VCode;
    int                 LabelNo;
    variable            *v;
    vertual_code_list_header *VCodeListHeader;

    //L = f->LiteralLabelList;
    L = LiteralLabelList;
    if(L == NULL) return P3CC_OK;

    //VCodeListHeader = &f->VCodeListHeader;
    VCodeListHeader = ExitVCodeListHeader;
    while(1){
        LabelNo = L->LabelNo;
        if(L->Type == LLABEL_NUMERIC_LITERAL){
            VCodeGen_ImmSet(&VCode, LabelNo, L->ExtInfo.Num, SrcFileIndex, SrcFileLine);
            if(VertualCodeAdd(VCodeListHeader, &VCode) == P3CC_NG){
                PrintError(__FILE__, __LINE__, "le[uϊsB", "", "");
                return P3CC_NG;
            }
        }
        else if(L->Type == LLABEL_STRING_LITERAL){
            Str = L->ExtInfo.Str;
            while(1){
                Val = (*Str & 0xFF) << 24;
                if(*Str == '\0'){
                    VCodeGen_ImmSet(&VCode, LabelNo, Val, SrcFileIndex, SrcFileLine);
                    if(VertualCodeAdd(VCodeListHeader, &VCode) == P3CC_NG){
                        PrintError(__FILE__, __LINE__, "le[uϊsB", "", "");
                        return P3CC_NG;
                    }
                    break;
                }
                ++Str;
                Val |= (*Str & 0xFF) << 16;
                if(*Str == '\0'){
                    VCodeGen_ImmSet(&VCode, LabelNo, Val, SrcFileIndex, SrcFileLine);
                    if(VertualCodeAdd(VCodeListHeader, &VCode) == P3CC_NG){
                        PrintError(__FILE__, __LINE__, "le[uϊsB", "", "");
                        return P3CC_NG;
                    }
                    break;
                }
                ++Str;
                Val |= (*Str & 0xFF) << 8;
                if(*Str == '\0'){
                    VCodeGen_ImmSet(&VCode, LabelNo, Val, SrcFileIndex, SrcFileLine);
                    if(VertualCodeAdd(VCodeListHeader, &VCode) == P3CC_NG){
                        PrintError(__FILE__, __LINE__, "le[uϊsB", "", "");
                        return P3CC_NG;
                    }
                    break;
                }
                ++Str;
                Val |= (*Str & 0xFF);
                VCodeGen_ImmSet(&VCode, LabelNo, Val, SrcFileIndex, SrcFileLine);
                LabelNo = PLABEL_NON;
                if(VertualCodeAdd(VCodeListHeader, &VCode) == P3CC_NG){
                    PrintError(__FILE__, __LINE__, "le[uϊsB", "", "");
                    return P3CC_NG;
                }
                if(*Str == '\0'){
                    break;
                }
                ++Str;
            }
        }
        else if(L->Type == LLABEL_VARIABLE){
            VertualCodeInit(&VCode);
            VCode.LabelNo = LabelNo;
            VCode.SrcFileIndex = SrcFileIndex;
            VCode.SrcFileLine = SrcFileLine;
            VCode.OpCode.Type = OPECODE_TYPE_DUMMY;
            VCode.OpCode.Code = OPECODE_IMMSET;
            VCode.OpRand0.Type = OPERAND_TYPE_VARIABLE;
            VCode.OpRand0.ValueInfo.var = L->ExtInfo.v;
            if(VertualCodeAdd(VCodeListHeader, &VCode) == P3CC_NG){
                PrintError(__FILE__, __LINE__, "le[uϊsB", "", "");
                return P3CC_NG;
            }
        }
        else if(L->Type == LLABEL_FUNCTION){
            VertualCodeInit(&VCode);
            VCode.LabelNo = LabelNo;
            VCode.SrcFileIndex = SrcFileIndex;
            VCode.SrcFileLine = SrcFileLine;
            VCode.OpCode.Type = OPECODE_TYPE_DUMMY;
            VCode.OpCode.Code = OPECODE_IMMSET;
            VCode.OpRand0.Type = OPERAND_TYPE_FUNCTION;
            VCode.OpRand0.ValueInfo.func = L->ExtInfo.f;
            if(VertualCodeAdd(VCodeListHeader, &VCode) == P3CC_NG){
                PrintError(__FILE__, __LINE__, "le[uϊsB", "", "");
                return P3CC_NG;
            }
        }
        else{
            PrintError(__FILE__, __LINE__, "ΉĂȂľ^B", "", "");
            return P3CC_NG;
        }
        if(L->Next == NULL) break;
        L = L->Next;
    }

    return P3CC_OK;
}
//====================================================================================================================
static int UserLabelListAdd(int LabelNo, char *LabelStr)
//====================================================================================================================
// [@\] lxe[uǉ
// []
// [Ԓl] P3CC_OK
{
    user_label   *Lbuf, *L;

    if(CurrentFuncInfo == NULL){
        PrintError(__FILE__, __LINE__, "Jg֐|C^ki炭RpC̃oOjB", "", "");
        return P3CC_NG;
    }

    Lbuf = calloc(1, sizeof(user_label));
    if(Lbuf == NULL){
        PrintError(__FILE__, __LINE__, "[U[`xe[up̈mێsB", "", "");
        return P3CC_NG;
    }
    Lbuf->Next = NULL;
    Lbuf->LabelNo = LabelNo;
    Lbuf->LabelStr = LabelStr;
    Lbuf->ReferSolvFlag = 0;

    L = CurrentFuncInfo->UserLabelList;
    if(L == NULL){
        CurrentFuncInfo->UserLabelList = Lbuf;
    }
    else{
        while(1){
            if(L->Next == NULL) break;
            L = L->Next;
        }
        L->Next = Lbuf;
    }

    return P3CC_OK;
}
//====================================================================================================================
static user_label *UserLabelFindByLabelNo(int LabelNo)
//====================================================================================================================
// [@\] lxe[uǉ
// []
// [Ԓl] ȂNULL
{
    user_label   *L;

    if(CurrentFuncInfo == NULL){
        PrintError(__FILE__, __LINE__, "Jg֐|C^ki炭RpC̃oOjB", "", "");
        return NULL;
    }

    L = CurrentFuncInfo->UserLabelList;
    if(L == NULL){
        return NULL;
    }
    else{
        while(1){
            if(L->LabelNo == LabelNo) break;
            if(L->Next == NULL) return NULL;
            L = L->Next;
        }
    }
    return L;
}
//====================================================================================================================
static user_label *UserLabelFindByLabelStr(char *LabelStr)
//====================================================================================================================
// [@\] lxe[uǉ
// []
// [Ԓl] ȂNULL
{
    user_label   *L;

    if(CurrentFuncInfo == NULL){
        PrintError(__FILE__, __LINE__, "Jg֐|C^ki炭RpC̃oOjB", "", "");
        return NULL;
    }

    L = CurrentFuncInfo->UserLabelList;
    if(L == NULL){
        return NULL;
    }
    else{
        while(1){
            if(strcmp(L->LabelStr,LabelStr) == 0) break;
            if(L->Next == NULL) return NULL;
            L = L->Next;
        }
    }
    return L;
}

//====================================================================================================================
static int  VertualCodeLabelNoReset(void)
//====================================================================================================================
// [@\] xNo
// []
// [Ԓl] P3CC_OK
{
    NumOfLabel = PLABEL_FUNC_EXIT + 1;
    return P3CC_OK;
}
//====================================================================================================================
static int  VertualCodeNewLabelNoGet(void)
//====================================================================================================================
// [@\] VKxNo擾
// []
// [Ԓl] xNo
{
    ++NumOfLabel;
    return NumOfLabel;
}

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// RpCʁiAZu`jo͊֐Q
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//====================================================================================================================
static int AsmOut(void)
//====================================================================================================================
// [@\] AZuTOP֐
// []
// [Ԓl] P3CC_OK/NG
{
    FILE        *Fp;
    int         Ret;
    char        AsmOutFileName[MAX_SOURCE_FILE_NAME_CHAR];
    //o̓t@C쐬āAt@CI[v
    FileExtensionSwitch(SrcFileName, AsmOutFileName, "asm");
    Fp = fopen(AsmOutFileName, "w");
    if(Fp==NULL){
        fprintf(MsgOut, "yG[z(p3cc2  LINE:%d) RpCʏo̓t@C(%s)I[vs\n", __LINE__, AsmOutFileName);
        return P3CC_NG;
    }

    if((Ret = AsmOutHeader(Fp))             == P3CC_NG) goto EndOfAsmOut; // wb_o
    //if((Ret = AsmOutSrcFileList(Fp))        == P3CC_NG) goto EndOfAsmOut; // t@CXgo
    if((Ret = AsmOutExtFuncList(Fp))        == P3CC_NG) goto EndOfAsmOut; // O`ꂽ֐Xgo
    if((Ret = AsmOutExtVarList(Fp))         == P3CC_NG) goto EndOfAsmOut; // O`ꂽϐXgo
    if((Ret = AsmOutGlobalVarList(Fp))      == P3CC_NG) goto EndOfAsmOut; // `ꂽO[oϐXgo
    if((Ret = AsmOutPrivateVarList(Fp))     == P3CC_NG) goto EndOfAsmOut; // ֐Ostatic`ꂽϐXgo
    if((Ret = AsmOutLocalStaticVarList(Fp)) == P3CC_NG) goto EndOfAsmOut; // ֐static`ꂽϐXgo
    if((Ret = AsmOutFunc(Fp))               == P3CC_NG) goto EndOfAsmOut; // ׂĂ̊֐̋Lqo

EndOfAsmOut:
    //t@CN[Y
    fclose(Fp);
    return Ret;
}
//====================================================================================================================
static int  AsmOutFunc(FILE *Fp)
//====================================================================================================================
// [@\] ׂĂ̊֐̋Lqo
// []
// [Ԓl] P3CC_OK/P3CC_NG
{
    function        *f;

    f = FunctionList;
    while(1){
        if(f == NULL) break;
        if(AsmOutFuncBody(Fp, f) == P3CC_NG) return P3CC_NG;
        f = f->Next;
    }
    return P3CC_OK;
}
//====================================================================================================================
static int AsmOutFuncBody(FILE *Fp, function *f)
//====================================================================================================================
// [@\] ֐̋Lqo
// []
// [Ԓl] P3CC_OK/P3CC_NG
{
    char            FuncName[MAX_SOURCE_FILE_NAME_CHAR + MAX_IDENTIFIER_CHAR];

    if(f == NULL) return P3CC_OK;

    if(f->DeclaredBody != 0){
        fprintf(Fp,"\n");
        fprintf(Fp,"\n");
        fprintf(Fp,"//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\n");
        fprintf(Fp,"//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\n");
        fprintf(Fp,"//- ֐{̂̋Lq \n");
        fprintf(Fp,"//- : .FUNCTION  ֐\n");
        fprintf(Fp,"//- : [ȗ] .ARG錾Xg\n");
        fprintf(Fp,"//- : [ȗ] .LOCAL_VAR錾Xg\n");
        fprintf(Fp,"//- : ֐:擪̃R[h\n");
        fprintf(Fp,"//- :           c\n");
        fprintf(Fp,"//- :        Ō̃R[h\n");
        fprintf(Fp,"//- : .ENDFUNCTION  ֐\n");
        fprintf(Fp,"//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\n");
        fprintf(Fp,"//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\n");

        if(AsmOutMakeFuncName(FuncName, f) == P3CC_NG) return P3CC_NG;
        fprintf(Fp,".FUNCTION  %s\n", FuncName);
        if(AsmOutArgList(Fp, f->ArgList) == P3CC_NG) return P3CC_NG;
        if(AsmOutLocalVarList(Fp, f->VariableList) == P3CC_NG) return P3CC_NG;
        if(AsmOutCodeAll(Fp, f) == P3CC_NG) return P3CC_NG;
        fprintf(Fp,".ENDFUNCTION\n");
    }

    return P3CC_OK;
}
//====================================================================================================================
static int AsmOutCodeAll(FILE *Fp, function *f)
//====================================================================================================================
// [@\] SR[ho
// []
// [Ԓl] P3CC_OK/P3CC_NG
{
    vertual_code        *VCode;

    VCode = f->VCodeListHeader.Entry;
    if(VCode == NULL) return P3CC_OK;
    fprintf(Fp,"//----------------------------------------------------------\n");
    fprintf(Fp,"//- ꂽsR[h \n");
    fprintf(Fp,"//- : [xF] IyR[h, Iyh[ ,Iyh] {fobO} //Rg\n");
    fprintf(Fp,"//- : []͏ȗ\n");
    fprintf(Fp,"//- : {fobO}͎̏b{\[Xt@CNo, s}\n");
    fprintf(Fp,"//----------------------------------------------------------\n");
    fprintf(Fp,".CODE\n");
    while(1){
        if(VCode == NULL) break;
        if(AsmOutCode(Fp, VCode, f) == P3CC_NG) return P3CC_NG;
        VCode = VCode->Next;
    }
    return P3CC_OK;
}
//====================================================================================================================
static int AsmOutCode(FILE *Fp, vertual_code *VCode, function *f)
//====================================================================================================================
// [@\] R[ho
// []
// [Ԓl] P3CC_OK/P3CC_NG
{
    int             i, StrLen, StrLenAll;

    if(AsmOutLabel(Fp, VCode, f) == P3CC_NG) return P3CC_NG;
    if((StrLen = AsmOutOpCode(Fp, &(VCode->OpCode))) == P3CC_NG) return P3CC_NG;
    if(VCode->OpCode.Code != OPECODE_NOP) {
        fprintf(Fp, ","); StrLen += 1;
    }
    StrLenAll = StrLen;
    for(i = StrLen; i <= 8; i ++){ fprintf(Fp, " "); ++StrLenAll;}
    if((StrLen = AsmOutOpRand(Fp, VCode)) == P3CC_NG) return P3CC_NG;
    StrLenAll += StrLen;
    for(i = StrLenAll; i < 48; i ++){ fprintf(Fp, " "); }
    AsmOutSrcInfo(Fp, VCode);
    AsmOutSrcCode(Fp, VCode);
    fprintf(Fp,"\n");
    return P3CC_OK;
}
//====================================================================================================================
static int AsmOutSrcCode(FILE *Fp, vertual_code *VCode)
//====================================================================================================================
// [@\] \[XR[ho
// []
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         i;
    int                         FileNo;
    int                         LineNo;
    static int                  FileNoOld = -1;
    static int                  LineNoOld = -1;

    FileNo = VCode->SrcFileIndex;
    LineNo = VCode->SrcFileLine;
    if((FileNo != FileNoOld) || (LineNo != LineNoOld)){
        FileNoOld = FileNo;
        LineNoOld = LineNo;
        for(i = 0; i < Cc0Result->NumOfSrcLine; i++){
            if((Cc0Result->SrcTbl[i].SourceFileNo == FileNo) && (Cc0Result->SrcTbl[i].SourceLineNo == LineNo)) break;
        }
        fprintf(Fp," %s", Cc0Result->SrcTbl[i].SourceCode);
    }
    return P3CC_OK;
}
//====================================================================================================================
static int AsmOutSrcInfo(FILE *Fp, vertual_code *VCode)
//====================================================================================================================
// [@\] \[Xt@Cƍso
// []
// [Ԓl] P3CC_OK/P3CC_NG
{

    //fprintf(Fp, "{%3d, %5d}",VCode->SrcFileIndex, VCode->SrcFileLine);
    fprintf(Fp, "// %s,%4d : ",TokenSrcFileNameGetBySrcTblIndex(VCode->SrcFileIndex), VCode->SrcFileLine);
    return P3CC_OK;
}
//====================================================================================================================
static int AsmOutOpRand(FILE *Fp, vertual_code *VCode)
//====================================================================================================================
// [@\] ԃR[h̃IyheLXgɕϊ
// []
// [Ԓl] sP3CC_NG(-1)A0ȏ̒l
{
    int             i, LastStrLen, StrLenAll;
    char            buf[MAX_SOURCE_FILE_NAME_CHAR ];


    if(AsmOutOpRandBody(buf, &(VCode->OpRand0)) == P3CC_NG) return P3CC_NG;
    fprintf(Fp,"%s",buf);
    LastStrLen = strlen(buf);
    StrLenAll = LastStrLen;
    if(AsmOutOpRandBody(buf, &(VCode->OpRand1)) == P3CC_NG) return P3CC_NG;
    if(buf[0] != '\0'){
        fprintf(Fp, ", "); StrLenAll += 2;  LastStrLen += 2;
        for(i = LastStrLen; i < 5; i ++){ fprintf(Fp, " "); ++StrLenAll;}
        fprintf(Fp,"%s",buf);
        LastStrLen = strlen(buf);
        StrLenAll += LastStrLen;
    }
    if(AsmOutOpRandBody(buf, &(VCode->OpRand2)) == P3CC_NG) return P3CC_NG;
    if(buf[0] != '\0'){
        fprintf(Fp, ", "); StrLenAll += 2;  LastStrLen += 2;
        for(i = LastStrLen; i < 5; i ++){fprintf(Fp, " "); ++StrLenAll;}
        fprintf(Fp,"%s",buf);
        StrLenAll += strlen(buf);
    }
    return StrLenAll;
}
//====================================================================================================================
static int AsmOutOpRandBody(char *p, v_operand *OpRand)
//====================================================================================================================
// [@\] ԃR[h̃IyheLXgɕϊ
// []
// [Ԓl] sP3CC_NG(-1)A0ȏ̒l
{
    variable        *v;
    char            Name[MAX_SOURCE_FILE_NAME_CHAR + MAX_IDENTIFIER_CHAR];

    if(OpRand->Type == OPERAND_TYPE_NOTHING){
        *p = '\0';
    }
    else if(OpRand->Type == OPERAND_TYPE_SPR){
        if     (OpRand->ValueInfo.RegNo == SPR_GP ) sprintf(p, "gp");
        else if(OpRand->ValueInfo.RegNo == SPR_FP ) sprintf(p, "fp");
        else if(OpRand->ValueInfo.RegNo == SPR_SP ) sprintf(p, "sp");
        else if(OpRand->ValueInfo.RegNo == SPR_LR ) sprintf(p, "lr");
        else if(OpRand->ValueInfo.RegNo == SPR_PC ) sprintf(p, "pc");
        else if(OpRand->ValueInfo.RegNo == SPR_NON) sprintf(p, "non");
        else{
            sprintf(p, "`̓ꃌWX^ ");
            PrintError(__FILE__, __LINE__, "RpCʏo͒", "`̓ꃌWX^", "oB");
            return P3CC_NG;
        }
    }
    else if(OpRand->Type == OPERAND_TYPE_GPR){
        sprintf(p, "r%d",OpRand->ValueInfo.RegNo);
    }
    else if(OpRand->Type == OPERAND_TYPE_SHORT_IMM){
        sprintf(p, "0x%04x", 0xFFFF & OpRand->ValueInfo.NumLiteral);
    }
    else if(OpRand->Type == OPERAND_TYPE_LONG_IMM){
        sprintf(p, "0x%08x",OpRand->ValueInfo.NumLiteral);
    }
    else if(OpRand->Type == OPERAND_TYPE_CONDITION){
        if     (OpRand->ValueInfo.Condition == COND_ALWAYS                  ) sprintf(p, "al");
        else if(OpRand->ValueInfo.Condition == COND_ZERO                    ) sprintf(p, "eq");
        else if(OpRand->ValueInfo.Condition == COND_NOT_ZERO                ) sprintf(p, "ne");
        else if(OpRand->ValueInfo.Condition == COND_UNSIGNED_HIGHER_OR_SAME ) sprintf(p, "hs");
        else if(OpRand->ValueInfo.Condition == COND_UNSIGNED_LOWER          ) sprintf(p, "lo");
        else if(OpRand->ValueInfo.Condition == COND_MINUS                   ) sprintf(p, "mi");
        else if(OpRand->ValueInfo.Condition == COND_PLUS                    ) sprintf(p, "pl");
        else if(OpRand->ValueInfo.Condition == COND_OVERFLOW                ) sprintf(p, "vs");
        else if(OpRand->ValueInfo.Condition == COND_NOT_OVERFLOW            ) sprintf(p, "vc");
        else if(OpRand->ValueInfo.Condition == COND_UNSIGNED_HIGHER         ) sprintf(p, "hi");
        else if(OpRand->ValueInfo.Condition == COND_UNSIGNED_LOWER_OR_SAME  ) sprintf(p, "ls");
        else if(OpRand->ValueInfo.Condition == COND_SIGNED_GRATER_THAN_OR_EQ) sprintf(p, "ge");
        else if(OpRand->ValueInfo.Condition == COND_SIGNED_LESS_THAN        ) sprintf(p, "lt");
        else if(OpRand->ValueInfo.Condition == COND_SIGNED_GRATER_THAN      ) sprintf(p, "gt");
        else if(OpRand->ValueInfo.Condition == COND_SIGNED_LESS_THAN_OR_EQ  ) sprintf(p, "le");
        else{
            sprintf(p, "`̏R[h");
            PrintError(__FILE__, __LINE__, "RpCʏo͒", "`̏R[h", "oB");
            return P3CC_NG;
        }
    }
    else if(OpRand->Type == OPERAND_TYPE_LABEL){
        sprintf(p, "PcOffsetOf(_@%04d)",OpRand->ValueInfo.LabelNo);
    }
    else if(OpRand->Type == OPERAND_TYPE_LABEL_ADR_HI){
        sprintf(p, "AddressHiOf(_@%04d)",OpRand->ValueInfo.LabelNo);
    }
    else if(OpRand->Type == OPERAND_TYPE_LABEL_ADR_LO){
        sprintf(p, "AddressLoOf(_@%04d)",OpRand->ValueInfo.LabelNo);
    }
    else if(OpRand->Type == OPERAND_TYPE_FUNCTION){
        if(AsmOutMakeFuncName(Name, OpRand->ValueInfo.func) == P3CC_NG) return P3CC_NG;
        sprintf(p, "EntryPointOf(%s)",Name);
    }
    else if(OpRand->Type == OPERAND_TYPE_PC_OFFSET_OFFUNCTION){
        if(AsmOutMakeFuncName(Name, OpRand->ValueInfo.func) == P3CC_NG) return P3CC_NG;
        sprintf(p, "PcOffsetOf(%s)",Name);
    }
    else if(OpRand->Type == OPERAND_TYPE_FUNCTION_HI){
        if(AsmOutMakeFuncName(Name, OpRand->ValueInfo.func) == P3CC_NG) return P3CC_NG;
        sprintf(p, "EntryPointHiOf(%s)",Name);
    }
    else if(OpRand->Type == OPERAND_TYPE_FUNCTION_LO){
        if(AsmOutMakeFuncName(Name, OpRand->ValueInfo.func) == P3CC_NG) return P3CC_NG;
        sprintf(p, "EntryPointLoOf(%s)",Name);
    }
    else if(OpRand->Type == OPERAND_TYPE_VARIABLE){
        v = OpRand->ValueInfo.var;
        if(AsmOutMakeVarName(Name, v) == P3CC_NG) return P3CC_NG;
        if((v->Scope == SCOPE_AT) || (v->Scope == SCOPE_ARG)){
            if(OpRand->VariableOffset != 0){
                sprintf(p, "(FpOffsetOf(%s) + %d)", Name, OpRand->VariableOffset);
            }
            else{
                sprintf(p, "FpOffsetOf(%s)", Name);
            }
        }
        else{
#ifdef USE_GP
            sprintf(p, "GpOffsetOf(%s)", Name);
#else
            sprintf(p, "AddressOf(%s)", Name);
#endif
        }
    }
    else if((OpRand->Type == OPERAND_TYPE_VARIABLE_HI) || (OpRand->Type == OPERAND_TYPE_VARIABLE_LO)){
        v = OpRand->ValueInfo.var;
        if(AsmOutMakeVarName(Name, v) == P3CC_NG) return P3CC_NG;
        if((v->Scope == SCOPE_AT) || (v->Scope == SCOPE_ARG)){
            PrintError(__FILE__, __LINE__, "ÓIϐ̃AhXwɎgpłȂʃR[hoB", "RpC̃oOB", "");
            return P3CC_NG;
        }
        else{
            if(OpRand->Type == OPERAND_TYPE_VARIABLE_HI){
#ifdef USE_GP
                sprintf(p, "GpOffsetHiOf(%s)", Name);
#else
                sprintf(p, "GvAddressHiOf(%s)", Name);
#endif
            }
            else{
#ifdef USE_GP
                sprintf(p, "GpOffsetLoOf(%s)", Name);
#else
                sprintf(p, "GvAddressLoOf(%s)", Name);
#endif
            }
        }
    }
    else if(OpRand->Type == OPERAND_TYPE_SIZEOF_LOCALS){
        sprintf(p, "$SizeOfLocals$");
    }
    else if(OpRand->Type == OPERAND_TYPE_SIZEOF_GLOBALS){
        sprintf(p, "$SizeOfGlobals$");
    }
    else if(OpRand->Type == OPERAND_TYPE_SIZEOF_ARGS){
        sprintf(p, "$SizeOfArgs$");
    }
    else{
        sprintf(p, "`̃Iyh^Cv");
        PrintError(__FILE__, __LINE__, "RpCʏo͒", "`̏R[h", "oB");
        return P3CC_NG;
    }

    return P3CC_OK;
}
//====================================================================================================================
static int AsmOutOpCode(FILE *Fp, v_opecode *OpCode)
//====================================================================================================================
// [@\] OpCodeo
// []
// [Ԓl] sP3CC_NG(-1)A0ȏ̒l
{
    unsigned char   Code;
    Code = OpCode->Code;
    if(Code == OPECODE_JP_R       ) { fprintf(Fp, "jpr"    ); return strlen("jpr"    );}
    if(Code == OPECODE_JP_I       ) { fprintf(Fp, "jpi"    ); return strlen("jpi"    );}
    if(Code == OPECODE_CALL_R     ) { fprintf(Fp, "callr"  ); return strlen("callr"  );}
    if(Code == OPECODE_CALL_I     ) { fprintf(Fp, "calli"  ); return strlen("calli"  );}
    if(Code == OPECODE_DJP_R      ) { fprintf(Fp, "djpr"   ); return strlen("djpr"   );}
    if(Code == OPECODE_RTI_R      ) { fprintf(Fp, "rtir"   ); return strlen("rtir"   );}
    if(Code == OPECODE_LDW_R      ) { fprintf(Fp, "ldwr"   ); return strlen("ldwr"   );}
    if(Code == OPECODE_LDW_I      ) { fprintf(Fp, "ldwi"   ); return strlen("ldwi"   );}
    if(Code == OPECODE_LDW_UB_R   ) { fprintf(Fp, "ldwubr" ); return strlen("ldwubr" );}
    if(Code == OPECODE_LDW_UB_I   ) { fprintf(Fp, "ldwubi" ); return strlen("ldwubi" );}
    if(Code == OPECODE_LDW_UA_R   ) { fprintf(Fp, "ldwuar" ); return strlen("ldwuar" );}
    if(Code == OPECODE_LDW_UA_I   ) { fprintf(Fp, "ldwuai" ); return strlen("ldwuai" );}
    if(Code == OPECODE_LDH_R      ) { fprintf(Fp, "ldhr"   ); return strlen("ldhr"   );}
    if(Code == OPECODE_LDH_I      ) { fprintf(Fp, "ldhi"   ); return strlen("ldhi"   );}
    if(Code == OPECODE_LDH_UB_R   ) { fprintf(Fp, "ldhubr" ); return strlen("ldhubr" );}
    if(Code == OPECODE_LDH_UB_I   ) { fprintf(Fp, "ldhubi" ); return strlen("ldhubi" );}
    if(Code == OPECODE_LDH_UA_R   ) { fprintf(Fp, "ldhuar" ); return strlen("ldhuar" );}
    if(Code == OPECODE_LDH_UA_I   ) { fprintf(Fp, "ldhuai" ); return strlen("ldhuai" );}
    if(Code == OPECODE_LDB_R      ) { fprintf(Fp, "ldbr"   ); return strlen("ldbr"   );}
    if(Code == OPECODE_LDB_I      ) { fprintf(Fp, "ldbi"   ); return strlen("ldbi"   );}
    if(Code == OPECODE_LDB_UB_R   ) { fprintf(Fp, "ldbubr" ); return strlen("ldbubr" );}
    if(Code == OPECODE_LDB_UB_I   ) { fprintf(Fp, "ldbubi" ); return strlen("ldbubi" );}
    if(Code == OPECODE_LDB_UA_R   ) { fprintf(Fp, "ldbuar" ); return strlen("ldbuar" );}
    if(Code == OPECODE_LDB_UA_I   ) { fprintf(Fp, "ldbuai" ); return strlen("ldbuai" );}
    if(Code == OPECODE_LDSH_R     ) { fprintf(Fp, "ldshr"  ); return strlen("ldshr"  );}
    if(Code == OPECODE_LDSH_I     ) { fprintf(Fp, "ldshi"  ); return strlen("ldshi"  );}
    if(Code == OPECODE_LDSH_UB_R  ) { fprintf(Fp, "ldshubr"); return strlen("ldshubr");}
    if(Code == OPECODE_LDSH_UB_I  ) { fprintf(Fp, "ldshubi"); return strlen("ldshubi");}
    if(Code == OPECODE_LDSH_UA_R  ) { fprintf(Fp, "ldshuar"); return strlen("ldshuar");}
    if(Code == OPECODE_LDSH_UA_I  ) { fprintf(Fp, "ldshuai"); return strlen("ldshuai");}
    if(Code == OPECODE_LDSB_R     ) { fprintf(Fp, "ldsbr"  ); return strlen("ldsbr"  );}
    if(Code == OPECODE_LDSB_I     ) { fprintf(Fp, "ldsbi"  ); return strlen("ldsbi"  );}
    if(Code == OPECODE_LDSB_UB_R  ) { fprintf(Fp, "ldsbubr"); return strlen("ldsbubr");}
    if(Code == OPECODE_LDSB_UB_I  ) { fprintf(Fp, "ldsbubi"); return strlen("ldsbubi");}
    if(Code == OPECODE_LDSB_UA_R  ) { fprintf(Fp, "ldsbuar"); return strlen("ldsbuar");}
    if(Code == OPECODE_LDSB_UA_I  ) { fprintf(Fp, "ldsbuai"); return strlen("ldsbuai");}
    if(Code == OPECODE_STW_R      ) { fprintf(Fp, "stwr"   ); return strlen("stwr"   );}
    if(Code == OPECODE_STW_I      ) { fprintf(Fp, "stwi"   ); return strlen("stwi"   );}
    if(Code == OPECODE_STW_UB_R   ) { fprintf(Fp, "stwubr" ); return strlen("stwubr" );}
    if(Code == OPECODE_STW_UB_I   ) { fprintf(Fp, "stwubi" ); return strlen("stwubi" );}
    if(Code == OPECODE_STW_UA_R   ) { fprintf(Fp, "stwuar" ); return strlen("stwuar" );}
    if(Code == OPECODE_STW_UA_I   ) { fprintf(Fp, "stwuai" ); return strlen("stwuai" );}
    if(Code == OPECODE_STH_R      ) { fprintf(Fp, "sthr"   ); return strlen("sthr"   );}
    if(Code == OPECODE_STH_I      ) { fprintf(Fp, "sthi"   ); return strlen("sthi"   );}
    if(Code == OPECODE_STH_UB_R   ) { fprintf(Fp, "sthubr" ); return strlen("sthubr" );}
    if(Code == OPECODE_STH_UB_I   ) { fprintf(Fp, "sthubi" ); return strlen("sthubi" );}
    if(Code == OPECODE_STH_UA_R   ) { fprintf(Fp, "sthuar" ); return strlen("sthuar" );}
    if(Code == OPECODE_STH_UA_I   ) { fprintf(Fp, "sthuai" ); return strlen("sthuai" );}
    if(Code == OPECODE_STB_R      ) { fprintf(Fp, "stbr"   ); return strlen("stbr"   );}
    if(Code == OPECODE_STB_I      ) { fprintf(Fp, "stbi"   ); return strlen("stbi"   );}
    if(Code == OPECODE_STB_UB_R   ) { fprintf(Fp, "stbubr" ); return strlen("stbubr" );}
    if(Code == OPECODE_STB_UB_I   ) { fprintf(Fp, "stbubi" ); return strlen("stbubi" );}
    if(Code == OPECODE_STB_UA_R   ) { fprintf(Fp, "stbuar" ); return strlen("stbuar" );}
    if(Code == OPECODE_STB_UA_I   ) { fprintf(Fp, "stbuai" ); return strlen("stbuai" );}
    if(Code == OPECODE_MOV_I      ) { fprintf(Fp, "movi"   ); return strlen("movi"   );}
    if(Code == OPECODE_MOV_R      ) { fprintf(Fp, "movr"   ); return strlen("movr"   );}
    if(Code == OPECODE_MOVL_I     ) { fprintf(Fp, "movli"  ); return strlen("movli"  );}
    if(Code == OPECODE_MOVH_I     ) { fprintf(Fp, "movhi"  ); return strlen("movhi"  );}
    if(Code == OPECODE_ADD_R      ) { fprintf(Fp, "addr"   ); return strlen("addr"   );}
    if(Code == OPECODE_ADD_I      ) { fprintf(Fp, "addi"   ); return strlen("addi"   );}
    if(Code == OPECODE_SUB_R      ) { fprintf(Fp, "subr"   ); return strlen("subr"   );}
    if(Code == OPECODE_SUB_I      ) { fprintf(Fp, "subi"   ); return strlen("subi"   );}
    if(Code == OPECODE_AND_R      ) { fprintf(Fp, "andr"   ); return strlen("andr"   );}
    if(Code == OPECODE_AND_I      ) { fprintf(Fp, "andi"   ); return strlen("andi"   );}
    if(Code == OPECODE_OR_R       ) { fprintf(Fp, "orr"    ); return strlen("orr"    );}
    if(Code == OPECODE_OR_I       ) { fprintf(Fp, "ori"    ); return strlen("ori"    );}
    if(Code == OPECODE_XOR_R      ) { fprintf(Fp, "xorr"   ); return strlen("xorr"   );}
    if(Code == OPECODE_XOR_I      ) { fprintf(Fp, "xori"   ); return strlen("xori"   );}
    if(Code == OPECODE_LSR_R      ) { fprintf(Fp, "lsrr"   ); return strlen("lsrr"   );}
    if(Code == OPECODE_LSR_I      ) { fprintf(Fp, "lsri"   ); return strlen("lsri"   );}
    if(Code == OPECODE_LSL_R      ) { fprintf(Fp, "lslr"   ); return strlen("lslr"   );}
    if(Code == OPECODE_LSL_I      ) { fprintf(Fp, "lsli"   ); return strlen("lsli"   );}
    if(Code == OPECODE_ASR_R      ) { fprintf(Fp, "asrr"   ); return strlen("asrr"   );}
    if(Code == OPECODE_ASR_I      ) { fprintf(Fp, "asri"   ); return strlen("asri"   );}
    if(Code == OPECODE_MUL_R      ) { fprintf(Fp, "mulr"   ); return strlen("mulr"   );}
    if(Code == OPECODE_MUL_I      ) { fprintf(Fp, "muli"   ); return strlen("muli"   );}
    if(Code == OPECODE_DIVU_R     ) { fprintf(Fp, "divur"  ); return strlen("divur"  );}
    if(Code == OPECODE_DIVU_I     ) { fprintf(Fp, "divui"  ); return strlen("divui"  );}
    if(Code == OPECODE_DIV_R      ) { fprintf(Fp, "divr"   ); return strlen("divr"   );}
    if(Code == OPECODE_DIV_I      ) { fprintf(Fp, "divi"   ); return strlen("divi"   );}
    if(Code == OPECODE_MODU_R     ) { fprintf(Fp, "modur"  ); return strlen("modur"  );}
    if(Code == OPECODE_MODU_I     ) { fprintf(Fp, "modui"  ); return strlen("modui"  );}
    if(Code == OPECODE_MOD_R      ) { fprintf(Fp, "modr"   ); return strlen("modr"   );}
    if(Code == OPECODE_MOD_I      ) { fprintf(Fp, "modi"   ); return strlen("modi"   );}
    if(Code == OPECODE_NOP        ) { fprintf(Fp, "nop"    ); return strlen("nop"    );}
    if(Code == OPECODE_IMMSET     ) { fprintf(Fp, "immset" ); return strlen("immset" );}
    if(Code == OPECODE_ESCAPE_REGS) { fprintf(Fp, "$EscapeRegs$"); return strlen("$EscapeRegs$");}
    if(Code == OPECODE_RETURN_REGS) { fprintf(Fp, "$ReturnRegs$"); return strlen("$ReturnRegs$");}

    fprintf(Fp, "`̃R[h");
    PrintError(__FILE__, __LINE__, "RpCʏo͒ɖ`̃R[hoB", "", "");
    return P3CC_NG;
}
//====================================================================================================================
static int AsmOutLabel(FILE *Fp, vertual_code *VCode, function *f)
//====================================================================================================================
// [@\] xo
// []
// [Ԓl] P3CC_OK/P3CC_NG
{
    int         i;
    int         FuncNameLength;
    char        Label[MAX_SOURCE_FILE_NAME_CHAR + MAX_IDENTIFIER_CHAR];

    if(VCode->LabelNo == PLABEL_NON){
        for(i = 0; i < PROGRAM_LABEL_INDENT_WIDTH; i++) Label[i] = ' ';
        Label[i] = '\0';
        fprintf(Fp,"%s", Label);
    }
    else{
        if(VCode->LabelNo == PLABEL_FUNC_ENTRY){
            if(AsmOutMakeFuncName(Label, f) == P3CC_NG) return P3CC_NG;
        }
        else{
            sprintf(Label, "_@%04d", VCode->LabelNo);
        }
        strcat(Label, ": ");
        FuncNameLength = strlen(Label);
        if(FuncNameLength < PROGRAM_LABEL_INDENT_WIDTH){
            for(i = FuncNameLength; i < PROGRAM_LABEL_INDENT_WIDTH; i++) Label[i] = ' ';
            Label[i] = '\0';
        }
        fprintf(Fp,"%s", Label);
    }
    return P3CC_OK;
}
//====================================================================================================================
static int AsmOutMakeFuncName(char *out, function *f)
//====================================================================================================================
// [@\] asmo͗pϐ쐬
// []
// [Ԓl] P3CC_OK/P3CC_NG
{
    char            SrcFileFirstName[MAX_SOURCE_FILE_NAME_CHAR];

    strcpy(out, f->FuncName);
    if(f->Scope == SCOPE_PV){
        strcat(out, "@");
        FileExtensionCut(SrcFileName, SrcFileFirstName);
        strcat(out, SrcFileFirstName);
    }
    return P3CC_OK;
}
//====================================================================================================================
static int AsmOutExtFuncList(FILE *Fp)
//====================================================================================================================
// [@\] O`ꂽ֐Xgo
// []
// [Ԓl] P3CC_OK/P3CC_NG
{
    function        *f;
    int             FirstFlag;
    char            FuncName[MAX_SOURCE_FILE_NAME_CHAR + MAX_IDENTIFIER_CHAR];

    f = FunctionList;
    if(f == NULL) return P3CC_OK;

    FirstFlag = 0;
    while(1){
        if(f == NULL) break;
        if(f->DeclaredBody == 0){
            if(FirstFlag == 0){
                fprintf(Fp,"\n");
                fprintf(Fp,"//----------------------------------------------------------\n");
                fprintf(Fp,"//- O`ꂽ֐Xg \n");
                fprintf(Fp,"//- : .EXTERNAL_FUNC V{\n");
                fprintf(Fp,"//----------------------------------------------------------\n");
                FirstFlag = 1;
            }
            if(AsmOutMakeFuncName(FuncName, f) == P3CC_NG) return P3CC_NG;
            fprintf(Fp,".EXTERNAL_FUNC  %s\n", FuncName);
        }
        f = f->Next;
    }
    return P3CC_OK;
}
//====================================================================================================================
static int AsmOutMakeVarName(char *out, variable *v)
//====================================================================================================================
// [@\] asmo͗pϐ쐬
// []
// [Ԓl] P3CC_OK/P3CC_NG
{
    char            SrcFileFirstName[MAX_SOURCE_FILE_NAME_CHAR];

    strcpy(out, v->Name);

/*
    if((v->Scope == SCOPE_PV) || (v->Scope == SCOPE_ATS)){
        FileExtensionCut(SrcFileName, SrcFileFirstName);
        strcat(out, "@");
        strcat(out, SrcFileFirstName);
        if(v->Scope == SCOPE_ATS){
            strcat(out, "@");
            strcat(out, v->FuncName);
        }
    }
*/
    if(v->Scope == SCOPE_ATS){
        strcat(out, "@");
        strcat(out, v->FuncName);
    }
    if((v->Scope == SCOPE_PV) || (v->Scope == SCOPE_ATS)){
        FileExtensionCut(SrcFileName, SrcFileFirstName);
        strcat(out, "@");
        strcat(out, SrcFileFirstName);
    }

    return P3CC_OK;
}
//====================================================================================================================
static int AsmOutArgList(FILE *Fp, variable *v)
//====================================================================================================================
// [@\] [JϐXgo
// []
// [Ԓl] P3CC_OK/P3CC_NG
{
    int             i;
    char            VarName[MAX_SOURCE_FILE_NAME_CHAR + MAX_IDENTIFIER_CHAR];

    if(v == NULL) return P3CC_OK;
    if((v->Type == TYPE_VOID) && (v->Pointer == 0) && (v->FuncPointer == 0)) return P3CC_OK;

    fprintf(Fp,"//----------------------------------------------------------\n");
    fprintf(Fp,"//- Xg \n");
    fprintf(Fp,"//- : .ARG V{ TCY FPɑ΂ItZbg\n");
    fprintf(Fp,"//- :  ItZbg͏ȗB\n");
    fprintf(Fp,"//- :  A֐ł̃ItZbgLƖ\n");
    fprintf(Fp,"//- :    ݂͕̍s\n");
    fprintf(Fp,"//----------------------------------------------------------\n");

    while(1){
        if(v == NULL) break;
        if(v->Scope == SCOPE_ARG){
            if(AsmOutMakeVarName(VarName, v) == P3CC_NG) return P3CC_NG;
            fprintf(Fp,".ARG        %s ", VarName);
            for(i = strlen(VarName); i < (MAX_IDENTIFIER_CHAR / 2); i++) fprintf(Fp, " ");
            fprintf(Fp,"%d    \t%d", v->TotalSize, v->Offset);
            if(v->OptiInfo.RegNo != 0) fprintf(Fp,"\t// (R%d)\n", v->OptiInfo.RegNo);
            else                       fprintf(Fp,"\n");
        }
        v = v->Next;
    }
    return P3CC_OK;
}
//====================================================================================================================
static int AsmOutLocalVarList(FILE *Fp, variable *v)
//====================================================================================================================
// [@\] [JϐXgo
// []
// [Ԓl] P3CC_OK/P3CC_NG
{
    int             i;
    char            VarName[MAX_SOURCE_FILE_NAME_CHAR + MAX_IDENTIFIER_CHAR];

    if(v == NULL) return P3CC_OK;

    fprintf(Fp,"//----------------------------------------------------------\n");
    fprintf(Fp,"//- [JϐXg \n");
    fprintf(Fp,"//- : .LOCAL_VAR V{ TCY FPɑ΂ItZbg\n");
    fprintf(Fp,"//- :  ItZbg͏ȗB\n");
    fprintf(Fp,"//- :  A֐ł̃ItZbgLƖ\n");
    fprintf(Fp,"//- :    ݂͕̍s\n");
    fprintf(Fp,"//----------------------------------------------------------\n");

    while(1){
        if(v == NULL) break;
        if(v->Scope == SCOPE_AT){
            if(AsmOutMakeVarName(VarName, v) == P3CC_NG) return P3CC_NG;
            if(v->OptiInfo.RegNo != 0) fprintf(Fp,"// ");
            fprintf(Fp,".LOCAL_VAR  %s ", VarName);
            for(i = strlen(VarName); i < (MAX_IDENTIFIER_CHAR / 2); i++) fprintf(Fp, " ");
            fprintf(Fp,"%d    \t%d", v->TotalSize, v->Offset);
            if(v->OptiInfo.RegNo != 0) fprintf(Fp,"\t// (R%d)\n", v->OptiInfo.RegNo);
            else                       fprintf(Fp,"\n");
        }
        v = v->Next;
    }
    return P3CC_OK;
}

//====================================================================================================================
static int AsmOutLocalStaticVarList(FILE *Fp)
//====================================================================================================================
// [@\] ֐static`ꂽϐXgo
// []
// [Ԓl] P3CC_OK/P3CC_NG
{
    function        *f;
    variable        *v;
    int             i, FirstFlag;
    char            VarName[MAX_SOURCE_FILE_NAME_CHAR + MAX_IDENTIFIER_CHAR];

    f = FunctionList;
    if(f == NULL) return P3CC_OK;

    FirstFlag = 0;
    while(1){
        if(f == NULL) break;
        v = f->VariableList;
        while(1){
            if(v == NULL) break;
            if(v->Scope == SCOPE_ATS){
                if(FirstFlag == 0){
                    fprintf(Fp,"\n");
                    fprintf(Fp,"//----------------------------------------------------------\n");
                    fprintf(Fp,"//- ֐static`ꂽϐXg \n");
                    fprintf(Fp,"//- : .GLOBAL_VAR V{@gqȂ̃t@C@֐ TCY\n");
                    fprintf(Fp,"//----------------------------------------------------------\n");
                    FirstFlag = 1;
                }
                if(AsmOutMakeVarName(VarName, v) == P3CC_NG) return P3CC_NG;
                fprintf(Fp,".GLOBAL_VAR  %s ", VarName);
                for(i = strlen(VarName); i < (MAX_IDENTIFIER_CHAR / 2); i++) fprintf(Fp, " ");
                fprintf(Fp,"%d", v->TotalSize);
                AsmOutVarInitList(Fp, v);
                fprintf(Fp,"\n");
            }
            v = v->Next;
        }
        f = f->Next;
    }
    return P3CC_OK;
}
//====================================================================================================================
static int AsmOutPrivateVarList(FILE *Fp)
//====================================================================================================================
// [@\] ֐Ostatic`ꂽϐXgo
// []
// [Ԓl] P3CC_OK/P3CC_NG
{
    variable        *v;
    int             i;
    char            VarName[MAX_SOURCE_FILE_NAME_CHAR + MAX_IDENTIFIER_CHAR];

    v = PvVariableList;
    if(v == NULL) return P3CC_OK;

    fprintf(Fp,"\n");
    fprintf(Fp,"//----------------------------------------------------------\n");
    fprintf(Fp,"//- ֐Ostatic`ꂽϐXg \n");
    fprintf(Fp,"//- : .GLOBAL_VAR V{@gqȂ̃t@C TCY [{lXg}]\n");
    fprintf(Fp,"//----------------------------------------------------------\n");
    while(1){
        if(v == NULL) break;
        if(AsmOutMakeVarName(VarName, v) == P3CC_NG) return P3CC_NG;
        fprintf(Fp,".GLOBAL_VAR  %s ", VarName);
        for(i = strlen(VarName); i < (MAX_IDENTIFIER_CHAR / 2); i++) fprintf(Fp, " ");
        fprintf(Fp,"%d", v->TotalSize);
        AsmOutVarInitList(Fp, v);
        fprintf(Fp,"\n");
        v = v->Next;
    }
    return P3CC_OK;
}
//====================================================================================================================
static int AsmOutGlobalVarList(FILE *Fp)
//====================================================================================================================
// [@\] `ꂽO[oϐXgo
// []
// [Ԓl] P3CC_OK/P3CC_NG
{
    variable        *v;
    int             i;
    char            VarName[MAX_SOURCE_FILE_NAME_CHAR + MAX_IDENTIFIER_CHAR];

    v = GlVariableList;
    if(v == NULL) return P3CC_OK;

    fprintf(Fp,"\n");
    fprintf(Fp,"//----------------------------------------------------------\n");
    fprintf(Fp,"//- `ꂽO[oϐXg \n");
    fprintf(Fp,"//- : .GLOBAL_VAR V{ TCY [{lXg}]\n");
    fprintf(Fp,"//----------------------------------------------------------\n");
    while(1){
        if(v == NULL) break;
        if(AsmOutMakeVarName(VarName, v) == P3CC_NG) return P3CC_NG;
        fprintf(Fp,".GLOBAL_VAR  %s ", VarName);
        for(i = strlen(VarName); i < (MAX_IDENTIFIER_CHAR / 2); i++) fprintf(Fp, " ");
        fprintf(Fp,"%d", v->TotalSize);
        AsmOutVarInitList(Fp, v);
        fprintf(Fp,"\n");
        v = v->Next;
    }
    return P3CC_OK;
}
//====================================================================================================================
static int AsmOutVarInitList(FILE *Fp, variable *v)
//====================================================================================================================
// [@\] ϐlXgóipfBOς݁j
// []
// [Ԓl] P3CC_OK/P3CC_NG
{
    int                         Num;
    int                         Offset;
    int                         Size;
    int                         Padding;
    int                         i, j, k, len;
    element_init_val_info       *InitValInfo;
    function                    *f;
    char                        FuncName[MAX_SOURCE_FILE_NAME_CHAR + MAX_IDENTIFIER_CHAR];
    char                        *p;
    char                        Str[MAX_STRING_LITERAL_CHAR + 1];

    if(v == NULL) return P3CC_NG;
    if(v->InitValHead.InfoNum == 0) return P3CC_OK;//lȂ
    fprintf(Fp," = {");
    Num = 0;
    InitValInfo = v->InitValHead.Entry;
    while(1){
        if(Num != 0) fprintf(Fp, ", ");
        if(((Num % 16) == 0) && (Num != 0)) fprintf(Fp, "\n                                    ");
        Offset = InitValInfo->Offset;
        Size   = InitValInfo->Size;
        if(InitValInfo->Str != NULL){
            if(InitValInfo->Id == 0){
                p = InitValInfo->Str;
                len = strlen(p) + 1;
                for(j = 0, k = 0; j < len; j++){
                    if(p[j] == '\n'){
                        Str[k] = '\\';
                        ++k;
                        Str[k] = 'n';
                    }
                    else{
                        Str[k] = p[j];
                    }
                    ++k;
                }
                fprintf(Fp, "\"%s\"", Str);
            }
            else{
                f = FunctionFind(InitValInfo->Str);
                if(f != NULL){
                    if(AsmOutMakeFuncName(FuncName, f) == P3CC_NG){ PrintError(__FILE__, __LINE__, "", "", ""); return P3CC_NG;}
                    fprintf(Fp, "%s", FuncName);
                }
                else{
                    PrintError(__FILE__, __LINE__, "", "", "");
                }
            }
            Num += 4;
        }
        else{
            if(Size == 1){
                fprintf(Fp, "0x%02x", InitValInfo->Value & 0xFF);
                Num += 1;
            }
            else if(Size == 2){
                fprintf(Fp, "0x%02x, ", (InitValInfo->Value >> 8) & 0xFF);
                Num += 1;
                if((Num % 16) == 0) fprintf(Fp, "\n                                    ");
                fprintf(Fp, "0x%02x", InitValInfo->Value & 0xFF);
                Num += 1;
            }
            else{
                fprintf(Fp, "0x%02x, ", (InitValInfo->Value >> 24) & 0xFF);
                Num += 1;
                if((Num % 16) == 0) fprintf(Fp, "\n                                    ");
                fprintf(Fp, "0x%02x, ", (InitValInfo->Value >> 16) & 0xFF);
                Num += 1;
                if((Num % 16) == 0) fprintf(Fp, "\n                                    ");
                fprintf(Fp, "0x%02x, ", (InitValInfo->Value >> 8) & 0xFF);
                Num += 1;
                if((Num % 16) == 0) fprintf(Fp, "\n                                    ");
                fprintf(Fp, "0x%02x", InitValInfo->Value & 0xFF);
                Num += 1;
            }
        }
        InitValInfo = InitValInfo->Next;
        if(InitValInfo == NULL) break;
        //--- padding ----
        Padding = InitValInfo->Offset - (Offset + Size);
        for(i = 0; i < Padding; i++){
            if((Num % 16) == 0) fprintf(Fp, ", \n                                    ");
            else                fprintf(Fp, ", ");
            fprintf(Fp, "0x00");
            Num += 1;
        }
    }
    fprintf(Fp,"}");
    return P3CC_OK;
}
//====================================================================================================================
static int AsmOutExtVarList(FILE *Fp)
//====================================================================================================================
// [@\] O`ꂽϐXgo
// []
// [Ԓl] P3CC_OK/P3CC_NG
{
    int             i;
    variable        *v;
    char            VarName[MAX_SOURCE_FILE_NAME_CHAR + MAX_IDENTIFIER_CHAR];

    v = ExtVariableList;
    if(v == NULL) return P3CC_OK;

    fprintf(Fp,"\n");
    fprintf(Fp,"//----------------------------------------------------------\n");
    fprintf(Fp,"//- O`ꂽϐXg \n");
    fprintf(Fp,"//- : .EXTERNAL_VAR V{ TCY\n");
    fprintf(Fp,"//----------------------------------------------------------\n");
    while(1){
        if(v == NULL) break;
        if(AsmOutMakeVarName(VarName, v) == P3CC_NG) return P3CC_NG;
        fprintf(Fp,".EXTERNAL_VAR  %s ", VarName);
        for(i = strlen(VarName); i < (MAX_IDENTIFIER_CHAR / 2); i++) fprintf(Fp, " ");
        fprintf(Fp,"%d\n", v->TotalSize);
        v = v->Next;
    }
    return P3CC_OK;
}

//====================================================================================================================
static int AsmOutSrcFileList(FILE *Fp)
//====================================================================================================================
// [@\] t@CXgo
// []
// [Ԓl] P3CC_OK/P3CC_NG
{
    int     i;
    fprintf(Fp,"\n");
    fprintf(Fp,"//----------------------------------------------------------\n");
    fprintf(Fp,"//- RpCɓǂݍ܂ꂽ\[Xt@C̃Xg \n");
    fprintf(Fp,"//- : .SRCFILE\n");
    fprintf(Fp,"//- :   \[Xt@CNo, \[Xt@C\n");
    fprintf(Fp,"//- :   \[Xt@CNo, \[Xt@C\n");
    fprintf(Fp,"//- :       c\n");
    fprintf(Fp,"//- :       c\n");
    fprintf(Fp,"//- : .ENDSRCFILE\n");
    fprintf(Fp,"//----------------------------------------------------------\n");
    fprintf(Fp,".SRCFILE\n");
    for(i = 0; i < Cc0Result->NumOfSrcFile; i++){
        fprintf(Fp,"%4d,  %s\n", i, SrcFileTbl[i].FileName);
    }
    fprintf(Fp,".ENDSRCFILE\n");
    return P3CC_OK;
}
//====================================================================================================================
static int AsmOutHeader(FILE *Fp)
//====================================================================================================================
// [@\] wb_[o
// []
// [Ԓl] P3CC_OK/P3CC_NG
{
    fprintf(Fp,"//----------------------------------------------------------\n");
    fprintf(Fp,"// This File was generated by P3cc.exe VerVer %d.%d.%d\n",VERSION_MAJOR, VERSION_MINER, VERSION_SUB_MINER);
    fprintf(Fp,"//----------------------------------------------------------\n");
    //fprintf(Fp,".P3CC_ASM_OUT Ver%d_%d_%d\n",VERSION_MAJOR, VERSION_MINER, VERSION_SUB_MINER);
    return P3CC_OK;
}
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// fobOp̓ԏo͊֐Q
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//====================================================================================================================
static void PrintFunctionBody(function *f)
//====================================================================================================================
// [@\] ֐̕\
// [] Ȃ
// [Ԓl] Ȃ
{
    int                         i;
    int                         NumOfVCode;
    int                         NumOfUsedVReg;
    vertual_reg_list            *VRegList;

    fprintf(LogFile, "");
    if     (f->Scope == SCOPE_EX ) fprintf(LogFile, "SCOPE_EX  ");
    else if(f->Scope == SCOPE_GL ) fprintf(LogFile, "SCOPE_GL  ");
    else if(f->Scope == SCOPE_PV ) fprintf(LogFile, "SCOPE_PV  ");
    else if(f->Scope == SCOPE_ATS) fprintf(LogFile, "SCOPE_ATS ");
    else if(f->Scope == SCOPE_AT ) fprintf(LogFile, "SCOPE_AT  ");
    else                           fprintf(LogFile, "SCOPE_%d ?", f->Scope);

    if     (f->Type == TYPE_STRUCT  ) fprintf(LogFile, "struct   ");
    else if(f->Type == TYPE_UNION   ) fprintf(LogFile, "union    ");
    else if(f->Type == TYPE_TYPEDEF ) fprintf(LogFile, "typedef  ");
    else{
        if(f->Sign == SIGN)           fprintf(LogFile, "signed   ");
        else                          fprintf(LogFile, "unsigned ");
    }

    if     (f->Type == TYPE_VOID    ) fprintf(LogFile, "void   ");
    else if(f->Type == TYPE_CHAR    ) fprintf(LogFile, "char   ");
    else if(f->Type == TYPE_SHORT   ) fprintf(LogFile, "short  ");
    else if(f->Type == TYPE_INT     ) fprintf(LogFile, "int    ");
    else if(f->Type == TYPE_LONG    ) fprintf(LogFile, "long   ");
    else if(f->Type == TYPE_FLOAT   ) fprintf(LogFile, "float  ");
    else if(f->Type == TYPE_DOUBLE  ) fprintf(LogFile, "double ");
    else if(f->Type == TYPE_ENUM    ) fprintf(LogFile, "enum   ");
    else if(f->Type == TYPE_STRUCT  ) {
        fprintf(LogFile, "%s\t",f->StructInfo->TagName);
    }
    //else if(f->Type == TYPE_UNION   ) fprintf(LogFile, "union    ");
    //else if(f->Type == TYPE_TYPEDEF ) fprintf(LogFile, "typedef  ");
    else                              fprintf(LogFile, "???[%d]", f->Type);
    for(i=0;i<f->Pointer;i++) fprintf(LogFile, "*");
    fprintf(LogFile, "%s",f->FuncName);

    fprintf(LogFile, "(\n");

    if(f->ArgList != NULL){
        ++PrintTabLebel;
        PrintVariableTableBody(f->ArgList, 0);
        --PrintTabLebel;
    }
    else{
        fprintf(LogFile, "ȗ");
    }
    fprintf(LogFile, "\n)");
    fprintf(LogFile, "\tTypeSize = %d",f->TypeSize);
    fprintf(LogFile, "\tPt=%d, Body=%d",f->DeclaredPt, f->DeclaredBody);
    fprintf(LogFile, "\n\n");

    if(f->VariableList != NULL){
        PrintVariableTableBody(f->VariableList, 0);
        fprintf(LogFile, "[JϐTCYF%doCg\n",f->SizeOfLocal);
        fprintf(LogFile, "\n");
    }

    if(PrintCodeFlag) PrintVertualCodeList(f->VCodeListHeader.Entry);

    if(f->DeclaredBody != 0){
#ifdef VAR_ON_REG_ENABLE
        fprintf(LogFile,"=== WX^Ɋ蓖Ăϐ =====\n");
        for(i = NUM_OF_SCRATCH_REG + 1; i < NUM_OF_SCRATCH_REG + NUM_OF_VER_ON_REG + 1; i++){
            if(f->RegVsVar.v[i] != NULL){
                fprintf(LogFile,"R%d : %s (%d)\n", i, f->RegVsVar.v[i]->Name, f->RegVsVar.v[i]->OptiInfo.RefCount);
            }
        }
        fprintf(LogFile,"===\n");
#endif

        VRegList = NULL;
        if(ExpressionOptiUsedVRegListGet(&VRegList, &NumOfUsedVReg, &NumOfVCode, f->VCodeListHeader.Entry, f->VCodeListHeader.Last) == P3CC_NG){
            PrintError(__FILE__, __LINE__, "", "", "");
        }
        fprintf(LogFile,"gpWX^F%d\n", NumOfUsedVReg);
        fprintf(LogFile,"R[hTCY  F%d\n", NumOfVCode);
        ExpressionOptiVRegListFree(&VRegList);
    }

    fprintf(LogFile, "\n\n");
}
//====================================================================================================================
static void PrintFunctionList(void)
//====================================================================================================================
// [@\] ֐e[u̕\
// [] Ȃ
// [Ԓl] Ȃ
{
    function *f;
    fprintf(LogFile, "====== FUNCTION INFO ========\n");
    f = FunctionList;
    if(f != NULL){
        while(1){
            PrintFunctionBody(f);
            if(f->Next == NULL) break;
            f = f->Next;
        }
    }
}
//====================================================================================================================
static void PrintTab(void)
//====================================================================================================================
// [@\] TAB̕\
// [] Ȃ
// [Ԓl] Ȃ
{
    int i;
    for(i=0;i<PrintTabLebel;i++) fprintf(LogFile, "\t");
}
//====================================================================================================================
static void PrintVariable(variable *v, int Mode)
//====================================================================================================================
// [@\] ϐ̕\
// [] Ȃ
// [Ԓl] Ȃ
{
    int i,j;
    int Flag;
    element_init_val_info *e;

    //Mode = 0;

    PrintTab();
    if(Mode == 0){
        if(v->FuncName != NULL) fprintf(LogFile, "FuncName= %s\t",v->FuncName);

        if     (v->Scope == SCOPE_EX ) fprintf(LogFile, "SCOPE_EX  ");
        else if(v->Scope == SCOPE_GL ) fprintf(LogFile, "SCOPE_GL  ");
        else if(v->Scope == SCOPE_PV ) fprintf(LogFile, "SCOPE_PV  ");
        else if(v->Scope == SCOPE_ATS) fprintf(LogFile, "SCOPE_ATS ");
        else if(v->Scope == SCOPE_AT ) fprintf(LogFile, "SCOPE_AT  ");
        else if(v->Scope == SCOPE_ARG) fprintf(LogFile, "SCOPE_ARG ");
        else                           fprintf(LogFile, "SCOPE_%d ?", v->Scope);
    }
    else{
        fprintf(LogFile, "\t");
    }
    if     (v->Type == TYPE_STRUCT  ) fprintf(LogFile, "struct   ");
    else if(v->Type == TYPE_UNION   ) fprintf(LogFile, "union    ");
    else if(v->Type == TYPE_TYPEDEF ) fprintf(LogFile, "typedef  ");
    else{
        if(v->Sign == SIGN)           fprintf(LogFile, "signed   ");
        else                          fprintf(LogFile, "unsigned ");
    }

    if     (v->Type == TYPE_VOID    ) fprintf(LogFile, "void   ");
    else if(v->Type == TYPE_CHAR    ) fprintf(LogFile, "char   ");
    else if(v->Type == TYPE_SHORT   ) fprintf(LogFile, "short  ");
    else if(v->Type == TYPE_INT     ) fprintf(LogFile, "int    ");
    else if(v->Type == TYPE_LONG    ) fprintf(LogFile, "long   ");
    else if(v->Type == TYPE_FLOAT   ) fprintf(LogFile, "float  ");
    else if(v->Type == TYPE_DOUBLE  ) fprintf(LogFile, "double ");
    else if(v->Type == TYPE_ENUM    ) fprintf(LogFile, "enum   ");
    else if(v->Type == TYPE_STRUCT  ) {
        fprintf(LogFile, "%s\t",v->StructInfo->TagName);
    }
    else if(v->Type == TYPE_UNION   ) {
        fprintf(LogFile, "%s\t",v->StructInfo->TagName);
    }
    //else if(v->Type == TYPE_TYPEDEF ) fprintf(LogFile, "typedef  ");
    else                              fprintf(LogFile, "???[%d]", v->Type);
    for(i=0;i<v->Pointer;i++) fprintf(LogFile, "*");

    if(v->FuncPointer != 0){
        fprintf(LogFile, "(");
        for(i=0; i < v->FuncPointer; i++) fprintf(LogFile, "*");
    }
    fprintf(LogFile, "%s",v->Name);
    if(v->FuncPointer != 0){
        fprintf(LogFile, ")");
        fprintf(LogFile, "(\n");
        ++PrintTabLebel;
        if(v->ArgList != NULL){
            PrintVariableTableBody(v->ArgList, 0);
        }
        else{
            PrintTab();
            fprintf(LogFile, "ȗ");
        }
        fprintf(LogFile, "\n");
        PrintTab();
        fprintf(LogFile, ")");
        --PrintTabLebel;
    }

    if(v->DimInfo != NULL){
        for(i=0;i<MAX_ARRAY_DIM;i++){
            if(i==0){
                fprintf(LogFile, "[%d(%d)]", v->DimInfo->NumOfElements[i], v->DimInfo->ElementSize[i]);
            }
            else if(v->DimInfo->NumOfElements[i] != 0){
                fprintf(LogFile, "[%d(%d)]", v->DimInfo->NumOfElements[i], v->DimInfo->ElementSize[i]);
            }
        }
    }
    fprintf(LogFile, "\tTypeSize = %d",v->TypeSize);
    fprintf(LogFile, "\tTotalSize = %d",v->TotalSize);
    fprintf(LogFile, "\tOffset = %d  ",v->Offset);
    fprintf(LogFile, "\tElements = %d  ",VariableCountElements(v));
    
    fprintf(LogFile, "[");
    if(v->OptiInfo.RegEna == REG_ENA) fprintf(LogFile, "REG_ENA, ");
    else                             fprintf(LogFile, "REG_DIS, ");
    if(v->OptiInfo.RegNo != 0){
        fprintf(LogFile, " R%d, %d]", v->OptiInfo.RegNo, v->OptiInfo.RefCount);
    }
    else{
        fprintf(LogFile, "    , %d]", v->OptiInfo.RefCount);
    }

    if(v->InitValHead.Entry != NULL){
        fprintf(LogFile, "={");
        e = v->InitValHead.Entry;
        Flag = 0;
        j = 0;
        while(1){
            if(Flag != 0) fprintf(LogFile, ", ");
            if((j==4) || ((j-4)%16 == 0)) fprintf(LogFile, "\n");
            if(e->Str != NULL){
                fprintf(LogFile, "(%d, \"%s\")", e->Offset, e->Str);
            }
            else{
                if     (e->Size == 1) fprintf(LogFile, "(%d, 0x%02x)", e->Offset, e->Value);
                else if(e->Size == 2) fprintf(LogFile, "(%d, 0x%04x)", e->Offset, e->Value);
                else                  fprintf(LogFile, "(%d, 0x%08x)", e->Offset, e->Value);
            }
            if(e->Next == NULL) break;
            e = e->Next;
            Flag = 1;
            ++j;
        }
        fprintf(LogFile, "}");
    }
    fprintf(LogFile, "\n");
    //fprintf(LogFile, "InitData   Pointer = 0x%08x\n",v->InitData);
}
//====================================================================================================================
static void PrintStructInfo(struct_info *si)
//====================================================================================================================
// [@\] \̌^̕\
// [] Ȃ
// [Ԓl] Ȃ
{
    variable *v;

    if     (si->Scope == SCOPE_EX ) fprintf(LogFile, "SCOPE_EX\t");
    else if(si->Scope == SCOPE_GL ) fprintf(LogFile, "SCOPE_GL\t");
    else if(si->Scope == SCOPE_PV ) fprintf(LogFile, "SCOPE_PV\t");
    else if(si->Scope == SCOPE_ATS) fprintf(LogFile, "SCOPE_ATS\t");
    else if(si->Scope == SCOPE_AT ) fprintf(LogFile, "SCOPE_AT\t");
    else                            fprintf(LogFile, "SCOPE_%d ?\t", si->Scope);

    if(si->Type == TYPE_STRUCT){
        fprintf(LogFile, "struct %s  Size=%d",si->TagName, si->StructSize);
    }
    else{
        fprintf(LogFile, "union  %s  Size=%d",si->TagName, si->StructSize);
    }
    if(si->FuncName != NULL) fprintf(LogFile, "\tFuncName= %s\n",si->FuncName);
    else                     fprintf(LogFile, "\n");

    if(si->Member != NULL){
        v = si->Member;
        while(1){
            fprintf(LogFile, "\t");
            PrintVariable(v, 1);
            if(v->Next == NULL) break;
            v = v->Next;
        }
    }

}
//====================================================================================================================
static void PrintTypedefInfoList(void)
//====================================================================================================================
// [@\] TypedefΉ\̕\
// [] Ȃ
// [Ԓl] Ȃ
{
    int             i;
    typedef_info    *t;
    t = TypedefInfoList;
    while(1){
        fprintf(LogFile, "typedef\t");
        if(t->StructInfo != NULL){
            fprintf(LogFile, "struct\t");
            fprintf(LogFile, "%s\t", t->StructInfo->TagName);
        }
        else{
            if(t->Sign == SIGN)               fprintf(LogFile, "signed   ");
            else                              fprintf(LogFile, "unsigned ");

            if     (t->Type == TYPE_VOID    ) fprintf(LogFile, "void   ");
            else if(t->Type == TYPE_CHAR    ) fprintf(LogFile, "char   ");
            else if(t->Type == TYPE_SHORT   ) fprintf(LogFile, "short  ");
            else if(t->Type == TYPE_INT     ) fprintf(LogFile, "int    ");
            else if(t->Type == TYPE_LONG    ) fprintf(LogFile, "long   ");
            else if(t->Type == TYPE_FLOAT   ) fprintf(LogFile, "float  ");
            else if(t->Type == TYPE_DOUBLE  ) fprintf(LogFile, "double ");
            else if(t->Type == TYPE_ENUM    ) fprintf(LogFile, "enum   ");
            else if(t->Type == TYPE_STRUCT  ) fprintf(LogFile, "???    ");
        }
        for(i=0;i<t->Pointer;i++) fprintf(LogFile, "*");

        if(t->FuncPointer != 0){
            fprintf(LogFile, "(");
            for(i=0; i < t->FuncPointer; i++) fprintf(LogFile, "*");
        }
        fprintf(LogFile, "%s", t->TypeName);
        if(t->FuncPointer != 0){
            fprintf(LogFile, ")");
            fprintf(LogFile, "(\n");
            ++PrintTabLebel;
            if(t->ArgList != NULL){
                PrintVariableTableBody(t->ArgList, 0);
            }
            else{
                PrintTab();
                fprintf(LogFile, "ȗ");
            }
            fprintf(LogFile, "\n");
            PrintTab();
            fprintf(LogFile, ")");
            --PrintTabLebel;
        }

        fprintf(LogFile, "\n");
        if(t->Next == NULL) break;
        t = t->Next;
    }
}
//====================================================================================================================
static void PrintStructInfoList(struct_info *si)
//====================================================================================================================
// [@\] \̃Xg̕\
// []
// [Ԓl]
{
    while(1){
        PrintStructInfo(si);
        if(si->Next == NULL) break;
        si = si->Next;
    }
}
//====================================================================================================================
static void PrintVariableTableBody(variable *v, int Mode)
//====================================================================================================================
// [@\] ϐe[u̕\({)
// []
// [Ԓl]
{
    while(1){
        PrintVariable(v,Mode);
        if(v->Next == NULL) break;
        v = v->Next;
    }
}
//====================================================================================================================
static void PrintVariableTable(void)
//====================================================================================================================
// [@\] ϐe[u̕\
// [] Ȃ
// [Ԓl] Ȃ
{
    variable    *v;
    struct_info *si;

    if(TypedefInfoList != NULL){
        fprintf(LogFile, "====== TYPEDEF INFO ========\n");
        PrintTypedefInfoList();
        fprintf(LogFile, "\n");
    }
    if(StructInfoList != NULL){
        fprintf(LogFile, "====== STRUCT TYPE INFO ========\n");
        si = StructInfoList;
        PrintStructInfoList(si);
        fprintf(LogFile, "\n");
    }
    if(ExtVariableList != NULL){
        fprintf(LogFile, "====== EXTERNAL VARIABLE INFO ========\n");
        v = ExtVariableList;
        PrintVariableTableBody(v, 0);
        fprintf(LogFile, "\n");
    }
    if(GlVariableList != NULL){
        fprintf(LogFile, "====== GLOBAL VARIABLE INFO ========\n");
        v = GlVariableList;
        PrintVariableTableBody(v, 0);
        fprintf(LogFile, "\n");
    }
    if(PvVariableList != NULL){
        fprintf(LogFile, "====== PRIVATE VARIABLE INFO ========\n");
        v = PvVariableList;
        PrintVariableTableBody(v, 0);
        fprintf(LogFile, "\n");
    }
}

//====================================================================================================================
static void Token2String(int TokenIndex, char *buf)
//====================================================================================================================
// [@\] TOKENtϊ
// []
// [Ԓl] ȂB
{
    int         TokenType;
    int         ExtInfoIndex;

    if(TokenIndex == Cc1Result->TokenTblIndex){
        sprintf(buf,"===END===");
        return;
    }

    TokenType = Cc1Result->TokenTbl[TokenIndex].Type;
    ExtInfoIndex = Cc1Result->TokenTbl[TokenIndex].ExtInfoIndex;
    if(TokenType == TOKEN_IDENTIFIER){
        sprintf(buf,"%s",Cc1Result->IdentifierTbl[ExtInfoIndex].Identifier);
    }
    else if(TokenType == TOKEN_STRING_LITERAL){
        sprintf(buf,"\"%s\"",Cc1Result->StrLiteralTbl[ExtInfoIndex].StringLiteral);
    }
    else if(TokenType == TOKEN_NUMERIC_LITERAL){
        if(Cc1Result->NumLiteralTbl[ExtInfoIndex].Type == DESCRIPTION_HEX){
            sprintf(buf,"0x%x",Cc1Result->NumLiteralTbl[ExtInfoIndex].Value.FixedPointValue);
        }
        if(Cc1Result->NumLiteralTbl[ExtInfoIndex].Type == DESCRIPTION_DEC){
            sprintf(buf,"%d",Cc1Result->NumLiteralTbl[ExtInfoIndex].Value.FixedPointValue);
        }
        if(Cc1Result->NumLiteralTbl[ExtInfoIndex].Type == DESCRIPTION_REAL){
            sprintf(buf,"(_)͖Ή");
            sprintf(buf,"%d",Cc1Result->NumLiteralTbl[ExtInfoIndex].Value.FloatingPointValue);
        }
    }
    else{
        if     (TokenType == TOKEN_VOLATILE    ) sprintf(buf, "volatile");
        else if(TokenType == TOKEN_REGISTER    ) sprintf(buf, "register");
        else if(TokenType == TOKEN_CONST       ) sprintf(buf, "const"   );
        else if(TokenType == TOKEN_AUTO        ) sprintf(buf, "auto"    );
        else if(TokenType == TOKEN_STATIC      ) sprintf(buf, "static"  );
        else if(TokenType == TOKEN_EXTERN      ) sprintf(buf, "extern"  );
        else if(TokenType == TOKEN_SIGNED      ) sprintf(buf, "signed"  );
        else if(TokenType == TOKEN_UNSIGNED    ) sprintf(buf, "unsigned");
        else if(TokenType == TOKEN_VOID        ) sprintf(buf, "void"    );
        else if(TokenType == TOKEN_CHAR        ) sprintf(buf, "char"    );
        else if(TokenType == TOKEN_SHORT       ) sprintf(buf, "short"   );
        else if(TokenType == TOKEN_INT         ) sprintf(buf, "int"     );
        else if(TokenType == TOKEN_LONG        ) sprintf(buf, "long"    );
        else if(TokenType == TOKEN_FLOAT       ) sprintf(buf, "float"   );
        else if(TokenType == TOKEN_DOUBLE      ) sprintf(buf, "double"  );
        else if(TokenType == TOKEN_ENUM        ) sprintf(buf, "enum"    );
        else if(TokenType == TOKEN_STRUCT      ) sprintf(buf, "struct"  );
        else if(TokenType == TOKEN_UNION       ) sprintf(buf, "union"   );
        else if(TokenType == TOKEN_TYPEDEF     ) sprintf(buf, "typedef" );
        else if(TokenType == TOKEN_IF          ) sprintf(buf, "if"      );
        else if(TokenType == TOKEN_ELSE        ) sprintf(buf, "else"    );
        else if(TokenType == TOKEN_BREAK       ) sprintf(buf, "break"   );
        else if(TokenType == TOKEN_CASE        ) sprintf(buf, "case"    );
        else if(TokenType == TOKEN_CONTINUE    ) sprintf(buf, "continue");
        else if(TokenType == TOKEN_DO          ) sprintf(buf, "do"      );
        else if(TokenType == TOKEN_FOR         ) sprintf(buf, "for"     );
        else if(TokenType == TOKEN_SWITCH      ) sprintf(buf, "switch"  );
        else if(TokenType == TOKEN_GOTO        ) sprintf(buf, "goto"    );
        else if(TokenType == TOKEN_RETURN      ) sprintf(buf, "return"  );
        else if(TokenType == TOKEN_WHILE       ) sprintf(buf, "while"   );
        else if(TokenType == TOKEN_DEFAULT     ) sprintf(buf, "default" );
        else if(TokenType == TOKEN_SIZEOF      ) sprintf(buf, "sizeof"  );
        else if(TokenType == TOKEN_SQUARE_L    ) sprintf(buf, "["       );
        else if(TokenType == TOKEN_SQUARE_R    ) sprintf(buf, "]"       );
        else if(TokenType == TOKEN_BRACE_L     ) sprintf(buf, "{"       );
        else if(TokenType == TOKEN_BRACE_R     ) sprintf(buf, "}"       );
        else if(TokenType == TOKEN_BRACKET_L   ) sprintf(buf, "("       );
        else if(TokenType == TOKEN_BRACKET_R   ) sprintf(buf, ")"       );
        else if(TokenType == TOKEN_COLON       ) sprintf(buf, ":"       );
        else if(TokenType == TOKEN_SEMICOLON   ) sprintf(buf, ";"       );
        else if(TokenType == TOKEN_COMMA       ) sprintf(buf, ","       );
        else if(TokenType == TOKEN_PERIOD      ) sprintf(buf, "."       );
        else if(TokenType == TOKEN_ARROW       ) sprintf(buf, "->"      );
        else if(TokenType == TOKEN_NOT         ) sprintf(buf, "~"       );
        else if(TokenType == TOKEN_DOUBLE_PLUS ) sprintf(buf, "++"      );
        else if(TokenType == TOKEN_DOUBLE_MINUS) sprintf(buf, "--"      );
        else if(TokenType == TOKEN_PLUS        ) sprintf(buf, "+"       );
        else if(TokenType == TOKEN_MINUS       ) sprintf(buf, "-"       );
        else if(TokenType == TOKEN_ASTERISK    ) sprintf(buf, "*"       );
        else if(TokenType == TOKEN_DIV         ) sprintf(buf, "/"       );
        else if(TokenType == TOKEN_MOD         ) sprintf(buf, "%"       );
        else if(TokenType == TOKEN_AMPERSAND   ) sprintf(buf, "&"       );
        else if(TokenType == TOKEN_OR          ) sprintf(buf, "|"       );
        else if(TokenType == TOKEN_XOR         ) sprintf(buf, "^"       );
        else if(TokenType == TOKEN_SHIFT_L     ) sprintf(buf, "<<"      );
        else if(TokenType == TOKEN_SHIFT_R     ) sprintf(buf, ">>"      );
        else if(TokenType == TOKEN_LESS        ) sprintf(buf, "<"       );
        else if(TokenType == TOKEN_GRATER      ) sprintf(buf, ">"       );
        else if(TokenType == TOKEN_LESS_EQ     ) sprintf(buf, "<="      );
        else if(TokenType == TOKEN_GRATER_EQ   ) sprintf(buf, ">="      );
        else if(TokenType == TOKEN_EQ_EQ       ) sprintf(buf, "=="      );
        else if(TokenType == TOKEN_NOT_EQ      ) sprintf(buf, "!="      );
        else if(TokenType == TOKEN_EXCLAMATION ) sprintf(buf, "!"       );
        else if(TokenType == TOKEN_AND_AND     ) sprintf(buf, "&&"      );
        else if(TokenType == TOKEN_OR_OR       ) sprintf(buf, "||"      );
        else if(TokenType == TOKEN_EQ          ) sprintf(buf, "="       );
        else if(TokenType == TOKEN_PLUS_EQ     ) sprintf(buf, "+="      );
        else if(TokenType == TOKEN_MINUS_EQ    ) sprintf(buf, "-="      );
        else if(TokenType == TOKEN_MULT_EQ     ) sprintf(buf, "*="      );
        else if(TokenType == TOKEN_DIV_EQ      ) sprintf(buf, "/="      );
        else if(TokenType == TOKEN_MOD_EQ      ) sprintf(buf, "%="      );
        else if(TokenType == TOKEN_AND_EQ      ) sprintf(buf, "&="      );
        else if(TokenType == TOKEN_XOR_EQ      ) sprintf(buf, "^="      );
        else if(TokenType == TOKEN_OR_EQ       ) sprintf(buf, "|="      );
        else if(TokenType == TOKEN_SHIFT_L_EQ  ) sprintf(buf, "<<="     );
        else if(TokenType == TOKEN_SHIFT_R_EQ  ) sprintf(buf, ">>="     );
        else if(TokenType == TOKEN_QUESTION    ) sprintf(buf, "?"       );
        else if(TokenType == TOKEN_ELLIPSIS    ) sprintf(buf, "..."     );
        else                                     sprintf(buf, "???"     );
    }
}
//====================================================================================================================
static int PrintVertualOpCode(v_opecode *OpCode)
//====================================================================================================================
// [@\] ԃR[h̃IyR[heLXgɕϊ
// []
// [Ԓl] P3CC_OK
{
#if 0
    switch(OpCode->Type){
        case OPECODE_TYPE_JP    : fprintf(LogFile, "TYPE_JP : "); break;
        case OPECODE_TYPE_LD    : fprintf(LogFile, "TYPE_LD : "); break;
        case OPECODE_TYPE_ST    : fprintf(LogFile, "TYPE_ST : "); break;
        case OPECODE_TYPE_OP    : fprintf(LogFile, "TYPE_OP : "); break;
        case OPECODE_TYPE_OTHER : fprintf(LogFile, "TYPE_OTH: "); break;
        case OPECODE_TYPE_DUMMY : fprintf(LogFile, "TYPE_DMY: "); break;
        default                 : fprintf(LogFile, "??????? : "); break;
    }
#endif

    if(OpCode -> Code == OPECODE_JP_R       ) { fprintf(LogFile, "JP_R,       "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_JP_I       ) { fprintf(LogFile, "JP_I,       "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_CALL_R     ) { fprintf(LogFile, "CALL_R,     "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_CALL_I     ) { fprintf(LogFile, "CALL_I,     "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_DJP_R      ) { fprintf(LogFile, "DJP_R,      "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_RTI_R      ) { fprintf(LogFile, "RTI_R,      "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_LDW_R      ) { fprintf(LogFile, "LDW_R,      "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_LDW_I      ) { fprintf(LogFile, "LDW_I,      "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_LDW_UB_R   ) { fprintf(LogFile, "LDW_UB_R,   "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_LDW_UB_I   ) { fprintf(LogFile, "LDW_UB_I,   "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_LDW_UA_R   ) { fprintf(LogFile, "LDW_UA_R,   "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_LDW_UA_I   ) { fprintf(LogFile, "LDW_UA_I,   "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_LDH_R      ) { fprintf(LogFile, "LDH_R,      "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_LDH_I      ) { fprintf(LogFile, "LDH_I,      "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_LDH_UB_R   ) { fprintf(LogFile, "LDH_UB_R,   "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_LDH_UB_I   ) { fprintf(LogFile, "LDH_UB_I,   "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_LDH_UA_R   ) { fprintf(LogFile, "LDH_UA_R,   "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_LDH_UA_I   ) { fprintf(LogFile, "LDH_UA_I,   "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_LDB_R      ) { fprintf(LogFile, "LDB_R,      "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_LDB_I      ) { fprintf(LogFile, "LDB_I,      "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_LDB_UB_R   ) { fprintf(LogFile, "LDB_UB_R,   "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_LDB_UB_I   ) { fprintf(LogFile, "LDB_UB_I,   "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_LDB_UA_R   ) { fprintf(LogFile, "LDB_UA_R,   "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_LDB_UA_I   ) { fprintf(LogFile, "LDB_UA_I,   "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_LDSH_R     ) { fprintf(LogFile, "LDSH_R,     "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_LDSH_I     ) { fprintf(LogFile, "LDSH_I,     "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_LDSH_UB_R  ) { fprintf(LogFile, "LDSH_UB_R,  "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_LDSH_UB_I  ) { fprintf(LogFile, "LDSH_UB_I,  "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_LDSH_UA_R  ) { fprintf(LogFile, "LDSH_UA_R,  "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_LDSH_UA_I  ) { fprintf(LogFile, "LDSH_UA_I,  "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_LDSB_R     ) { fprintf(LogFile, "LDSB_R,     "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_LDSB_I     ) { fprintf(LogFile, "LDSB_I,     "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_LDSB_UB_R  ) { fprintf(LogFile, "LDSB_UB_R,  "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_LDSB_UB_I  ) { fprintf(LogFile, "LDSB_UB_I,  "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_LDSB_UA_R  ) { fprintf(LogFile, "LDSB_UA_R,  "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_LDSB_UA_I  ) { fprintf(LogFile, "LDSB_UA_I,  "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_STW_R      ) { fprintf(LogFile, "STW_R,      "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_STW_I      ) { fprintf(LogFile, "STW_I,      "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_STW_UB_R   ) { fprintf(LogFile, "STW_UB_R,   "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_STW_UB_I   ) { fprintf(LogFile, "STW_UB_I,   "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_STW_UA_R   ) { fprintf(LogFile, "STW_UA_R,   "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_STW_UA_I   ) { fprintf(LogFile, "STW_UA_I,   "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_STH_R      ) { fprintf(LogFile, "STH_R,      "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_STH_I      ) { fprintf(LogFile, "STH_I,      "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_STH_UB_R   ) { fprintf(LogFile, "STH_UB_R,   "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_STH_UB_I   ) { fprintf(LogFile, "STH_UB_I,   "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_STH_UA_R   ) { fprintf(LogFile, "STH_UA_R,   "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_STH_UA_I   ) { fprintf(LogFile, "STH_UA_I,   "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_STB_R      ) { fprintf(LogFile, "STB_R,      "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_STB_I      ) { fprintf(LogFile, "STB_I,      "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_STB_UB_R   ) { fprintf(LogFile, "STB_UB_R,   "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_STB_UB_I   ) { fprintf(LogFile, "STB_UB_I,   "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_STB_UA_R   ) { fprintf(LogFile, "STB_UA_R,   "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_STB_UA_I   ) { fprintf(LogFile, "STB_UA_I,   "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_MOV_I      ) { fprintf(LogFile, "MOV_I,      "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_MOV_R      ) { fprintf(LogFile, "MOV_R,      "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_MOVL_I     ) { fprintf(LogFile, "MOVL_I,     "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_MOVH_I     ) { fprintf(LogFile, "MOVH_I,     "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_ADD_R      ) { fprintf(LogFile, "ADD_R,      "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_ADD_I      ) { fprintf(LogFile, "ADD_I,      "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_SUB_R      ) { fprintf(LogFile, "SUB_R,      "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_SUB_I      ) { fprintf(LogFile, "SUB_I,      "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_AND_R      ) { fprintf(LogFile, "AND_R,      "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_AND_I      ) { fprintf(LogFile, "AND_I,      "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_OR_R       ) { fprintf(LogFile, "OR_R,       "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_OR_I       ) { fprintf(LogFile, "OR_I,       "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_XOR_R      ) { fprintf(LogFile, "XOR_R,      "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_XOR_I      ) { fprintf(LogFile, "XOR_I,      "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_LSR_R      ) { fprintf(LogFile, "LSR_R,      "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_LSR_I      ) { fprintf(LogFile, "LSR_I,      "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_LSL_R      ) { fprintf(LogFile, "LSL_R,      "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_LSL_I      ) { fprintf(LogFile, "LSL_I,      "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_ASR_R      ) { fprintf(LogFile, "ASR_R,      "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_ASR_I      ) { fprintf(LogFile, "ASR_I,      "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_MUL_R      ) { fprintf(LogFile, "MUL_R,      "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_MUL_I      ) { fprintf(LogFile, "MUL_I,      "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_DIVU_R     ) { fprintf(LogFile, "DIVU_R,     "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_DIVU_I     ) { fprintf(LogFile, "DIVU_I,     "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_DIV_R      ) { fprintf(LogFile, "DIV_R,      "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_DIV_I      ) { fprintf(LogFile, "DIV_I,      "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_MODU_R     ) { fprintf(LogFile, "MODU_R,     "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_MODU_I     ) { fprintf(LogFile, "MODU_I,     "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_MOD_R      ) { fprintf(LogFile, "MOD_R,      "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_MOD_I      ) { fprintf(LogFile, "MOD_I,      "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_NOP        ) { fprintf(LogFile, "NOP         "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_IMMSET     ) { fprintf(LogFile, "IMMSET,     "); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_ESCAPE_REGS) { fprintf(LogFile, "$EscapeRegs$"); return P3CC_OK;}
    if(OpCode -> Code == OPECODE_RETURN_REGS) { fprintf(LogFile, "$ReturnRegs$"); return P3CC_OK;}
    fprintf(LogFile, "`̃R[h");
    return P3CC_NG;
}
//====================================================================================================================
static int PrintVertualOpRand(v_operand *OpRand)
//====================================================================================================================
// [@\] ԃR[h̃IyheLXgɕϊ
// []
// [Ԓl] P3CC_OK
{
    variable *v;
    char     c[5];

    if(OpRand->Type == OPERAND_TYPE_NOTHING){
        ;
    }
    else if(OpRand->Type == OPERAND_TYPE_SPR){
        if     (OpRand->ValueInfo.RegNo == SPR_GP ) fprintf(LogFile, "GP,   ");
        else if(OpRand->ValueInfo.RegNo == SPR_FP ) fprintf(LogFile, "FP,    ");
        else if(OpRand->ValueInfo.RegNo == SPR_SP ) fprintf(LogFile, "SP,    ");
        else if(OpRand->ValueInfo.RegNo == SPR_LR ) fprintf(LogFile, "LR,    ");
        else if(OpRand->ValueInfo.RegNo == SPR_PC ) fprintf(LogFile, "PC,    ");
        else if(OpRand->ValueInfo.RegNo == SPR_NON) fprintf(LogFile, "NON,   ");
        else                                        fprintf(LogFile, "`̓ꃌWX^, ");
    }
    else if(OpRand->Type == OPERAND_TYPE_GPR){
        fprintf(LogFile, "R%04d, ",OpRand->ValueInfo.RegNo);
    }
    else if(OpRand->Type == OPERAND_TYPE_SHORT_IMM){
        fprintf(LogFile, "%d(0x%04x),", OpRand->ValueInfo.NumLiteral, 0xFFFF & OpRand->ValueInfo.NumLiteral);
    }
    else if(OpRand->Type == OPERAND_TYPE_LONG_IMM){
        fprintf(LogFile, "0x%08x(%d ",OpRand->ValueInfo.NumLiteral, OpRand->ValueInfo.NumLiteral);
        c[0] = (char)(OpRand->ValueInfo.NumLiteral >> 24);
        c[1] = (char)((OpRand->ValueInfo.NumLiteral >> 16) & 0xFF);
        c[2] = (char)((OpRand->ValueInfo.NumLiteral >> 8) & 0xFF);
        c[3] = (char)(OpRand->ValueInfo.NumLiteral & 0xFF);
        if((c[0] < ' ') || (c[0] > '~')) c[0] = '?';
        if((c[1] < ' ') || (c[1] > '~')) c[1] = '?';
        if((c[2] < ' ') || (c[2] > '~')) c[2] = '?';
        if((c[3] < ' ') || (c[3] > '~')) c[3] = '?';
        c[4] = '\0';
        fprintf(LogFile, "\"%s\"),", c);
    }
    else if(OpRand->Type == OPERAND_TYPE_CONDITION){
        if     (OpRand->ValueInfo.Condition == COND_ALWAYS                  ) fprintf(LogFile, "AL,    ");
        else if(OpRand->ValueInfo.Condition == COND_ZERO                    ) fprintf(LogFile, "EQ,    ");
        else if(OpRand->ValueInfo.Condition == COND_NOT_ZERO                ) fprintf(LogFile, "NE,    ");
        else if(OpRand->ValueInfo.Condition == COND_UNSIGNED_HIGHER_OR_SAME ) fprintf(LogFile, "HS,    ");
        else if(OpRand->ValueInfo.Condition == COND_UNSIGNED_LOWER          ) fprintf(LogFile, "LO,    ");
        else if(OpRand->ValueInfo.Condition == COND_MINUS                   ) fprintf(LogFile, "MI,    ");
        else if(OpRand->ValueInfo.Condition == COND_PLUS                    ) fprintf(LogFile, "PL,    ");
        else if(OpRand->ValueInfo.Condition == COND_OVERFLOW                ) fprintf(LogFile, "VS,    ");
        else if(OpRand->ValueInfo.Condition == COND_NOT_OVERFLOW            ) fprintf(LogFile, "VC,    ");
        else if(OpRand->ValueInfo.Condition == COND_UNSIGNED_HIGHER         ) fprintf(LogFile, "HI,    ");
        else if(OpRand->ValueInfo.Condition == COND_UNSIGNED_LOWER_OR_SAME  ) fprintf(LogFile, "LS,    ");
        else if(OpRand->ValueInfo.Condition == COND_SIGNED_GRATER_THAN_OR_EQ) fprintf(LogFile, "GE,    ");
        else if(OpRand->ValueInfo.Condition == COND_SIGNED_LESS_THAN        ) fprintf(LogFile, "LT,    ");
        else if(OpRand->ValueInfo.Condition == COND_SIGNED_GRATER_THAN      ) fprintf(LogFile, "GT,    ");
        else if(OpRand->ValueInfo.Condition == COND_SIGNED_LESS_THAN_OR_EQ  ) fprintf(LogFile, "LE,    ");
        else                                                                  fprintf(LogFile, "`̏R[h,      ");
    }
    else if(OpRand->Type == OPERAND_TYPE_LABEL){
//fprintf(LogFile, "\n");
        fprintf(LogFile, "PcOffsetOf(_@%d)",OpRand->ValueInfo.LabelNo);
//fprintf(LogFile, "\n");
    }
    else if(OpRand->Type == OPERAND_TYPE_FUNCTION){
        fprintf(LogFile, "EntryPointOf(%s)",OpRand->ValueInfo.func->FuncName);
    }
    else if(OpRand->Type == OPERAND_TYPE_FUNCTION_HI){
        fprintf(LogFile, "EntryPointHiOf(%s)",OpRand->ValueInfo.func->FuncName);
    }
    else if(OpRand->Type == OPERAND_TYPE_FUNCTION_LO){
        fprintf(LogFile, "EntryPointLoOf(%s)",OpRand->ValueInfo.func->FuncName);
    }
    else if((OpRand->Type == OPERAND_TYPE_VARIABLE) || (OpRand->Type == OPERAND_TYPE_VARIABLE_HI) || (OpRand->Type == OPERAND_TYPE_VARIABLE_LO)){
        v = OpRand->ValueInfo.var;
        if((v->Scope == SCOPE_AT) || (v->Scope == SCOPE_ARG)){
            fprintf(LogFile, "FpOffsetOf(%s)", v->Name);
            if(OpRand->VariableOffset != 0) fprintf(LogFile, " + %d", OpRand->VariableOffset);
        }
        else{
            if(OpRand->Type == OPERAND_TYPE_VARIABLE){
                fprintf(LogFile, "GpOffsetOf(%s)", v->Name);
            }
            else if(OpRand->Type == OPERAND_TYPE_VARIABLE_HI){
                fprintf(LogFile, "GpOffsetHiOf(%s)", v->Name);
            }
            else{
                fprintf(LogFile, "GpOffsetLoOf(%s)", v->Name);
            }
        }
    }
    else if(OpRand->Type == OPERAND_TYPE_SIZEOF_LOCALS){
        fprintf(LogFile, "$SizeOfLocals$");
    }
    else if(OpRand->Type == OPERAND_TYPE_SIZEOF_GLOBALS){
        fprintf(LogFile, "$SizeOfGlobals$");
    }
    else if(OpRand->Type == OPERAND_TYPE_SIZEOF_ARGS){
        fprintf(LogFile, "$SizeOfArgs$");
    }
    else{
        fprintf(LogFile, "`̃Iyh^Cv(%d)", OpRand->Type);
    }

    return P3CC_OK;
}
//====================================================================================================================
static int PrintVertualCodeOptimaHint(vertual_code *VCode)
//====================================================================================================================
// [@\] ԃR[h̍œKqgOo
// []
// [Ԓl] P3CC_OK
{
    char buf[6];
    buf[0] = (char)VCode->OptimaizationHint.Position;
    buf[1] = ',';
    buf[2] = (char)VCode->OptimaizationHint.Result;
    buf[3] = ',';
    buf[4] = (char)VCode->OptimaizationHint.Copy;
    buf[5] = '\0';
    fprintf(LogFile, "{%2d,%s}  ",VCode->OptimaizationHint.LoopLevel, buf);
    return P3CC_OK;
}
//====================================================================================================================
static int PrintVertualCodeBody(vertual_code *VCode)
//====================================================================================================================
// [@\] ԃR[hOo
// []
// [Ԓl] P3CC_OK
{
    PrintVertualCodeOptimaHint(VCode);
    if(VCode->LabelNo == PLABEL_NON)   fprintf(LogFile, "\t\t");
    else                              fprintf(LogFile, "_@%02d\t",VCode->LabelNo);
    PrintVertualOpCode(&VCode->OpCode);
    PrintVertualOpRand(&VCode->OpRand0);
    PrintVertualOpRand(&VCode->OpRand1);
    PrintVertualOpRand(&VCode->OpRand2);
    fprintf(LogFile, "\n");
    return P3CC_OK;
}
//====================================================================================================================
static int PrintVertualCodeList(vertual_code *CodeList)
//====================================================================================================================
// [@\] ԃR[hXgOo
// []
// [Ԓl] P3CC_OK
{
    char buf[256];
    int  i,len;
    if(CodeList == NULL) return P3CC_OK;
    while(1){
        sprintf(buf, "%s : %d",  TokenSrcFileNameGetBySrcTblIndex(CodeList->SrcFileIndex), CodeList->SrcFileLine);
        len = strlen(buf);
//fprintf(LogFile,"%d\n",len);
        for(i=len;i<16;i++) strcat(buf," ");
        fprintf(LogFile, "%s",buf);
//fprintf(LogFile, " %08x,%08x,%08x ", CodeList->Prev, CodeList, CodeList->Next);
        PrintVertualCodeBody(CodeList);
        if(CodeList->Next == NULL) break;
        CodeList = CodeList->Next;
    }
    return P3CC_OK;
}
//====================================================================================================================
static int PrintVertualRegList(vertual_reg_list *VRegList)
//====================================================================================================================
// [@\] vertual_reg_listOo
// []
// [Ԓl] P3CC_OK
{
    vertual_reg_list *p;
    char             *str;

    fprintf(LogFile, "gpς݉zWX^ :");
    p = VRegList;
    while(1){
        if(p == NULL) break;
        str = "";
        if(p->Result == P3CC_TRUE) str = ",*";
        fprintf(LogFile, "R%d(%d%s), ",p->RegNo, p->UsedTimes, str);
        p = p->Next;
    }
    fprintf(LogFile, "\n");
    return P3CC_OK;
}

//====================================================================================================================
static void PrintSpace(int Num)
//====================================================================================================================
// [@\] Num̐Space
// [Ԓl] P3CC_OK
{
    int i;
    for(i=0; i < Num; i++) fprintf(LogFile, "  ");
}

//====================================================================================================================
static int PrintExpAnaResult(expression_analsys_result *Res, char *Str)
//====================================================================================================================
// [@\] ͌ʕ\
// []
// [Ԓl] P3CC_OK
{
    int i;

    if(Res == NULL) return P3CC_OK;
    if(Str == NULL) return P3CC_OK;
    fprintf(LogFile, "+--------------------------------+\n");
    fprintf(LogFile, "| %s\n", Str);
    fprintf(LogFile, "| Res->Method   = %s\n", (Res->Method)? "NUM" : "REG");
    fprintf(LogFile, "| Res->Property = %s\n", (Res->Property)? "VAL" : "ADR");
    fprintf(LogFile, "| Res->Value    = %d 0x%08x\n", Res->Value.Num, Res->Value.Num);
    fprintf(LogFile, "| Res->TypeInfo.Sign      = %d\n", Res->TypeInfo.Sign);
    fprintf(LogFile, "| Res->TypeInfo.Pointer   = %d\n", Res->TypeInfo.Pointer);
    fprintf(LogFile, "| Res->TypeInfo.Type      = %d\n", Res->TypeInfo.Type);
    fprintf(LogFile, "| Res->TypeInfo.TypeFunc  = %d\n", Res->TypeInfo.TypeFunction);
    fprintf(LogFile, "| Res->TypeInfo.FuncPtr   = %d\n", Res->TypeInfo.FuncPointer);
    fprintf(LogFile, "| Res->TypeInfo.ArgNum    = %d\n", Res->TypeInfo.ArgNum);
    fprintf(LogFile, "| Res->TypeInfo.BasicTSize= %d\n", Res->TypeInfo.BasicTypeSize);
    fprintf(LogFile, "| Res->TypeInfo.ArgList   = %d\n", Res->TypeInfo.ArgList);
    fprintf(LogFile, "| Res->TypeInfo.DimInfo   = 0x%08x ", Res->TypeInfo.DimInfo);
    if(Res->TypeInfo.DimInfo != NULL){
        for(i=0;i<MAX_ARRAY_DIM;i++){
            if(i==0){
                fprintf(LogFile, "[%d(%d)]", Res->TypeInfo.DimInfo->NumOfElements[i], Res->TypeInfo.DimInfo->ElementSize[i]);
            }
            else if(Res->TypeInfo.DimInfo->NumOfElements[i] != 0){
                fprintf(LogFile, "[%d(%d)]", Res->TypeInfo.DimInfo->NumOfElements[i], Res->TypeInfo.DimInfo->ElementSize[i]);
            }
        }
    }
    fprintf(LogFile, "\n");
    fprintf(LogFile, "| Res->TypeInfo.StructInfo= %d\n", Res->TypeInfo.StructInfo);
    fprintf(LogFile, "+--------------------------------+\n");
    return P3CC_OK;
}
//====================================================================================================================
static void PrintWarning(char *FileName, int Line, char *Str0, char *Str1, char *Str2)
//====================================================================================================================
// [@\] x\
// []
// [Ԓl]
{
    fprintf(MsgOut, "yxz(%s  LINE:%d) %s %s %s %s%ds\n"
                ,FileName , Line, Str0, Str1, Str2, TokenSrcFileNameGet(TokenIndex), TokenSrcLineGet(TokenIndex));
    fprintf(LogFile, "yxz(%s  LINE:%d) %s %s %s %s%ds\n"
                ,FileName , Line, Str0, Str1, Str2, TokenSrcFileNameGet(TokenIndex), TokenSrcLineGet(TokenIndex));
}
//====================================================================================================================
static void PrintInfo(char *FileName, int Line, char *Str0, char *Str1, char *Str2)
//====================================================================================================================
// [@\] \
// []
// [Ԓl]
{
    fprintf(MsgOut, "yINFOz(%s  LINE:%d) %s %s %s %s%ds\n"
                ,FileName , Line, Str0, Str1, Str2, TokenSrcFileNameGet(TokenIndex), TokenSrcLineGet(TokenIndex));
    fprintf(LogFile, "yINFOz(%s  LINE:%d) %s %s %s %s%ds\n"
                ,FileName , Line, Str0, Str1, Str2, TokenSrcFileNameGet(TokenIndex), TokenSrcLineGet(TokenIndex));
}

//====================================================================================================================
static void PrintError(char *FileName, int Line, char *Str0, char *Str1, char *Str2)
//====================================================================================================================
// [@\] G[\
// []
// [Ԓl]
{
    fprintf(MsgOut, "yG[z(%s  LINE:%d) %s %s %s %s%ds\n"
                ,FileName , Line, Str0, Str1, Str2, TokenSrcFileNameGet(TokenIndex), TokenSrcLineGet(TokenIndex));
    fprintf(LogFile, "yG[z(%s  LINE:%d) %s %s %s %s%ds\n"
                ,FileName , Line, Str0, Str1, Str2, TokenSrcFileNameGet(TokenIndex), TokenSrcLineGet(TokenIndex));

}
